/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/map","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,t=Q.length;D<t;D++)e[D]=ie[Q[D]];return e};define(ie[53],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(L){return L?L.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=D;class t{constructor(P,I,E){this.id=P,this.definition=I,this.description=E,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(L,P){const I=["codicon","codicon-"+L];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=R;var T;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function I(b){if(b instanceof t)return["codicon","codicon-"+b.id];const v=P.exec(b.id);if(!v)return I(t.error);const[,m,f]=v,p=["codicon","codicon-"+m];return f&&p.push("codicon-modifier-"+f.substr(1)),p}L.asClassNameArray=I;function E(b){return I(b).join(" ")}L.asClassName=E;function C(b){return"."+I(b).join(".")}L.asCSSSelector=C})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ie[63],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(L){return(P,I,E)=>{let C=null,b=null;if(typeof E.value=="function"?(C="value",b=E.value):typeof E.get=="function"&&(C="get",b=E.get),!b)throw new Error("not supported");E[C]=L(b,I)}}e.createDecorator=D;function t(L,P,I){let E=null,C=null;if(typeof I.value=="function"?(E="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(E="get",C=I.get),!C)throw new Error("not supported");const b=`$memoize$${P}`;I[E]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[b]}}e.memoize=t;function R(L,P,I){return D((E,C)=>{const b=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...m){this[v]||(this[v]=I?I():void 0),clearTimeout(this[b]),P&&(this[v]=P(this[v],...m),m=[this[v]]),this[b]=setTimeout(()=>{E.apply(this,m),this[v]=I?I():void 0},L)}})}e.debounce=R;function T(L,P,I){return D((E,C)=>{const b=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,m=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...p){if(this[v]||(this[v]=I?I():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...p)),this[f])return;const y=this[m]+L;y<=Date.now()?(this[m]=Date.now(),E.apply(this,[this[v]]),this[v]=I?I():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[m]=Date.now(),E.apply(this,[this[v]]),this[v]=I?I():void 0},y-Date.now()))}})}e.throttle=T}),define(ie[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?c.isErrorNoTelemetry(i)?new c(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(r=>{r(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=D,e.errorHandler=new D;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function R(l){I(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function T(l){I(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function L(l){if(l instanceof Error){const{name:i,message:r}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:c.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=L;const P="Canceled";function I(l){return l instanceof E?!0:l instanceof Error&&l.name===P&&l.message===P}e.isCancellationError=I;class E extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=E;function C(){const l=new Error(P);return l.name=l.message,l}e.canceled=C;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function v(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=v;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function f(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=f;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=p;class y extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=y;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class c extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof c)return i;const r=new c;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class d extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(ie[18],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(Z,ne=0){return Z[Z.length-(1+ne)]}e.tail=t;function R(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=R;function T(Z,ne,oe=(ue,de)=>ue===de){if(Z===ne)return!0;if(!Z||!ne||Z.length!==ne.length)return!1;for(let ue=0,de=Z.length;ue<de;ue++)if(!oe(Z[ue],ne[ue]))return!1;return!0}e.equals=T;function L(Z,ne){const oe=Z.length-1;ne<oe&&(Z[ne]=Z[oe]),Z.pop()}e.removeFastWithoutKeepingOrder=L;function P(Z,ne,oe){return I(Z.length,ue=>oe(Z[ue],ne))}e.binarySearch=P;function I(Z,ne){let oe=0,ue=Z-1;for(;oe<=ue;){const de=(oe+ue)/2|0,ve=ne(de);if(ve<0)oe=de+1;else if(ve>0)ue=de-1;else return de}return-(oe+1)}e.binarySearch2=I;function E(Z,ne){let oe=0,ue=Z.length;if(ue===0)return 0;for(;oe<ue;){const de=Math.floor((oe+ue)/2);ne(Z[de])?ue=de:oe=de+1}return oe}e.findFirstInSorted=E;function C(Z,ne,oe){if(Z=Z|0,Z>=ne.length)throw new TypeError("invalid index");const ue=ne[Math.floor(ne.length*Math.random())],de=[],ve=[],we=[];for(const Ee of ne){const Pe=oe(Ee,ue);Pe<0?de.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return Z<de.length?C(Z,de,oe):Z<de.length+we.length?we[0]:C(Z-(de.length+we.length),ve,oe)}e.quickSelect=C;function b(Z,ne){const oe=[];let ue;for(const de of Z.slice(0).sort(ne))!ue||ne(ue[0],de)!==0?(ue=[de],oe.push(ue)):ue.push(de);return oe}e.groupBy=b;function v(Z,ne,oe){const ue=[];function de(Ee,Pe,Oe){if(Pe===0&&Oe.length===0)return;const $e=ue[ue.length-1];$e&&$e.start+$e.deleteCount===Ee?($e.deleteCount+=Pe,$e.toInsert.push(...Oe)):ue.push({start:Ee,deleteCount:Pe,toInsert:Oe})}let ve=0,we=0;for(;;){if(ve===Z.length){de(ve,0,ne.slice(we));break}if(we===ne.length){de(ve,Z.length-ve,[]);break}const Ee=Z[ve],Pe=ne[we],Oe=oe(Ee,Pe);Oe===0?(ve+=1,we+=1):Oe<0?(de(ve,1,[]),ve+=1):Oe>0&&(de(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=v;function m(Z,ne,oe){const ue=v(Z,ne,oe),de=[],ve=[];for(const we of ue)de.push(...Z.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:de,added:ve}}e.delta=m;function f(Z,ne,oe){if(oe===0)return[];const ue=Z.slice(0,oe).sort(ne);return y(Z,ne,ue,oe,Z.length),ue}e.top=f;function p(Z,ne,oe,ue,de){return oe===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=Z.length,Pe=Z.slice(0,oe).sort(ne);for(let Oe=oe,$e=Math.min(oe+ue,Ee);Oe<Ee;Oe=$e,$e=Math.min($e+ue,Ee)){if(Oe>oe&&await new Promise(Ve=>setTimeout(Ve)),de&&de.isCancellationRequested)throw new D.CancellationError;y(Z,ne,Pe,Oe,$e)}return Pe})().then(ve,we)})}e.topAsync=p;function y(Z,ne,oe,ue,de){for(const ve=oe.length;ue<de;ue++){const we=Z[ue];if(ne(we,oe[ve-1])<0){oe.pop();const Ee=E(oe,Pe=>ne(we,Pe)<0);oe.splice(Ee,0,we)}}}function u(Z){return Z.filter(ne=>!!ne)}e.coalesce=u;function g(Z){let ne=0;for(let oe=0;oe<Z.length;oe++)Z[oe]&&(Z[ne]=Z[oe],ne+=1);Z.length=ne}e.coalesceInPlace=g;function c(Z,ne,oe){Z.splice(oe,0,Z.splice(ne,1)[0])}e.move=c;function d(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=d;function l(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=l;function i(Z,ne=oe=>oe){const oe=new Set;return Z.filter(ue=>{const de=ne(ue);return oe.has(de)?!1:(oe.add(de),!0)})}e.distinct=i;function r(Z){const ne=new Set;return oe=>{const ue=Z(oe);return ne.has(ue)?!1:(ne.add(ue),!0)}}e.uniqueFilter=r;function n(Z,ne){const oe=o(Z,ne);if(oe!==-1)return Z[oe]}e.findLast=n;function o(Z,ne){for(let oe=Z.length-1;oe>=0;oe--){const ue=Z[oe];if(ne(ue))return oe}return-1}e.lastIndex=o;function s(Z,ne){return Z.length>0?Z[0]:ne}e.firstOrDefault=s;function h(Z,ne){return Z.length>0?Z[Z.length-1]:ne}e.lastOrDefault=h;function a(Z,ne,oe=(ue,de)=>ue===de){let ue=0;for(let de=0,ve=Math.min(Z.length,ne.length);de<ve&&oe(Z[de],ne[de]);de++)ue++;return ue}e.commonPrefixLength=a;function S(Z){return[].concat(...Z)}e.flatten=S;function w(Z,ne){let oe=typeof ne=="number"?Z:0;typeof ne=="number"?oe=Z:(oe=0,ne=Z);const ue=[];if(oe<=ne)for(let de=oe;de<ne;de++)ue.push(de);else for(let de=oe;de>ne;de--)ue.push(de);return ue}e.range=w;function A(Z,ne,oe){return Z.reduce((ue,de)=>(ue[ne(de)]=oe?oe(de):de,ue),Object.create(null))}e.index=A;function q(Z,ne){return Z.push(ne),()=>U(Z,ne)}e.insert=q;function U(Z,ne){const oe=Z.indexOf(ne);if(oe>-1)return Z.splice(oe,1),ne}e.remove=U;function O(Z,ne,oe){const ue=Z.slice(0,ne),de=Z.slice(ne);return ue.concat(oe,de)}e.arrayInsert=O;function $(Z,ne){let oe;if(typeof ne=="number"){let ue=ne;oe=()=>{const de=Math.sin(ue++)*179426549;return de-Math.floor(de)}}else oe=Math.random;for(let ue=Z.length-1;ue>0;ue-=1){const de=Math.floor(oe()*(ue+1)),ve=Z[ue];Z[ue]=Z[de],Z[de]=ve}}e.shuffle=$;function k(Z,ne){const oe=Z.indexOf(ne);oe>-1&&(Z.splice(oe,1),Z.unshift(ne))}e.pushToStart=k;function M(Z,ne){const oe=Z.indexOf(ne);oe>-1&&(Z.splice(oe,1),Z.push(ne))}e.pushToEnd=M;function F(Z,ne){for(const oe of ne)Z.push(oe)}e.pushMany=F;function G(Z,ne){return Array.isArray(Z)?Z.map(ne):ne(Z)}e.mapArrayOrNot=G;function W(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=W;function B(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=B;function z(Z,ne){for(const oe of Z){const ue=ne(oe);if(ue!==void 0)return ue}}e.mapFind=z;function x(Z,ne,oe){const ue=X(Z,ne),de=Z.length,ve=oe.length;Z.length=de+ve;for(let we=de-1;we>=ue;we--)Z[we+ve]=Z[we];for(let we=0;we<ve;we++)Z[we+ue]=oe[we]}e.insertInto=x;function J(Z,ne,oe,ue){const de=X(Z,ne),ve=Z.splice(de,oe);return x(Z,de,ue),ve}e.splice=J;function X(Z,ne){return ne<0?Math.max(ne+Z.length,0):Math.min(ne,Z.length)}var se;(function(Z){function ne(de){return de<0}Z.isLessThan=ne;function oe(de){return de>0}Z.isGreaterThan=oe;function ue(de){return de===0}Z.isNeitherLessOrGreaterThan=ue,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(se=e.CompareResult||(e.CompareResult={}));function j(Z,ne){return(oe,ue)=>ne(Z(oe),Z(ue))}e.compareBy=j;function H(...Z){return(ne,oe)=>{for(const ue of Z){const de=ue(ne,oe);if(!se.isNeitherLessOrGreaterThan(de))return de}return se.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const _=(Z,ne)=>Z-ne;e.numberComparator=_;function N(Z,ne){if(Z.length===0)return;let oe=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ne(de,oe)>0&&(oe=de)}return oe}e.findMaxBy=N;function V(Z,ne){if(Z.length===0)return;let oe=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ne(de,oe)>=0&&(oe=de)}return oe}e.findLastMaxBy=V;function K(Z,ne){return N(Z,(oe,ue)=>-ne(oe,ue))}e.findMinBy=K;class ee{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let oe=this.firstIdx;for(;oe<this.items.length&&ne(this.items[oe]);)oe++;const ue=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,ue}takeFromEndWhile(ne){let oe=this.lastIdx;for(;oe>=0&&ne(this.items[oe]);)oe--;const ue=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ne=this.items[this.firstIdx];return this.firstIdx++,ne}removeLast(){const ne=this.items[this.lastIdx];return this.lastIdx--,ne}takeCount(ne){const oe=this.items.slice(this.firstIdx,this.firstIdx+ne);return this.firstIdx+=ne,oe}}e.ArrayQueue=ee;class ae{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(oe=>(ne(oe),!0))}toArray(){const ne=[];return this.iterate(oe=>(ne.push(oe),!0)),ne}filter(ne){return new ae(oe=>this.iterate(ue=>ne(ue)?oe(ue):!0))}map(ne){return new ae(oe=>this.iterate(ue=>oe(ne(ue))))}some(ne){let oe=!1;return this.iterate(ue=>(oe=ne(ue),!oe)),oe}findFirst(ne){let oe;return this.iterate(ue=>ne(ue)?(oe=ue,!1):!0),oe}findLast(ne){let oe;return this.iterate(ue=>(ne(ue)&&(oe=ue),!0)),oe}findLastMaxBy(ne){let oe,ue=!0;return this.iterate(de=>((ue||se.isGreaterThan(ne(de,oe)))&&(ue=!1,oe=de),!0)),oe}}e.CallbackIterable=ae,ae.empty=new ae(Z=>{})}),define(ie[120],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(I,E){if(!I)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=t;function R(I,E="Unreachable"){throw new Error(E)}e.assertNever=R;function T(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=T;function L(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function P(I,E){let C=0;for(;C<I.length-1;){const b=I[C],v=I[C+1];if(!E(b,v))return!1;C++}return!0}e.checkAdjacentItems=P}),define(ie[80],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(t){const R=this;let T=!1,L;return function(){return T||(T=!0,L=t.apply(R,arguments)),L}}e.once=D}),define(ie[64],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(t){function R(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=R;const T=Object.freeze([]);function L(){return T}t.empty=L;function*P(d){yield d}t.single=P;function I(d){return R(d)?d:P(d)}t.wrap=I;function E(d){return d||T}t.from=E;function C(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=C;function b(d){return d[Symbol.iterator]().next().value}t.first=b;function v(d,l){for(const i of d)if(l(i))return!0;return!1}t.some=v;function m(d,l){for(const i of d)if(l(i))return i}t.find=m;function*f(d,l){for(const i of d)l(i)&&(yield i)}t.filter=f;function*p(d,l){let i=0;for(const r of d)yield l(r,i++)}t.map=p;function*y(...d){for(const l of d)for(const i of l)yield i}t.concat=y;function u(d,l,i){let r=i;for(const n of d)r=l(r,n);return r}t.reduce=u;function*g(d,l,i=d.length){for(l<0&&(l+=d.length),i<0?i+=d.length:i>d.length&&(i=d.length);l<i;l++)yield d[l]}t.slice=g;function c(d,l=Number.POSITIVE_INFINITY){const i=[];if(l===0)return[i,d];const r=d[Symbol.iterator]();for(let n=0;n<l;n++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=c})(D=e.Iterable||(e.Iterable={}))}),define(ie[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(i,r=!1){let n=0;const o=i.length;let s="",h=0,a=16,S=0;function w(M){let F=0,G=0;for(;F<M;){const W=i.charCodeAt(n);if(W>=48&&W<=57)G=G*16+W-48;else if(W>=65&&W<=70)G=G*16+W-65+10;else if(W>=97&&W<=102)G=G*16+W-97+10;else break;n++,F++}return F<M&&(G=-1),G}function A(M){n=M,s="",h=0,a=16,S=0}function q(){const M=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&E(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&E(i.charCodeAt(n)))for(n++;n<i.length&&E(i.charCodeAt(n));)n++;else return S=3,i.substring(M,n);let F=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&E(i.charCodeAt(n))){for(n++;n<i.length&&E(i.charCodeAt(n));)n++;F=n}else S=3;return i.substring(M,F)}function U(){let M="",F=n;for(;;){if(n>=o){M+=i.substring(F,n),S=2;break}const G=i.charCodeAt(n);if(G===34){M+=i.substring(F,n),n++;break}if(G===92){if(M+=i.substring(F,n),n++,n>=o){S=2;break}switch(i.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=w(4);B>=0?M+=String.fromCharCode(B):S=4;break}default:S=5}F=n;continue}if(G>=0&&G<=31)if(I(G)){M+=i.substring(F,n),S=2;break}else S=6;n++}return M}function O(){if(s="",S=0,h=n,n>=o)return h=o,a=17;let M=i.charCodeAt(n);if(P(M)){do n++,s+=String.fromCharCode(M),M=i.charCodeAt(n);while(P(M));return a=15}if(I(M))return n++,s+=String.fromCharCode(M),M===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),a=14;switch(M){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,s=U(),a=10;case 47:{const F=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!I(i.charCodeAt(n));)n++;return s=i.substring(F,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const G=o-1;let W=!1;for(;n<G;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,S=1),s=i.substring(F,n),a=13}return s+=String.fromCharCode(M),n++,a=16}case 45:if(s+=String.fromCharCode(M),n++,n===o||!E(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=q(),a=11;default:for(;n<o&&$(M);)n++,M=i.charCodeAt(n);if(h!==n){switch(s=i.substring(h,n),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(M),n++,a=16}}function $(M){if(P(M)||I(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:A,getPosition:()=>n,scan:r?k:O,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>S}}e.createScanner=L;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function I(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function b(i,r){const n=[],o=new Object;let s;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function S(w,A,q,U){h.value=w,h.offset=A,h.length=q,h.type=U,h.colonOffset=void 0,s=h}try{c(i,{onObjectBegin:(w,A)=>{if(r<=w)throw o;s=void 0,a=r>w,n.push("")},onObjectProperty:(w,A,q)=>{if(r<A||(S(w,A,q,"property"),n[n.length-1]=w,r<=A+q))throw o},onObjectEnd:(w,A)=>{if(r<=w)throw o;s=void 0,n.pop()},onArrayBegin:(w,A)=>{if(r<=w)throw o;s=void 0,n.push(0)},onArrayEnd:(w,A)=>{if(r<=w)throw o;s=void 0,n.pop()},onLiteralValue:(w,A,q)=>{if(r<A||(S(w,A,q,l(w)),r<=A+q))throw o},onSeparator:(w,A,q)=>{if(r<=A)throw o;if(w===":"&&s&&s.type==="property")s.colonOffset=A,a=!1,s=void 0;else if(w===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(a=!0,n[n.length-1]=""),s=void 0}}})}catch(w){if(w!==o)throw w}return{path:n,previousNode:s,isAtPropertyKey:a,matches:w=>{let A=0;for(let q=0;A<w.length&&q<n.length;q++)if(w[A]===n[q]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}e.getLocation=b;function v(i,r=[],n=T.DEFAULT){let o=null,s=[];const h=[];function a(w){Array.isArray(s)?s.push(w):o!==null&&(s[o]=w)}return c(i,{onObjectBegin:()=>{const w={};a(w),h.push(s),s=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const w=[];a(w),h.push(s),s=w,o=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:a,onError:(w,A,q)=>{r.push({error:w,offset:A,length:q})}},n),s[0]}e.parse=v;function m(i,r=[],n=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function h(w){return o.children.push(w),w}c(i,{onObjectBegin:w=>{o=h({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,A,q)=>{o=h({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:A,length:q,parent:o})},onObjectEnd:(w,A)=>{o.length=w+A-o.offset,o=o.parent,s(w+A)},onArrayBegin:(w,A)=>{o=h({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,A)=>{o.length=w+A-o.offset,o=o.parent,s(w+A)},onLiteralValue:(w,A,q)=>{h({type:l(w),offset:A,length:q,parent:o,value:w}),s(A+q)},onSeparator:(w,A,q)=>{o.type==="property"&&(w===":"?o.colonOffset=A:w===","&&s(A))},onError:(w,A,q)=>{r.push({error:w,offset:A,length:q})}},n);const S=o.children[0];return S&&delete S.parent,S}e.parseTree=m;function f(i,r){if(!i)return;let n=i;for(const o of r)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===o){n=h.children[1],s=!0;break}if(!s)return}else{const s=o;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=f;function p(i){if(!i.parent||!i.parent.children)return[];const r=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=p;function y(i){switch(i.type){case"array":return i.children.map(y);case"object":{const r=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(r[n.children[0].value]=y(o))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=y;function u(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=u;function g(i,r,n=!1){if(u(i,r,n)){const o=i.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=r;s++){const h=g(o[s],r,n);if(h)return h}return i}}e.findNodeAtOffset=g;function c(i,r,n=T.DEFAULT){const o=L(i,!1);function s(j){return j?()=>j(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(j){return j?H=>j(H,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=s(r.onObjectBegin),S=h(r.onObjectProperty),w=s(r.onObjectEnd),A=s(r.onArrayBegin),q=s(r.onArrayEnd),U=h(r.onLiteralValue),O=h(r.onSeparator),$=s(r.onComment),k=h(r.onError),M=n&&n.disallowComments,F=n&&n.allowTrailingComma;function G(){for(;;){const j=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:M||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(j){case 12:case 13:M?W(10):$();break;case 16:W(1);break;case 15:case 14:break;default:return j}}}function W(j,H=[],_=[]){if(k(j),H.length+_.length>0){let N=o.getToken();for(;N!==17;){if(H.indexOf(N)!==-1){G();break}else if(_.indexOf(N)!==-1)break;N=G()}}}function B(j){const H=o.getTokenValue();return j?U(H):S(H),G(),!0}function z(){switch(o.getToken()){case 11:{let j=0;try{j=JSON.parse(o.getTokenValue()),typeof j!="number"&&(W(2),j=0)}catch{W(2)}U(j);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return G(),!0}function x(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(B(!1),o.getToken()===6?(O(":"),G(),se()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function J(){a(),G();let j=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(j||W(4,[],[]),O(","),G(),o.getToken()===2&&F)break}else j&&W(6,[],[]);x()||W(4,[],[2,5]),j=!0}return w(),o.getToken()!==2?W(7,[2],[]):G(),!0}function X(){A(),G();let j=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(j||W(4,[],[]),O(","),G(),o.getToken()===4&&F)break}else j&&W(6,[],[]);se()||W(4,[],[4,5]),j=!0}return q(),o.getToken()!==4?W(8,[4],[]):G(),!0}function se(){switch(o.getToken()){case 3:return X();case 1:return J();case 10:return B(!0);default:return z()}}return G(),o.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):se()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=c;function d(i,r){const n=L(i),o=[];let s,h=0,a;do switch(a=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:h!==a&&o.push(i.substring(h,a)),r!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,r)),h=n.getPosition();break}while(s!==17);return o.join("")}e.stripComments=d;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ie[46],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(E,C,b){let v,m,f,p,y;if(C){for(p=C.offset,y=p+C.length,f=p;f>0&&!I(E,f-1);)f--;let a=y;for(;a<E.length&&!I(E,a);)a++;m=E.substring(f,a),v=L(m,b)}else m=E,v=0,f=0,p=0,y=E.length;const u=P(b,E);let g=!1,c=0,d;b.insertSpaces?d=T(" ",b.tabSize||4):d="	";const l=(0,D.createScanner)(m,!1);let i=!1;function r(){return u+T(d,v+c)}function n(){let a=l.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=l.scan();return i=a===16||l.getTokenError()!==0,a}const o=[];function s(a,S,w){!i&&S<y&&w>p&&E.substring(S,w)!==a&&o.push({offset:S,length:w-S,content:a})}let h=n();if(h!==17){const a=l.getTokenOffset()+f,S=T(d,v);s(S,f,a)}for(;h!==17;){let a=l.getTokenOffset()+l.getTokenLength()+f,S=n(),w="";for(;!g&&(S===12||S===13);){const q=l.getTokenOffset()+f;s(" ",a,q),a=l.getTokenOffset()+l.getTokenLength()+f,w=S===12?r():"",S=n()}if(S===2)h!==1&&(c--,w=r());else if(S===4)h!==3&&(c--,w=r());else{switch(h){case 3:case 1:c++,w=r();break;case 5:case 12:w=r();break;case 13:g?w=r():w=" ";break;case 6:w=" ";break;case 10:if(S===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?w=" ":S!==5&&S!==17&&(i=!0);break;case 16:i=!0;break}g&&(S===12||S===13)&&(w=r())}const A=l.getTokenOffset()+f;s(w,a,A),h=S}return o}e.format=t;function R(E,C){const b=JSON.stringify(E,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?b.replace(/\r\n|\r|\n/g,C.eol):b}e.toFormattedString=R;function T(E,C){let b="";for(let v=0;v<C;v++)b+=E;return b}function L(E,C){let b=0,v=0;const m=C.tabSize||4;for(;b<E.length;){const f=E.charAt(b);if(f===" ")v++;else if(f==="	")v+=m;else break;b++}return Math.floor(v/m)}function P(E,C){for(let b=0;b<C.length;b++){const v=C.charAt(b);if(v==="\r")return b+1<C.length&&C.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function I(E,C){return`\r
`.indexOf(E.charAt(C))!==-1}e.isEOL=I}),define(ie[81],re([0,1,35,46]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,C,b){return T(E,C,void 0,b)}e.removeProperty=R;function T(E,C,b,v,m){const f=C.slice(),p=[],y=(0,D.parseTree)(E,p);let u,g;for(;f.length>0&&(g=f.pop(),u=(0,D.findNodeAtLocation)(y,f),u===void 0&&b!==void 0);)typeof g=="string"?b={[g]:b}:b=[b];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const c=(0,D.findNodeAtLocation)(u,[g]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const d=u.children.indexOf(c.parent);let l,i=c.parent.offset+c.parent.length;if(d>0){const r=u.children[d-1];l=r.offset+r.length}else l=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return L(E,{offset:l,length:i-l,content:""},v)}else return L(E,{offset:c.offset,length:c.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const d=`${JSON.stringify(g)}: ${JSON.stringify(b)}`,l=m?m(u.children.map(r=>r.children[0].value)):u.children.length;let i;if(l>0){const r=u.children[l-1];i={offset:r.offset+r.length,length:0,content:","+d}}else u.children.length===0?i={offset:u.offset+1,length:0,content:d}:i={offset:u.offset+1,length:0,content:d+","};return L(E,i,v)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let d;if(u.children.length===0||g===0)d={offset:u.offset+1,length:0,content:u.children.length===0?c:c+","};else{const l=g===-1||g>u.children.length?u.children.length:g,i=u.children[l-1];d={offset:i.offset+i.length,length:0,content:","+c}}return L(E,d,v)}else{const c=g,d=u.children[c];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===c){const i=u.children[c-1],r=i.offset+i.length,n=u.offset+u.length;l={offset:r,length:n-2-r,content:""}}else l={offset:d.offset,length:u.children[c+1].offset-d.offset,content:""};return L(E,l,v)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return L(E,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(b)},v)}}e.setProperty=T;function L(E,C,b){let v=P(E,C),m=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;m>0&&!(0,t.isEOL)(v,m-1);)m--;for(;f<v.length&&!(0,t.isEOL)(v,f);)f++}const p=(0,t.format)(v,{offset:m,length:f-m},b);for(let u=p.length-1;u>=0;u--){const g=p[u];v=P(v,g),m=Math.min(m,g.offset),f=Math.max(f,g.offset+g.length),f+=g.content.length-g.length}const y=E.length-(v.length-f)-m;return[{offset:m,length:y,content:v.substring(m,f)}]}e.withFormatting=L;function P(E,C){return E.substring(0,C.offset)+C.content+E.substring(C.offset+C.length)}e.applyEdit=P;function I(E,C){const b=C.slice(0).sort((m,f)=>{const p=m.offset-f.offset;return p===0?m.length-f.length:p});let v=E.length;for(let m=b.length-1;m>=0;m--){const f=b[m];if(f.offset+f.length<=v)E=P(E,f);else throw new Error("Overlapping edit");v=f.offset}return E}e.applyEdits=I}),define(ie[121],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(ie[2],re([0,1,80,64]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function L(h){T=h}if(e.setDisposableTracker=L,R){const h="__is_disposable_tracked__";L(new class{trackDisposable(a){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[h]||console.log(S)},3e3)}setParent(a,S){if(a&&a!==g.None)try{a[h]=!0}catch{}}markAsDisposed(a){if(a&&a!==g.None)try{a[h]=!0}catch{}}markAsSingleton(a){}})}function P(h){return T?.trackDisposable(h),h}function I(h){T?.markAsDisposed(h)}function E(h,a){T?.setParent(h,a)}function C(h,a){if(!!T)for(const S of h)T.setParent(S,a)}function b(h){return T?.markAsSingleton(h),h}e.markAsSingleton=b;function v(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=v;function m(h){if(t.Iterable.is(h)){const a=[];for(const S of h)if(S)try{S.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.dispose=m;function f(h){for(const a of h)v(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function p(...h){const a=y(()=>m(h));return C(h,a),a}e.combinedDisposable=p;function y(h){const a=P({dispose:(0,D.once)(()=>{I(a),h()})});return a}e.toDisposable=y;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new u,P(this),E(this._store,this)}dispose(){I(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=c;class d{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let S=a;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,I(this))},this}}e.SafeDisposable=l;class i{constructor(){this.references=new Map}acquire(a,...S){let w=this.references.get(a);w||(w={counter:0,object:this.createReferencedObject(a,...S)},this.references.set(a,w));const{object:A}=w,q=(0,D.once)(()=>{--w.counter===0&&(this.destroyReferencedObject(a,w.object),this.references.delete(a))});return w.counter++,{object:A,dispose:q}}}e.ReferenceCollection=i;class r{constructor(a){this.referenceCollection=a}async acquire(a,...S){const w=this.referenceCollection.acquire(a,...S);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(A){throw w.dispose(),A}}}e.AsyncReferenceCollection=r;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function o(h){const a=new u;try{h(a)}finally{a.dispose()}}e.disposeOnReturn=o;class s{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){I(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,S,w=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this._store.get(a)?.dispose(),this._store.set(a,S)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(ie[82],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class t{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const L=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=L}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,L){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(L){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),define(ie[40],re([0,1]),function(Q,e){"use strict";var D,t,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(f,p,y){let u=f.get(p);return u===void 0&&(u=y,f.set(p,u)),u}e.getOrSet=T;function L(f){const p=[];return f.forEach((y,u)=>{p.push(`${u} => ${y}`)}),`Map(${f.size}) {${p.join(", ")}}`}e.mapToString=L;function P(f){const p=[];return f.forEach(y=>{p.push(y)}),`Set(${f.size}) {${p.join(", ")}}`}e.setToString=P;class I{constructor(p,y){this.uri=p,this.value=y}}class E{constructor(p,y){this[D]="ResourceMap",p instanceof E?(this.map=new Map(p.map),this.toKey=y??E.defaultToKey):(this.map=new Map,this.toKey=p??E.defaultToKey)}set(p,y){return this.map.set(this.toKey(p),new I(p,y)),this}get(p){return this.map.get(this.toKey(p))?.value}has(p){return this.map.has(this.toKey(p))}get size(){return this.map.size}clear(){this.map.clear()}delete(p){return this.map.delete(this.toKey(p))}forEach(p,y){typeof y<"u"&&(p=p.bind(y));for(const[u,g]of this.map)p(g.value,g.uri,this)}*values(){for(const p of this.map.values())yield p.value}*keys(){for(const p of this.map.values())yield p.uri}*entries(){for(const p of this.map.values())yield[p.uri,p.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.map)yield[p.uri,p.value]}}e.ResourceMap=E,E.defaultToKey=f=>f.toString();class C{constructor(p,y){this[t]="ResourceSet",!p||typeof p=="function"?this._map=new E(p):(this._map=new E(y),p.forEach(this.add,this))}get size(){return this._map.size}add(p){return this._map.set(p,p),this}clear(){this._map.clear()}delete(p){return this._map.delete(p)}forEach(p,y){this._map.forEach((u,g)=>p.call(y,g,g,this))}has(p){return this._map.has(p)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class v{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(p){return this._map.has(p)}get(p,y=0){const u=this._map.get(p);if(!!u)return y!==0&&this.touch(u,y),u.value}set(p,y,u=0){let g=this._map.get(p);if(g)g.value=y,u!==0&&this.touch(g,u);else{switch(g={key:p,value:y,next:void 0,previous:void 0},u){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(p,g),this._size++}return this}delete(p){return!!this.remove(p)}remove(p){const y=this._map.get(p);if(!!y)return this._map.delete(p),this.removeItem(y),this._size--,y.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const p=this._head;return this._map.delete(p.key),this.removeItem(p),this._size--,p.value}forEach(p,y){const u=this._state;let g=this._head;for(;g;){if(y?p.bind(y)(g.value,g.key,this):p(g.value,g.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const p=this,y=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(p._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return g}values(){const p=this,y=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(p._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return g}entries(){const p=this,y=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(p._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return g}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(p){if(p>=this.size)return;if(p===0){this.clear();return}let y=this._head,u=this.size;for(;y&&u>p;)this._map.delete(y.key),y=y.next,u--;this._head=y,this._size=u,y&&(y.previous=void 0),this._state++}addItemFirst(p){if(!this._head&&!this._tail)this._tail=p;else if(this._head)p.next=this._head,this._head.previous=p;else throw new Error("Invalid list");this._head=p,this._state++}addItemLast(p){if(!this._head&&!this._tail)this._head=p;else if(this._tail)p.previous=this._tail,this._tail.next=p;else throw new Error("Invalid list");this._tail=p,this._state++}removeItem(p){if(p===this._head&&p===this._tail)this._head=void 0,this._tail=void 0;else if(p===this._head){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this._head=p.next}else if(p===this._tail){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this._tail=p.previous}else{const y=p.next,u=p.previous;if(!y||!u)throw new Error("Invalid list");y.previous=u,u.next=y}p.next=void 0,p.previous=void 0,this._state++}touch(p,y){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(p===this._head)return;const u=p.next,g=p.previous;p===this._tail?(g.next=void 0,this._tail=g):(u.previous=g,g.next=u),p.previous=void 0,p.next=this._head,this._head.previous=p,this._head=p,this._state++}else if(y===2){if(p===this._tail)return;const u=p.next,g=p.previous;p===this._head?(u.previous=void 0,this._head=u):(u.previous=g,g.next=u),p.next=void 0,p.previous=this._tail,this._tail.next=p,this._tail=p,this._state++}}}toJSON(){const p=[];return this.forEach((y,u)=>{p.push([u,y])}),p}fromJSON(p){this.clear();for(const[y,u]of p)this.set(y,u)}}e.LinkedMap=v;class m extends v{constructor(p,y=1){super(),this._limit=p,this._ratio=Math.min(Math.max(0,y),1)}get limit(){return this._limit}set limit(p){this._limit=p,this.checkTrim()}get ratio(){return this._ratio}set ratio(p){this._ratio=Math.min(Math.max(0,p),1),this.checkTrim()}get(p,y=2){return super.get(p,y)}peek(p){return super.get(p,0)}set(p,y){return super.set(p,y,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(ie[83],re([0,1,40]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new D.LRUCache(1e4);function R(E){return I(E,"NFC",t)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function L(E){return I(E,"NFD",T)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function I(E,C,b){if(!E)return E;const v=b.get(E);if(v)return v;let m;return P.test(E)?m=E.normalize(C):m=E,b.set(E,m),m}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(C){return L(C).replace(E,"")}}()}),function(){function Q(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function L(I){T.push(I,Date.now())}function P(){const I=[];for(let E=0;E<T.length;E+=2)I.push({name:T[E],startTime:T[E+1]});return I}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(R+L.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=D(t))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var t in D)(typeof exports=="object"?exports:Q)[t]=D[t]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(t){if(e[t])return e[t].exports;var R=e[t]={i:t,l:!1,exports:{}};return Q[t].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(t,R,T){D.o(t,R)||Object.defineProperty(t,R,{enumerable:!0,get:T})},D.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},D.t=function(t,R){if(1&R&&(t=D(t)),8&R||4&R&&typeof t=="object"&&t&&t.__esModule)return t;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:t}),2&R&&typeof t!="string")for(var L in t)D.d(T,L,function(P){return t[P]}.bind(null,L));return T},D.n=function(t){var R=t&&t.__esModule?function(){return t.default}:function(){return t};return D.d(R,"a",R),R},D.o=function(t,R){return Object.prototype.hasOwnProperty.call(t,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(t){var R;e=Q.exports=_,R=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],E=0,C=E++;I[C]="0|[1-9]\\d*";var b=E++;I[b]="[0-9]+";var v=E++;I[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=E++;I[m]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var f=E++;I[f]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var p=E++;I[p]="(?:"+I[C]+"|"+I[v]+")";var y=E++;I[y]="(?:"+I[b]+"|"+I[v]+")";var u=E++;I[u]="(?:-("+I[p]+"(?:\\."+I[p]+")*))";var g=E++;I[g]="(?:-?("+I[y]+"(?:\\."+I[y]+")*))";var c=E++;I[c]="[0-9A-Za-z-]+";var d=E++;I[d]="(?:\\+("+I[c]+"(?:\\."+I[c]+")*))";var l=E++,i="v?"+I[m]+I[u]+"?"+I[d]+"?";I[l]="^"+i+"$";var r="[v=\\s]*"+I[f]+I[g]+"?"+I[d]+"?",n=E++;I[n]="^"+r+"$";var o=E++;I[o]="((?:<|>)?=?)";var s=E++;I[s]=I[b]+"|x|X|\\*";var h=E++;I[h]=I[C]+"|x|X|\\*";var a=E++;I[a]="[v=\\s]*("+I[h]+")(?:\\.("+I[h]+")(?:\\.("+I[h]+")(?:"+I[u]+")?"+I[d]+"?)?)?";var S=E++;I[S]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[g]+")?"+I[d]+"?)?)?";var w=E++;I[w]="^"+I[o]+"\\s*"+I[a]+"$";var A=E++;I[A]="^"+I[o]+"\\s*"+I[S]+"$";var q=E++;I[q]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=E++;I[U]="(?:~>?)";var O=E++;I[O]="(\\s*)"+I[U]+"\\s+",P[O]=new RegExp(I[O],"g");var $=E++;I[$]="^"+I[U]+I[a]+"$";var k=E++;I[k]="^"+I[U]+I[S]+"$";var M=E++;I[M]="(?:\\^)";var F=E++;I[F]="(\\s*)"+I[M]+"\\s+",P[F]=new RegExp(I[F],"g");var G=E++;I[G]="^"+I[M]+I[a]+"$";var W=E++;I[W]="^"+I[M]+I[S]+"$";var B=E++;I[B]="^"+I[o]+"\\s*("+r+")$|^$";var z=E++;I[z]="^"+I[o]+"\\s*("+i+")$|^$";var x=E++;I[x]="(\\s*)"+I[o]+"\\s*("+r+"|"+I[a]+")",P[x]=new RegExp(I[x],"g");var J=E++;I[J]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var X=E++;I[X]="^\\s*("+I[S]+")\\s+-\\s+("+I[S]+")\\s*$";var se=E++;I[se]="(<|>)?=?\\s*\\*";for(var j=0;j<35;j++)R(j,I[j]),P[j]||(P[j]=new RegExp(I[j]));function H(ce,fe){if(ce instanceof _)return ce;if(typeof ce!="string"||ce.length>T||!(fe?P[n]:P[l]).test(ce))return null;try{return new _(ce,fe)}catch{return null}}function _(ce,fe){if(ce instanceof _){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof _))return new _(ce,fe);R("SemVer",ce,fe),this.loose=fe;var ge=ce.trim().match(fe?P[n]:P[l]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<L)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=H,e.valid=function(ce,fe){var ge=H(ce,fe);return ge?ge.version:null},e.clean=function(ce,fe){var ge=H(ce.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ce){return R("SemVer.compare",this.version,this.loose,ce),ce instanceof _||(ce=new _(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},_.prototype.compareMain=function(ce){return ce instanceof _||(ce=new _(ce,this.loose)),V(this.major,ce.major)||V(this.minor,ce.minor)||V(this.patch,ce.patch)},_.prototype.comparePre=function(ce){if(ce instanceof _||(ce=new _(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ce.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return V(ge,be)}while(++fe)},_.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new _(ce,ge).inc(fe,be).version}catch{return null}},e.diff=function(ce,fe){if(Z(ce,fe))return null;var ge=H(ce),be=H(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=V;var N=/^[0-9]+$/;function V(ce,fe){var ge=N.test(ce),be=N.test(fe);return ge&&be&&(ce=+ce,fe=+fe),ge&&!be?-1:be&&!ge?1:ce<fe?-1:ce>fe?1:0}function K(ce,fe,ge){return new _(ce,ge).compare(new _(fe,ge))}function ee(ce,fe,ge){return K(ce,fe,ge)>0}function ae(ce,fe,ge){return K(ce,fe,ge)<0}function Z(ce,fe,ge){return K(ce,fe,ge)===0}function ne(ce,fe,ge){return K(ce,fe,ge)!==0}function oe(ce,fe,ge){return K(ce,fe,ge)>=0}function ue(ce,fe,ge){return K(ce,fe,ge)<=0}function de(ce,fe,ge,be){var Ie;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Ie=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Ie=ce!==ge;break;case"":case"=":case"==":Ie=Z(ce,ge,be);break;case"!=":Ie=ne(ce,ge,be);break;case">":Ie=ee(ce,ge,be);break;case">=":Ie=oe(ce,ge,be);break;case"<":Ie=ae(ce,ge,be);break;case"<=":Ie=ue(ce,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function ve(ce,fe){if(ce instanceof ve){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof ve))return new ve(ce,fe);R("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ce,fe){return V(fe,ce)},e.major=function(ce,fe){return new _(ce,fe).major},e.minor=function(ce,fe){return new _(ce,fe).minor},e.patch=function(ce,fe){return new _(ce,fe).patch},e.compare=K,e.compareLoose=function(ce,fe){return K(ce,fe,!0)},e.rcompare=function(ce,fe,ge){return K(fe,ce,ge)},e.sort=function(ce,fe){return ce.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ce,fe){return ce.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=ee,e.lt=ae,e.eq=Z,e.neq=ne,e.gte=oe,e.lte=ue,e.cmp=de,e.Comparator=ve;var we={};function Ee(ce,fe){if(ce instanceof Ee)return ce.loose===fe?ce:new Ee(ce.raw,fe);if(ce instanceof ve)return new Ee(ce.value,fe);if(!(this instanceof Ee))return new Ee(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Pe(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Oe(ce,fe,ge,be,Ie,Te,Re,Ne,_e,Me,We,ke,Ae){return((fe=Pe(ge)?"":Pe(be)?">="+ge+".0.0":Pe(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Ne=Pe(_e)?"":Pe(Me)?"<"+(+_e+1)+".0.0":Pe(We)?"<"+_e+"."+(+Me+1)+".0":ke?"<="+_e+"."+Me+"."+We+"-"+ke:"<="+Ne)).trim()}function $e(ce,fe){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ce.length;ge++)if(R(ce[ge].semver),ce[ge].semver!==we&&ce[ge].semver.prerelease.length>0){var be=ce[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function Ve(ce,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ce)}function Je(ce,fe,ge,be){var Ie,Te,Re,Ne,_e;switch(ce=new _(ce,be),fe=new Ee(fe,be),ge){case">":Ie=ee,Te=ue,Re=ae,Ne=">",_e=">=";break;case"<":Ie=ae,Te=oe,Re=ee,Ne="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ce,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var We=fe.set[Me],ke=null,Ae=null;if(We.forEach(function(te){te.semver===we&&(te=new ve(">=0.0.0")),ke=ke||te,Ae=Ae||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,Ae.semver,be)&&(Ae=te)}),ke.operator===Ne||ke.operator===_e||(!Ae.operator||Ae.operator===Ne)&&Te(ce,Ae.semver)||Ae.operator===_e&&Re(ce,Ae.semver))return!1}return!0}ve.prototype.parse=function(ce){var fe=this.loose?P[B]:P[z],ge=ce.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new _(ge[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ce){return R("Comparator.test",ce,this.loose),this.semver===we||(typeof ce=="string"&&(ce=new _(ce,this.loose)),de(ce,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ce,fe){if(!(ce instanceof ve))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ce.value,fe),Ve(this.value,ge,fe);if(ce.operator==="")return ge=new Ee(this.value,fe),Ve(ce.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Te=this.semver.version===ce.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ne=de(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),_e=de(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return be||Ie||Te&&Re||Ne||_e},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),R("range",ce,fe);var ge=fe?P[X]:P[J];ce=ce.replace(ge,Oe),R("hyphen replace",ce),ce=ce.replace(P[x],"$1$2$3"),R("comparator trim",ce,P[x]),ce=(ce=(ce=ce.replace(P[O],"$1~")).replace(P[F],"$1^")).split(/\s+/).join(" ");var be=fe?P[B]:P[z],Ie=ce.split(" ").map(function(Te){return function(Re,Ne){return R("comp",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(We){return function(ke,Ae){R("caret",ke,Ae);var te=Ae?P[W]:P[G];return ke.replace(te,function(le,he,me,Se,Ce){var De;return R("caret",ke,le,he,me,Se,Ce),Pe(he)?De="":Pe(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Pe(Se)?De=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Ce?(R("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Ce+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Ce+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Ce+" <"+(+he+1)+".0.0"):(R("no pr"),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),R("caret return",De),De})}(We,Me)}).join(" ")}(Re,Ne),R("caret",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(We){return function(ke,Ae){var te=Ae?P[k]:P[$];return ke.replace(te,function(le,he,me,Se,Ce){var De;return R("tilde",ke,le,he,me,Se,Ce),Pe(he)?De="":Pe(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Pe(Se)?De=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Ce?(R("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),De=">="+he+"."+me+"."+Se+Ce+" <"+he+"."+(+me+1)+".0"):De=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",R("tilde return",De),De})}(We,Me)}).join(" ")}(Re,Ne),R("tildes",Re),Re=function(_e,Me){return R("replaceXRanges",_e,Me),_e.split(/\s+/).map(function(We){return function(ke,Ae){ke=ke.trim();var te=Ae?P[A]:P[w];return ke.replace(te,function(le,he,me,Se,Ce,De){R("xRange",ke,le,he,me,Se,Ce,De);var ze=Pe(me),Fe=ze||Pe(Se),Le=Fe||Pe(Ce);return he==="="&&Le&&(he=""),ze?le=he===">"||he==="<"?"<0.0.0":"*":he&&Le?(Fe&&(Se=0),Le&&(Ce=0),he===">"?(he=">=",Fe?(me=+me+1,Se=0,Ce=0):Le&&(Se=+Se+1,Ce=0)):he==="<="&&(he="<",Fe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Ce):Fe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",le),le})}(We,Me)}).join(" ")}(Re,Ne),R("xrange",Re),Re=function(_e,Me){return R("replaceStars",_e,Me),_e.trim().replace(P[se],"")}(Re,Ne),R("stars",Re),Re}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Te){return!!Te.match(be)})),Ie=Ie.map(function(Te){return new ve(Te,fe)})},Ee.prototype.intersects=function(ce,fe){if(!(ce instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ce.set.some(function(Ie){return Ie.every(function(Te){return be.intersects(Te,fe)})})})})},e.toComparators=function(ce,fe){return new Ee(ce,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new _(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if($e(this.set[fe],ce))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ce,fe,ge){var be=null,Ie=null;try{var Te=new Ee(fe,ge)}catch{return null}return ce.forEach(function(Re){Te.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new _(be=Re,ge)))}),be},e.minSatisfying=function(ce,fe,ge){var be=null,Ie=null;try{var Te=new Ee(fe,ge)}catch{return null}return ce.forEach(function(Re){Te.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new _(be=Re,ge)))}),be},e.validRange=function(ce,fe){try{return new Ee(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,ge){return Je(ce,fe,"<",ge)},e.gtr=function(ce,fe,ge){return Je(ce,fe,">",ge)},e.outside=Je,e.prerelease=function(ce,fe){var ge=H(ce,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,fe,ge){return ce=new Ee(ce,ge),fe=new Ee(fe,ge),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof _)return ce;if(typeof ce!="string")return null;var fe=ce.match(P[q]);return fe==null?null:H((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,t,R=Q.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(y){if(D===setTimeout)return setTimeout(y,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{t=typeof clearTimeout=="function"?clearTimeout:L}catch{t=L}})();var I,E=[],C=!1,b=-1;function v(){C&&I&&(C=!1,I.length?E=I.concat(E):b=-1,E.length&&m())}function m(){if(!C){var y=P(v);C=!0;for(var u=E.length;u;){for(I=E,E=[];++b<u;)I&&I[b].run();b=-1,u=E.length}I=null,C=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===L||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(y)}}function f(y,u){this.fun=y,this.array=u}function p(){}R.nextTick=function(y){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];E.push(new f(y,u)),E.length!==1||C||P(m)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=p,R.addListener=p,R.once=p,R.off=p,R.removeListener=p,R.removeAllListeners=p,R.emit=p,R.prependListener=p,R.prependOnceListener=p,R.listeners=function(y){return[]},R.binding=function(y){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(y){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[122],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,I,E){this.level=P,this.key=I,this.value=E,this.forward=[]}}const R=void 0;class T{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new t(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,R,R)}has(P){return Boolean(T._search(this,P,this.comparator))}get(P){return T._search(this,P,this.comparator)?.value}set(P,I){return T._insert(this,P,I,this.comparator)&&(this._size+=1),this}delete(P){const I=T._delete(this,P,this.comparator);return I&&(this._size-=1),I}forEach(P,I){let E=this._header.forward[0];for(;E;)P.call(I,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this._header.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static _search(P,I,E){let C=P._header;for(let b=P._level-1;b>=0;b--)for(;C.forward[b]&&E(C.forward[b].key,I)<0;)C=C.forward[b];if(C=C.forward[0],C&&E(C.key,I)===0)return C}static _insert(P,I,E,C){const b=[];let v=P._header;for(let m=P._level-1;m>=0;m--){for(;v.forward[m]&&C(v.forward[m].key,I)<0;)v=v.forward[m];b[m]=v}if(v=v.forward[0],v&&C(v.key,I)===0)return v.value=E,!1;{const m=T._randomLevel(P);if(m>P._level){for(let f=P._level;f<m;f++)b[f]=P._header;P._level=m}v=new t(m,I,E);for(let f=0;f<m;f++)v.forward[f]=b[f].forward[f],b[f].forward[f]=v;return!0}}static _randomLevel(P,I=.5){let E=1;for(;Math.random()<I&&E<P._maxLevel;)E+=1;return E}static _delete(P,I,E){const C=[];let b=P._header;for(let v=P._level-1;v>=0;v--){for(;b.forward[v]&&E(b.forward[v].key,I)<0;)b=b.forward[v];C[v]=b}if(b=b.forward[0],!b||E(b.key,I)!==0)return!1;for(let v=0;v<P._level&&C[v].forward[v]===b;v++)C[v].forward[v]=b.forward[v];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=T}),define(ie[42],re([0,1,9,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(d){const l=d;return l?typeof l.read=="function":!1}e.isReadable=R;function T(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=T;function L(d){const l=d;return l?T(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=L;function P(d,l){return new I(d,l)}e.newWriteableStream=P;class I{constructor(l,i){this.reducer=l,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(i=>i(l))}emitError(l){this.listeners.error.length===0?(0,D.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(i=>i(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,i){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(l,i){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(d,l){const i=[];let r;for(;(r=d.read())!==null;)i.push(r);return l(i)}e.consumeReadable=E;function C(d,l,i){const r=[];let n;for(;(n=d.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return d.read()}}}e.peekReadable=C;function b(d,l){return new Promise((i,r)=>{const n=[];v(d,{onData:o=>{l&&n.push(o)},onError:o=>{l?r(o):i(void 0)},onEnd:()=>{i(l?l(n):void 0)}})})}e.consumeStream=b;function v(d,l){let i=!1;return d.on("error",r=>{i||l.onError(r)}),d.on("end",()=>{i||l.onEnd()}),d.on("data",r=>{i||l.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function m(d,l){return new Promise((i,r)=>{const n=new t.DisposableStore,o=[],s=S=>{if(o.push(S),o.length>l)return n.dispose(),d.pause(),i({stream:d,buffer:o,ended:!1})},h=S=>r(S),a=()=>i({stream:d,buffer:o,ended:!0});n.add((0,t.toDisposable)(()=>d.removeListener("error",h))),d.on("error",h),n.add((0,t.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,t.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=m;function f(d,l){const i=P(l);return i.end(d),i}e.toStream=f;function p(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=p;function y(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=y;function u(d,l,i){const r=P(i);return v(d,{onData:n=>r.write(l.data(n)),onError:n=>r.error(l.error?l.error(n):n),onEnd:()=>r.end()}),r}e.transform=u;function g(d,l,i){let r=!1;return{read:()=>{const n=l.read();return r?n:(r=!0,n!==null?i([d,n]):d)}}}e.prefixedReadable=g;function c(d,l,i){let r=!1;const n=P(i);return v(l,{onData:o=>r?n.write(o):(r=!0,n.write(i([d,o]))),onError:o=>n.error(o),onEnd:()=>{r||(r=!0,n.write(d)),n.end()}}),n}e.prefixedStream=c}),define(ie[17],re([0,1,42]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let R,T;class L{static alloc(S){return t?new L(Buffer.allocUnsafe(S)):new L(new Uint8Array(S))}static wrap(S){return t&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new L(S)}static fromString(S,w){return!(w?.dontUseNodeBuffer||!1)&&t?new L(Buffer.from(S)):(R||(R=new TextEncoder),new L(R.encode(S)))}static fromByteArray(S){const w=L.alloc(S.length);for(let A=0,q=S.length;A<q;A++)w.buffer[A]=S[A];return w}static concat(S,w){if(typeof w>"u"){w=0;for(let U=0,O=S.length;U<O;U++)w+=S[U].byteLength}const A=L.alloc(w);let q=0;for(let U=0,O=S.length;U<O;U++){const $=S[U];A.set($,q),q+=$.byteLength}return A}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=L.alloc(this.byteLength);return S.set(this),S}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(S,w){return new L(this.buffer.subarray(S,w))}set(S,w){if(S instanceof L)this.buffer.set(S.buffer,w);else if(S instanceof Uint8Array)this.buffer.set(S,w);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),w);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return E(this.buffer,S)}writeUInt32BE(S,w){C(this.buffer,S,w)}readUInt32LE(S){return b(this.buffer,S)}writeUInt32LE(S,w){v(this.buffer,S,w)}readUInt8(S){return m(this.buffer,S)}writeUInt8(S,w){f(this.buffer,S,w)}}e.VSBuffer=L;function P(a,S){return a[S+0]<<0>>>0|a[S+1]<<8>>>0}e.readUInt16LE=P;function I(a,S,w){a[w+0]=S&255,S=S>>>8,a[w+1]=S&255}e.writeUInt16LE=I;function E(a,S){return a[S]*2**24+a[S+1]*2**16+a[S+2]*2**8+a[S+3]}e.readUInt32BE=E;function C(a,S,w){a[w+3]=S,S=S>>>8,a[w+2]=S,S=S>>>8,a[w+1]=S,S=S>>>8,a[w]=S}e.writeUInt32BE=C;function b(a,S){return a[S+0]<<0>>>0|a[S+1]<<8>>>0|a[S+2]<<16>>>0|a[S+3]<<24>>>0}e.readUInt32LE=b;function v(a,S,w){a[w+0]=S&255,S=S>>>8,a[w+1]=S&255,S=S>>>8,a[w+2]=S&255,S=S>>>8,a[w+3]=S&255}e.writeUInt32LE=v;function m(a,S){return a[S]}e.readUInt8=m;function f(a,S,w){a[w]=S}e.writeUInt8=f;function p(a){return D.consumeReadable(a,S=>L.concat(S))}e.readableToBuffer=p;function y(a){return D.toReadable(a)}e.bufferToReadable=y;function u(a){return D.consumeStream(a,S=>L.concat(S))}e.streamToBuffer=u;async function g(a){return a.ended?L.concat(a.buffer):L.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=g;function c(a){return D.toStream(a,S=>L.concat(S))}e.bufferToStream=c;function d(a){return D.transform(a,{data:S=>typeof S=="string"?L.fromString(S):L.wrap(S)},S=>L.concat(S))}e.streamToBufferReadableStream=d;function l(a){return D.newWriteableStream(S=>L.concat(S),a)}e.newWriteableBufferStream=l;function i(a,S){return D.prefixedReadable(a,S,w=>L.concat(w))}e.prefixedBufferReadable=i;function r(a,S){return D.prefixedStream(a,S,w=>L.concat(w))}e.prefixedBufferStream=r;function n(a){let S=0,w=0,A=0;const q=new Uint8Array(Math.floor(a.length/4*3)),U=$=>{switch(w){case 3:q[A++]=S|$,w=0;break;case 2:q[A++]=S|$>>>2,S=$<<6,w=3;break;case 1:q[A++]=S|$>>>4,S=$<<4,w=2;break;default:S=$<<2,w=1}};for(let $=0;$<a.length;$++){const k=a.charCodeAt($);if(k>=65&&k<=90)U(k-65);else if(k>=97&&k<=122)U(k-97+26);else if(k>=48&&k<=57)U(k-48+52);else if(k===43||k===45)U(62);else if(k===47||k===95)U(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${a[$]}`)}}const O=A;for(;w>0;)U(0);return L.wrap(q).slice(0,O)}e.decodeBase64=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:a},S=!0,w=!1){const A=w?s:o;let q="";const U=a.byteLength%3;let O=0;for(;O<a.byteLength-U;O+=3){const $=a[O+0],k=a[O+1],M=a[O+2];q+=A[$>>>2],q+=A[($<<4|k>>>4)&63],q+=A[(k<<2|M>>>6)&63],q+=A[M&63]}if(U===1){const $=a[O+0];q+=A[$>>>2],q+=A[$<<4&63],S&&(q+="==")}else if(U===2){const $=a[O+0],k=a[O+1];q+=A[$>>>2],q+=A[($<<4|k>>>4)&63],q+=A[k<<2&63],S&&(q+="=")}return q}e.encodeBase64=h}),define(ie[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(r){return typeof r=="string"}e.isString=D;function t(r){return Array.isArray(r)&&r.every(n=>D(n))}e.isStringArray=t;function R(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=R;function T(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=T;function L(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=L;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function I(r){return r===!0||r===!1}e.isBoolean=I;function E(r){return typeof r>"u"}e.isUndefined=E;function C(r){return!b(r)}e.isDefined=C;function b(r){return E(r)||r===null}e.isUndefinedOrNull=b;function v(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=v;function m(r){if(b(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=m;function f(...r){const n=[];for(let o=0;o<r.length;o++){const s=r[o];if(b(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(s)}return n}e.assertAllDefined=f;const p=Object.prototype.hasOwnProperty;function y(r){if(!R(r))return!1;for(const n in r)if(p.call(r,n))return!1;return!0}e.isEmptyObject=y;function u(r){return typeof r=="function"}e.isFunction=u;function g(...r){return r.length>0&&r.every(u)}e.areFunctions=g;function c(r,n){const o=Math.min(r.length,n.length);for(let s=0;s<o;s++)d(r[s],n[s])}e.validateConstraints=c;function d(r,n){if(D(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(r instanceof n)return}catch{}if(!b(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function l(r){return r===null?void 0:r}e.withNullAsUndefined=l;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(ie[32],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([c,d])=>{g[c]=d&&typeof d=="object"?t(d):d}),g}e.deepClone=t;function R(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const c=g.shift();Object.freeze(c);for(const d in c)if(T.call(c,d)){const l=c[d];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.isTypedArray)(l)&&g.push(l)}}return u}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function L(u,g){return P(u,g,new Set)}e.cloneAndChange=L;function P(u,g,c){if((0,D.isUndefinedOrNull)(u))return u;const d=g(u);if(typeof d<"u")return d;if(Array.isArray(u)){const l=[];for(const i of u)l.push(P(i,g,c));return l}if((0,D.isObject)(u)){if(c.has(u))throw new Error("Cannot clone recursive data-structure");c.add(u);const l={};for(const i in u)T.call(u,i)&&(l[i]=P(u[i],g,c));return c.delete(u),l}return u}function I(u,g,c=!0){return(0,D.isObject)(u)?((0,D.isObject)(g)&&Object.keys(g).forEach(d=>{d in u?c&&((0,D.isObject)(u[d])&&(0,D.isObject)(g[d])?I(u[d],g[d],c):u[d]=g[d]):u[d]=g[d]}),u):g}e.mixin=I;function E(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let c,d;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(c=0;c<u.length;c++)if(!E(u[c],g[c]))return!1}else{const l=[];for(d in u)l.push(d);l.sort();const i=[];for(d in g)i.push(d);if(i.sort(),!E(l,i))return!1;for(c=0;c<l.length;c++)if(!E(u[l[c]],g[l[c]]))return!1}return!0}e.equals=E;function C(u){const g=new Set;return JSON.stringify(u,(c,d)=>{if((0,D.isObject)(d)||Array.isArray(d)){if(g.has(d))return"[Circular]";g.add(d)}return d})}e.safeStringify=C;function b(u,g){const c=Object.create(null);return!u||!g||Object.keys(g).forEach(l=>{const i=u[l],r=g[l];E(i,r)||(c[l]=r)}),c}e.distinct=b;function v(u,g){const c=g.toLowerCase(),d=Object.keys(u).find(l=>l.toLowerCase()===c);return d?u[d]:u[g]}e.getCaseInsensitive=v;function m(u,g){const c=Object.create(null);for(const[d,l]of Object.entries(u))g(d,l)&&(c[d]=l);return c}e.filter=m;function f(u){let g=[],c=Object.getPrototypeOf(u);for(;Object.prototype!==c;)g=g.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return g}e.getAllPropertyNames=f;function p(u){const g=[];for(const c of f(u))typeof u[c]=="function"&&g.push(c);return g}e.getAllMethodNames=p;function y(u,g){const c=l=>function(){const i=Array.prototype.slice.call(arguments,0);return g(l,i)},d={};for(const l of u)d[l]=c(l);return d}e.createProxyObject=y}),define(ie[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(R){return D.test(R)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const T=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){R(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let I=0,E="";return E+=L[T[I++]],E+=L[T[I++]],E+=L[T[I++]],E+=L[T[I++]],E+="-",E+=L[T[I++]],E+=L[T[I++]],E+="-",E+=L[T[I++]],E+=L[T[I++]],E+="-",E+=L[T[I++]],E+=L[T[I++]],E+="-",E+=L[T[I++]],E+=L[T[I++]],E+=L[T[I++]],E+=L[T[I++]],E+=L[T[I++]],E+=L[T[I++]],E}}()}),define(ie[123],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(L){const P=L.replace(/\-/g,":").toLowerCase();return!t.has(P)}function T(){const L=(0,D.networkInterfaces)();for(const P in L){const I=L[P];if(I){for(const{mac:E}of I)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ie[124],re([0,1,84]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,I,E,C=1){let b=!1;return new Promise(v=>{const m=setTimeout(()=>{if(!b)return b=!0,v(0)},E);R(P,I,C,f=>{if(!b)return b=!0,clearTimeout(m),v(f)})})}e.findFreePort=t;function R(P,I,E,C){if(I===0)return C(0);const b=new D.Socket;b.once("connect",()=>(L(b),R(P+E,I-1,E,C))),b.once("data",()=>{}),b.once("error",v=>(L(b),v.code!=="ECONNREFUSED"?R(P+E,I-1,E,C):C(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(P,I,E,C="127.0.0.1"){let b=!1,v,m=1;const f=D.createServer({pauseOnConnect:!0});function p(y,u){b||(b=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),u(y))}return new Promise(y=>{v=setTimeout(()=>{p(0,y)},E),f.on("listening",()=>{p(P,y)}),f.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&m<I?(P++,m++,f.listen(P,C)):p(0,y)}),f.on("close",()=>{p(0,y)}),f.listen(P,C)})}e.findFreePortFaster=T;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(ie[125],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function t(T){return T instanceof R?!0:T instanceof Error&&T.name===D&&T.message===D}e.isOfflineError=t;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(ie[126],re([0,1,17,9,125]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(I,E){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((b,v)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),L(C,I),C.responseType="arraybuffer",C.onerror=m=>v(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=m=>{b({res:{statusCode:C.status,headers:P(C)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=m=>v(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),E.onCancellationRequested(()=>{C.abort(),v((0,t.canceled)())})})}e.request=T;function L(I,E){if(E.headers){e:for(const C in E.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,E.headers[C])}}}function P(I){const E=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const b=C.indexOf(":");E[C.substr(0,b).trim().toLowerCase()]=C.substr(b+1).trim()}return E}}),define(ie[127],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ie[65],re([0,1,127]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,R=t*60,T=R*24,L=T*7,P=T*30,I=T*365;function E(b,v,m){typeof b!="number"&&(b=b.getTime());const f=Math.round((new Date().getTime()-b)/1e3);if(f<-30)return(0,D.localize)(0,null,E(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let p;return f<t?(p=f,v?p===1?m?(0,D.localize)(2,null,p):(0,D.localize)(3,null,p):m?(0,D.localize)(4,null,p):(0,D.localize)(5,null,p):p===1?m?(0,D.localize)(6,null,p):(0,D.localize)(7,null,p):m?(0,D.localize)(8,null,p):(0,D.localize)(9,null,p)):f<R?(p=Math.floor(f/t),v?p===1?m?(0,D.localize)(10,null,p):(0,D.localize)(11,null,p):m?(0,D.localize)(12,null,p):(0,D.localize)(13,null,p):p===1?m?(0,D.localize)(14,null,p):(0,D.localize)(15,null,p):m?(0,D.localize)(16,null,p):(0,D.localize)(17,null,p)):f<T?(p=Math.floor(f/R),v?p===1?m?(0,D.localize)(18,null,p):(0,D.localize)(19,null,p):m?(0,D.localize)(20,null,p):(0,D.localize)(21,null,p):p===1?m?(0,D.localize)(22,null,p):(0,D.localize)(23,null,p):m?(0,D.localize)(24,null,p):(0,D.localize)(25,null,p)):f<L?(p=Math.floor(f/T),v?p===1?(0,D.localize)(26,null,p):(0,D.localize)(27,null,p):p===1?(0,D.localize)(28,null,p):(0,D.localize)(29,null,p)):f<P?(p=Math.floor(f/L),v?p===1?m?(0,D.localize)(30,null,p):(0,D.localize)(31,null,p):m?(0,D.localize)(32,null,p):(0,D.localize)(33,null,p):p===1?m?(0,D.localize)(34,null,p):(0,D.localize)(35,null,p):m?(0,D.localize)(36,null,p):(0,D.localize)(37,null,p)):f<I?(p=Math.floor(f/P),v?p===1?m?(0,D.localize)(38,null,p):(0,D.localize)(39,null,p):m?(0,D.localize)(40,null,p):(0,D.localize)(41,null,p):p===1?m?(0,D.localize)(42,null,p):(0,D.localize)(43,null,p):m?(0,D.localize)(44,null,p):(0,D.localize)(45,null,p)):(p=Math.floor(f/I),v?p===1?m?(0,D.localize)(46,null,p):(0,D.localize)(47,null,p):m?(0,D.localize)(48,null,p):(0,D.localize)(49,null,p):p===1?m?(0,D.localize)(50,null,p):(0,D.localize)(51,null,p):m?(0,D.localize)(52,null,p):(0,D.localize)(53,null,p))}e.fromNow=E;function C(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(ie[128],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ie[37],re([0,1,18,15,128]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(b,v){return v&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),L(b.stack)||L(b.stacktrace)):P(b)}function L(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function I(b=null,v=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const m=D.coalesce(b),f=I(m[0],v);return m.length>1?R.localize(4,null,f,m.length):f}if(t.isString(b))return b;if(b.detail){const m=b.detail;if(m.error)return T(m.error,v);if(m.exception)return T(m.exception,v)}return b.stack?T(b,v):b.message?b.message:R.localize(5,null)}e.toErrorMessage=I;function E(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=E;function C(b,v){let m;return typeof b=="string"?m=new Error(b):m=b,m.actions=v,m}e.createErrorWithActions=C}),define(ie[129],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ie[130],re([0,1,129]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ie[131],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ie[5],re([0,1,131]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,R=!1,T=!1,L=!1,P=!1,I=!1,E=!1,C=!1,b=!1,v=!1,m,f=e.LANGUAGE_DEFAULT,p,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",c=g&&u?.type==="renderer";if(typeof navigator=="object"&&!c)y=navigator.userAgent,t=y.indexOf("Windows")>=0,R=y.indexOf("Macintosh")>=0,C=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=y.indexOf("Linux")>=0,v=y?.indexOf("Mobi")>=0,I=!0,m=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,f=m;else if(typeof u=="object"){t=u.platform==="win32",R=u.platform==="darwin",T=u.platform==="linux",L=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,E=g,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const S=JSON.parse(a),w=S.availableLanguages["*"];m=S.locale,f=w||e.LANGUAGE_DEFAULT,p=S._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var d;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let i=0;R?i=1:t?i=3:T&&(i=2),e.isWindows=t,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=L,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=v,e.isCI=b,e.platform=i,e.userAgent=y,e.language=f;var r;(function(a){function S(){return e.language}a.value=S;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=w;function A(){return e.language==="en"}a.isDefault=A})(r=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let A=0,q=a.length;A<q;A++){const U=a[A];if(U.id===w.data.vscodeScheduleAsyncWork){a.splice(A,1),U.callback();return}}});let S=0;return w=>{const A=++S;a.push({id:A,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return a=>setTimeout(a)})();var n;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:t?1:3;let o=!0,s=!1;function h(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=h,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[36],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ie[12],re([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,R=97,T=90,L=122,P=46,I=47,E=92,C=58,b=63;class v extends Error{constructor(d,l,i){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const n=d.indexOf(".")!==-1?"property":"argument";let o=`The "${d}" ${n} ${r} of type ${l}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,d){if(typeof c!="string")throw new v(d,"string",c)}function f(c){return c===I||c===E}function p(c){return c===I}function y(c){return c>=t&&c<=T||c>=R&&c<=L}function u(c,d,l,i){let r="",n=0,o=-1,s=0,h=0;for(let a=0;a<=c.length;++a){if(a<c.length)h=c.charCodeAt(a);else{if(i(h))break;h=I}if(i(h)){if(!(o===a-1||s===1))if(s===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const S=r.lastIndexOf(l);S===-1?(r="",n=0):(r=r.slice(0,S),n=r.length-1-r.lastIndexOf(l)),o=a,s=0;continue}else if(r.length!==0){r="",n=0,o=a,s=0;continue}}d&&(r+=r.length>0?`${l}..`:"..",n=2)}else r.length>0?r+=`${l}${c.slice(o+1,a)}`:r=c.slice(o+1,a),n=a-o-1;o=a,s=0}else h===P&&s!==-1?++s:s=-1}return r}function g(c,d){if(d===null||typeof d!="object")throw new v("pathObject","Object",d);const l=d.dir||d.root,i=d.base||`${d.name||""}${d.ext||""}`;return l?l===d.root?`${l}${i}`:`${l}${c}${i}`:i}e.win32={resolve(...c){let d="",l="",i=!1;for(let r=c.length-1;r>=-1;r--){let n;if(r>=0){if(n=c[r],m(n,"path"),n.length===0)continue}else d.length===0?n=D.cwd():(n=D.env[`=${d}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==d.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${d}\\`));const o=n.length;let s=0,h="",a=!1;const S=n.charCodeAt(0);if(o===1)f(S)&&(s=1,a=!0);else if(f(S))if(a=!0,f(n.charCodeAt(1))){let w=2,A=w;for(;w<o&&!f(n.charCodeAt(w));)w++;if(w<o&&w!==A){const q=n.slice(A,w);for(A=w;w<o&&f(n.charCodeAt(w));)w++;if(w<o&&w!==A){for(A=w;w<o&&!f(n.charCodeAt(w));)w++;(w===o||w!==A)&&(h=`\\\\${q}\\${n.slice(A,w)}`,s=w)}}}else s=1;else y(S)&&n.charCodeAt(1)===C&&(h=n.slice(0,2),s=2,o>2&&f(n.charCodeAt(2))&&(a=!0,s=3));if(h.length>0)if(d.length>0){if(h.toLowerCase()!==d.toLowerCase())continue}else d=h;if(i){if(d.length>0)break}else if(l=`${n.slice(s)}\\${l}`,i=a,a&&d.length>0)break}return l=u(l,!i,"\\",f),i?`${d}\\${l}`:`${d}${l}`||"."},normalize(c){m(c,"path");const d=c.length;if(d===0)return".";let l=0,i,r=!1;const n=c.charCodeAt(0);if(d===1)return p(n)?"\\":c;if(f(n))if(r=!0,f(c.charCodeAt(1))){let s=2,h=s;for(;s<d&&!f(c.charCodeAt(s));)s++;if(s<d&&s!==h){const a=c.slice(h,s);for(h=s;s<d&&f(c.charCodeAt(s));)s++;if(s<d&&s!==h){for(h=s;s<d&&!f(c.charCodeAt(s));)s++;if(s===d)return`\\\\${a}\\${c.slice(h)}\\`;s!==h&&(i=`\\\\${a}\\${c.slice(h,s)}`,l=s)}}}else l=1;else y(n)&&c.charCodeAt(1)===C&&(i=c.slice(0,2),l=2,d>2&&f(c.charCodeAt(2))&&(r=!0,l=3));let o=l<d?u(c.slice(l),!r,"\\",f):"";return o.length===0&&!r&&(o="."),o.length>0&&f(c.charCodeAt(d-1))&&(o+="\\"),i===void 0?r?`\\${o}`:o:r?`${i}\\${o}`:`${i}${o}`},isAbsolute(c){m(c,"path");const d=c.length;if(d===0)return!1;const l=c.charCodeAt(0);return f(l)||d>2&&y(l)&&c.charCodeAt(1)===C&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let d,l;for(let n=0;n<c.length;++n){const o=c[n];m(o,"path"),o.length>0&&(d===void 0?d=l=o:d+=`\\${o}`)}if(d===void 0)return".";let i=!0,r=0;if(typeof l=="string"&&f(l.charCodeAt(0))){++r;const n=l.length;n>1&&f(l.charCodeAt(1))&&(++r,n>2&&(f(l.charCodeAt(2))?++r:i=!1))}if(i){for(;r<d.length&&f(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.win32.normalize(d)},relative(c,d){if(m(c,"from"),m(d,"to"),c===d)return"";const l=e.win32.resolve(c),i=e.win32.resolve(d);if(l===i||(c=l.toLowerCase(),d=i.toLowerCase(),c===d))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===E;)r++;let n=c.length;for(;n-1>r&&c.charCodeAt(n-1)===E;)n--;const o=n-r;let s=0;for(;s<d.length&&d.charCodeAt(s)===E;)s++;let h=d.length;for(;h-1>s&&d.charCodeAt(h-1)===E;)h--;const a=h-s,S=o<a?o:a;let w=-1,A=0;for(;A<S;A++){const U=c.charCodeAt(r+A);if(U!==d.charCodeAt(s+A))break;U===E&&(w=A)}if(A!==S){if(w===-1)return i}else{if(a>S){if(d.charCodeAt(s+A)===E)return i.slice(s+A+1);if(A===2)return i.slice(s+A)}o>S&&(c.charCodeAt(r+A)===E?w=A:A===2&&(w=3)),w===-1&&(w=0)}let q="";for(A=r+w+1;A<=n;++A)(A===n||c.charCodeAt(A)===E)&&(q+=q.length===0?"..":"\\..");return s+=w,q.length>0?`${q}${i.slice(s,h)}`:(i.charCodeAt(s)===E&&++s,i.slice(s,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const d=e.win32.resolve(c);if(d.length<=2)return c;if(d.charCodeAt(0)===E){if(d.charCodeAt(1)===E){const l=d.charCodeAt(2);if(l!==b&&l!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(y(d.charCodeAt(0))&&d.charCodeAt(1)===C&&d.charCodeAt(2)===E)return`\\\\?\\${d}`;return c},dirname(c){m(c,"path");const d=c.length;if(d===0)return".";let l=-1,i=0;const r=c.charCodeAt(0);if(d===1)return f(r)?c:".";if(f(r)){if(l=i=1,f(c.charCodeAt(1))){let s=2,h=s;for(;s<d&&!f(c.charCodeAt(s));)s++;if(s<d&&s!==h){for(h=s;s<d&&f(c.charCodeAt(s));)s++;if(s<d&&s!==h){for(h=s;s<d&&!f(c.charCodeAt(s));)s++;if(s===d)return c;s!==h&&(l=i=s+1)}}}}else y(r)&&c.charCodeAt(1)===C&&(l=d>2&&f(c.charCodeAt(2))?3:2,i=l);let n=-1,o=!0;for(let s=d-1;s>=i;--s)if(f(c.charCodeAt(s))){if(!o){n=s;break}}else o=!1;if(n===-1){if(l===-1)return".";n=l}return c.slice(0,n)},basename(c,d){d!==void 0&&m(d,"ext"),m(c,"path");let l=0,i=-1,r=!0,n;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===C&&(l=2),d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let o=d.length-1,s=-1;for(n=c.length-1;n>=l;--n){const h=c.charCodeAt(n);if(f(h)){if(!r){l=n+1;break}}else s===-1&&(r=!1,s=n+1),o>=0&&(h===d.charCodeAt(o)?--o===-1&&(i=n):(o=-1,i=s))}return l===i?i=s:i===-1&&(i=c.length),c.slice(l,i)}for(n=c.length-1;n>=l;--n)if(f(c.charCodeAt(n))){if(!r){l=n+1;break}}else i===-1&&(r=!1,i=n+1);return i===-1?"":c.slice(l,i)},extname(c){m(c,"path");let d=0,l=-1,i=0,r=-1,n=!0,o=0;c.length>=2&&c.charCodeAt(1)===C&&y(c.charCodeAt(0))&&(d=i=2);for(let s=c.length-1;s>=d;--s){const h=c.charCodeAt(s);if(f(h)){if(!n){i=s+1;break}continue}r===-1&&(n=!1,r=s+1),h===P?l===-1?l=s:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||r===-1||o===0||o===1&&l===r-1&&l===i+1?"":c.slice(l,r)},format:g.bind(null,"\\"),parse(c){m(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const l=c.length;let i=0,r=c.charCodeAt(0);if(l===1)return f(r)?(d.root=d.dir=c,d):(d.base=d.name=c,d);if(f(r)){if(i=1,f(c.charCodeAt(1))){let w=2,A=w;for(;w<l&&!f(c.charCodeAt(w));)w++;if(w<l&&w!==A){for(A=w;w<l&&f(c.charCodeAt(w));)w++;if(w<l&&w!==A){for(A=w;w<l&&!f(c.charCodeAt(w));)w++;w===l?i=w:w!==A&&(i=w+1)}}}}else if(y(r)&&c.charCodeAt(1)===C){if(l<=2)return d.root=d.dir=c,d;if(i=2,f(c.charCodeAt(2))){if(l===3)return d.root=d.dir=c,d;i=3}}i>0&&(d.root=c.slice(0,i));let n=-1,o=i,s=-1,h=!0,a=c.length-1,S=0;for(;a>=i;--a){if(r=c.charCodeAt(a),f(r)){if(!h){o=a+1;break}continue}s===-1&&(h=!1,s=a+1),r===P?n===-1?n=a:S!==1&&(S=1):n!==-1&&(S=-1)}return s!==-1&&(n===-1||S===0||S===1&&n===s-1&&n===o+1?d.base=d.name=c.slice(o,s):(d.name=c.slice(o,n),d.base=c.slice(o,s),d.ext=c.slice(n,s))),o>0&&o!==i?d.dir=c.slice(0,o-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let d="",l=!1;for(let i=c.length-1;i>=-1&&!l;i--){const r=i>=0?c[i]:D.cwd();m(r,"path"),r.length!==0&&(d=`${r}/${d}`,l=r.charCodeAt(0)===I)}return d=u(d,!l,"/",p),l?`/${d}`:d.length>0?d:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===I,l=c.charCodeAt(c.length-1)===I;return c=u(c,!d,"/",p),c.length===0?d?"/":l?"./":".":(l&&(c+="/"),d?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===I},join(...c){if(c.length===0)return".";let d;for(let l=0;l<c.length;++l){const i=c[l];m(i,"path"),i.length>0&&(d===void 0?d=i:d+=`/${i}`)}return d===void 0?".":e.posix.normalize(d)},relative(c,d){if(m(c,"from"),m(d,"to"),c===d||(c=e.posix.resolve(c),d=e.posix.resolve(d),c===d))return"";const l=1,i=c.length,r=i-l,n=1,o=d.length-n,s=r<o?r:o;let h=-1,a=0;for(;a<s;a++){const w=c.charCodeAt(l+a);if(w!==d.charCodeAt(n+a))break;w===I&&(h=a)}if(a===s)if(o>s){if(d.charCodeAt(n+a)===I)return d.slice(n+a+1);if(a===0)return d.slice(n+a)}else r>s&&(c.charCodeAt(l+a)===I?h=a:a===0&&(h=0));let S="";for(a=l+h+1;a<=i;++a)(a===i||c.charCodeAt(a)===I)&&(S+=S.length===0?"..":"/..");return`${S}${d.slice(n+h)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===I;let l=-1,i=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===I){if(!i){l=r;break}}else i=!1;return l===-1?d?"/":".":d&&l===1?"//":c.slice(0,l)},basename(c,d){d!==void 0&&m(d,"ext"),m(c,"path");let l=0,i=-1,r=!0,n;if(d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let o=d.length-1,s=-1;for(n=c.length-1;n>=0;--n){const h=c.charCodeAt(n);if(h===I){if(!r){l=n+1;break}}else s===-1&&(r=!1,s=n+1),o>=0&&(h===d.charCodeAt(o)?--o===-1&&(i=n):(o=-1,i=s))}return l===i?i=s:i===-1&&(i=c.length),c.slice(l,i)}for(n=c.length-1;n>=0;--n)if(c.charCodeAt(n)===I){if(!r){l=n+1;break}}else i===-1&&(r=!1,i=n+1);return i===-1?"":c.slice(l,i)},extname(c){m(c,"path");let d=-1,l=0,i=-1,r=!0,n=0;for(let o=c.length-1;o>=0;--o){const s=c.charCodeAt(o);if(s===I){if(!r){l=o+1;break}continue}i===-1&&(r=!1,i=o+1),s===P?d===-1?d=o:n!==1&&(n=1):d!==-1&&(n=-1)}return d===-1||i===-1||n===0||n===1&&d===i-1&&d===l+1?"":c.slice(d,i)},format:g.bind(null,"/"),parse(c){m(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const l=c.charCodeAt(0)===I;let i;l?(d.root="/",i=1):i=0;let r=-1,n=0,o=-1,s=!0,h=c.length-1,a=0;for(;h>=i;--h){const S=c.charCodeAt(h);if(S===I){if(!s){n=h+1;break}continue}o===-1&&(s=!1,o=h+1),S===P?r===-1?r=h:a!==1&&(a=1):r!==-1&&(a=-1)}if(o!==-1){const S=n===0&&l?1:n;r===-1||a===0||a===1&&r===o-1&&r===n+1?d.base=d.name=c.slice(S,o):(d.name=c.slice(S,r),d.base=c.slice(S,o),d.ext=c.slice(r,o))}return n>0?d.dir=c.slice(0,n-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ie[132],re([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(C){const b=(0,D.extname)(C),v=t[b.toLowerCase()];return v!==void 0?v:L(C)}e.getMediaOrTextMime=T;function L(C){const b=(0,D.extname)(C);return R[b.toLowerCase()]}e.getMediaMime=L;function P(C){for(const b in R)if(R[b]===C)return b}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function E(C,b){const v=I.exec(C);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:b?void 0:C}e.normalizeMimeType=E}),define(ie[85],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(P,...I){const E=I.reduce((v,m)=>(v[m]=!0,v),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!E[v]).forEach(v=>{for(let m=0;m<C.length;m++)if(v.search(C[m])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=T;function L(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(ie[133],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(L=!0){return new R(L)}constructor(L){this._highResolution=t&&L,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ie[3],re([0,1,9,80,2,82,133]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var E;(function(h){h.None=()=>R.Disposable.None;function a(N){if(I){const{onListenerDidAdd:V}=N,K=f.create();let ee=0;N.onListenerDidAdd=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),V?.()}}}function S(N){return(V,K=null,ee)=>{let ae=!1,Z;return Z=N(ne=>{if(!ae)return Z?Z.dispose():ae=!0,V.call(K,ne)},null,ee),ae&&Z.dispose(),Z}}h.once=S;function w(N,V,K){return k((ee,ae=null,Z)=>N(ne=>ee.call(ae,V(ne)),null,Z),K)}h.map=w;function A(N,V,K){return k((ee,ae=null,Z)=>N(ne=>{V(ne),ee.call(ae,ne)},null,Z),K)}h.forEach=A;function q(N,V,K){return k((ee,ae=null,Z)=>N(ne=>V(ne)&&ee.call(ae,ne),null,Z),K)}h.filter=q;function U(N){return N}h.signal=U;function O(...N){return(V,K=null,ee)=>(0,R.combinedDisposable)(...N.map(ae=>ae(Z=>V.call(K,Z),null,ee)))}h.any=O;function $(N,V,K,ee){let ae=K;return w(N,Z=>(ae=V(ae,Z),ae),ee)}h.reduce=$;function k(N,V){let K;const ee={onFirstListenerAdd(){K=N(ae.fire,ae)},onLastListenerRemove(){K?.dispose()}};V||a(ee);const ae=new y(ee);return V?.add(ae),ae.event}function M(N,V,K=100,ee=!1,ae,Z){let ne,oe,ue,de=0;const ve={leakWarningThreshold:ae,onFirstListenerAdd(){ne=N(Ee=>{de++,oe=V(oe,Ee),ee&&!ue&&(we.fire(oe),oe=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=oe;oe=void 0,ue=void 0,(!ee||de>1)&&we.fire(Pe),de=0},K)})},onLastListenerRemove(){ne.dispose()}};Z||a(ve);const we=new y(ve);return Z?.add(we),we.event}h.debounce=M;function F(N,V=(ee,ae)=>ee===ae,K){let ee=!0,ae;return q(N,Z=>{const ne=ee||!V(Z,ae);return ee=!1,ae=Z,ne},K)}h.latch=F;function G(N,V,K){return[h.filter(N,V,K),h.filter(N,ee=>!V(ee),K)]}h.split=G;function W(N,V=!1,K=[]){let ee=K.slice(),ae=N(oe=>{ee?ee.push(oe):ne.fire(oe)});const Z=()=>{ee?.forEach(oe=>ne.fire(oe)),ee=null},ne=new y({onFirstListenerAdd(){ae||(ae=N(oe=>ne.fire(oe)))},onFirstListenerDidAdd(){ee&&(V?setTimeout(Z):Z())},onLastListenerRemove(){ae&&ae.dispose(),ae=null}});return ne.event}h.buffer=W;class B{constructor(V){this.event=V,this.disposables=new R.DisposableStore}map(V){return new B(w(this.event,V,this.disposables))}forEach(V){return new B(A(this.event,V,this.disposables))}filter(V){return new B(q(this.event,V,this.disposables))}reduce(V,K){return new B($(this.event,V,K,this.disposables))}latch(){return new B(F(this.event,void 0,this.disposables))}debounce(V,K=100,ee=!1,ae){return new B(M(this.event,V,K,ee,ae,this.disposables))}on(V,K,ee){return this.event(V,K,ee)}once(V,K,ee){return S(this.event)(V,K,ee)}dispose(){this.disposables.dispose()}}function z(N){return new B(N)}h.chain=z;function x(N,V,K=ee=>ee){const ee=(...oe)=>ne.fire(K(...oe)),ae=()=>N.on(V,ee),Z=()=>N.removeListener(V,ee),ne=new y({onFirstListenerAdd:ae,onLastListenerRemove:Z});return ne.event}h.fromNodeEventEmitter=x;function J(N,V,K=ee=>ee){const ee=(...oe)=>ne.fire(K(...oe)),ae=()=>N.addEventListener(V,ee),Z=()=>N.removeEventListener(V,ee),ne=new y({onFirstListenerAdd:ae,onLastListenerRemove:Z});return ne.event}h.fromDOMEventEmitter=J;function X(N){return new Promise(V=>S(N)(V))}h.toPromise=X;function se(N,V){return V(void 0),N(K=>V(K))}h.runAndSubscribe=se;function j(N,V){let K=null;function ee(Z){K?.dispose(),K=new R.DisposableStore,V(Z,K)}ee(void 0);const ae=N(Z=>ee(Z));return(0,R.toDisposable)(()=>{ae.dispose(),K?.dispose()})}h.runAndSubscribeWithStore=j;class H{constructor(V,K){this.obs=V,this._counter=0,this._hasChanged=!1;const ee={onFirstListenerAdd:()=>{V.addObserver(this)},onLastListenerRemove:()=>{V.removeObserver(this)}};K||a(ee),this.emitter=new y(ee),K&&K.add(this.emitter)}beginUpdate(V){this._counter++}handleChange(V,K){this._hasChanged=!0}endUpdate(V){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function _(N,V){return new H(N,V).emitter.event}h.fromObservable=_})(E=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C._idPool++}`,C.all.add(this)}start(a){this._stopWatch=new L.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=C,C.all=new Set,C._idPool=0;let b=-1;function v(h){const a=b;return b=h,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=v;class m{constructor(a,S=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=S,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,S){let w=b;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||S<w)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let q,U=0;for(const[O,$]of this._stacks)(!q||U<$)&&(q=O,U=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${U}):`),console.warn(q)}return()=>{const q=this._stacks.get(a.value)||0;this._stacks.set(a.value,q-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(a,S,w){this.callback=a,this.callbackThis=S,this.stack=w,this.subscription=new R.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class y{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const S of a)S.subscription.isset()&&(S.subscription.unset(),S.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,S,w)=>{this._listeners||(this._listeners=new T.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let q,U;this._leakageMon&&this._listeners.size>=30&&(U=f.create(),q=this._leakageMon.check(U,this._listeners.size+1)),P&&(U=U??f.create());const O=new p(a,S,U),$=this._listeners.push(O);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,S);const k=O.subscription.set(()=>{q?.(),this._disposed||($(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return w instanceof R.DisposableStore?w.add(k):Array.isArray(w)&&w.push(k),k}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const S of this._listeners)this._deliveryQueue.push(this,S,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class u{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(a,S,w){this._queue.push(new c(a,S,w))}clear(a){const S=new T.LinkedList;for(const w of this._queue)w.emitter!==a&&S.push(w);this._queue=S}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(S){(0,D.onUnexpectedError)(S)}}}}e.EventDeliveryQueue=u;class g extends u{clear(a){this._queue.clear()}}class c{constructor(a,S,w){this.emitter=a,this.listener=S,this.event=w}}class d extends y{async fireAsync(a,S,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,a]);for(;this._asyncDeliveryQueue.size>0&&!S.isCancellationRequested;){const[A,q]=this._asyncDeliveryQueue.shift(),U=[],O={...q,token:S,waitUntil:$=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");w&&($=w($,A.callback)),U.push($)}};try{A.invoke(O)}catch($){(0,D.onUnexpectedError)($);continue}Object.freeze(U),await Promise.allSettled(U).then($=>{for(const k of $)k.status==="rejected"&&(0,D.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=d;class l extends y{constructor(a){super(a),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class i extends l{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=i;class r extends y{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(S=>super.fire(S)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const S={event:a,listener:null};this.events.push(S),this.hasListeners&&this.hook(S);const w=()=>{this.hasListeners&&this.unhook(S);const A=this.events.indexOf(S);this.events.splice(A,1)};return(0,R.toDisposable)((0,t.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(S=>this.emitter.fire(S))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class o{constructor(){this.buffers=[]}wrapEvent(a){return(S,w,A)=>a(q=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>S.call(w,q)):S.call(w,q)},void 0,A)}bufferEvents(a){const S=[];this.buffers.push(S);const w=a();return this.buffers.pop(),S.forEach(A=>A()),w}}e.EventBufferer=o;class s{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ie[24],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,I){const E=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function I(E){return E===P.None||E===P.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=L}),define(ie[134],re([0,1,24]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,I=this.task(P.token);return this.result={promise:I,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class R{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const I=JSON.stringify(P);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=R;class T{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const I=this.fn(P);return this._map.set(P,I),I}}e.CachedFunction=T}),define(ie[86],re([0,1,3,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=L=>({onDidChange:D.Event.None,value:L});e.staticObservableValue=R;class T extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=T}),define(ie[27],re([0,1,134,121]),function(Q,e,D,t){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=T;const L=/{(\d+)}/g;function P(te,...le){return le.length===0?te:te.replace(L,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const I=/{([^}]+)}/g;function E(te,le){return te.replace(I,(he,me)=>le[me]??he)}e.format2=E;function C(te){return te.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=C;function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function v(te,le){let he=0;const me=le.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&he++;return he}e.count=v;function m(te,le,he="\u2026"){return te.length<=le?te:`${te.substr(0,le)}${he}`}e.truncate=m;function f(te,le=" "){const he=p(te,le);return y(he,le)}e.trim=f;function p(te,le){if(!te||!le)return te;const he=le.length;if(he===0||te.length===0)return te;let me=0;for(;te.indexOf(le,me)===me;)me=me+he;return te.substring(me)}e.ltrim=p;function y(te,le){if(!te||!le)return te;const he=le.length,me=te.length;if(he===0||me===0)return te;let Se=me,Ce=-1;for(;Ce=te.lastIndexOf(le,Se-1),!(Ce===-1||Ce+he!==Se);){if(Ce===0)return"";Se=Ce}return te.substring(0,Se)}e.rtrim=y;function u(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(te){return te.replace(/\*/g,"")}e.stripWildcards=g;function c(te,le,he={}){if(!te)throw new Error("Cannot create regex from empty string");le||(te=b(te)),he.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=c;function d(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function l(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=i;function r(te){return te.split(/\r\n|\r|\n/)}e.splitLines=r;function n(te){for(let le=0,he=te.length;le<he;le++){const me=te.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function o(te,le=0,he=te.length){for(let me=le;me<he;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(le,me)}return te.substring(le,he)}e.getLeadingWhitespace=o;function s(te,le=te.length-1){for(let he=le;he>=0;he--){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function h(te,le,he){const me=[];let Se=0;for(const Ce of te.matchAll(le)){if(me.push(te.slice(Se,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Se=Ce.index+Ce[0].length,me.push(he(Ce[0],...Ce.slice(1),Ce.index,te,Ce.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Ce=>Ce.join(""))}e.replaceAsync=h;function a(te,le){return te<le?-1:te>le?1:0}e.compare=a;function S(te,le,he=0,me=te.length,Se=0,Ce=le.length){for(;he<me&&Se<Ce;he++,Se++){const Fe=te.charCodeAt(he),Le=le.charCodeAt(Se);if(Fe<Le)return-1;if(Fe>Le)return 1}const De=me-he,ze=Ce-Se;return De<ze?-1:De>ze?1:0}e.compareSubstring=S;function w(te,le){return A(te,le,0,te.length,0,le.length)}e.compareIgnoreCase=w;function A(te,le,he=0,me=te.length,Se=0,Ce=le.length){for(;he<me&&Se<Ce;he++,Se++){let Fe=te.charCodeAt(he),Le=le.charCodeAt(Se);if(Fe===Le)continue;if(Fe>=128||Le>=128)return S(te.toLowerCase(),le.toLowerCase(),he,me,Se,Ce);U(Fe)&&(Fe-=32),U(Le)&&(Le-=32);const qe=Fe-Le;if(qe!==0)return qe}const De=me-he,ze=Ce-Se;return De<ze?-1:De>ze?1:0}e.compareSubstringIgnoreCase=A;function q(te){return te>=48&&te<=57}e.isAsciiDigit=q;function U(te){return te>=97&&te<=122}e.isLowerAsciiLetter=U;function O(te){return te>=65&&te<=90}e.isUpperAsciiLetter=O;function $(te,le){return te.length===le.length&&A(te,le)===0}e.equalsIgnoreCase=$;function k(te,le){const he=le.length;return le.length>te.length?!1:A(te,le,0,he)===0}e.startsWithIgnoreCase=k;function M(te,le){const he=Math.min(te.length,le.length);let me;for(me=0;me<he;me++)if(te.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=M;function F(te,le){const he=Math.min(te.length,le.length);let me;const Se=te.length-1,Ce=le.length-1;for(me=0;me<he;me++)if(te.charCodeAt(Se-me)!==le.charCodeAt(Ce-me))return me;return he}e.commonSuffixLength=F;function G(te){return 55296<=te&&te<=56319}e.isHighSurrogate=G;function W(te){return 56320<=te&&te<=57343}e.isLowSurrogate=W;function B(te,le){return(te-55296<<10)+(le-56320)+65536}e.computeCodePoint=B;function z(te,le,he){const me=te.charCodeAt(he);if(G(me)&&he+1<le){const Se=te.charCodeAt(he+1);if(W(Se))return B(me,Se)}return me}e.getNextCodePoint=z;function x(te,le){const he=te.charCodeAt(le-1);if(W(he)&&le>1){const me=te.charCodeAt(le-2);if(G(me))return B(me,he)}return he}class J{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=x(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=z(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=J;class X{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new J(le,he)}nextGraphemeLength(){const le=Te.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ce=he.offset,De=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,De)){he.setOffset(Ce);break}Se=De}return he.offset-me}prevGraphemeLength(){const le=Te.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ce=he.offset,De=le.getGraphemeBreakType(he.prevCodePoint());if(be(De,Se)){he.setOffset(Ce);break}Se=De}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function se(te,le){return new X(te,le).nextGraphemeLength()}e.nextCharLength=se;function j(te,le){return new X(te,le).prevGraphemeLength()}e.prevCharLength=j;function H(te,le){le>0&&W(te.charCodeAt(le))&&le--;const he=le+se(te,le);return[he-j(te,he),he]}e.getCharContainingOffset=H;function _(te){const le=new X(te);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=_;let N;function V(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(te){return N||(N=V()),N.test(te)}e.containsRTL=K;const ee=/^[\t\n\r\x20-\x7E]*$/;function ae(te){return ee.test(te)}e.isBasicASCII=ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=Z;function ne(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ne;function oe(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=oe;function ue(te,le){if(te.length<le)return te;const he=/\b/g;let me=0;for(;he.test(te)&&!(te.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ue;const de=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(de,""),te=te.replace(ve,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Oe(te){return Pe(te)?te.substr(1):te}e.stripUTF8BOM=Oe;function $e(te,le){if(!te||!le||te.length<le.length)return!1;const he=le.length,me=te.toLowerCase();let Se=0,Ce=-1;for(;Se<he;){const De=me.indexOf(le[Se],Ce+1);if(De<0)return!1;Ce=De,Se++}return!0}e.fuzzyContains=$e;function Ve(te,le=!1){return te?(le&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ve;function Je(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Je;function ce(te,le=1){if(le===0)return"";let he=-1;do he=te.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?te:(te[he-1]==="\r"&&he--,te.substr(0,he))}e.getNLines=ce;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Te.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,le){return te===0?le!==5&&le!==7:te===2&&le===3?!1:te===4||te===2||te===3||le===4||le===2||le===3?!0:!(te===8&&(le===8||le===9||le===11||le===12)||(te===11||te===9)&&(le===9||le===10)||(te===12||te===10)&&le===10||le===5||le===13||le===7||te===1||te===13&&le===14||te===6&&le===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}Te._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(te,le){if(te===0)return 0;const he=_e(te,le);if(he!==void 0)return he;const me=new J(le,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ne;function _e(te,le){const he=new J(le,te);let me=he.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!oe(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function Me(te){return 127995<=te&&te<=127999}var We;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(le){return ke.cache.get(Array.from(le))}static getLocales(){return ke._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function le(Le){const qe=new Map;for(let Be=0;Be<Le.length;Be+=2)qe.set(Le[Be],Le[Be+1]);return qe}function he(Le,qe){const Be=new Map(Le);for(const[Ze,et]of qe)Be.set(Ze,et);return Be}function me(Le,qe){if(!Le)return qe;const Be=new Map;for(const[Ze,et]of Le)qe.has(Ze)&&Be.set(Ze,et);return Be}const Se=R.ambiguousCharacterData.getValue();let Ce=te.filter(Le=>!Le.startsWith("_")&&Le in Se);Ce.length===0&&(Ce=["_default"]);let De;for(const Le of Ce){const qe=le(Se[Le]);De=me(De,qe)}const ze=le(Se._common),Fe=he(ze,De);return new ke(Fe)}),ke._locales=new t.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(le){return Ae.getData().has(le)}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae,Ae._data=void 0}),define(ie[47],re([0,1,12,5,27,15]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(s){return s===47||s===92}e.isPathSeparator=L;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function E(s,h=D.posix.sep){if(!s)return"";const a=s.length,S=s.charCodeAt(0);if(L(S)){if(L(s.charCodeAt(1))&&!L(s.charCodeAt(2))){let A=3;const q=A;for(;A<a&&!L(s.charCodeAt(A));A++);if(q!==A&&!L(s.charCodeAt(A+1))){for(A+=1;A<a;A++)if(L(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,h)}}return h}else if(u(S)&&s.charCodeAt(1)===58)return L(s.charCodeAt(2))?s.slice(0,2)+h:s.slice(0,2);let w=s.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(L(s.charCodeAt(w)))return s.slice(0,w+1)}return""}e.getRoot=E;function C(s){if(!t.isWindows||!s||s.length<5)return!1;let h=s.charCodeAt(0);if(h!==92||(h=s.charCodeAt(1),h!==92))return!1;let a=2;const S=a;for(;a<s.length&&(h=s.charCodeAt(a),h!==92);a++);return!(S===a||(h=s.charCodeAt(a+1),isNaN(h)||h===92))}e.isUNC=C;const b=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,h=t.isWindows){const a=h?b:v;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||h&&m.test(s)||s==="."||s===".."||h&&s[s.length-1]==="."||h&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function p(s,h,a){const S=s===h;return!a||S?S:!s||!h?!1:(0,R.equalsIgnoreCase)(s,h)}e.isEqual=p;function y(s,h,a,S=D.sep){if(s===h)return!0;if(!s||!h||h.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,h))return!1;if(h.length===s.length)return!0;let A=h.length;return h.charAt(h.length-1)===S&&A--,s.charAt(A)===S}return h.charAt(h.length-1)!==S&&(h+=S),s.indexOf(h)===0}e.isEqualOrParent=y;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function g(s,h){return t.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(h,s)),s=(0,D.normalize)(s),t.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=g;function c(s){const h=(0,D.normalize)(s);return t.isWindows?s.length>3?!1:d(h)&&(s.length===2||h.charCodeAt(2)===92):h===D.posix.sep}e.isRootOrDriveLetter=c;function d(s,h=t.isWindows){return h?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(s){return d(s)?s[0]:void 0}e.getDriveLetter=l;function i(s,h,a){return h.length>s.length?-1:s===h?0:(a&&(s=s.toLowerCase(),h=h.toLowerCase()),s.indexOf(h))}e.indexOfPath=i;function r(s){const h=s.split(":");let a,S,w;for(const A of h){const q=Number(A);(0,T.isNumber)(q)?S===void 0?S=q:w===void 0&&(w=q):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:S!==void 0?S:void 0,column:w!==void 0?w:S!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(s,h,a=8){let S="";for(let A=0;A<a;A++)S+=n.charAt(Math.floor(Math.random()*n.length));let w;return h?w=`${h}-${S}`:w=S,s?(0,D.join)(s,w):w}e.randomPath=o}),define(ie[66],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return R(u,0)}e.hash=t;function R(u,g){switch(typeof u){case"object":return u===null?T(349,g):Array.isArray(u)?I(u,g):E(u,g);case"string":return P(u,g);case"boolean":return L(u,g);case"number":return T(u,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=R;function T(u,g){return(g<<5)-g+u|0}e.numberHash=T;function L(u,g){return T(u?433:863,g)}function P(u,g){g=T(149417,g);for(let c=0,d=u.length;c<d;c++)g=T(u.charCodeAt(c),g);return g}e.stringHash=P;function I(u,g){return g=T(104579,g),u.reduce((c,d)=>R(d,c),g)}function E(u,g){return g=T(181387,g),Object.keys(u).sort().reduce((c,d)=>(c=P(d,c),R(u[d],c)),g)}class C{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=R(g,this._value),this._value}}e.Hasher=C;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v(u,g,c=32){const d=c-g,l=~((1<<d)-1);return(u<<g|(l&u)>>>d)>>>0}function m(u,g=0,c=u.byteLength,d=0){for(let l=0;l<c;l++)u[g+l]=d}function f(u,g,c="0"){for(;u.length<g;)u=c+u;return u}function p(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),g/4)}e.toHexString=p;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const c=g.length;if(c===0)return;const d=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,r,n;for(i!==0?(r=i,n=-1,i=0):(r=g.charCodeAt(0),n=0);;){let o=r;if(D.isHighSurrogate(r))if(n+1<c){const s=g.charCodeAt(n+1);D.isLowSurrogate(s)?(n++,o=D.computeCodePoint(r,s)):o=65533}else{i=r;break}else D.isLowSurrogate(r)&&(o=65533);if(l=this._push(d,l,o),n++,n<c)r=g.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(g,c,d){return d<128?g[c++]=d:d<2048?(g[c++]=192|(d&1984)>>>6,g[c++]=128|(d&63)>>>0):d<65536?(g[c++]=224|(d&61440)>>>12,g[c++]=128|(d&4032)>>>6,g[c++]=128|(d&63)>>>0):(g[c++]=240|(d&1835008)>>>18,g[c++]=128|(d&258048)>>>12,g[c++]=128|(d&4032)>>>6,g[c++]=128|(d&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=y._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,v(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let d=this._h0,l=this._h1,i=this._h2,r=this._h3,n=this._h4,o,s,h;for(let a=0;a<80;a++)a<20?(o=l&i|~l&r,s=1518500249):a<40?(o=l^i^r,s=1859775393):a<60?(o=l&i|l&r|i&r,s=2400959708):(o=l^i^r,s=3395469782),h=v(d,5)+o+n+s+g.getUint32(a*4,!1)&4294967295,n=r,r=i,i=v(l,30),l=d,d=h;this._h0=this._h0+d&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ie[87],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(t||(t={})),function(R){const T="error",L="warning",P="warn",I="info",E="ignore";function C(v){return v?D.equalsIgnoreCase(T,v)?R.Error:D.equalsIgnoreCase(L,v)||D.equalsIgnoreCase(P,v)?R.Warning:D.equalsIgnoreCase(I,v)?R.Info:R.Ignore:R.Ignore}R.fromValue=C;function b(v){switch(v){case R.Error:return T;case R.Warning:return L;case R.Info:return I;default:return E}}R.toString=b}(t||(t={})),e.default=t}),define(ie[48],re([0,1,18,27]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(m){return this._value=m,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(m){const f=m.charCodeAt(0),p=this._value.charCodeAt(this._pos);return f-p}value(){return this._value[this._pos]}}e.StringIterator=R;class T{constructor(m=!0){this._caseSensitive=m}reset(m){return this._value=m,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let m=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(m)this._from++;else break;else m=!1;return this}cmp(m){return this._caseSensitive?(0,t.compareSubstring)(m,this._value,0,m.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(m,this._value,0,m.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class L{constructor(m=!0,f=!0){this._splitOnBackslash=m,this._caseSensitive=f}reset(m){this._from=0,this._to=0,this._value=m,this._valueLen=m.length;for(let f=m.length-1;f>=0;f--,this._valueLen--){const p=this._value.charCodeAt(f);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let m=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(m)this._from++;else break;else m=!1}return this}cmp(m){return this._caseSensitive?(0,t.compareSubstring)(m,this._value,0,m.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(m,this._value,0,m.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(m,f){this._ignorePathCasing=m,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(m){return this._value=m,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(m)),this._pathIterator.reset(m.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(m)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(m){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(m,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(m,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(m);if(this._states[this._stateIdx]===4)return(0,t.compare)(m,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(m,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(C||(C={}));class b{static forUris(m=()=>!1,f=()=>!1){return new b(new I(m,f))}static forPaths(m=!1){return new b(new L(void 0,!m))}static forStrings(){return new b(new R)}static forConfigKeys(){return new b(new T)}constructor(m){this._iter=m}clear(){this._root=void 0}fill(m,f){if(f){const p=f.slice(0);(0,D.shuffle)(p);for(const y of p)this.set(y,m)}else{const p=m.slice(0);(0,D.shuffle)(p);for(const y of p)this.set(y[0],y[1])}}set(m,f){const p=this._iter.reset(m);let y;this._root||(this._root=new E,this._root.segment=p.value());const u=[];for(y=this._root;;){const c=p.cmp(y.segment);if(c>0)y.left||(y.left=new E,y.left.segment=p.value()),u.push([-1,y]),y=y.left;else if(c<0)y.right||(y.right=new E,y.right.segment=p.value()),u.push([1,y]),y=y.right;else if(p.hasNext())p.next(),y.mid||(y.mid=new E,y.mid.segment=p.value()),u.push([0,y]),y=y.mid;else break}const g=y.value;y.value=f,y.key=m;for(let c=u.length-1;c>=0;c--){const d=u[c][1];d.updateHeight();const l=d.balanceFactor();if(l<-1||l>1){const i=u[c][0],r=u[c+1][0];if(i===1&&r===1)u[c][1]=d.rotateLeft();else if(i===-1&&r===-1)u[c][1]=d.rotateRight();else if(i===1&&r===-1)d.right=u[c+1][1]=u[c+1][1].rotateRight(),u[c][1]=d.rotateLeft();else if(i===-1&&r===1)d.left=u[c+1][1]=u[c+1][1].rotateLeft(),u[c][1]=d.rotateRight();else throw new Error;if(c>0)switch(u[c-1][0]){case-1:u[c-1][1].left=u[c][1];break;case 1:u[c-1][1].right=u[c][1];break;case 0:u[c-1][1].mid=u[c][1];break}else this._root=u[0][1]}}return g}get(m){return this._getNode(m)?.value}_getNode(m){const f=this._iter.reset(m);let p=this._root;for(;p;){const y=f.cmp(p.segment);if(y>0)p=p.left;else if(y<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else break}return p}has(m){const f=this._getNode(m);return!(f?.value===void 0&&f?.mid===void 0)}delete(m){return this._delete(m,!1)}deleteSuperstr(m){return this._delete(m,!0)}_delete(m,f){const p=this._iter.reset(m),y=[];let u=this._root;for(;u;){const g=p.cmp(u.segment);if(g>0)y.push([-1,u]),u=u.left;else if(g<0)y.push([1,u]),u=u.right;else if(p.hasNext())p.next(),y.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this._min(u.right);if(g.key){const{key:c,value:d,segment:l}=g;this._delete(g.key,!1),u.key=c,u.value=d,u.segment=l}}else{const g=u.left??u.right;if(y.length>0){const[c,d]=y[y.length-1];switch(c){case-1:d.left=g;break;case 0:d.mid=g;break;case 1:d.right=g;break}}else this._root=g}for(let g=y.length-1;g>=0;g--){const c=y[g][1];c.updateHeight();const d=c.balanceFactor();if(d>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),y[g][1]=c.rotateLeft()):d<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),y[g][1]=c.rotateRight()),g>0)switch(y[g-1][0]){case-1:y[g-1][1].left=y[g][1];break;case 1:y[g-1][1].right=y[g][1];break;case 0:y[g-1][1].mid=y[g][1];break}else this._root=y[0][1]}}}_min(m){for(;m.left;)m=m.left;return m}findSubstr(m){const f=this._iter.reset(m);let p=this._root,y;for(;p;){const u=f.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(f.hasNext())f.next(),y=p.value||y,p=p.mid;else break}return p&&p.value||y}findSuperstr(m){const f=this._iter.reset(m);let p=this._root;for(;p;){const y=f.cmp(p.segment);if(y>0)p=p.left;else if(y<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else return p.mid?this._entries(p.mid):void 0}}forEach(m){for(const[f,p]of this)m(p,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(m){const f=[];return this._dfsEntries(m,f),f[Symbol.iterator]()}_dfsEntries(m,f){!m||(m.left&&this._dfsEntries(m.left,f),m.value&&f.push([m.key,m.value]),m.mid&&this._dfsEntries(m.mid,f),m.right&&this._dfsEntries(m.right,f))}_isBalanced(){const m=f=>{if(!f)return!0;const p=f.balanceFactor();return p<-1||p>1?!1:m(f.left)&&m(f.right)};return m(this._root)}}e.TernarySearchTree=b}),define(ie[7],re([0,1,12,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,L=/^\/\//;function P(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(n,o){return!n&&!o?"file":n}function E(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const C="",b="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,s,h,a,S,w=!1){typeof o=="object"?(this.scheme=o.scheme||C,this.authority=o.authority||C,this.path=o.path||C,this.query=o.query||C,this.fragment=o.fragment||C):(this.scheme=I(o,w),this.authority=s||C,this.path=E(this.scheme,h||C),this.query=a||C,this.fragment=S||C,P(this,w))}get fsPath(){return c(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:h,path:a,query:S,fragment:w}=o;return s===void 0?s=this.scheme:s===null&&(s=C),h===void 0?h=this.authority:h===null&&(h=C),a===void 0?a=this.path:a===null&&(a=C),S===void 0?S=this.query:S===null&&(S=C),w===void 0?w=this.fragment:w===null&&(w=C),s===this.scheme&&h===this.authority&&a===this.path&&S===this.query&&w===this.fragment?this:new p(s,h,a,S,w)}static parse(o,s=!1){const h=v.exec(o);return h?new p(h[2]||C,r(h[4]||C),r(h[5]||C),r(h[7]||C),r(h[9]||C),s):new p(C,C,C,C,C)}static file(o){let s=C;if(t.isWindows&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const h=o.indexOf(b,2);h===-1?(s=o.substring(2),o=b):(s=o.substring(2,h),o=o.substring(h)||b)}return new p("file",s,o,C,C)}static from(o){const s=new p(o.scheme,o.authority,o.path,o.query,o.fragment);return P(s,!0),s}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return t.isWindows&&o.scheme==="file"?h=m.file(D.win32.join(c(o,!0),...s)).path:h=D.posix.join(o.path,...s),o.with({path:h})}toString(o=!1){return d(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const s=new p(o);return s._formatted=o.external,s._fsPath=o._sep===f?o.fsPath:null,s}}else return o}}e.URI=m;const f=t.isWindows?1:void 0;class p extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(o=!1){return o?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=f),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,o){let s,h=-1;for(let a=0;a<n.length;a++){const S=n.charCodeAt(a);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||o&&S===47)h!==-1&&(s+=encodeURIComponent(n.substring(h,a)),h=-1),s!==void 0&&(s+=n.charAt(a));else{s===void 0&&(s=n.substr(0,a));const w=y[S];w!==void 0?(h!==-1&&(s+=encodeURIComponent(n.substring(h,a)),h=-1),s+=w):h===-1&&(h=a)}}return h!==-1&&(s+=encodeURIComponent(n.substring(h))),s!==void 0?s:n}function g(n){let o;for(let s=0;s<n.length;s++){const h=n.charCodeAt(s);h===35||h===63?(o===void 0&&(o=n.substr(0,s)),o+=y[h]):o!==void 0&&(o+=n[s])}return o!==void 0?o:n}function c(n,o){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function d(n,o){const s=o?g:u;let h="",{scheme:a,authority:S,path:w,query:A,fragment:q}=n;if(a&&(h+=a,h+=":"),(S||a==="file")&&(h+=b,h+=b),S){let U=S.indexOf("@");if(U!==-1){const O=S.substr(0,U);S=S.substr(U+1),U=O.indexOf(":"),U===-1?h+=s(O,!1):(h+=s(O.substr(0,U),!1),h+=":",h+=s(O.substr(U+1),!1)),h+="@"}S=S.toLowerCase(),U=S.indexOf(":"),U===-1?h+=s(S,!1):(h+=s(S.substr(0,U),!1),h+=S.substr(U))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const U=w.charCodeAt(1);U>=65&&U<=90&&(w=`/${String.fromCharCode(U+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const U=w.charCodeAt(0);U>=65&&U<=90&&(w=`${String.fromCharCode(U+32)}:${w.substr(2)}`)}h+=s(w,!0)}return A&&(h+="?",h+=s(A,!1)),q&&(h+="#",h+=o?q:u(q,!1)),h}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,o=>l(o)):n}}),define(ie[135],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const C=E;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function R(E){const C=[];let b;try{const v=JSON.parse(E.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),b=m.__$stack),C.push(...v)}catch{C.push("Unable to log remote console arguments",E.arguments)}return{args:C,stack:b}}e.parse=R;function T(E){if(typeof E!="string")return T(R(E).stack);const C=E;if(C){const b=L(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=T;function L(E){if(!E)return E;const C=E.indexOf(`
`);return C===-1?E:E.substring(0,C)}function P(E,C){const{args:b,stack:v}=R(E),m=typeof b[0]=="string"&&b.length===1;let f=L(v);f&&(f=`(${f.trim()})`);let p=[];if(typeof b[0]=="string"?f&&m?p=[`%c[${C}] %c${b[0]} %c${f}`,I("blue"),I(""),I("grey")]:p=[`%c[${C}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:p=[`%c[${C}]%`,I("blue"),...b],f&&!m&&p.push(f),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,p)}e.log=P;function I(E){return`color: ${E}`}}),define(ie[67],re([0,1,17,27,7]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(E){return JSON.stringify(E,P)}e.stringify=T;function L(E){let C=JSON.parse(E);return C=I(C),C}e.parse=L;function P(E,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function I(E,C=0){if(!E||C>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 15:return new Date(E.source)}if(E instanceof D.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let b=0;b<E.length;++b)E[b]=I(E[b],C+1);else for(const b in E)Object.hasOwnProperty.call(E,b)&&(E[b]=I(E[b],C+1))}return E}e.revive=I}),define(ie[22],re([0,1,5,7]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${R.vscodeRemoteResource}`}set(E,C,b){this._hosts[E]=C,this._ports[E]=b}setConnectionToken(E,C){this._connectionTokens[E]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const C=E.authority;let b=this._hosts[C];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const v=this._ports[C],m=this._connectionTokens[C];let f=`path=${encodeURIComponent(E.path)}`;return typeof m=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),t.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${v}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new T;class L{asBrowserUri(E,C){const b=this.toUri(E,C);return b.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(E,C){const b=this.toUri(E,C);return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==L.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(E,C){return t.URI.isUri(E)?E:t.URI.parse(C.toUrl(E))}}L.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new L;var P;(function(I){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(E.get("3"));const C="vscode-coi";function b(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:t.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const p=f?.get(C);if(!!p)return E.get(p)}I.getHeadersFromQuery=b;function v(m,f,p){if(!globalThis.crossOriginIsolated)return;const y=f&&p?"3":p?"2":"1";m instanceof URLSearchParams?m.set(C,y):m[C]=y}I.addSearchParam=v})(P=e.COI||(e.COI={}))}),define(ie[19],re([0,1,47,22,12,5,27,7]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=I;class E{constructor(f){this._ignorePathCasing=f}compare(f,p,y=!1){return f===p?0:(0,L.compare)(this.getComparisonKey(f,y),this.getComparisonKey(p,y))}isEqual(f,p,y=!1){return f===p?!0:!f||!p?!1:this.getComparisonKey(f,y)===this.getComparisonKey(p,y)}getComparisonKey(f,p=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,p,y=!1){if(f.scheme===p.scheme){if(f.scheme===t.Schemas.file)return D.isEqualOrParent(I(f),I(p),this._ignorePathCasing(f))&&f.query===p.query&&(y||f.fragment===p.fragment);if((0,e.isEqualAuthority)(f.authority,p.authority))return D.isEqualOrParent(f.path,p.path,this._ignorePathCasing(f),"/")&&f.query===p.query&&(y||f.fragment===p.fragment)}return!1}joinPath(f,...p){return P.URI.joinPath(f,...p)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let p;return f.scheme===t.Schemas.file?p=P.URI.file(R.dirname(I(f))).path:(p=R.posix.dirname(f.path),f.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),p="/")),f.with({path:p})}normalizePath(f){if(!f.path.length)return f;let p;return f.scheme===t.Schemas.file?p=P.URI.file(R.normalize(I(f))).path:p=R.posix.normalize(f.path),f.with({path:p})}relativePath(f,p){if(f.scheme!==p.scheme||!(0,e.isEqualAuthority)(f.authority,p.authority))return;if(f.scheme===t.Schemas.file){const g=R.relative(I(f),I(p));return T.isWindows?D.toSlashes(g):g}let y=f.path||"/";const u=p.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const c=Math.min(y.length,u.length);g<c&&!(y.charCodeAt(g)!==u.charCodeAt(g)&&y.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);y=u.substr(0,g)+y.substr(g)}return R.posix.relative(y,u)}resolvePath(f,p){if(f.scheme===t.Schemas.file){const y=P.URI.file(R.resolve(I(f),p));return f.with({authority:y.authority,path:y.path})}return p=D.toPosixPath(p),f.with({path:R.posix.resolve(f.path,p)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,p){return f===p||f!==void 0&&p!==void 0&&(0,L.equalsIgnoreCase)(f,p)}hasTrailingPathSeparator(f,p=R.sep){if(f.scheme===t.Schemas.file){const y=I(f);return y.length>D.getRoot(y).length&&y[y.length-1]===p}else{const y=f.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,p=R.sep){return(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,p=R.sep){let y=!1;if(f.scheme===t.Schemas.file){const u=I(f);y=u!==void 0&&u.length===D.getRoot(u).length&&u[u.length-1]===p}else{p="/";const u=f.path;y=u.length===1&&u.charCodeAt(u.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path+"/"}):f}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(m=>m.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(m,f){const p=[];for(let y=0;y<m.length;y++){const u=f(m[y]);m.some((g,c)=>c===y?!1:(0,e.isEqualOrParent)(u,f(g)))||p.push(m[y])}return p}e.distinctParents=C;var b;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function f(p){const y=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(c=>{const[d,l]=c.split(":");d&&l&&y.set(d,l)});const g=p.path.substring(0,p.path.indexOf(";"));return g&&y.set(m.META_DATA_MIME,g),y}m.parseMetaData=f})(b=e.DataUri||(e.DataUri={}));function v(m,f,p){if(f){let y=m.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),m.with({scheme:p,authority:f,path:y})}return m.with({scheme:p})}e.toLocalResource=v}),define(ie[6],re([0,1,24,9,3,2,19,5]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(H){return!!H&&typeof H.then=="function"}e.isThenable=I;function E(H){const _=new D.CancellationTokenSource,N=H(_.token),V=new Promise((K,ee)=>{const ae=_.token.onCancellationRequested(()=>{ae.dispose(),_.dispose(),ee(new t.CancellationError)});Promise.resolve(N).then(Z=>{ae.dispose(),_.dispose(),K(Z)},Z=>{ae.dispose(),_.dispose(),ee(Z)})});return new class{cancel(){_.cancel()}then(K,ee){return V.then(K,ee)}catch(K){return this.then(void 0,K)}finally(K){return V.finally(K)}}}e.createCancelablePromise=E;function C(H,_,N){return new Promise((V,K)=>{const ee=_.onCancellationRequested(()=>{ee.dispose(),V(N)});H.then(V,K).finally(()=>ee.dispose())})}e.raceCancellation=C;function b(H,_){return new Promise((N,V)=>{const K=_.onCancellationRequested(()=>{K.dispose(),V(new t.CancellationError)});H.then(N,V).finally(()=>K.dispose())})}e.raceCancellationError=b;async function v(H){let _=-1;const N=H.map((K,ee)=>K.then(ae=>(_=ee,ae))),V=await Promise.race(N);return H.forEach((K,ee)=>{ee!==_&&K.cancel()}),V}e.raceCancellablePromises=v;function m(H,_,N){let V;const K=setTimeout(()=>{V?.(void 0),N?.()},_);return Promise.race([H.finally(()=>clearTimeout(K)),new Promise(ee=>V=ee)])}e.raceTimeout=m;function f(H){return new Promise((_,N)=>{const V=H();I(V)?V.then(_,N):_(V)})}e.asPromise=f;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(N,N).then(V)})}return new Promise((N,V)=>{this.queuedPromise.then(N,V)})}return this.activePromise=_(),new Promise((N,V)=>{this.activePromise.then(K=>{this.activePromise=null,N(K)},K=>{this.activePromise=null,V(K)})})}}e.Throttler=p;class y{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=y;class u{constructor(){this.promiseMap=new Map}queue(_,N){const K=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(_)===K&&this.promiseMap.delete(_)});return this.promiseMap.set(_,K),K}}e.SequencerByKey=u;const g=(H,_)=>{let N=!0;const V=setTimeout(()=>{N=!1,_()},H);return{isTriggered:()=>N,dispose:()=>{clearTimeout(V),N=!1}}},c=H=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,H())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,N=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((K,ee)=>{this.doResolve=K,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const K=this.task;return this.task=null,K()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?c(V):g(N,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class l{constructor(_){this.delayer=new d(_),this.throttler=new p}trigger(_,N){return this.delayer.trigger(()=>this.throttler.queue(_),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((_,N)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class r extends i{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(H,_){return _?new Promise((N,V)=>{const K=setTimeout(()=>{ee.dispose(),N()},H),ee=_.onCancellationRequested(()=>{clearTimeout(K),ee.dispose(),V(new t.CancellationError)})}):E(N=>n(H,N))}e.timeout=n;function o(H,_=0){const N=setTimeout(H,_);return(0,T.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=o;function s(H){const _=[];let N=0;const V=H.length;function K(){return N<V?H[N++]():null}function ee(ae){ae!=null&&_.push(ae);const Z=K();return Z?Z.then(ee):Promise.resolve(_)}return Promise.resolve(null).then(ee)}e.sequence=s;function h(H,_=V=>!!V,N=null){let V=0;const K=H.length,ee=()=>{if(V>=K)return Promise.resolve(N);const ae=H[V++];return Promise.resolve(ae()).then(ne=>_(ne)?Promise.resolve(ne):ee())};return ee()}e.first=h;function a(H,_=V=>!!V,N=null){if(H.length===0)return Promise.resolve(N);let V=H.length;const K=()=>{V=-1;for(const ee of H)ee.cancel?.()};return new Promise((ee,ae)=>{for(const Z of H)Z.then(ne=>{--V>=0&&_(ne)?(K(),ee(ne)):V===0&&ee(N)}).catch(ne=>{--V>=0&&(K(),ae(ne))})})}e.firstParallel=a;class S{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((N,V)=>{this.outstandingPromises.push({factory:_,c:N,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const N=_.factory();N.then(_.c,_.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=S;class w extends S{constructor(){super(1)}}e.Queue=w;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new z;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,N=L.extUri){const V=N.getComparisonKey(_);let K=this.queues.get(V);return K||(K=new w,R.Event.once(K.onDrained)(()=>{K?.dispose(),this.queues.delete(V),this.onDidQueueDrain()}),this.queues.set(V,K)),K}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class q{constructor(_,N){this._token=-1,typeof _=="function"&&typeof N=="number"&&this.setIfNotSet(_,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},N)}setIfNotSet(_,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},N))}}e.TimeoutTimer=q;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,N){this.cancel(),this._token=setInterval(()=>{_()},N)}}e.IntervalTimer=U;class O{constructor(_,N){this.timeoutToken=-1,this.runner=_,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=O;class ${constructor(_,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class k extends O{constructor(_,N){super(_,N),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class M extends T.Disposable{constructor(_,N){super(),this.options=_,this.handler=N,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,P.setTimeout0)(()=>{if(_)return;const N=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(H,_)=>{const N=requestIdleCallback(H,typeof _=="number"?{timeout:_}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(N))}}}}();class F{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function G(H,_,N){let V;for(let K=0;K<N;K++)try{return await H()}catch(ee){V=ee,await n(_)}throw V}e.retry=G;class W{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,N,V){return this._pending={taskId:_,cancel:()=>V?.(),promise:N},N.then(()=>this.donePending(_),()=>this.donePending(_)),N}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let N,V;const K=new Promise((ee,ae)=>{N=ee,V=ae});this._next={run:_,promise:K,promiseResolve:N,promiseReject:V}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class B{constructor(_,N=()=>Date.now()){this.interval=_,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,N)=>{this.completeCallback=_,this.errorCallback=N})}complete(_){return new Promise(N=>{this.completeCallback(_),this.resolved=!0,N()})}error(_){return new Promise(N=>{this.errorCallback(_),this.rejected=!0,N()})}cancel(){new Promise(_=>{this.errorCallback(new t.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=z;var x;(function(H){async function _(V){let K;const ee=await Promise.all(V.map(ae=>ae.then(Z=>Z,Z=>{K||(K=Z)})));if(typeof K<"u")throw K;return ee}H.settled=_;function N(V){return new Promise(async(K,ee)=>{try{await V(K,ee)}catch(ae){ee(ae)}})}H.withAsyncBody=N})(x=e.Promises||(e.Promises={}));var J;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(J||(J={}));class X{static fromArray(_){return new X(N=>{N.emitMany(_)})}static fromPromise(_){return new X(async N=>{N.emitMany(await _)})}static fromPromises(_){return new X(async N=>{await Promise.all(_.map(async V=>N.emitOne(await V)))})}static merge(_){return new X(async N=>{await Promise.all(_.map(async V=>{for await(const K of V)N.emitOne(K)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const N={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(_(N)),this.resolve()}catch(V){this.reject(V)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,N){return new X(async V=>{for await(const K of _)V.emitOne(N(K))})}map(_){return X.map(this,_)}static filter(_,N){return new X(async V=>{for await(const K of _)N(K)&&V.emitOne(K)})}filter(_){return X.filter(this,_)}static coalesce(_){return X.filter(_,N=>!!N)}coalesce(){return X.coalesce(this)}static async toPromise(_){const N=[];for await(const V of _)N.push(V);return N}toPromise(){return X.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class se extends X{constructor(_,N){super(N),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function j(H){const _=new D.CancellationTokenSource,N=H(_.token);return new se(_,async V=>{const K=_.token.onCancellationRequested(()=>{K.dispose(),_.dispose(),V.reject(new t.CancellationError)});try{for await(const ee of N){if(_.token.isCancellationRequested)return;V.emitOne(ee)}K.dispose(),_.dispose()}catch(ee){K.dispose(),_.dispose(),V.reject(ee)}})}e.createCancelableAsyncIterable=j}),define(ie[88],re([0,1,18,6,47,40,12,5,27]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",b="[^/\\\\]",v=/\//g;function m(z,x){switch(z){case 0:return"";case 1:return`${b}*?`;default:return`(?:${C}|${b}+${C}${x?`|${C}${b}+`:""})*?`}}function f(z,x){if(!z)return[];const J=[];let X=!1,se=!1,j="";for(const H of z){switch(H){case x:if(!X&&!se){J.push(j),j="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":se=!0;break;case"]":se=!1;break}j+=H}return j&&J.push(j),J}e.splitGlobAware=f;function p(z){if(!z)return"";let x="";const J=f(z,e.GLOB_SPLIT);if(J.every(X=>X===e.GLOBSTAR))x=".*";else{let X=!1;J.forEach((se,j)=>{if(se===e.GLOBSTAR){if(X)return;x+=m(2,j===J.length-1)}else{let H=!1,_="",N=!1,V="";for(const K of se){if(K!=="}"&&H){_+=K;continue}if(N&&(K!=="]"||!V)){let ee;K==="-"?ee=K:(K==="^"||K==="!")&&!V?ee="^":K===e.GLOB_SPLIT?ee="":ee=(0,I.escapeRegExpCharacters)(K),V+=ee;continue}switch(K){case"{":H=!0;continue;case"[":N=!0;continue;case"}":{x+=`(?:${f(_,",").map(Z=>p(Z)).join("|")})`,H=!1,_="";break}case"]":{x+="["+V+"]",N=!1,V="";break}case"?":x+=b;continue;case"*":x+=m(1);continue;default:x+=(0,I.escapeRegExpCharacters)(K)}}j<J.length-1&&(J[j+1]!==e.GLOBSTAR||j+2<J.length)&&(x+=C)}X=se===e.GLOBSTAR})}return x}const y=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.LRUCache(1e4),r=function(){return!1},n=function(){return null};function o(z,x){if(!z)return n;let J;typeof z!="string"?J=z.pattern:J=z,J=J.trim();const X=`${J}_${!!x.trimForExclusions}`;let se=i.get(X);if(se)return s(se,z);let j;return y.test(J)?se=a(J.substr(4),J):(j=u.exec(h(J,x)))?se=S(j[1],J):(x.trimForExclusions?c:g).test(J)?se=w(J,x):(j=d.exec(h(J,x)))?se=A(j[1].substr(1),J,!0):(j=l.exec(h(J,x)))?se=A(j[1],J,!1):se=q(J),i.set(X,se),s(se,z)}function s(z,x){if(typeof x=="string")return z;const J=function(X,se){return(0,R.isEqualOrParent)(X,x.base,!P.isLinux)?z(X.substr(x.base.length+1),se):null};return J.allBasenames=z.allBasenames,J.allPaths=z.allPaths,J.basenames=z.basenames,J.patterns=z.patterns,J}function h(z,x){return x.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function a(z,x){return function(J,X){return typeof J=="string"&&J.endsWith(z)?x:null}}function S(z,x){const J=`/${z}`,X=`\\${z}`,se=function(H,_){return typeof H!="string"?null:_?_===z?x:null:H===z||H.endsWith(J)||H.endsWith(X)?x:null},j=[z];return se.basenames=j,se.patterns=[x],se.allBasenames=j,se}function w(z,x){const J=W(z.slice(1,-1).split(",").map(_=>o(_,x)).filter(_=>_!==n),z),X=J.length;if(!X)return n;if(X===1)return J[0];const se=function(_,N){for(let V=0,K=J.length;V<K;V++)if(J[V](_,N))return z;return null},j=J.find(_=>!!_.allBasenames);j&&(se.allBasenames=j.allBasenames);const H=J.reduce((_,N)=>N.allPaths?_.concat(N.allPaths):_,[]);return H.length&&(se.allPaths=H),se}function A(z,x,J){const X=L.sep===L.posix.sep,se=X?z:z.replace(v,L.sep),j=L.sep+se,H=L.posix.sep+z;let _;return J?_=function(N,V){return typeof N=="string"&&(N===se||N.endsWith(j)||!X&&(N===z||N.endsWith(H)))?x:null}:_=function(N,V){return typeof N=="string"&&(N===se||!X&&N===z)?x:null},_.allPaths=[(J?"*/":"./")+z],_}function q(z){try{const x=new RegExp(`^${p(z)}$`);return function(J){return x.lastIndex=0,typeof J=="string"&&x.test(J)?z:null}}catch{return n}}function U(z,x,J){return!z||typeof x!="string"?!1:O(z)(x,void 0,J)}e.match=U;function O(z,x={}){if(!z)return r;if(typeof z=="string"||$(z)){const J=o(z,x);if(J===n)return r;const X=function(se,j){return!!J(se,j)};return J.allBasenames&&(X.allBasenames=J.allBasenames),J.allPaths&&(X.allPaths=J.allPaths),X}return F(z,x)}e.parse=O;function $(z){const x=z;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=$;function k(z){return z.allBasenames||[]}e.getBasenameTerms=k;function M(z){return z.allPaths||[]}e.getPathTerms=M;function F(z,x){const J=W(Object.getOwnPropertyNames(z).map(_=>G(_,z[_],x)).filter(_=>_!==n)),X=J.length;if(!X)return n;if(!J.some(_=>!!_.requiresSiblings)){if(X===1)return J[0];const _=function(K,ee){let ae;for(let Z=0,ne=J.length;Z<ne;Z++){const oe=J[Z](K,ee);if(typeof oe=="string")return oe;(0,t.isThenable)(oe)&&(ae||(ae=[]),ae.push(oe))}return ae?(async()=>{for(const Z of ae){const ne=await Z;if(typeof ne=="string")return ne}return null})():null},N=J.find(K=>!!K.allBasenames);N&&(_.allBasenames=N.allBasenames);const V=J.reduce((K,ee)=>ee.allPaths?K.concat(ee.allPaths):K,[]);return V.length&&(_.allPaths=V),_}const se=function(_,N,V){let K,ee;for(let ae=0,Z=J.length;ae<Z;ae++){const ne=J[ae];ne.requiresSiblings&&V&&(N||(N=(0,L.basename)(_)),K||(K=N.substr(0,N.length-(0,L.extname)(_).length)));const oe=ne(_,N,K,V);if(typeof oe=="string")return oe;(0,t.isThenable)(oe)&&(ee||(ee=[]),ee.push(oe))}return ee?(async()=>{for(const ae of ee){const Z=await ae;if(typeof Z=="string")return Z}return null})():null},j=J.find(_=>!!_.allBasenames);j&&(se.allBasenames=j.allBasenames);const H=J.reduce((_,N)=>N.allPaths?_.concat(N.allPaths):_,[]);return H.length&&(se.allPaths=H),se}function G(z,x,J){if(x===!1)return n;const X=o(z,J);if(X===n)return n;if(typeof x=="boolean")return X;if(x){const se=x.when;if(typeof se=="string"){const j=(H,_,N,V)=>{if(!V||!X(H,_))return null;const K=se.replace("$(basename)",N),ee=V(K);return(0,t.isThenable)(ee)?ee.then(ae=>ae?z:null):ee?z:null};return j.requiresSiblings=!0,j}}return X}function W(z,x){const J=z.filter(_=>!!_.basenames);if(J.length<2)return z;const X=J.reduce((_,N)=>{const V=N.basenames;return V?_.concat(V):_},[]);let se;if(x){se=[];for(let _=0,N=X.length;_<N;_++)se.push(x)}else se=J.reduce((_,N)=>{const V=N.patterns;return V?_.concat(V):_},[]);const j=function(_,N){if(typeof _!="string")return null;if(!N){let K;for(K=_.length;K>0;K--){const ee=_.charCodeAt(K-1);if(ee===47||ee===92)break}N=_.substr(K)}const V=X.indexOf(N);return V!==-1?se[V]:null};j.basenames=X,j.patterns=se,j.allBasenames=X;const H=z.filter(_=>!_.basenames);return H.push(j),H}function B(z,x){return(0,D.equals)(z,x,(J,X)=>typeof J=="string"&&typeof X=="string"?J===X:typeof J!="string"&&typeof X!="string"?J.base===X.base&&J.pattern===X.pattern:!1)}e.patternsEquals=B}),define(ie[136],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class R{constructor(b){this._uriTransformer=b}transformIncoming(b){const v=this._uriTransformer.transformIncoming(b);return v===b?b:t(D.URI.from(v))}transformOutgoing(b){const v=this._uriTransformer.transformOutgoing(b);return v===b?b:t(D.URI.from(v))}transformOutgoingURI(b){const v=this._uriTransformer.transformOutgoing(b);return v===b?b:D.URI.from(v)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function T(C,b,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof D.URI)return b.transformOutgoing(C);for(const m in C)if(Object.hasOwnProperty.call(C,m)){const f=T(C[m],b,v+1);f!==null&&(C[m]=f)}}return null}function L(C,b){const v=T(C,b,0);return v===null?C:v}e.transformOutgoingURIs=L;function P(C,b,v,m){if(!C||m>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?D.URI.revive(b.transformIncoming(C)):b.transformIncoming(C);for(const f in C)if(Object.hasOwnProperty.call(C,f)){const p=P(C[f],b,v,m+1);p!==null&&(C[f]=p)}}return null}function I(C,b){const v=P(C,b,!1,0);return v===null?C:v}e.transformIncomingURIs=I;function E(C,b){const v=P(C,b,!0,0);return v===null?C:v}e.transformAndReviveIncomingURIs=E}),define(ie[137],re([0,1,34,9,48,30,123]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,b=0;const v=(0,D.networkInterfaces)();for(const m in v){const f=v[m];if(f)for(const{mac:p,internal:y}of f)y||(b+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(C+=1))}this._value=b>0?C/b:0}return this._value}};let P;async function I(){return P||(P=(async()=>await E()||T.generateUuid())()),P}e.getMachineId=I;async function E(){try{const C=await new Promise((v,m)=>{Q(["crypto"],v,m)}),b=(0,L.getMac)();return C.createHash("sha256").update(b,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(ie[28],re([0,1,54,34,280,6,47,83,12,5,19,7]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function m(F,G=v.UNLINK){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return G===v.UNLINK?p(F):f(F)}async function f(F){try{const G=(0,L.randomPath)((0,t.tmpdir)());try{await D.promises.rename(F,G)}catch(W){return W.code==="ENOENT"?void 0:p(F)}p(G).catch(W=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(F){return(0,R.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function y(F){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function u(F,G){return d(await(G?g(F):(0,R.promisify)(D.readdir)(F)))}async function g(F){try{return await(0,R.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const G=[],W=await u(F);for(const B of W){let z=!1,x=!1,J=!1;try{const X=await e.Promises.lstat((0,I.join)(F,B));z=X.isFile(),x=X.isDirectory(),J=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}G.push({name:B,isFile:()=>z,isDirectory:()=>x,isSymbolicLink:()=>J})}return G}function c(F){return d(D.readdirSync(F))}e.readdirSync=c;function d(F){return F.map(G=>typeof G=="string"?E.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=E.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function l(F){const G=await u(F),W=[];for(const B of G)await r.existsDirectory((0,I.join)(F,B))&&W.push(B);return W}function i(F,G=1e3){return new Promise(W=>{let B=!1;const z=setInterval(()=>{B||(B=!0,D.access(F,x=>{B=!1,x&&(clearInterval(z),W(void 0))}))},G)})}e.whenDeleted=i;var r;(function(F){async function G(z){let x;try{if(x=await e.Promises.lstat(z),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.isWindows&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw X}throw J}}F.stat=G;async function W(z){try{const{stat:x,symbolicLink:J}=await F.stat(z);return x.isFile()&&J?.dangling!==!0}catch{}return!1}F.existsFile=W;async function B(z){try{const{stat:x,symbolicLink:J}=await F.stat(z);return x.isDirectory()&&J?.dangling!==!0}catch{}return!1}F.existsDirectory=B})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new T.ResourceQueue;function o(F,G,W){return n.queueFor(b.URI.file(F),C.extUriBiasedIgnorePathCase).queue(()=>{const B=w(W);return new Promise((z,x)=>a(F,G,B,J=>J?x(J):z()))})}let s=!0;function h(F){s=F}e.configureFlushOnWrite=h;function a(F,G,W,B){if(!s)return D.writeFile(F,G,{mode:W.mode,flag:W.flag},B);D.open(F,W.flag,W.mode,(z,x)=>{if(z)return B(z);D.writeFile(x,G,J=>{if(J)return D.close(x,()=>B(J));D.fdatasync(x,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),h(!1)),D.close(x,se=>B(se))))})})}function S(F,G,W){const B=w(W);if(!s)return D.writeFileSync(F,G,{mode:B.mode,flag:B.flag});const z=D.openSync(F,B.flag,B.mode);try{D.writeFileSync(z,G);try{D.fdatasyncSync(z)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),h(!1)}}finally{D.closeSync(z)}}e.writeFileSync=S;function w(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,G){if(F!==G)try{await e.Promises.rename(F,G)}catch(W){if(F.toLowerCase()!==G.toLowerCase()&&W.code==="EXDEV"||F.endsWith("."))await q(F,G,{preserveSymlinks:!1}),await m(F,v.MOVE);else throw W}}async function q(F,G,W){return O(F,G,{root:{source:F,target:G},options:W,handledSourcePaths:new Set})}const U=511;async function O(F,G,W){if(W.handledSourcePaths.has(F))return;W.handledSourcePaths.add(F);const{stat:B,symbolicLink:z}=await r.stat(F);if(z){if(W.options.preserveSymlinks)try{return await M(F,G,W)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(z.dangling)return}return B.isDirectory()?$(F,G,B.mode&U,W):k(F,G,B.mode&U)}async function $(F,G,W,B){await e.Promises.mkdir(G,{recursive:!0,mode:W});const z=await u(F);for(const x of z)await O((0,I.join)(F,x),(0,I.join)(G,x),B)}async function k(F,G,W){await e.Promises.copyFile(F,G),await e.Promises.chmod(G,W)}async function M(F,G,W){let B=await e.Promises.readlink(F);(0,L.isEqualOrParent)(B,W.root.source,!E.isLinux)&&(B=(0,I.join)(W.root.target,B.substr(W.root.source.length+1))),await e.Promises.symlink(B,G)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(F,G,W,B,z)=>new Promise((x,J)=>{D.read(F,G,W,B,z,(X,se,j)=>X?J(X):x({bytesRead:se,buffer:j}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(F,G,W,B,z)=>new Promise((x,J)=>{D.write(F,G,W,B,z,(X,se,j)=>X?J(X):x({bytesWritten:se,buffer:j}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return o}get rm(){return m}get move(){return A}get copy(){return q}}}),define(ie[138],re([0,1,54,12,5,27,28]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(R.isLinux)return v;const m=(0,t.dirname)(v);if(v===m)return v;const f=((0,t.basename)(v)||v).toLowerCase();try{const y=(0,L.readdirSync)(m).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=P(m);if(u)return(0,t.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const g=P(m);if(g)return(0,t.join)(g,y[u])}}}catch{}return null}e.realcaseSync=P;async function I(v){if(R.isLinux)return v;const m=(0,t.dirname)(v);if(v===m)return v;const f=((0,t.basename)(v)||v).toLowerCase();try{const y=(await L.Promises.readdir(m)).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=await I(m);if(u)return(0,t.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const g=await I(m);if(g)return(0,t.join)(g,y[u])}}}catch{}return null}e.realcase=I;async function E(v){try{return await L.Promises.realpath(v)}catch{const f=b(v);return await L.Promises.access(f,D.constants.R_OK),f}}e.realpath=E;function C(v){try{return D.realpathSync(v)}catch{const f=b(v);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=C;function b(v){return(0,T.rtrim)((0,t.normalize)(v),t.sep)}}),define(ie[89],re([0,1,34,12,28]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(I||(I={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class b{constructor(l,i,r){this.exePath=l,this.displayName=i,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:d=!1}={}){return d?E===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:d=!1,findPreview:l=!1}={}){const i=v({useAlternateBitness:d});if(!i)return null;const r=t.join(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let n=-1,o=null;for(const a of await R.Promises.readdir(r)){let S=-1;if(l){const A=a.indexOf("-");if(A<0)continue;const q=a.substring(0,A);if(!T.test(q)||a.substring(A+1)!=="preview")continue;S=parseInt(q,10)}else{if(!T.test(a))continue;S=parseInt(a,10)}if(S<=n)continue;const w=t.join(r,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(w)||(o=w,n=S)}if(!o)return null;const s=i.includes("x86")?" (x86)":"",h=l?" Preview":"";return new b(o,`PowerShell${h}${s}`,!0)}async function f({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=d?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(l))if(i.test(n)){const o=t.join(l,n,"pwsh.exe");return new b(o,r)}return null}function p(){const d=t.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(d,".NET Core PowerShell Global Tool")}function y(){const d=t.join(process.env.windir,E===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(d,"Windows PowerShell",!0)}async function*u(){let d=await m();d&&(yield d),d=await m({useAlternateBitness:!0}),d&&(yield d),d=await f(),d&&(yield d),d=p(),d&&(yield d),d=await m({findPreview:!0}),d&&(yield d),d=await f({findPreview:!0}),d&&(yield d),d=await m({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=y(),d&&(yield d)}async function*g(){for await(const d of u())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=g;async function c(){for await(const d of g())return d;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ie[90],re([0,1,12,5,36,85,15,28]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function I(b=R.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function E(b){let v=[],m=!1;const f=function(p){if(m){v.push(p);return}(!b.send(p,u=>{if(u&&console.error(u),m=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(c=>f(c))}})||t.isWindows)&&(m=!0)};return{send:f}}e.createQueuedSender=E;var C;(function(b){async function v(m,f,p){if(D.isAbsolute(m))return m;if(f===void 0&&(f=R.cwd()),D.dirname(m)!=="."||(p===void 0&&L.isString(R.env.PATH)&&(p=R.env.PATH.split(D.delimiter)),p===void 0||p.length===0))return D.join(f,m);async function u(g){if(await P.Promises.exists(g)){let c;try{c=await P.Promises.stat(g)}catch(d){d.message.startsWith("EACCES")&&(c=await P.Promises.lstat(g))}return c?!c.isDirectory():!1}return!1}for(const g of p){let c;if(D.isAbsolute(g)?c=D.join(g,m):c=D.join(f,g,m),await u(c))return c;let d=c+".com";if(await u(d)||(d=c+".exe",await u(d)))return d}return D.join(f,m)}b.findExecutable=v})(C=e.win32||(e.win32={}))}),define(ie[139],re([0,1,49,22]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(L){return new Promise((P,I)=>{let E;const C=new Map;function b(m,f,p,y,u){const g=C.get(f);if(m===L||g){const c={name:v(p),cmd:p,pid:m,ppid:f,load:y,mem:u};C.set(m,c),m===L&&(E=c),g&&(g.children||(g.children=[]),g.children.push(c),g.children.length>1&&(g.children=g.children.sort((d,l)=>d.pid-l.pid)))}}function v(m){const f=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,d=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(c.exec(m))return"electron-crash-reporter";if(d.exec(m))return"winpty-process";if(l.exec(m))return"console-window-host (Windows internal process)";let r=i.exec(m);if(r&&r.length===2){if(r[1]==="renderer")return f.exec(m)?"shared-process":p.exec(m)?"issue-reporter":y.exec(m)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(m))return"utility-network-service";if(g.exec(m))return"extension-host"}return r[1]}const n=/[a-zA-Z-]+\.js/g;let o="";do r=n.exec(m),r&&(o+=r+" ");while(r);return o&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${o}`:m}if(process.platform==="win32"){const m=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,p)=>{Q(["windows-process-tree"],f,p)}).then(f=>{f.getProcessList(L,p=>{if(!p){I(new Error(`Root process ${L} not found`));return}f.getProcessCpuUsage(p,y=>{const u=new Map;y.forEach(g=>{const c=m(g.commandLine||"");u.set(g.pid,{name:v(c),cmd:c,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),E=u.get(L),E?(u.forEach(g=>{const c=u.get(g.ppid);c&&(c.children||(c.children=[]),c.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((c,d)=>c.pid-d.pid))}),P(E)):I(new Error(`Root process ${L} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let m=function(){let f=[E];const p=[];for(;f.length;){const u=f.shift();u&&(p.push(u.pid),u.children&&(f=f.concat(u.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);y+=" "+p.join(" "),(0,D.exec)(y,{},(u,g,c)=>{if(u||c)I(u||new Error(c.toString()));else{const d=g.toString().split(`
`);for(let l=0;l<p.length;l++){const i=C.get(p[l]);i.load=parseFloat(d[l])}if(!E){I(new Error(`Root process ${L} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(f,p,y)=>{if(f||y)if(process.platform!=="linux")I(f||new Error(y.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(u,{},(g,c,d)=>{g||d?I(g||new Error(d.toString())):(T(c,b),m())})}else{const u=p.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,d,l)=>{c||l&&!l.includes("screen size is bogus")?I(c||new Error(l.toString())):(T(d,b),process.platform==="linux"?m():E?P(E):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=R;function T(L,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=L.toString().split(`
`);for(const C of E){const b=I.exec(C.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ie[140],re([0,1,34,5,89,90]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(m,f){return m===1?t.isWindows?b():T.getWindowsShell(f):E(m,f)}e.getSystemShell=L;function P(m,f){return m===1?t.isWindows?v(f):T.getWindowsShell(f):E(m,f)}e.getSystemShellSync=P;let I=null;function E(m,f){if(t.isLinux&&m===2||t.isMacintosh&&m===3)return"/bin/bash";if(!I){let p;if(t.isWindows)p="/bin/bash";else{if(p=f.SHELL,!p)try{p=(0,D.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}I=p}return I}let C=null;async function b(){return C||(C=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),C}function v(m){if(C)return C;const f=t.isWindows&&parseFloat((0,D.release)())>=10,p=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${m.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:T.getWindowsShell(m)}});var pe=this&&this.__decorate||function(Q,e,D,t){var R=arguments.length,T=R<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,D):t,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,D,t);else for(var P=Q.length-1;P>=0;P--)(L=Q[P])&&(T=(R<3?L(T):R>3?L(e,D,T):L(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(ie[38],re([0,1,18,6,17,24,63,9,3,2,67,27,15]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function f(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function y(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(u||(u={}));class g{constructor(x){this.buffer=x,this.pos=0}read(x){const J=this.buffer.slice(this.pos,this.pos+x);return this.pos+=J.byteLength,J}}class c{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var d;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(d||(d={}));function l(z){const x=R.VSBuffer.alloc(4);return x.writeUInt32BE(z,0),x}function i(z){return z.read(4).readUInt32BE(0)}function r(z){const x=R.VSBuffer.alloc(1);return x.writeUInt8(z,0),x}const n={Undefined:r(d.Undefined),String:r(d.String),Buffer:r(d.Buffer),VSBuffer:r(d.VSBuffer),Array:r(d.Array),Object:r(d.Object)},o=typeof Buffer<"u";function s(z,x){if(typeof x>"u")z.write(n.Undefined);else if(typeof x=="string"){const J=R.VSBuffer.fromString(x);z.write(n.String),z.write(l(J.byteLength)),z.write(J)}else if(o&&Buffer.isBuffer(x)){const J=R.VSBuffer.wrap(x);z.write(n.Buffer),z.write(l(J.byteLength)),z.write(J)}else if(x instanceof R.VSBuffer)z.write(n.VSBuffer),z.write(l(x.byteLength)),z.write(x);else if(Array.isArray(x)){z.write(n.Array),z.write(l(x.length));for(const J of x)s(z,J)}else{const J=R.VSBuffer.fromString(JSON.stringify(x));z.write(n.Object),z.write(l(J.byteLength)),z.write(J)}}function h(z){switch(z.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return z.read(i(z)).toString();case d.Buffer:return z.read(i(z)).buffer;case d.VSBuffer:return z.read(i(z));case d.Array:{const J=i(z),X=[];for(let se=0;se<J;se++)X.push(h(z));return X}case d.Object:return JSON.parse(z.read(i(z)).toString())}}class a{constructor(x,J,X=null,se=1e3){this.protocol=x,this.ctx=J,this.logger=X,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:200})}registerChannel(x,J){this.channels.set(x,J),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const J=this.send([x.type]);this.logger?.logOutgoing(J,0,1,y(x.type));return}case 201:case 202:case 204:case 203:{const J=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(J,x.id,1,y(x.type),x.data);return}}}send(x,J=void 0){const X=new c;return s(X,x),s(X,J),this.sendBuffer(X.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const J=new g(x),X=h(J),se=h(J),j=X[0];switch(j){case 100:return this.logger?.logIncoming(x.byteLength,X[1],1,`${f(j)}: ${X[2]}.${X[3]}`,se),this.onPromise({type:j,id:X[1],channelName:X[2],name:X[3],arg:se});case 102:return this.logger?.logIncoming(x.byteLength,X[1],1,`${f(j)}: ${X[2]}.${X[3]}`,se),this.onEventListen({type:j,id:X[1],channelName:X[2],name:X[3],arg:se});case 101:return this.logger?.logIncoming(x.byteLength,X[1],1,`${f(j)}`),this.disposeActiveRequest({type:j,id:X[1]});case 103:return this.logger?.logIncoming(x.byteLength,X[1],1,`${f(j)}`),this.disposeActiveRequest({type:j,id:X[1]})}}onPromise(x){const J=this.channels.get(x.channelName);if(!J){this.collectPendingRequest(x);return}const X=new T.CancellationTokenSource;let se;try{se=J.call(this.ctx,x.name,x.arg,X.token)}catch(_){se=Promise.reject(_)}const j=x.id;se.then(_=>{this.sendResponse({id:j,data:_,type:201}),this.activeRequests.delete(x.id)},_=>{_ instanceof Error?this.sendResponse({id:j,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:j,data:_,type:203}),this.activeRequests.delete(x.id)});const H=(0,E.toDisposable)(()=>X.cancel());this.activeRequests.set(x.id,H)}onEventListen(x){const J=this.channels.get(x.channelName);if(!J){this.collectPendingRequest(x);return}const X=x.id,j=J.listen(this.ctx,x.name,x.arg)(H=>this.sendResponse({id:X,data:H,type:204}));this.activeRequests.set(x.id,j)}disposeActiveRequest(x){const J=this.activeRequests.get(x.id);J&&(J.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let J=this.pendingRequests.get(x.channelName);J||(J=[],this.pendingRequests.set(x.channelName,J));const X=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:x,timeoutTimer:X})}flushPendingRequests(x){const J=this.pendingRequests.get(x);if(J){for(const X of J)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var S;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(x,J=null){this.protocol=x,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=J}getChannel(x){const J=this;return{call(X,se,j){return J.isDisposed?Promise.reject(new P.CancellationError):J.requestPromise(x,X,se,j)},listen(X,se){return J.isDisposed?I.Event.None:J.requestEvent(x,X,se)}}}requestPromise(x,J,X,se=T.CancellationToken.None){const j=this.lastRequestId++,_={id:j,type:100,channelName:x,name:J,arg:X};if(se.isCancellationRequested)return Promise.reject(new P.CancellationError);let N;return new Promise((K,ee)=>{if(se.isCancellationRequested)return ee(new P.CancellationError);const ae=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(j),K(de.data);break;case 202:{this.handlers.delete(j);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ee(ve);break}case 203:this.handlers.delete(j),ee(de.data);break}};this.handlers.set(j,ue),this.sendRequest(_)};let Z=null;this.state===u.Idle?ae():(Z=(0,t.createCancelablePromise)(ue=>this.whenInitialized()),Z.then(()=>{Z=null,ae()}));const ne=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:j,type:101}),ee(new P.CancellationError)},oe=se.onCancellationRequested(ne);N=(0,E.combinedDisposable)((0,E.toDisposable)(ne),oe),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(x,J,X){const se=this.lastRequestId++,H={id:se,type:102,channelName:x,name:J,arg:X};let _=null;const N=new I.Emitter({onFirstListenerAdd:()=>{_=(0,t.createCancelablePromise)(K=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(N),this.sendRequest(H)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(N),this.sendRequest({id:se,type:103}))}}),V=K=>N.fire(K.data);return this.handlers.set(se,V),N.event}sendRequest(x){switch(x.type){case 100:case 102:{const J=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(J,x.id,0,`${f(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const J=this.send([x.type,x.id]);this.logger?.logOutgoing(J,x.id,0,f(x.type));return}}}send(x,J=void 0){const X=new c;return s(X,x),s(X,J),this.sendBuffer(X.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const J=new g(x),X=h(J),se=h(J),j=X[0];switch(j){case 200:return this.logger?.logIncoming(x.byteLength,0,0,y(j)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,X[1],0,y(j),se),this.onResponse({type:X[0],id:X[1],data:se})}}onResponse(x){if(x.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([L.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class A{get connections(){const x=[];return this._connections.forEach(J=>x.push(J)),x}constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:J,onDidClientDisconnect:X})=>{I.Event.once(J.onMessage)(j=>{const H=new g(j),_=h(H),N=new a(J,_),V=new w(J);this.channels.forEach((ee,ae)=>N.registerChannel(ae,ee));const K={channelServer:N,channelClient:V,ctx:_};this._connections.add(K),this._onDidAddConnection.fire(K),X(()=>{N.dispose(),V.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}getChannel(x,J){const X=this;return{call(se,j,H){let _;if((0,v.isFunction)(J)){const V=(0,D.getRandomElement)(X.connections.filter(J));_=V?Promise.resolve(V):I.Event.toPromise(I.Event.filter(X.onDidAddConnection,J))}else _=J.routeCall(X,se,j);const N=_.then(V=>V.channelClient.getChannel(x));return U(N).call(se,j,H)},listen(se,j){if((0,v.isFunction)(J))return X.getMulticastEvent(x,J,se,j);const H=J.routeEvent(X,se,j).then(_=>_.channelClient.getChannel(x));return U(H).listen(se,j)}}}getMulticastEvent(x,J,X,se){const j=this;let H=new E.DisposableStore;const _=new I.Emitter({onFirstListenerAdd:()=>{H=new E.DisposableStore;const N=new I.EventMultiplexer,V=new Map,K=ae=>{const ne=ae.channelClient.getChannel(x).listen(X,se),oe=N.add(ne);V.set(ae,oe)},ee=ae=>{const Z=V.get(ae);!Z||(Z.dispose(),V.delete(ae))};j.connections.filter(J).forEach(K),I.Event.filter(j.onDidAddConnection,J)(K,void 0,H),j.onDidRemoveConnection(ee,void 0,H),N.event(_.fire,_,H),H.add(N)},onLastListenerRemove:()=>{H.dispose()}});return _.event}registerChannel(x,J){this.channels.set(x,J),this._connections.forEach(X=>{X.channelServer.registerChannel(x,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class q{constructor(x,J,X=null){const se=new c;s(se,J),x.send(se.buffer),this.channelClient=new w(x,X),this.channelServer=new a(x,J,X)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,J){this.channelServer.registerChannel(x,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=q;function U(z){return{call(x,J,X){return z.then(se=>se.call(x,J,X))},listen(x,J){const X=new I.Relay;return z.then(se=>X.input=se.listen(x,J)),X.event}}}e.getDelayedChannel=U;function O(z){let x=!1;return{call(J,X,se){return x?z.call(J,X,se):(0,t.timeout)(0).then(()=>x=!0).then(()=>z.call(J,X,se))},listen(J,X){if(x)return z.listen(J,X);const se=new I.Relay;return(0,t.timeout)(0).then(()=>x=!0).then(()=>se.input=z.listen(J,X)),se.event}}}e.getNextTickChannel=O;class ${constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const J of x.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await I.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=$;var k;(function(z){function x(j,H){const _=j,N=H&&H.disableMarshalling,V=new Map;for(const K in _)X(K)&&V.set(K,I.Event.buffer(_[K],!0));return new class{listen(K,ee,ae){const Z=V.get(ee);if(Z)return Z;if(se(ee)){const ne=_[ee];if(typeof ne=="function")return ne.call(_,ae)}throw new Error(`Event not found: ${ee}`)}call(K,ee,ae){const Z=_[ee];if(typeof Z=="function"){if(!N&&Array.isArray(ae))for(let ne=0;ne<ae.length;ne++)ae[ne]=(0,C.revive)(ae[ne]);return Z.apply(_,ae)}throw new Error(`Method not found: ${ee}`)}}}z.fromService=x;function J(j,H){const _=H&&H.disableMarshalling;return new Proxy({},{get(N,V){if(typeof V=="string")return H?.properties?.has(V)?H.properties.get(V):se(V)?function(K){return j.listen(V,K)}:X(V)?j.listen(V):async function(...K){let ee;H&&!(0,v.isUndefinedOrNull)(H.context)?ee=[H.context,...K]:ee=K;const ae=await j.call(V,ee);return _?ae:(0,C.revive)(ae)};throw new Error(`Property not found: ${String(V)}`)}})}z.toService=J;function X(j){return j[0]==="o"&&j[1]==="n"&&b.isUpperAsciiLetter(j.charCodeAt(2))}function se(j){return/^onDynamic/.test(j)&&b.isUpperAsciiLetter(j.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const x=z.toString();if(x!=="[object Object]")return x}return z}function G(z){return Array.isArray(z)?z.map(F):F(z)}function W(z,x,J,X,se,j,H){H=G(H);const _=M[se],N=_[X%_.length];let V=[`%c[${z}]%c[${String(x).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(j)?(V=V.concat(H),V.push(")")):V.push(H),console.log.apply(console,V)}e.logWithColors=W;class B{constructor(x,J){this._outgoingPrefix=x,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,J,X,se,j){this._totalOutgoing+=x,W(this._outgoingPrefix,this._totalOutgoing,x,J,X,se,j)}logIncoming(x,J,X,se,j){this._totalIncoming+=x,W(this._incomingPrefix,this._totalIncoming,x,J,X,se,j)}}e.IPCLogger=B}),define(ie[141],re([0,1,17,3,38]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(I){this.port=I,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),I.start()}send(I){this.port.postMessage(I.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class L extends R.IPCClient{constructor(I,E){const C=new T(I);super(C,E),this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=L}),define(ie[91],re([0,1,17,3,2,38]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(L=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(o){o.enableDiagnostics=!1,o.records=[];const s=new WeakMap;let h=0;function a(w,A){if(!s.has(w)){const q=String(++h);s.set(w,q)}return s.get(w)}function S(w,A,q,U){if(!o.enableDiagnostics)return;const O=a(w,A);if(U instanceof D.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const $=D.VSBuffer.alloc(U.byteLength);$.set(U),o.records.push({timestamp:Date.now(),id:O,label:A,type:q,buff:$})}else o.records.push({timestamp:Date.now(),id:O,label:A,type:q,data:U})}o.traceSocketEvent=S})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function C(){return E||(E=D.VSBuffer.alloc(0)),E}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,h){if(s===0)return C();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return h&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const a=D.VSBuffer.alloc(s);let S=0,w=0;for(;s>0;){const A=this._chunks[w];if(A.byteLength>s){const q=A.slice(0,s);a.set(q,S),S+=s,h&&(this._chunks[w]=A.slice(s),this._totalLength-=s),s-=s}else a.set(A,S),S+=A.byteLength,h?(this._chunks.shift(),this._totalLength-=A.byteLength):w++,s-=A.byteLength}return a}}e.ChunkStream=b;var v;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(v||(v={}));function m(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,h,a,S){this.type=s,this.id=h,this.ack=a,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends R.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,S=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new p(a,S,w,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.VSBuffer.alloc(13);h.writeUInt8(s.type,0),h.writeUInt32BE(s.id,1),h.writeUInt32BE(s.ack,5),h.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(h,s.data)}_bufferAdd(s,h){const a=this._totalLength===0;return this._data.push(s,h),this._totalLength+=s.byteLength+h.byteLength,a}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,h){this._bufferAdd(s,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class g extends R.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=g;class c extends T.IPCClient{static fromSocket(s,h){return new c(new g(s),h)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,h,a=null){super(s,h,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class l{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,h=this._first;for(;h;)h=h.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let h=0,a=this._first;for(;a;)s[h++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const h=new l(s);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let h=0;h<r._HISTORY_LENGTH;h++)this.lastRuns[h]=s-1e3*h;setInterval(()=>{for(let h=r._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),h=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let S=0;S<r._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=h&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,h=null,a=r.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),h&&this._socketReader.acceptChunk(h),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,C());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new p(7,0,0,C());this._socketWriter.write(s)}sendResume(){const s=new p(8,0,0,C());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,h){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,C());this._socketWriter.write(s);const h=this._outgoingUnackMsg.toArray();for(let a=0,S=h.length;a<S;a++)this._socketWriter.write(h[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new p(6,0,0,C())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let a=0,S=h.length;a<S;a++)this._socketWriter.write(h[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,h,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const h=new p(2,0,0,s);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),h=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,S=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&a>=2e4&&S>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-h,2e4-a,2e4-S,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,C());this._socketWriter.write(s)}_sendKeepAlive(){const s=new p(9,0,0,C());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ie[142],re([0,1,92,3,38,141]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends R.IPCServer{static getOnDidClientConnect(){const I=t.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,C)=>C);return t.Event.map(I,E=>{const{port1:C,port2:b}=new MessageChannel,m={protocol:new T.Protocol(C),onDidClientDisconnect:t.Event.fromDOMEventEmitter(C,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),m})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(ie[68],re([0,1,49,6,17,24,135,9,3,2,32,90,85,38]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends m.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",g=>R.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class p{constructor(u,g){this.modulePath=u,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(c),this.child=null,this._client=null}getChannel(u){const g=this;return{call(c,d,l){return g.requestPromise(u,c,d,l)},listen(c,d){return g.requestEvent(u,c,d)}}}requestPromise(u,g,c,d=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(u),i=(0,t.createCancelablePromise)(o=>l.call(g,c,o)),r=d.onCancellationRequested(()=>i.cancel()),n=(0,E.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(u,g,c){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let d;const l=new I.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(u).listen(g,c)(l.fire,l),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,v.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,u,g);const c=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,L.isRemoteConsoleLog)(s)){(0,L.log)(s,`IPC Library: ${this.options.serverName}`);return}c.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const l=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&l.send(s.buffer.toString("base64")),r=c.event,n={send:i,onMessage:r};this._client=new m.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,h)=>{process.removeListener("exit",o),this.activeRequests.forEach(a=>(0,E.dispose)(a)),this.activeRequests.clear(),s!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+h),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:h})})}return this._client}getCachedChannel(u){let g=this.channels.get(u);return g||(g=this.client.getChannel(u),this.channels.set(u,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(ie[143],re([0,1,17,9,3,2,12,5,30,38,91]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class v{traceSocketEvent(a,S){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,S)}constructor(a,S=""){this._canWrite=!0,this.debugLabel=S,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,t.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener),this._closeListener=w=>{this.traceSocketEvent("close",{hadError:w}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const S=w=>{this.traceSocketEvent("read",w),a(D.VSBuffer.wrap(w))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(a){const S=w=>{a({type:0,hadError:w,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(a){const S=()=>{a()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=v;var m;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var f;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(f||(f={}));class p extends T.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,S){this.socket.traceSocketEvent(a,S)}constructor(a,S,w,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:w?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new y(this,S,w,A,this._onData,(q,U)=>this._write(q,U))),this._register(this._flowManager.onError(q=>{console.error(q),(0,t.onUnexpectedError)(q),this._onClose.fire({type:0,hadError:!0,error:q})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(q=>this._onClose.fire(q)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,S){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let w=2;a.byteLength<126?w+=0:a.byteLength<2**16?w+=2:w+=8;const A=D.VSBuffer.alloc(w);if(S?A.writeUInt8(194,0):A.writeUInt8(130,0),a.byteLength<126)A.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){A.writeUInt8(126,1);let q=1;A.writeUInt8(a.byteLength>>>8&255,++q),A.writeUInt8(a.byteLength>>>0&255,++q)}else{A.writeUInt8(127,1);let q=1;A.writeUInt8(0,++q),A.writeUInt8(0,++q),A.writeUInt8(0,++q),A.writeUInt8(0,++q),A.writeUInt8(a.byteLength>>>24&255,++q),A.writeUInt8(a.byteLength>>>16&255,++q),A.writeUInt8(a.byteLength>>>8&255,++q),A.writeUInt8(a.byteLength>>>0&255,++q)}this.socket.write(D.VSBuffer.concat([A,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),w=S.readUInt8(0),A=(w&128)>>>7,q=(w&64)>>>6,U=S.readUInt8(1),O=(U&128)>>>7,$=U&127;this._state.state=2,this._state.readLen=2+(O?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(q)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),w=S.readUInt8(1),A=(w&128)>>>7;let q=w&127,U=1;q===126?q=S.readUInt8(++U)*2**8+S.readUInt8(++U):q===127&&(q=S.readUInt8(++U)*0+S.readUInt8(++U)*0+S.readUInt8(++U)*0+S.readUInt8(++U)*0+S.readUInt8(++U)*2**24+S.readUInt8(++U)*2**16+S.readUInt8(++U)*2**8+S.readUInt8(++U));let O=0;A&&(O=S.readUInt8(++U)*2**24+S.readUInt8(++U)*2**16+S.readUInt8(++U)*2**8+S.readUInt8(++U)),this._state.state=3,this._state.readLen=q,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),c(S,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(S,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class y extends T.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,S,w,A,q,U){super(),this._tracer=a,this._onData=q,this._writeFn=U,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,S?(this._zlibInflateStream=this._register(new u(this._tracer,A,w,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const S=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(S,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,S){return new Promise((w,A)=>{a.write(S),a.flush(q=>w(q))})}acceptFrame(a,S,w){this._readQueue.push({data:a,isCompressed:S,isLastFrameOfMessage:w}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const S=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(S)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,S,w){return new Promise((A,q)=>{a.write(S),w&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(U=>A(U))})}}class u extends T.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,S,w,A){super(),this._tracer=a,this._recordInflateBytes=S,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(A),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent("zlibInflateData",q),this._pendingInflateData.push(D.VSBuffer.wrap(q))}),w&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this._zlibInflate.write(w.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const S=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(S)})}}class g extends T.Disposable{constructor(a,S){super(),this._tracer=a,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",w=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this._onError.fire(w)}),this._zlibDeflate.on("data",w=>{this._tracer.traceSocketEvent("zlibDeflateData",w),this._pendingDeflateData.push(D.VSBuffer.wrap(w))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let S=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.byteLength-4),a(S)})}}function c(h,a){if(a===0)return;const S=h.byteLength>>>2;for(let $=0;$<S;$++){const k=h.readUInt32BE($*4);h.writeUInt32BE(k^a,$*4)}const w=S*4,A=h.byteLength-w,q=a>>>24&255,U=a>>>16&255,O=a>>>8&255;A>=1&&h.writeUInt8(h.readUInt8(w)^q,w),A>=2&&h.writeUInt8(h.readUInt8(w+1)^U,w+1),A>=3&&h.writeUInt8(h.readUInt8(w+2)^O,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function l(){const h=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):a=(0,L.join)(b().os.tmpdir(),`vscode-ipc-${h}.sock`),r(a),a}e.createRandomIPCHandle=l;function i(h,a,S){const w=b().crypto.createHash("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${S}-${a}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${S}-${a}.sock`):A=(0,L.join)(h,`${S}-${a}.sock`),r(A),A}e.createStaticIPCHandle=i;function r(h){const a=d[P.platform];typeof a=="number"&&h.length>=a&&console.warn(`WARNING: IPC handle "${h}" is longer than ${a} chars, try a shorter --user-data-dir`)}class n extends E.IPCServer{static toClientConnectionEvent(a){const S=R.Event.fromNodeEventEmitter(a,"connection");return R.Event.map(S,w=>({protocol:new C.Protocol(new v(w,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(w,"close"))}))}constructor(a){super(n.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function o(h){return new Promise((a,S)=>{const w=b().net.createServer();w.on("error",S),w.listen(h,()=>{w.removeListener("error",S),a(new n(w))})})}e.serve=o;function s(h,a){return new Promise((S,w)=>{const A=b().net.createConnection(h,()=>{A.removeListener("error",w),S(C.Client.fromSocket(new v(A,`ipc-client${a}`),a))});A.once("error",w)})}e.connect=s}),define(ie[69],re([0,1,6,3,2,15]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(b){const v=b;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(v,m=Object.create(null)){super(),this.database=v,this.options=m,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=I.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((m,f)=>this.accept(f,m)),v.deleted?.forEach(m=>this.accept(m,void 0))}accept(v,m){if(this.state===I.Closed)return;let f=!1;(0,T.isUndefinedOrNull)(m)?f=this.cache.delete(v):this.cache.get(v)!==m&&(this.cache.set(v,m),f=!0),f&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===I.None&&(this.state=I.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,m){const f=this.cache.get(v);return(0,T.isUndefinedOrNull)(f)?m:f}getBoolean(v,m){const f=this.get(v);return(0,T.isUndefinedOrNull)(f)?m:f==="true"}getNumber(v,m){const f=this.get(v);return(0,T.isUndefinedOrNull)(f)?m:parseInt(f,10)}async set(v,m){if(this.state===I.Closed)return;if((0,T.isUndefinedOrNull)(m))return this.delete(v);const f=String(m);if(this.cache.get(v)!==f)return this.cache.set(v,f),this.pendingInserts.set(v,f),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===I.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=I.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((m,f)=>this.items.set(f,m)),v.delete?.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=C}),define(ie[144],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ie[145],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[146],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ie[147],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ie[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[151],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[152],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ie[153],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[154],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[155],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[156],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ie[157],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ie[158],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ie[159],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[160],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[161],re([10,11]),function(Q,e){return Q.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(ie[162],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ie[163],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ie[164],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[165],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[166],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[168],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ie[169],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ie[170],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ie[171],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ie[172],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ie[173],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ie[174],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ie[93],re([0,1,65,63,22,12,36,19,7]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class E{get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return I.URI.file((0,T.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=L.env.VSCODE_PORTABLE;return p?I.URI.file((0,T.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,T.resolve)(p):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?I.URI.file((0,T.resolve)(p)):I.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,T.resolve)(p);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const u=L.env.VSCODE_PORTABLE;return u?(0,T.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(y=>/^[^:/?#]+?:\/\//.test(y)?I.URI.parse(y):I.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?I.URI.parse(p):I.URI.file((0,T.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const y of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);u&&u[1]&&u[2]&&p.push([u[1],u[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=L.env.VSCODE_PORTABLE;return p?I.URI.file((0,T.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this._args}constructor(p,y,u){this._args=p,this.paths=y,this.productService=u,this.editSessionId=this.args.editSessionId}}pe([t.memoize],E.prototype,"appRoot",null),pe([t.memoize],E.prototype,"userHome",null),pe([t.memoize],E.prototype,"userDataPath",null),pe([t.memoize],E.prototype,"appSettingsHome",null),pe([t.memoize],E.prototype,"tmpDir",null),pe([t.memoize],E.prototype,"cacheHome",null),pe([t.memoize],E.prototype,"stateResource",null),pe([t.memoize],E.prototype,"userRoamingDataHome",null),pe([t.memoize],E.prototype,"userDataSyncHome",null),pe([t.memoize],E.prototype,"userDataSyncLogResource",null),pe([t.memoize],E.prototype,"editSessionsLogResource",null),pe([t.memoize],E.prototype,"remoteTunnelLogResource",null),pe([t.memoize],E.prototype,"sync",null),pe([t.memoize],E.prototype,"machineSettingsResource",null),pe([t.memoize],E.prototype,"workspaceStorageHome",null),pe([t.memoize],E.prototype,"localHistoryHome",null),pe([t.memoize],E.prototype,"keyboardLayoutResource",null),pe([t.memoize],E.prototype,"argvResource",null),pe([t.memoize],E.prototype,"isExtensionDevelopment",null),pe([t.memoize],E.prototype,"untitledWorkspacesHome",null),pe([t.memoize],E.prototype,"installSourcePath",null),pe([t.memoize],E.prototype,"builtinExtensionsPath",null),pe([t.memoize],E.prototype,"extensionsPath",null),pe([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],E.prototype,"extensionDevelopmentKind",null),pe([t.memoize],E.prototype,"extensionTestsLocationURI",null),pe([t.memoize],E.prototype,"debugExtensionHost",null),pe([t.memoize],E.prototype,"logLevel",null),pe([t.memoize],E.prototype,"extensionLogLevel",null),pe([t.memoize],E.prototype,"serviceMachineIdResource",null),pe([t.memoize],E.prototype,"telemetryLogResource",null),pe([t.memoize],E.prototype,"disableWorkspaceTrust",null),pe([t.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function C(f,p){return m(f["inspect-extensions"],f["inspect-brk-extensions"],5870,p,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=C;function b(f,p){return m(f["inspect-search"],f["inspect-brk-search"],5876,p,f.extensionEnvironment)}e.parseSearchPort=b;function v(f,p){return m(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,p,f.extensionEnvironment)}e.parsePtyHostPort=v;function m(f,p,y,u,g,c){const l=Number(p||f)||(u?null:y),i=l?Boolean(!!p):!1;let r;if(c)try{r=JSON.parse(c)}catch{}return{port:l,break:i,debugId:g,env:r}}}),define(ie[175],re([0,1,281,5,146]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,y,u=L){const g=p.find(h=>h.length>0&&h[0]!=="-"),c={},d=["_"],l=[],i={};let r;for(const h in y){const a=y[h];a.type==="subcommand"?h===g&&(r=a):(a.alias&&(c[h]=a.alias),a.type==="string"||a.type==="string[]"?(d.push(h),a.deprecates&&d.push(...a.deprecates)):a.type==="boolean"&&(l.push(h),a.deprecates&&l.push(...a.deprecates)),a.global&&(i[h]=a))}if(r&&g){const h=i;for(const A in r.options)h[A]=r.options[A];const a=p.filter(A=>A!==g),S=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,w=P(a,h,S);return{[g]:w,_:[]}}const n=D(p,{string:d,boolean:l,alias:c}),o={},s=n;o._=n._.map(h=>String(h)).filter(h=>h.length>0),delete s._;for(const h in y){const a=y[h];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let S=s[h];if(a.deprecates)for(const w of a.deprecates)s.hasOwnProperty(w)&&(S||(S=s[w],S&&u.onDeprecatedOption(w,a.deprecationMessage||(0,R.localize)(36,null,h))),delete s[w]);if(typeof S<"u"){if(a.type==="string[]"){if(Array.isArray(S)||(S=[S]),!a.allowEmptyValue){const w=S.filter(A=>A.length>0);w.length!==S.length&&(u.onEmptyValue(h),S=w.length>0?w:void 0)}}else a.type==="string"&&(Array.isArray(S)?(S=S.pop(),u.onMultipleValues(h,S)):!S&&!a.allowEmptyValue&&(u.onEmptyValue(h),S=void 0));o[h]=S,a.deprecationMessage&&u.onDeprecatedOption(h,a.deprecationMessage)}delete s[h]}for(const h in s)u.onUnknownOption(h);return o}e.parseArgs=P;function I(p,y){let u="";return y.args&&(Array.isArray(y.args)?u=` <${y.args.join("> <")}>`:u=` <${y.args}>`),y.alias?`-${y.alias} --${p}${u}`:`--${p}${u}`}function E(p,y){const u=[];for(const g in p){const c=p[g],d=I(g,c);u.push([d,c.description])}return C(u,y)}e.formatOptions=E;function C(p,y){const g=p.reduce((l,i)=>Math.max(l,i[0].length),12)+2+1;if(y-g<25)return p.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const c=y-g-1,d=[];for(const l of p){const i=l[0],r=v(l[1],c),n=b(g-i.length-2);d.push("  "+i+n+r[0]);for(let o=1;o<r.length;o++)d.push(b(g)+r[o])}return d}function b(p){return" ".repeat(p)}function v(p,y){const u=[];for(;p.length;){const g=p.length<y?p.length:p.lastIndexOf(" ",y),c=p.slice(0,g).trim();p=p.slice(g),u.push(c)}return u}function m(p,y,u,g,c){const d=process.stdout.isTTY&&process.stdout.columns||80,l=c?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",i=[`${p} ${u}`];i.push(""),i.push(`${(0,R.localize)(38,null)}: ${y} [${(0,R.localize)(39,null)}]${l}`),i.push(""),c?.noPipe!==!0&&(t.isWindows?i.push((0,R.localize)(40,null,y)):i.push((0,R.localize)(41,null,y)),i.push(""));const r={},n=[];for(const o in g){const s=g[o];if(s.type==="subcommand")s.description&&n.push({command:o,description:s.description});else if(s.description&&s.cat){let h=r[s.cat];h||(r[s.cat]=h={}),h[o]=s}}for(const o in r){const s=o,h=r[s];h&&(i.push(T[s]),i.push(...E(h,d)),i.push(""))}return n.length&&(i.push((0,R.localize)(42,null)),i.push(...C(n.map(o=>[o.command,o.description]),d)),i.push("")),i.join(`
`)}e.buildHelpMessage=m;function f(p,y){return`${p||(0,R.localize)(43,null)}
${y||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ie[176],re([0,1,282,147,175]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function L(v,m){const f=(d,l)=>{console.warn((0,t.localize)(0,null,d,l))},p=d=>{console.warn((0,t.localize)(1,null,d))},y=(d,l)=>{console.warn((0,t.localize)(2,null,d,l))},u=d=>({onUnknownOption:l=>{d!=="tunnel"&&console.warn((0,t.localize)(3,null,l,d))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:y,getSubcommandReporter:d!=="tunnel"?u:void 0}),g={onUnknownOption:d=>{console.warn((0,t.localize)(4,null,d))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:y,getSubcommandReporter:u},c=(0,R.parseArgs)(v,R.OPTIONS,m?g:void 0);return c.goto&&c._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,t.localize)(5,null))),c["max-memory"]&&D(parseInt(c["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),c}function P(v){const m=v.findIndex(f=>!/^-/.test(f));if(m>-1)return[...v.slice(0,m),...v.slice(m+1)]}function I(v){let[,...m]=v;process.env.VSCODE_DEV&&(m=P(m)||[]);const f=!b(process.env);return L(m,f)}e.parseMainProcessArgv=I;function E(v){let[,,...m]=v;return process.env.VSCODE_DEV&&(m=P(m)||[]),L(m,!0)}e.parseCLIProcessArgv=E;function C(v,...m){const f=v.indexOf("--");return f===-1?v.push(...m):v.splice(f,0,...m),v}e.addArg=C;function b(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function Q(e,D,t){function R(L,P){const I=T(L,P),E=[I];return e.isAbsolute(I)||E.unshift(t),e.resolve(...E)}function T(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,P);const C=L["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,P)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[177],re([283,34,36]),function(e,D,t){return Q(e,D,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[178],re([0,1,34,93,177]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends t.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=T}),define(ie[179],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(y){const u=y.match(L);return u?u[1]:null}function C(y){if(y.indexOf("://")===-1){const u=y.match(t);return u?E(u[2]):null}try{const u=D.URI.parse(y);if(u.authority)return E(u.authority)}catch{}return null}function b(y,u){const g=new Set;let c;for(;c=P.exec(y);){const l=C(c[1]);l&&g.add(l)}const d=new Set(u);return Array.from(g).map(l=>d.has(l)?l:l.replace(I,"a"))}e.getDomainsOfRemotes=b;function v(y){const u=y.match(T);return u?u[2]:null}function m(y,u,g){return y&&u?(g&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${y}${u}`:`${y}/${u}`):null}function f(y,u){if(y.indexOf("://")===-1){const g=y.match(R);if(g)return m(g[2],g[3],u)}try{const g=D.URI.parse(y);if(g.authority)return m(v(g.authority),g.path,u)}catch{}return null}function p(y,u=!1){const g=[];let c;for(;c=P.exec(y);){const d=f(c[1],u);d&&g.push(d)}return g}e.getRemotes=p}),define(ie[180],re([0,1,15,150]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(L,P,I){try{T(L,P,I)}catch{}return L}e.localizeManifest=R;function T(L,P,I){const E=(C,b,v)=>{const m=C[b];if((0,D.isString)(m)){const f=m,p=f.length;if(p>1&&f[0]==="%"&&f[p-1]==="%"){const y=f.substr(1,p-2);let u=P[y];u===void 0&&I&&(u=I[y]);const g=typeof u=="string"?u:u.message;if(g!==void 0){const c=I?.[y],d=typeof c=="string"?c:c?.message;if(v&&(b==="title"||b==="category")&&d&&d!==g){const l={value:g,original:d};C[b]=l}else C[b]=g}else console.warn(`[${L.name}]: ${(0,t.localize)(0,null,y)}`)}}else if((0,D.isObject)(m))for(const f in m)m.hasOwnProperty(f)&&(f==="commands"?E(m,f,!0):E(m,f,v));else if(Array.isArray(m))for(let f=0;f<m.length;f++)E(m,f,v)};for(const C in L)L.hasOwnProperty(C)&&E(L,C)}}),define(ie[181],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,L,P,I){return this.channel.call("promptImportantExtensionsInstallNotification",[T,L,P,I])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class t{constructor(T){this.service=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(ie[70],re([0,1,19,87,155,55]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=I;function E(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(L);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=E;function C(u){if(!u)return null;const g=u.majorBase,c=u.majorMustEqual,d=u.minorBase;let l=u.minorMustEqual;const i=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(g===0||(l=!1),r=!1);let n=0;if(u.preRelease){const o=P.exec(u.preRelease);if(o){const[,s,h,a]=o;n=Date.UTC(Number(s),Number(h)-1,Number(a))}}return{majorBase:g,majorMustEqual:c,minorBase:d,minorMustEqual:l,patchBase:i,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=C;function b(u,g,c){let d;typeof u=="string"?d=C(E(u)):d=u;let l;g instanceof Date?l=g.getTime():typeof g=="string"&&(l=new Date(g).getTime());let i;if(typeof c=="string"?i=C(E(c)):i=c,!d||!i)return!1;const r=d.majorBase,n=d.minorBase,o=d.patchBase;let s=i.majorBase,h=i.minorBase,a=i.patchBase;const S=i.notBefore;let w=i.majorMustEqual,A=i.minorMustEqual,q=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:n>h?!0:n<h||l&&l<S?!1:o>=a:(r===1&&s===0&&(!w||!A||!q)&&(s=1,h=0,a=0,w=!0,A=!1,q=!1),r<s?!1:r>s?!w:n<h?!1:n>h?!A:o<a?!1:o>a?!q:!(l&&l<S))}e.isValidVersion=b;function v(u,g,c,d,l){const i=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return i.push([t.default.Error,R.localize(0,null)]),i;if(typeof d.name!="string")return i.push([t.default.Error,R.localize(1,null,"name")]),i;if(typeof d.version!="string")return i.push([t.default.Error,R.localize(2,null,"version")]),i;if(!d.engines)return i.push([t.default.Error,R.localize(3,null,"engines")]),i;if(typeof d.engines.vscode!="string")return i.push([t.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof d.extensionDependencies<"u"&&!y(d.extensionDependencies))return i.push([t.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof d.activationEvents<"u"){if(!y(d.activationEvents))return i.push([t.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof d.main>"u"&&typeof d.browser>"u")return i.push([t.default.Error,R.localize(7,null,"activationEvents","main")]),i}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&i.push([t.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return i.push([t.default.Error,R.localize(9,null,"main")]),i;{const o=(0,D.joinPath)(c,d.main);(0,D.isEqualOrParent)(o,c)||i.push([t.default.Warning,R.localize(10,null,o.path,c.path)])}if(typeof d.activationEvents>"u")return i.push([t.default.Error,R.localize(11,null,"activationEvents","main")]),i}if(typeof d.browser<"u"){if(typeof d.browser!="string")return i.push([t.default.Error,R.localize(12,null,"browser")]),i;{const o=(0,D.joinPath)(c,d.browser);(0,D.isEqualOrParent)(o,c)||i.push([t.default.Warning,R.localize(13,null,o.path,c.path)])}if(typeof d.activationEvents>"u")return i.push([t.default.Error,R.localize(14,null,"activationEvents","browser")]),i}if(!T.valid(d.version))return i.push([t.default.Error,R.localize(15,null)]),i;const r=[];if(!m(u,g,d,l,r))for(const o of r)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=v;function m(u,g,c,d,l){return d||typeof c.main>"u"&&typeof c.browser>"u"?!0:p(u,g,c.engines.vscode,l)}e.isValidExtensionVersion=m;function f(u,g,c){return u==="*"||p(g,c,u)}e.isEngineValid=f;function p(u,g,c,d=[]){const l=C(E(c));if(!l)return d.push(R.localize(16,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return d.push(R.localize(17,null,c)),!1}else if(!l.majorMustEqual)return d.push(R.localize(18,null,c)),!1;return b(u,g,l)?!0:(d.push(R.localize(19,null,u,c)),!1)}function y(u){if(!Array.isArray(u))return!1;for(let g=0,c=u.length;g<c;g++)if(typeof u[g]!="string")return!1;return!0}}),define(ie[50],re([0,1,17,30]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,L,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await L.readFile(T.serviceMachineIdResource)).value.toString();I=(0,t.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,t.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(ie[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],L=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=D}),define(ie[94],re([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function T(P,I,E){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(E))),t.push([P,I])}e.registerSingleton=T;function L(){return t}e.getSingletonServiceDescriptors=L}),define(ie[182],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const P=this.lookupOrInsertNode(T),I=this.lookupOrInsertNode(L);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(const P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let P=this._nodes.get(L);return P||(P=new D(L,T),this._nodes.set(L,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[L,P]of this._nodes)T.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this._nodes){const P=new Set([T]),I=this._findCycle(L,P);if(I)return I}}_findCycle(T,L){for(const[P,I]of T.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const E=this._findCycle(I,L);if(E)return E;L.delete(P)}}}e.Graph=t}),define(ie[4],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function t(L,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:L,index:I}):(P[D.DI_DEPENDENCIES]=[{id:L,index:I}],P[D.DI_TARGET]=P)}function R(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const P=function(I,E,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,I,C)};return P.toString=()=>L,D.serviceIds.set(L,P),P}e.createDecorator=R;function T(L){return L}e.refineServiceDecorator=T}),define(ie[183],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ie[16],re([0,1,15,7,4]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=T;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=L;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(u,g){const c=Object.create(null);for(const d in u)C(c,d,u[d],g);return c}e.toValuesTree=E;function C(u,g,c,d){const l=g.split("."),i=l.pop();let r=u;for(let n=0;n<l.length;n++){const o=l[n];let s=r[o];switch(typeof s){case"undefined":s=r[o]=Object.create(null);break;case"object":break;default:d(`Ignoring ${g} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=c}catch{d(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function b(u,g){const c=g.split(".");v(u,c)}e.removeFromValueTree=b;function v(u,g){const c=g.shift();if(g.length===0){delete u[c];return}if(Object.keys(u).indexOf(c)!==-1){const d=u[c];typeof d=="object"&&!Array.isArray(d)&&(v(d,g),Object.keys(d).length===0&&delete u[c])}}function m(u,g,c){function d(r,n){let o=r;for(const s of n){if(typeof o!="object"||o===null)return;o=o[s]}return o}const l=g.split("."),i=d(u,l);return typeof i>"u"?c:i}e.getConfigurationValue=m;function f(u,g,c){Object.keys(g).forEach(d=>{d!=="__proto__"&&(d in u?D.isObject(u[d])&&D.isObject(g[d])?f(u[d],g[d],c):c&&(u[d]=g[d]):u[d]=g[d])})}e.merge=f;function p(u,g,c){const d=u.inspect(g),l=u.inspect(c);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:d.defaultValue}e.getMigratedSettingValue=p;function y(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(ie[184],re([0,1,5,27,4]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const L=Object.prototype.hasOwnProperty;var P;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return b.INSTANCE}static true(){return v.INSTANCE}static has(k){return m.create(k)}static equals(k,M){return f.create(k,M)}static notEquals(k,M){return u.create(k,M)}static regex(k,M){return n.create(k,M)}static in(k,M){return p.create(k,M)}static notIn(k,M){return y.create(k,M)}static not(k){return g.create(k)}static and(...k){return h.create(k,null,!0)}static or(...k){return a.create(k,null,!0)}static greater(k,M){return d.create(k,M)}static greaterEquals(k,M){return l.create(k,M)}static smaller(k,M){return i.create(k,M)}static smallerEquals(k,M){return r.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){const F=k.split("||");return a.create(F.map(G=>this._deserializeAndExpression(G,M)),null,!0)}static _deserializeAndExpression(k,M){const F=k.split("&&");return h.create(F.map(G=>this._deserializeOne(G,M)),null,!0)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){const F=k.split("!=");return u.create(F[0].trim(),this._deserializeValue(F[1],M))}if(k.indexOf("==")>=0){const F=k.split("==");return f.create(F[0].trim(),this._deserializeValue(F[1],M))}if(k.indexOf("=~")>=0){const F=k.split("=~");return n.create(F[0].trim(),this._deserializeRegexValue(F[1],M))}if(k.indexOf(" not in ")>=0){const F=k.split(" not in ");return y.create(F[0].trim(),this._deserializeValue(F[1],M))}if(k.indexOf(" in ")>=0){const F=k.split(" in ");return p.create(F[0].trim(),this._deserializeValue(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const F=k.split(">=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const F=k.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const F=k.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const F=k.split("<");return i.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):m.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const F=/^'([^']*)'$/.exec(k);return F?F[1].trim():k}static _deserializeRegexValue(k,M){if((0,t.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=k.indexOf("/"),G=k.lastIndexOf("/");if(F===G||F<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const W=k.slice(F+1,G),B=k[G+1]==="i"?"i":"";try{return new RegExp(W,B)}catch(z){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${z}`);return console.warn(`bad regexp-value '${k}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function E($,k){const M=$?$.substituteConstants():void 0,F=k?k.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=E;function C($,k){return $.cmp(k)}class b{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class v{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class m{static create(k,M=null){const F=T.get(k);return typeof F=="boolean"?F?v.INSTANCE:b.INSTANCE:new m(k,M)}constructor(k,M){this.key=k,this.negated=M,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?v.INSTANCE:b.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class f{static create(k,M,F=null){if(typeof M=="boolean")return M?m.create(k,F):g.create(k,F);const G=T.get(k);return typeof G=="boolean"?M===(G?"true":"false")?v.INSTANCE:b.INSTANCE:new f(k,M,F)}constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?v.INSTANCE:b.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class p{static create(k,M){return new p(k,M)}constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),F=k.getValue(this.key);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?L.call(M,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class y{static create(k,M){return new y(k,M)}constructor(k,M){this.key=k,this.valueKey=M,this.type=11,this._negated=p.create(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class u{static create(k,M,F=null){if(typeof M=="boolean")return M?g.create(k,F):m.create(k,F);const G=T.get(k);return typeof G=="boolean"?M===(G?"true":"false")?b.INSTANCE:v.INSTANCE:new u(k,M,F)}constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?b.INSTANCE:v.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class g{static create(k,M=null){const F=T.get(k);return typeof F=="boolean"?F?b.INSTANCE:v.INSTANCE:new g(k,M)}constructor(k,M){this.key=k,this.negated=M,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?b.INSTANCE:v.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function c($,k){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?k($):b.INSTANCE}class d{static create(k,M,F=null){return c(M,G=>new d(k,G,F))}constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class l{static create(k,M,F=null){return c(M,G=>new l(k,G,F))}constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class i{static create(k,M,F=null){return c(M,G=>new i(k,G,F))}constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class r{static create(k,M,F=null){return c(M,G=>new r(k,G,F))}constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{static create(k,M){return new n(k,M)}constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return M<F?-1:M>F?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return this.key===k.key&&M===F}return!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class o{static create(k){return new o(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new o(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function s($){let k=null;for(let M=0,F=$.length;M<F;M++){const G=$[M].substituteConstants();if($[M]!==G&&k===null){k=[];for(let W=0;W<M;W++)k[W]=$[W]}k!==null&&(k[M]=G)}return k===null?$:k}class h{static create(k,M,F){return h._normalizeArr(k,M,F)}constructor(k,M){this.expr=k,this.negated=M,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const G=C(this.expr[M],k.expr[M]);if(G!==0)return G}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:h.create(k,this.negated,!1)}evaluate(k){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M,F){const G=[];let W=!1;for(const B of k)if(!!B){if(B.type===1){W=!0;continue}if(B.type===0)return b.INSTANCE;if(B.type===6){G.push(...B.expr);continue}G.push(B)}if(G.length===0&&W)return v.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(C);for(let B=1;B<G.length;B++)G[B-1].equals(G[B])&&(G.splice(B,1),B--);if(G.length===1)return G[0];for(;G.length>1;){const B=G[G.length-1];if(B.type!==9)break;G.pop();const z=G.pop(),x=G.length===0,J=a.create(B.expr.map(X=>h.create([X,z],null,F)),null,x);J&&(G.push(J),G.sort(C))}if(G.length===1)return G[0];if(F){for(let B=0;B<G.length;B++)for(let z=B+1;z<G.length;z++)if(G[B].negate().equals(G[z]))return b.INSTANCE;if(G.length===1)return G[0]}return new h(G,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new h(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());this.negated=a.create(k,this,!0)}return this.negated}}class a{static create(k,M,F){return a._normalizeArr(k,M,F)}constructor(k,M){this.expr=k,this.negated=M,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const G=C(this.expr[M],k.expr[M]);if(G!==0)return G}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:a.create(k,this.negated,!1)}evaluate(k){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,F){let G=[],W=!1;if(k){for(let B=0,z=k.length;B<z;B++){const x=k[B];if(!!x){if(x.type===0){W=!0;continue}if(x.type===1)return v.INSTANCE;if(x.type===9){G=G.concat(x.expr);continue}G.push(x)}}if(G.length===0&&W)return b.INSTANCE;G.sort(C)}if(G.length!==0){if(G.length===1)return G[0];for(let B=1;B<G.length;B++)G[B-1].equals(G[B])&&(G.splice(B,1),B--);if(G.length===1)return G[0];if(F){for(let B=0;B<G.length;B++)for(let z=B+1;z<G.length;z++)if(G[B].negate().equals(G[z]))return v.INSTANCE;if(G.length===1)return G[0]}return new a(G,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new a(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),F=k.shift(),G=[];for(const W of O(M))for(const B of O(F))G.push(h.create([W,B],null,!1));k.unshift(a.create(G,null,!1))}this.negated=a.create(k,this,!0)}return this.negated}}class S extends m{static all(){return S._info.values()}constructor(k,M,F){super(k,null),this._defaultValue=M,typeof F=="object"?S._info.push({...F,key:k}):F!==!0&&S._info.push({key:k,description:F,type:M!=null?typeof M:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return f.create(this.key,k)}notEqualsTo(k){return u.create(this.key,k)}}e.RawContextKey=S,S._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w($,k){return $<k?-1:$>k?1:0}function A($,k,M,F){return $<M?-1:$>M?1:k<F?-1:k>F?1:0}function q($,k){if($.type===0||k.type===1)return!0;if($.type===9)return k.type===9?U($.expr,k.expr):!1;if(k.type===9){for(const M of k.expr)if(q($,M))return!0;return!1}if($.type===6){if(k.type===6)return U(k.expr,$.expr);for(const M of $.expr)if(q(M,k))return!0;return!1}return $.equals(k)}e.implies=q;function U($,k){let M=0,F=0;for(;M<$.length&&F<k.length;){const G=$[M].cmp(k[F]);if(G<0)return!1;G===0&&M++,F++}return M===$.length}function O($){return $.type===9?$.expr:[$]}}),define(ie[95],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function t(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=t;class R{async getPerformanceInfo(L,P){return{}}async getSystemInfo(L,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,P){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=R}),define(ie[96],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ie[13],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[29],re([0,1,149,4]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function T(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function L(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function P(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(u,g,c){return P(g,c)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===c?!0:E(c).includes(u)}e.isTargetPlatformCompatible=I;function E(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=C;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var m;(function(u){u.Install="install",u.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(g,c){super(g),this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ie[185],re([0,1,3,2,67,32,7,136,29]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(y,u){return L.URI.revive(u?u.transformIncoming(y):y)}function C(y,u){return u?u.transformOutgoingURI(y):y}function b(y,u){u=u||P.DefaultURITransformer;const g=y.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...y,manifest:void 0},u),manifest:g}}function v(y,u){return u?(0,T.cloneAndChange)(y,g=>g instanceof L.URI?u.transformOutgoingURI(g):void 0):y}class m{constructor(u,g){this.service=u,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,g){const c=this.getUriTransformer(u);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(l=>({...l,local:l.local?v(l.local,c):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,g,c){const d=this.getUriTransformer(u);switch(g){case"zip":return this.service.zip(b(c[0],d)).then(l=>C(l,d));case"unzip":return this.service.unzip(E(c[0],d));case"install":return this.service.install(E(c[0],d),(0,R.revive)(c[1]));case"getManifest":return this.service.getManifest(E(c[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,R.revive)(c[1]));case"uninstall":return this.service.uninstall(b(c[0],d),(0,R.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(b(c[0],d));case"getInstalled":return this.service.getInstalled(c[0],L.URI.revive(c[1])).then(l=>l.map(i=>v(i,d)));case"getMetadata":return this.service.getMetadata(b(c[0],d));case"updateMetadata":return this.service.updateMetadata(b(c[0],d),c[1]).then(l=>v(l,d));case"updateExtensionScope":return this.service.updateExtensionScope(b(c[0],d),c[1]).then(l=>v(l,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class f extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?L.URI.revive(g.source):g.source,profileLocation:L.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(c=>({...c,local:c.local?b(c.local,null):c.local,source:this.isUriComponents(c.source)?L.URI.revive(c.source):c.source,profileLocation:L.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:L.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:L.URI.revive(g.profileLocation)})))}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const g=await this.getTargetPlatform();return u.allTargetPlatforms.some(c=>(0,I.isTargetPlatformCompatible)(c,u.allTargetPlatforms,g))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(g=>L.URI.revive(g)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,g){return Promise.resolve(this.channel.call("install",[u,g])).then(c=>b(c,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,g){return Promise.resolve(this.channel.call("installFromGallery",[u,g])).then(c=>b(c,null))}uninstall(u,g){return Promise.resolve(this.channel.call("uninstall",[u,g]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u]))}getInstalled(u=null,g){return Promise.resolve(this.channel.call("getInstalled",[u,g])).then(c=>c.map(d=>b(d,null)))}getMetadata(u){return Promise.resolve(this.channel.call("getMetadata",[u]))}updateMetadata(u,g){return Promise.resolve(this.channel.call("updateMetadata",[u,g])).then(c=>b(c,null))}updateExtensionScope(u,g){return Promise.resolve(this.channel.call("updateExtensionScope",[u,g])).then(c=>b(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,g){const c=await this.channel.call("download",[u,g]);return L.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class p{constructor(u){this.service=u}listen(u,g){throw new Error("Invalid listen")}call(u,g,c){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(ie[97],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class t{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((T,L)=>Q(["vsce-sign"],async P=>T(P),L))),this.moduleLoadingPromise}async verify(T,L){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(T,L)}}e.ExtensionSignatureVerificationService=t}),define(ie[98],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function R(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ie[14],re([0,1,48,12,27,15,7,157,4]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function E(W){return W.create===!0}e.isFileOpenForWriteOptions=E;var C;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var b;(function(W){W[W.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var v;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=m;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function p(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=p;function y(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function u(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=u;function g(W){return m(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var c;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(B,z){super(B),this.code=z}}e.FileSystemProviderError=d;function l(W,B){const z=new d(W.toString(),B);return r(z,B),z}e.createFileSystemProviderError=l;function i(W){return W||l((0,P.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=i;function r(W,B){return W.name=B?`${B} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=r;function n(W){if(!W)return c.Unknown;if(W instanceof d)return W.code;const B=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!B)return c.Unknown;switch(B[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=n;function o(W){if(W instanceof A)return W.fileOperationResult;switch(n(W)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class h{constructor(B,z,x){this.resource=B,this.operation=z,this.target=x}isOperation(B){return this.operation===B}}e.FileOperationEvent=h;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class S{constructor(B,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const x=new Map;for(const J of B){const X=x.get(J.type);switch(X?X.push([J.resource,J]):x.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,X]of x)switch(J){case 1:this.added=D.TernarySearchTree.forUris(()=>z),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>z),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>z),this.deleted.fill(X);break}}contains(B,...z){return this.doContains(B,{includeChildren:!1},...z)}affects(B,...z){return this.doContains(B,{includeChildren:!0},...z)}doContains(B,z,...x){if(!B)return!1;const J=x.length>0;return!!((!J||x.includes(1))&&(this.added?.get(B)||z.includeChildren&&this.added?.findSuperstr(B))||(!J||x.includes(0))&&(this.updated?.get(B)||z.includeChildren&&this.updated?.findSuperstr(B))||(!J||x.includes(2))&&(this.deleted?.findSubstr(B)||z.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=S;function w(W,B,z){return!W||!B||W===B||B.length>W.length?!1:(B.charAt(B.length-1)!==t.sep&&(B+=t.sep),z?(0,R.startsWithIgnoreCase)(W,B):W.indexOf(B)===0)}e.isParent=w;class A extends Error{constructor(B,z,x){super(B),this.fileOperationResult=z,this.options=x}}e.FileOperationError=A;class q extends A{constructor(B,z,x){super(B,2,x),this.stat=z}}e.NotModifiedSinceFileOperationError=q;var U;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=$;async function k(W,B){if(!B.hasProvider(L.URI.from({scheme:W.scheme})))return new Promise(z=>{const x=B.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===W.scheme&&J.added&&(x.dispose(),z())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(B){return(0,T.isNumber)(B)||(B=0),B<M.KB?(0,P.localize)(1,null,B.toFixed(0)):B<M.MB?(0,P.localize)(2,null,(B/M.KB).toFixed(2)):B<M.GB?(0,P.localize)(3,null,(B/M.MB).toFixed(2)):B<M.TB?(0,P.localize)(4,null,(B/M.GB).toFixed(2)):(0,P.localize)(5,null,(B/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function G(W){return{maxFileSize:W===0?300*M.MB:16*M.GB,maxHeapSize:W===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G});var Y=this&&this.__param||function(Q,e){return function(D,t){e(D,t,Q)}};define(ie[186],re([0,1,99,42,14]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}async checksum(P){const I=(await this.fileService.readFileStream(P)).value;return new Promise((E,C)=>{const b=(0,D.createHash)("md5");(0,t.listenStream)(I,{onData:v=>b.update(v.buffer),onError:v=>C(v),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};T=pe([Y(0,R.IFileService)],T),e.ChecksumService=T}),define(ie[187],re([0,1,17,37,9,3,2,42,7,30,14]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends L.Disposable{constructor(m,f){super(),this.channel=m,this.extraCapabilities=f,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,f){const{buffer:p}=await this.channel.call("readFile",[m,f]);return p}readFileStream(m,f,p){const y=(0,P.newWriteableStream)(g=>D.VSBuffer.concat(g.map(c=>D.VSBuffer.wrap(c))).buffer),u=this.channel.listen("readFileStream",[m,f])(g=>{if(g instanceof D.VSBuffer)y.write(g.buffer);else{if(g==="end")y.end();else{let c=g;c instanceof Error||(c=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(c),C.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}u.dispose()}});return p.onCancellationRequested(()=>{y.error((0,R.canceled)()),y.end(),u.dispose()}),y}writeFile(m,f,p){return this.channel.call("writeFile",[m,D.VSBuffer.wrap(f),p])}open(m,f){return this.channel.call("open",[m,f])}close(m){return this.channel.call("close",[m])}async read(m,f,p,y,u){const[g,c]=await this.channel.call("read",[m,f,u]);return p.set(g.buffer.slice(0,c),y),c}write(m,f,p,y,u){return this.channel.call("write",[m,f,D.VSBuffer.wrap(p),y,u])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,f){return this.channel.call("delete",[m,f])}rename(m,f,p){return this.channel.call("rename",[m,f,p])}copy(m,f,p){return this.channel.call("copy",[m,f,p])}cloneFile(m,f){return this.channel.call("cloneFile",[m,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const f=m;this._onDidChange.fire(f.map(p=>({resource:I.URI.revive(p.resource),type:p.type})))}else{const f=m;this._onDidWatchError.fire(f)}}))}watch(m,f){const p=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,p,m,f]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=b}),define(ie[100],re([0,1,17,9,158,14]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(C,b,v,m,f,p){let y;try{await P(C,b,v,m,f,p)}catch(u){y=u}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&v.error(y),v.end()}}e.readFileIntoStream=L;async function P(C,b,v,m,f,p){I(p);const y=await C.open(b,{create:!1});try{I(p);let u=0,g=0,c=f&&typeof f.length=="number"?f.length:void 0,d=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),l=f&&typeof f.position=="number"?f.position:0,i=0;do g=await C.read(y,l,d.buffer,i,d.byteLength-i),l+=g,i+=g,u+=g,typeof c=="number"&&(c-=g),i===d.byteLength&&(await v.write(m(d)),d=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),i=0);while(g>0&&(typeof c!="number"||c>0)&&I(p)&&E(u,f));if(i>0){let r=i;typeof c=="number"&&(r=Math.min(i,c)),v.write(m(d.slice(0,r)))}}catch(u){throw(0,T.ensureFileSystemProviderError)(u)}finally{await C.close(y)}}function I(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function E(C,b){if(b?.limits){if(typeof b.limits.memory=="number"&&C>b.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&C>b.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[57],re([0,1,88,2,12,5,7,14]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class E extends t.Disposable{constructor(g,c,d,l){super(),this.onFileChanges=g,this.onLogMessage=c,this.verboseLogging=d,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new t.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),g.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),g.add(this.watcher.onDidError(c=>this.onError(c)))}onError(g){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class C extends E{constructor(g,c,d){super(g,c,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class b extends E{constructor(g,c,d){super(g,c,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function v(u){return u.map(g=>({type:g.type,resource:L.URI.file(g.path)}))}e.toFileChanges=v;function m(u){const g=new y;for(const c of u)g.processEvent(c);return g.coalesce()}e.coalesceEvents=m;function f(u,g){return typeof g=="string"&&!g.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=f;function p(u,g){const c=[];for(const d of g)c.push((0,D.parse)(f(u,d)));return c}e.parseWatcherPatterns=p;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return T.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const c=this.mapPathToChange.get(this.toKey(g));let d=!1;if(c){const l=c.type,i=g.type;c.path!==g.path&&(g.type===2||g.type===1)?d=!0:l===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(c)):l===2&&i===1?c.type=0:l===1&&i===0||(c.type=i)}else d=!0;d&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],c=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,l)=>d.path.length-l.path.length).filter(d=>c.some(l=>(0,P.isParent)(d.path,l,!T.isLinux))?!1:(c.push(d.path),!0)).concat(g)}}}),define(ie[188],re([0,1,54,6,24,47,2,83,12,5,138,28,57]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends L.Disposable{constructor(y,u,g,c){super(),this.request=y,this.onDidFilesChange=u,this.onLogMessage=g,this.verboseLogging=c,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(m.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await b.Promises.stat(y);this._register(await this.doWatch(y,u.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let u=y.path;try{u=await b.Promises.realpath(y.path),y.path===u&&(u=await(0,C.realcase)(y.path)??y.path),y.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${u})`)}catch{}return u}async doWatch(y,u){if(E.isMacintosh&&(0,T.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const g=new R.CancellationTokenSource(this.cts.token),c=new L.DisposableStore;try{const d=(0,I.basename)(y),l=(0,D.watch)(y);c.add((0,L.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${y}'`);const i=new Set;if(u)try{for(const n of await b.Promises.readdir(y))i.add(n)}catch(n){this.error(n)}const r=new Map;c.add((0,L.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),l.on("error",(n,o)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),l.on("change",(n,o)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${o}`);let s="";if(o&&(s=o.toString(),E.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){r.get(s)?.dispose();const h=setTimeout(async()=>{if(r.delete(s),s===d&&!await b.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,I.join)(y,s));if(g.token.isCancellationRequested)return;let S;a?i.has(s)?S=0:(S=1,i.add(s)):(i.delete(s),S=2),this.onFileChange({path:(0,I.join)(this.request.path,s),type:S})},m.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,L.toDisposable)(()=>clearTimeout(h)))}else{let h;i.has(s)?h=0:(h=1,i.add(s)),this.onFileChange({path:(0,I.join)(this.request.path,s),type:h})}else if(n==="rename"||s!==d){const h=setTimeout(async()=>{const a=await b.Promises.exists(y);g.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},m.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,L.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await b.Promises.exists(y)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${d.toString()})`)}return(0,L.toDisposable)(()=>{g.dispose(!0),c.dispose()})}async onFileChange(y,u=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!u&&this.excludes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,v.coalesceEvents)(g);if(c.length>0){if(this.verboseLogging)for(const l of c)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(E.isLinux)return b.Promises.exists(y);try{const u=(0,I.basename)(y);return(await b.Promises.readdir((0,I.dirname)(y))).some(c=>c===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.FILE_DELETE_HANDLER_DELAY=100,m.FILE_CHANGES_HANDLER_DELAY=50;async function f(p,y,u,g,c=512){const d=await b.Promises.open(p,"r"),l=Buffer.allocUnsafe(c),i=new R.CancellationTokenSource(g);let r,n=!1;const o={path:p,excludes:[],recursive:!1},s=new m(o,h=>{(async()=>{for(const{type:a}of h)if(a===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:S}=await b.Promises.read(d,l,0,c,null);if(!S||i.token.isCancellationRequested)break;y(l.slice(0,S))}}catch(S){r=new Error(S),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,u(),new Promise((h,a)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(d)}catch(S){r=new Error(S)}r?a(r):h()})})}e.watchFileContents=f}),define(ie[189],re([0,1,3,88,2,5,188]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const C=this.normalizeRequests(E),b=C.filter(m=>{const f=this.watchers.get(m.path);return f?!(0,t.patternsEquals)(f.request.excludes,m.excludes)||!(0,t.patternsEquals)(f.request.includes,m.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:m})=>!C.find(f=>f.path===m.path&&(0,t.patternsEquals)(f.excludes,m.excludes)&&(0,t.patternsEquals)(f.includes,m.includes))).map(({request:m})=>m.path);b.length&&this.trace(`Request to start watching: ${b.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const m of v)this.stopWatching(m);for(const m of b)this.startWatching(m)}startWatching(E){const C=new L.NodeJSFileWatcherLibrary(E,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),b={request:E,instance:C};this.watchers.set(E.path,b)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const C=this.watchers.get(E);C&&(this.watchers.delete(E),C.instance.dispose())}normalizeRequests(E){const C=new Map;for(const b of E){const v=T.isLinux?b.path:b.path.toLowerCase();C.set(v,b)}return Array.from(C.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,C]of this.watchers)C.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,C){return C?`[File Watcher (node.js)] ${E} (path: ${C.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(ie[190],re([0,1,57,189]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,I){super(L,P,I),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(ie[191],re([0,1,22,38,68,57]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends T.AbstractUniversalWatcherClient{constructor(I,E,C){super(I,E,C),this.init()}createWatcher(I){const E=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(E.onDidProcessExit(({code:C,signal:b})=>this.onError(`terminated by itself with code ${C}, signal: ${b}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(ie[71],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[T,L]of R)this.set(T,L)}set(R,T){const L=this._entries.get(R);return this._entries.set(R,T),L}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(ie[192],re([0,1,6,9,2,56,182,4,71,82]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class v{constructor(y=new I.ServiceCollection,u=!1,g,c=C){this._services=y,this._strict=u,this._parent=g,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=c?g?._globalGraph??new L.Graph(d=>d):void 0}createChild(y){return new v(y,this._strict,this,this._enableTracing)}invokeFunction(y,...u){const g=f.traceInvocation(this._enableTracing,y);let c=!1;try{return y({get:l=>{if(c)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(l,g);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...u)}finally{c=!0,g.stop()}}createInstance(y,...u){let g,c;return y instanceof T.SyncDescriptor?(g=f.traceCreation(this._enableTracing,y.ctor),c=this._createInstance(y.ctor,y.staticArguments.concat(u),g)):(g=f.traceCreation(this._enableTracing,y),c=this._createInstance(y,u,g)),g.stop(),c}_createInstance(y,u=[],g){const c=P._util.getServiceDependencies(y).sort((i,r)=>i.index-r.index),d=[];for(const i of c){const r=this._getOrCreateServiceInstance(i.id,g);r||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${i.id}.`,!1),d.push(r)}const l=c.length>0?c[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${y.name} at position ${l+1} conflicts with ${u.length} static arguments`);const i=l-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,l)}return Reflect.construct(y,u.concat(d))}_setServiceInstance(y,u){if(this._services.get(y)instanceof T.SyncDescriptor)this._services.set(y,u);else if(this._parent)this._parent._setServiceInstance(y,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const u=this._services.get(y);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):u}_getOrCreateServiceInstance(y,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const g=this._getServiceInstanceOrDescriptor(y);return g instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,g,u.branch(y,!0)):(u.branch(y,!1),g)}_safeCreateAndCacheServiceInstance(y,u,g){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,u,g)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,u,g){const c=new L.Graph(i=>i.id.toString());let d=0;const l=[{id:y,desc:u,_trace:g}];for(;l.length;){const i=l.pop();if(c.lookupOrInsertNode(i),d++>1e3)throw new b(c);for(const r of P._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(r.id);if(n||this._throwIfStrict(`[createInstance] ${y} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof T.SyncDescriptor){const o={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};c.insertEdge(i,o),l.push(o)}}}for(;;){const i=c.roots();if(i.length===0){if(!c.isEmpty())throw new b(c);break}for(const{data:r}of i){if(this._getServiceInstanceOrDescriptor(r.id)instanceof T.SyncDescriptor){const o=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,o)}c.removeNode(r)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,u,g=[],c,d){if(this._services.get(y)instanceof T.SyncDescriptor)return this._createServiceInstance(y,u,g,c,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,u,g,c,d);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(y,u,g=[],c,d){if(c){const l=new v(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(y);const i=new Map,r=new D.IdleValue(()=>{const n=l._createInstance(u,g,d);for(const[o,s]of i){const h=n[o];if(typeof h=="function")for(const a of s)h.apply(n,a)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=i.get(o);return a||(a=new E.LinkedList,i.set(o,a)),(w,A,q)=>{const U=a.push([w,A,q]);return(0,R.toDisposable)(U)}}if(o in n)return n[o];const s=r.value;let h=s[o];return typeof h!="function"||(h=h.bind(s),n[o]=h),h},set(n,o,s){return r.value[o]=s,!0}})}else return this._createInstance(u,g,d)}_throwIfStrict(y,u){if(u&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=v;var m;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(m||(m={}));class f{static traceInvocation(y,u){return y?new f(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(y,u){return y?new f(0,u.name):f._None}constructor(y,u){this.type=y,this.name=u,this._start=Date.now(),this._dep=[]}branch(y,u){const g=new f(2,y.toString());return this._dep.push([y,u,g]),g}stop(){const y=Date.now()-this._start;f._totals+=y;let u=!1;function g(d,l){const i=[],r=new Array(d+1).join("	");for(const[n,o,s]of l._dep)if(o&&s){u=!0,i.push(`${r}CREATES -> ${n}`);const h=g(d+1,s);h&&i.push(h)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(y>2||u)&&f.all.add(c.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ie[193],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(ie[58],re([0,1,38,56,94,4]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(m,f,p,y){const u=p.getChannel(m);return P(f)?y.createInstance(new t.SyncDescriptor(f.channelClientCtor,[u])):D.ProxyChannel.toService(u,f?.proxyOptions)}}function P(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let I=class extends L{constructor(m,f,p,y){super(m,f,p,y)}};I=pe([Y(2,e.IMainProcessService),Y(3,T.IInstantiationService)],I);function E(v,m,f){(0,R.registerSingleton)(v,new t.SyncDescriptor(I,[m,f],!0))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let C=class extends L{constructor(m,f,p,y){super(m,f,p,y)}};C=pe([Y(2,e.ISharedProcessService),Y(3,T.IInstantiationService)],C);function b(v,m,f){(0,R.registerSingleton)(v,new t.SyncDescriptor(C,[m,f],!0))}e.registerSharedProcessRemoteService=b}),define(ie[72],re([0,1,24,2,5,160,29,4]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let I=class extends t.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new D.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const m=b.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(p=>p.startsWith("lp-"))).map(f=>{const p=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,p,f),extensionId:f.identifier.id,galleryExtension:f}});return m.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),m}getLocale(C){return C.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C,b,v){const m=b??C;let f;if(m!==C&&(f=`(${C})`),C.toLowerCase()===R.language.toLowerCase()&&(f??="",f+=(0,T.localize)(0,null)),v?.installCount){f??="";const p=v.installCount;let y;p>1e6?y=`${Math.floor(p/1e5)/10}M`:p>1e3?y=`${Math.floor(p/1e3)}K`:y=String(p),f+=` $(cloud-download) ${y}`}return{id:C,label:m,description:f}}};I=pe([Y(0,L.IExtensionGalleryService)],I),e.LanguagePackBaseService=I}),define(ie[194],re([0,1,2,72]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(L){super(),this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=pe([Y(0,t.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(ie[8],re([0,1,37,3,2,40,5,7,4]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function E(){return new Date().toISOString()}var C;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(h,a,S){switch(a){case C.Trace:h.trace(S);break;case C.Debug:h.debug(S);break;case C.Info:h.info(S);break;case C.Warning:h.warn(S);break;case C.Error:h.error(S);break;case C.Critical:h.critical(S);break;default:throw new Error("Invalid log level")}}e.log=b;function v(h){let a="";for(let S=0;S<h.length;S++){let w=h[S];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}a+=(S>0?" ":"")+w}return a}e.format=v;class m extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class f extends m{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...S){this.checkLogLevel(C.Trace)&&this.log(C.Trace,v([a,...S]))}debug(a,...S){this.checkLogLevel(C.Debug)&&this.log(C.Debug,v([a,...S]))}info(a,...S){this.checkLogLevel(C.Info)&&this.log(C.Info,v([a,...S]))}warn(a,...S){this.checkLogLevel(C.Warning)&&this.log(C.Warning,v([a,...S]))}error(a,...S){if(this.checkLogLevel(C.Error))if(a instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=a.stack,this.log(C.Error,v(w))}else this.log(C.Error,v([a,...S]))}critical(a,...S){this.checkLogLevel(C.Critical)&&this.log(C.Critical,v([a,...S]))}flush(){}}e.AbstractMessageLogger=f;class p extends m{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!L.isWindows}trace(a,...S){this.getLevel()<=C.Trace&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...S):console.log(`[main ${E()}]`,a,...S))}debug(a,...S){this.getLevel()<=C.Debug&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...S):console.log(`[main ${E()}]`,a,...S))}info(a,...S){this.getLevel()<=C.Info&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...S):console.log(`[main ${E()}]`,a,...S))}warn(a,...S){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,a,...S):console.warn(`[main ${E()}]`,a,...S))}error(a,...S){this.getLevel()<=C.Error&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,a,...S):console.error(`[main ${E()}]`,a,...S))}critical(a,...S){this.getLevel()<=C.Critical&&(this.useColors?console.error(`\x1B[90m[main ${E()}]\x1B[0m`,a,...S):console.error(`[main ${E()}]`,a,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class y extends m{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...S){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",a,...S)}debug(a,...S){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...S)}info(a,...S){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",a,...S)}warn(a,...S){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",a,...S)}error(a,...S){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",a,...S)}critical(a,...S){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...S)}dispose(){}flush(){}}e.ConsoleLogger=y;class u extends m{constructor(a,S=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(S)}trace(a,...S){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(a),...S])}debug(a,...S){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(a),...S])}info(a,...S){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(a),...S])}warn(a,...S){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(a),...S])}error(a,...S){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(a),...S])}critical(a,...S){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(a),...S])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class g extends m{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const S of this.logServices)S.setLevel(a);super.setLevel(a)}trace(a,...S){for(const w of this.logServices)w.trace(a,...S)}debug(a,...S){for(const w of this.logServices)w.debug(a,...S)}info(a,...S){for(const w of this.logServices)w.info(a,...S)}warn(a,...S){for(const w of this.logServices)w.warn(a,...S)}error(a,...S){for(const w of this.logServices)w.error(a,...S)}critical(a,...S){for(const w of this.logServices)w.critical(a,...S)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=g;class c extends R.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...S){this.logger.trace(a,...S)}debug(a,...S){this.logger.debug(a,...S)}info(a,...S){this.logger.info(a,...S)}warn(a,...S){this.logger.warn(a,...S)}error(a,...S){this.logger.error(a,...S)}critical(a,...S){this.logger.critical(a,...S)}flush(){this.logger.flush()}}e.LogService=c;class d extends R.Disposable{constructor(a,S){super(),this.logLevel=a,this.loggerItems=new T.ResourceMap,this._register(S(w=>this.setLevel(w)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,S,w){let A=this.loggerItems.get(a)?.logger;return A||(w=S?.always?C.Trace:w,A=this.doCreateLogger(a,w??this.logLevel,S),this.loggerItems.set(a,{logger:A,logLevel:w})),A}setLevel(a,S){const w=P.URI.isUri(a)?a:void 0,A=w?S:a;if(w){const q=this.loggerItems.get(w);q&&q.logLevel!==A&&(q.logLevel=A,q.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:q,logger:U})=>{q===void 0&&U.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=d;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...S){}debug(a,...S){}info(a,...S){}warn(a,...S){}error(a,...S){}critical(a,...S){}dispose(){}flush(){}}e.NullLogger=l;class i extends l{}e.NullLogService=i;class r extends d{constructor(){super(C.Info,t.Event.None)}doCreateLogger(a,S,w){return new l}}e.NullLoggerService=r;function n(h){if(h.verbose)return C.Trace;if(typeof h.logLevel=="string"){const a=o(h.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function o(h){switch(h){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=o;function s(h){switch(h){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=s}),define(ie[195],re([0,1,6,9,2,12,28,13,8]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(b,v){super(),this.environmentService=b,this.logService=v,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,T.basename)(this.environmentService.logsPath),v=(0,T.dirname)(this.environmentService.logsPath),p=(await L.Promises.readdir(v)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==b),y=p.slice(0,Math.max(0,p.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(u=>L.Promises.rm((0,T.join)(v,u)))))}catch(b){(0,t.onUnexpectedError)(b)}}};E=pe([Y(0,P.IEnvironmentService),Y(1,I.ILogService)],E),e.LogsDataCleaner=E}),define(ie[196],re([0,1,18,6,9,3,2,12,57,8]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends L.Disposable{constructor(v,m){super(),this.logService=v,this.options=m,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(v,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,m):this.watchNonRecursive(v,m)}watchUniversal(v,m){const f={path:this.toFilePath(v),excludes:m.excludes,includes:m.includes,recursive:m.recursive},p=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,R.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,I.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const m of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const m of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(m)&&v.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,m){const f={path:this.toFilePath(v),excludes:m.excludes,includes:m.includes,recursive:!1},p=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,R.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,I.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(ie[197],re([0,1,18,6,17,24,3,66,64,2,48,22,198,19,42,156,14,100,8]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends E.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${l}`);const r=new E.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),r.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new y.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,E.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){i.push(r)}}),!this.provider.has(l)&&await t.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return I.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,m.isAbsolutePath)(l))throw new y.FileOperationError((0,p.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const r=new Error;throw r.name="ENOPRO",r.message=(0,p.localize)(1,null,l.toString()),r}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)||(0,y.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,p.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(l,i){const r=await this.withProvider(l),n=this.isPathCaseSensitive(r),o=i?.resolveTo,s=i?.resolveSingleChildDescendants,h=i?.resolveMetadata,a=await r.stat(l);let S;return this.toFileStat(r,l,a,void 0,!!h,(w,A)=>(S||(S=C.TernarySearchTree.forUris(()=>!n),S.set(l,!0),o&&S.fill(!0,o)),S.get(w.resource)||S.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&s?A===1:!1))}async toFileStat(l,i,r,n,o,s){const{providerExtUri:h}=this.getExtUri(l),a={resource:i,name:h.basename(i),isFile:(r.type&y.FileType.File)!==0,isDirectory:(r.type&y.FileType.Directory)!==0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&s(a,n)){try{const S=await l.readdir(i),w=await t.Promises.settled(S.map(async([A,q])=>{try{const U=h.joinPath(i,A),O=o?await l.stat(U):{type:q};return await this.toFileStat(l,U,O,S.length,o,s)}catch(U){return this.logService.trace(U),null}}));a.children=(0,D.coalesce)(w)}catch(S){this.logService.trace(S),a.children=[]}return a}return a}async resolveAll(l){return t.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.withProvider(l),r=await i.stat(l);return this.toFileStat(i,l,r,void 0,!0,()=>!1)}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(r){return r}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new y.FileOperationError((0,p.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=R.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const n=await this.writeFile(l,i);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,n)),n}async writeFile(l,i,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:o}=this.getExtUri(n);try{await this.validateWriteFile(n,l,r)||await this.mkdirp(n,o.dirname(l));let h;if((0,y.hasReadWriteCapability)(n)&&!(i instanceof R.VSBuffer))if((0,f.isReadableStream)(i)){const a=await(0,f.peekStream)(i,3);a.ended?h=R.VSBuffer.concat(a.buffer):h=a}else h=(0,f.peekReadable)(i,a=>R.VSBuffer.concat(a),3);else h=i;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&h instanceof R.VSBuffer?await this.doWriteUnbuffered(n,l,r,h):await this.doWriteBuffered(n,l,r,h instanceof R.VSBuffer?(0,R.bufferToReadable)(h):h),this._onDidRunOperation.fire(new y.FileOperationEvent(l,4))}catch(s){throw new y.FileOperationError((0,p.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(i)));let o;try{o=await l.stat(i)}catch{return}if((o.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,p.localize)(6,null,this.resourceForError(i)),0,r);if(this.throwIfFileIsReadonly(i,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:o.size}))throw new y.FileOperationError((0,p.localize)(7,null),3,r);return o}async readFile(l,i,r){const n=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(n,l,i,r):this.doReadFile(n,l,i,r)}async doReadFileAtomic(l,i,r,n){return new Promise((o,s)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const h=await this.doReadFile(l,i,r,n);o(h)}catch(h){s(h)}})})}async doReadFile(l,i,r,n){const o=await this.doReadFileStream(l,i,{...r,preferUnbuffered:!0},n);return{...o,value:await(0,R.streamToBuffer)(o.value)}}async readFileStream(l,i,r){const n=await this.withReadProvider(l);return this.doReadFileStream(n,l,i,r)}async doReadFileStream(l,i,r,n){const o=new T.CancellationTokenSource(n),s=this.validateReadFile(i,r).then(a=>a,a=>{throw o.cancel(),a});let h;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await s,r?.atomic&&(0,y.hasFileAtomicReadCapability)(l)||!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&r?.preferUnbuffered?h=this.readFileUnbuffered(l,i,r):(0,y.hasFileReadStreamCapability)(l)?h=this.readFileStreamed(l,i,o.token,r):h=this.readFileBuffered(l,i,o.token,r),{...await s,value:h}}catch(a){h&&await(0,f.consumeStream)(h);const S=(0,p.localize)(8,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(S,a.stat,r):new y.FileOperationError(S,(0,y.toFileOperationResult)(a),r)}}readFileStreamed(l,i,r,n=Object.create(null)){const o=l.readFileStream(i,n,r);return(0,f.transform)(o,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,p.localize)(9,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),n)},s=>R.VSBuffer.concat(s))}readFileBuffered(l,i,r,n=Object.create(null)){const o=(0,R.newWriteableBufferStream)();return(0,u.readFileIntoStream)(l,i,o,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,p.localize)(10,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),n)},r),o}readFileUnbuffered(l,i,r){const n=(0,f.newWriteableStream)(o=>R.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,y.hasFileAtomicReadCapability)(l)?o=await l.readFile(i,{atomic:!0}):o=await l.readFile(i),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.validateReadFileLimits(i,o.byteLength,r),n.end(R.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(l,i){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,p.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==y.ETAG_DISABLED&&i.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,p.localize)(12,null),r,i);return this.validateReadFileLimits(l,r.size,i),r}validateReadFileLimits(l,i,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&i>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&i>r.limits.size&&(n=7),typeof n=="number")throw new y.FileOperationError((0,p.localize)(13,null,this.resourceForError(l)),n)}}async canMove(l,i,r){return this.doCanMoveCopy(l,i,"move",r)}async canCopy(l,i,r){return this.doCanMoveCopy(l,i,"copy",r)}async doCanMoveCopy(l,i,r,n){if(l.toString()!==i.toString())try{const o=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(o,l,s,i,r,n)}catch(o){return o}return!0}async move(l,i,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,l,o,i,"move",!!r),h=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,s==="move"?2:3,h)),h}async copy(l,i,r){const n=await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,l,o,i,"copy",!!r),h=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,s==="copy"?3:2,h)),h}async doMoveCopy(l,i,r,n,o,s){if(i.toString()===n.toString())return o;const{exists:h,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,i,r,n,o,s);if(h&&!a&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),o==="copy"){if(l===r&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(i,n,{overwrite:s});else{const S=await this.resolve(i);S.isDirectory?await this.doCopyFolder(l,S,r,n):await this.doCopyFile(l,i,r,n)}return o}else return l===r?(await l.rename(i,n,{overwrite:s}),o):(await this.doMoveCopy(l,i,r,n,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,r,n){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,i,r,n);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,i,r,n);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,i,r,n);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,i,r,n)}async doCopyFolder(l,i,r,n){await r.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async o=>{const s=this.getExtUri(r).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(l,await this.resolve(o.resource),r,s):this.doCopyFile(l,o.resource,r,s)}))}async doValidateMoveCopy(l,i,r,n,o,s){let h=!1;if(l===r){const{providerExtUri:S,isPathCaseSensitive:w}=this.getExtUri(l);if(w||(h=S.isEqual(i,n)),h&&o==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!h&&S.isEqualOrParent(n,i))throw new Error((0,p.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const a=await this.exists(n);if(a&&!h){if(!s)throw new y.FileOperationError((0,p.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(l===r){const{providerExtUri:S}=this.getExtUri(l);if(S.isEqualOrParent(i,n))throw new Error((0,p.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:a,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,r)),r}async mkdirp(l,i){const r=[],{providerExtUri:n}=this.getExtUri(l);for(;!n.isEqual(i,n.dirname(i));)try{if(((await l.stat(i)).type&y.FileType.Directory)===0)throw new Error((0,p.localize)(18,null,this.resourceForError(i)));break}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(n.basename(i)),i=n.dirname(i)}for(let o=r.length-1;o>=0;o--){i=n.joinPath(i,r[o]);try{await l.mkdir(i)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(r){return r}return!0}async doValidateDelete(l,i){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(r.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(l)));let o;try{o=await r.stat(l)}catch{}if(o)this.throwIfFileIsReadonly(l,o);else throw new y.FileOperationError((0,p.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(l)))}return r}async del(l,i){const r=await this.doValidateDelete(l,i),n=!!i?.useTrash,o=!!i?.recursive;await r.delete(l,{recursive:o,useTrash:n}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}async cloneFile(l,i){const r=await this.withProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(r===n&&this.getExtUri(r).providerExtUri.isEqual(l,i))return;if(r===n&&(0,y.hasFileCloneCapability)(r))return r.cloneFile(l,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const o=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===n&&(0,y.hasFileFolderCopyCapability)(r)?o.queue(()=>r.copy(l,i,{overwrite:!0})):o.queue(()=>this.doCopyFile(r,l,n,i))}watch(l,i={recursive:!1,excludes:[]}){const r=new E.DisposableStore;let n=!1,o=()=>{n=!0};return r.add((0,E.toDisposable)(()=>o())),(async()=>{try{const s=await this.doWatch(l,i);n?(0,E.dispose)(s):o=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(l,i){const r=await this.withProvider(l),n=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),i]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:r.watch(l,i)},this.activeWatchers.set(n,o)),o.count+=1,(0,E.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,E.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,r,n){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const o=await l.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,f.isReadableStream)(n)||(0,f.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(l,o,n):await this.doWriteReadableBufferedQueued(l,o,n)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await l.close(o)}})}async doWriteStreamBufferedQueued(l,i,r){let n=0,o;if((0,f.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=R.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,i,s,s.byteLength,n,0),n+=s.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((s,h)=>{(0,f.listenStream)(o,{onData:async a=>{o.pause();try{await this.doWriteBuffer(l,i,a,a.byteLength,n,0)}catch(S){return h(S)}n+=a.byteLength,setTimeout(()=>o.resume())},onError:a=>h(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,i,r){let n=0,o;for(;(o=r.read())!==null;)await this.doWriteBuffer(l,i,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(l,i,r,n,o,s){let h=0;for(;h<n;)h+=await l.write(i,o+h,r.buffer,s+h,n-h)}async doWriteUnbuffered(l,i,r,n){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,r,n))}async doWriteUnbufferedQueued(l,i,r,n){let o;n instanceof R.VSBuffer?o=n:(0,f.isReadableStream)(n)?o=await(0,R.streamToBuffer)(n):(0,f.isReadableBufferedStream)(n)?o=await(0,R.bufferedStreamToBuffer)(n):o=(0,R.readableToBuffer)(n),await l.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,r,n))}async doPipeBufferedQueued(l,i,r,n){let o,s;try{o=await l.open(i,{create:!1}),s=await r.open(n,{create:!0,unlock:!1});const h=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,S=0,w=0;do w=await l.read(o,a,h.buffer,S,h.byteLength-S),await this.doWriteBuffer(r,s,h,w,a,S),a+=w,S+=w,S===h.byteLength&&(S=0);while(w>0)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await t.Promises.settled([typeof o=="number"?l.close(o):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,r,n))}async doPipeUnbufferedQueued(l,i,r,n){return r.writeFile(n,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,r,n))}async doPipeUnbufferedToBufferedQueued(l,i,r,n){const o=await r.open(n,{create:!0,unlock:!1});try{const s=await l.readFile(i);await this.doWriteBuffer(r,o,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await r.close(o)}}async doPipeBufferedToUnbuffered(l,i,r,n){const o=await(0,R.streamToBuffer)(this.readFileBuffered(l,i,T.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,o)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new y.FileOperationError((0,p.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,p.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===b.Schemas.file?l.fsPath:l.toString(!0)}};c=pe([Y(0,g.ILogService)],c),e.FileService=c}),define(ie[199],re([0,1,54,284,6,40,17,3,47,2,12,5,19,42,28,159,14,100,196,37,191,190]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(r)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(n,o){super(n,o),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new T.ResourceMap(s=>v.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,s),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await f.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(o.map(async h=>{try{let a;h.isSymbolicLink()?a=(await this.stat((0,v.joinPath)(n,h.name))).type:a=this.toType(h),s.push([h.name,a])}catch(a){this.logService.trace(a)}})),s}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let s;return o?.dangling?s=y.FileType.Unknown:n.isFile()?s=y.FileType.File:n.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,o&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(n){const o=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let s;for(;s=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await s.wait();const h=new R.Barrier;return this.resourceLocks.set(n,h),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,E.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(n)===h&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),h.open()})}async readFile(n,o){let s;try{o?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const h=this.toFilePath(n);return await f.Promises.readFile(h)}catch(h){throw this.toFileSystemProviderError(h)}finally{s?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,o,s){const h=(0,m.newWriteableStream)(a=>L.VSBuffer.concat(a.map(S=>L.VSBuffer.wrap(S))).buffer);return(0,u.readFileIntoStream)(this,n,h,a=>a.buffer,{...o,bufferSize:256*1024},s),h}async writeFile(n,o,s){let h;try{const a=this.toFilePath(n);if(!s.create||!s.overwrite){if(await f.Promises.exists(a)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,p.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,p.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(n,a)}finally{typeof h=="number"&&await this.close(h)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,o){const s=this.toFilePath(n);let h;(0,y.isFileOpenForWriteOptions)(o)&&(h=await this.createResourceLock(n));let a;try{if((0,y.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:w}=await f.SymlinkSupport.stat(s);w.mode&128||await f.Promises.chmod(s,w.mode|128)}catch(w){this.logService.trace(w)}let S;if((0,y.isFileOpenForWriteOptions)(o)){if(b.isWindows)try{await f.Promises.truncate(s,0),S="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}S||(S="w")}else S="r";a=await f.Promises.open(s,S)}catch(S){throw h?.dispose(),(0,y.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,S):this.toFileSystemProviderError(S)}if(this.mapHandleToPos.set(a,0),(0,y.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(a,n),h){const S=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,h),S&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),S.dispose())}return a}async close(n){const o=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await f.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{o&&(this.mapHandleToLock.get(n)===o&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),o.dispose())}}async read(n,o,s,h,a){const S=this.normalizePos(n,o);let w=null;try{w=(await f.Promises.read(n,s,h,a,S)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,S,w)}return w}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,s){const h=this.mapHandleToPos.get(n);typeof h=="number"&&(typeof o=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,h+s):this.mapHandleToPos.delete(n)))}async write(n,o,s,h,a){return(0,R.retry)(()=>this.doWrite(n,o,s,h,a),100,3)}async doWrite(n,o,s,h,a){const S=this.normalizePos(n,o);let w=null;try{w=(await f.Promises.write(n,s,h,a,S)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),A)}finally{this.updatePos(n,S,w)}return w}async mkdir(n){try{await f.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const s=this.toFilePath(n);o.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,o,s){const h=this.toFilePath(n),a=this.toFilePath(o);if(h!==a)try{await this.validateTargetDeleted(n,o,"move",s.overwrite),await f.Promises.move(h,a)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(2,null,(0,C.basename)(h),(0,C.basename)((0,C.dirname)(a)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(n,o,s){const h=this.toFilePath(n),a=this.toFilePath(o);if(h!==a)try{await this.validateTargetDeleted(n,o,"copy",s.overwrite),await f.Promises.copy(h,a,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(3,null,(0,C.basename)(h),(0,C.basename)((0,C.dirname)(a)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(n,o,s,h){const a=this.toFilePath(n),S=this.toFilePath(o);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(a,S,!0)),w&&s==="copy")throw(0,y.createFileSystemProviderError)((0,p.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!w&&await f.Promises.exists(S)){if(!h)throw(0,y.createFileSystemProviderError)((0,p.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(n,o){return this.doCloneFile(n,o,!1)}async doCloneFile(n,o,s){const h=this.toFilePath(n),a=this.toFilePath(o),S=!!(this.capabilities&1024);if((0,I.isEqual)(h,a,!S))return;const w=new E.DisposableStore;try{const[A,q]=await Promise.all([this.createResourceLock(n),this.createResourceLock(o)]);w.add(A),w.add(q),s&&await f.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await f.Promises.copyFile(h,a)}catch(A){if(A.code==="ENOENT"&&!s)return this.doCloneFile(n,o,!0);throw this.toFileSystemProviderError(A)}finally{w.dispose()}}createUniversalWatcher(n,o,s){return new d.UniversalWatcherClient(h=>n(h),h=>o(h),s)}createNonRecursiveWatcher(n,o,s){return new l.NodeJSWatcherClient(h=>n(h),h=>o(h),s)}toFileSystemProviderError(n){if(n instanceof y.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=y.FileSystemProviderErrorCode.NoPermissions;break;default:o=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let s=this.toFileSystemProviderError(o);if(n&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await f.SymlinkSupport.stat(this.toFilePath(n));h.mode&128||(s=(0,y.createFileSystemProviderError)(o,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return s}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(ie[101],re([0,1,6,3,2,4,8]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(E){super(),this.logService=E,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new t.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(C){E.push(C)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(E)}catch(C){this.logService.error(C)}})(),this.pendingWillShutdownPromise}};P=pe([Y(0,L.ILogService)],P),e.SharedProcessLifecycleService=P}),define(ie[102],re([0,1,3,7,8]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(v,m){this.logService=v,this.loggerService=m,this.onDidChangeLogLevel=D.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(v,m,f){switch(m){case"setLevel":return f[1]?this.loggerService.setLevel(t.URI.revive(f[1]),f[0]):this.logService.setLevel(f[0])}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=T;class L{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v,m){L.setLevel(this.channel,v,m)}static setLevel(v,m,f){return v.call("setLevel",[m,f])}}e.LogLevelChannelClient=L;class P{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,m){throw new Error(`Event not found: ${m}`)}async call(v,m,f){switch(m){case"createLogger":this.createLogger(t.URI.revive(f[0]),f[1]);return;case"log":return this.log(t.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${m}`)}createLogger(v,m){this.loggers.set(v.toString(),this.loggerService.createLogger(v,m))}consoleLog(v,m){let f=console.log;switch(v){case R.LogLevel.Error:f=console.error;break;case R.LogLevel.Warning:f=console.warn;break;case R.LogLevel.Info:f=console.info;break}f.call(console,...m)}log(v,m){const f=this.loggers.get(v.toString());if(!f)throw new Error("Create the logger before logging");for(const[p,y]of m)(0,R.log)(f,p,y)}}e.LoggerChannel=P;class I extends R.AbstractLoggerService{constructor(v,m,f){super(v,m),this.channel=f}createConsoleMainLogger(){return new R.AdapterLogger({log:(v,m)=>{this.channel.call("consoleLog",[v,m])}})}doCreateLogger(v,m,f){return new E(this.channel,v,m,f)}}e.LoggerChannelClient=I;class E extends R.AbstractMessageLogger{constructor(v,m,f,p){super(p?.always),this.channel=v,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[m,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,m){const f=[[v,m]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(v){this.channel.call("log",[this.file,v])}}class C extends R.LogService{constructor(v,m){super(m),this.parent=v,this._register(v.onDidChangeLogLevel(f=>m.setLevel(f)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=C}),define(ie[59],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ie[60],re([0,1,3,64,2,4]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class L extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(E){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(E),t.Iterable.reduce(this.policies.entries(),(b,[v,m])=>({...b,[v]:m}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[C,b])=>({...E,[C]:{definition:b,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=L;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ie[200],re([0,1,3,2,60]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(I){this.service=I,this.disposables=new t.DisposableStore}listen(I,E){switch(E){case"onDidChange":return D.Event.map(this.service.onDidChange,C=>C.reduce((b,v)=>({...b,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(I,E,C){switch(E){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class L extends R.AbstractPolicyService{constructor(I,E){super(),this.channel=E;for(const C in I){const{definition:b,value:v}=I[C];this.policyDefinitions[C]=b,v!==void 0&&this.policies.set(C,v)}this.channel.listen("onDidChange")(C=>{for(const b in C){const v=C[b];v===null?this.policies.delete(b):this.policies.set(b,v)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(I){const E=await this.channel.call("registerPolicyDefinitions",I);for(const C in E)this.policies.set(C,E[C])}}e.PolicyChannelClient=L}),define(ie[103],re([0,1,22,5,36,19]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)L=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",Q));if(L=Q.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const I=Q.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);Object.assign(L,{version:I.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ie[25],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[201],re([0,1,6,9,2,12,28,8,25]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(b,v,m){super(),this.productService=v,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),m=(0,T.dirname)(b),f=(0,T.basename)(b),p=await L.Promises.readdir(m);await Promise.all(p.map(async y=>{if(y===f)return;const u=(0,T.join)(m,y),g=await L.Promises.stat(u);if(g.isDirectory()&&v-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),L.Promises.rm(u)}))}catch(v){(0,t.onUnexpectedError)(v)}}};E=pe([Y(1,I.IProductService),Y(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(ie[202],re([0,1,6,9,2,12,28,13,8,25]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends R.Disposable{constructor(v,m,f){super(),this.environmentService=v,this.logService=m,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),m=JSON.parse(await L.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(m)){const c=m[g];v[`${c.hash}.${g}`]=!0}const f=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(f))return;const y=await L.Promises.readdir(f);for(const g of y){if(v[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await L.Promises.rm((0,T.join)(f,g))}const u=Date.now();for(const g of Object.keys(v)){const c=(0,T.join)(f,g),d=await L.Promises.readdir(c);for(const l of d){if(l==="tcf.json")continue;const i=(0,T.join)(c,l),r=await L.Promises.stat(i);r.isDirectory()&&u-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(g,l)}`),await L.Promises.rm(i))}}}catch(v){(0,t.onUnexpectedError)(v)}}};C=pe([Y(0,P.INativeEnvironmentService),Y(1,I.ILogService),Y(2,E.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(ie[203],re([0,1,12,4]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var R;(function(T){function L(I){return Boolean(I.samples&&I.timeDeltas)}T.isValidProfile=L;function P(I,E="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,D.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.join)(E,(0,D.basename)(C.callFrame.url)));return I}T.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(ie[204],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(T){const P=await(await new Promise((E,C)=>{Q(["v8-inspect-profiler"],E,C)})).startProfiling({port:T.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this._sessions.set(I,P),I}async stopProfiling(T){const L=this._sessions.get(T);if(!L)throw new Error(`UNKNOWN session '${T}'`);const P=await L.stop();return this._sessions.delete(T),P.profile}}e.InspectProfilingService=t}),define(ie[39],re([0,1,120,15]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(L,P){D.ok(t.isString(L)),D.ok(t.isObject(P)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new R}),define(ie[104],re([0,1,3,39]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,E){this.schemasById[R(I)]=E,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;t.Registry.add(e.Extensions.JSONContribution,L)}),define(ie[43],re([0,1,18,3,15,145,16,104,39]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=this.doRegisterConfigurations(i,r);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const r=this.doDeregisterConfigurations(i);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=[];n.push(...this.doDeregisterConfigurations(r)),n.push(...this.doRegisterConfigurations(i,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(n)})}registerDefaultConfigurations(i){const r=[],n=[];for(const{overrides:o,source:s}of i)for(const h in o)if(r.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const a=this.configurationDefaultsOverrides.get(h),S=a?.valuesSources??new Map;if(s)for(const U of Object.keys(o[h]))S.set(U,s);const w={...a?.value||{},...o[h]};this.configurationDefaultsOverrides.set(h,{source:s,value:w,valuesSources:S});const A=(0,L.getLanguageTagSettingPlainKey)(h),q={type:"object",default:w,description:T.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:R.isString(s)?void 0:s,defaultValueSource:s};n.push(...p(h)),this.configurationProperties[h]=q,this.defaultLanguageConfigurationOverridesNode.properties[h]=q}else{this.configurationDefaultsOverrides.set(h,{value:o[h],source:s});const a=this.configurationProperties[h];a&&(this.updatePropertyDefaultValue(h,a),this.updateSchema(h,a))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const r=[];for(const{overrides:n,source:o}of i)for(const s in n){const h=this.configurationDefaultsOverrides.get(s),a=R.isString(o)?o:o?.id,S=R.isString(h?.source)?h?.source:h?.source?.id;if(a===S)if(r.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const w=this.configurationProperties[s];w&&(this.updatePropertyDefaultValue(s,w),this.updateSchema(s,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const r of i)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,r){const n=[];return i.forEach(o=>{n.push(...this.validateAndRegisterProperties(o,r,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),n}doDeregisterConfigurations(i){const r=[],n=o=>{if(o.properties)for(const s in o.properties){r.push(s);const h=this.configurationProperties[s];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s])}o.allOf?.forEach(s=>n(s))};for(const o of i){n(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}return r}validateAndRegisterProperties(i,r=!0,n,o,s=3){s=R.isUndefinedOrNull(i.scope)?s:i.scope;const h=[],a=i.properties;if(a)for(const w in a){const A=a[w];if(r&&c(w,A)){delete a[w];continue}if(A.source=n,A.defaultDefaultValue=a[w].default,this.updatePropertyDefaultValue(w,A),e.OVERRIDE_PROPERTY_REGEX.test(w)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!o?.includes(w):A.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.excludedConfigurationProperties[w]=a[w],delete a[w];continue}else this.configurationProperties[w]=a[w],a[w].policy?.name&&this.policyConfigurations.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),h.push(w)}const S=i.allOf;if(S)for(const w of S)h.push(...this.validateAndRegisterProperties(w,r,n,o,s));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const r=n=>{const o=n.properties;if(o)for(const h in o)this.updateSchema(h,o[h]);n.allOf?.forEach(r)};r(i)}updateSchema(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.resourceLanguageSettingsSchema.properties[i]=r;break}}removeFromSchema(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const r=`[${i}]`,n={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,r){const n=this.configurationDefaultsOverrides.get(i);let o=n?.value,s=n?.source;R.isUndefined(o)&&(o=r.defaultDefaultValue,s=void 0),R.isUndefined(o)&&(o=u(r.type)),r.default=o,r.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",f=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=f.exec(l);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=f.exec(l)}}return(0,D.distinct)(i)}e.overrideIdentifiersFromKey=p;function y(l){return l.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new v;I.Registry.add(e.Extensions.Configuration,g);function c(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?T.localize(7,null,l):g.getConfigurationProperties()[l]!==void 0?T.localize(8,null,l):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,l,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}e.validateProperty=c;function d(){const l=[],i=g.getConfigurationProperties();for(const r of Object.keys(i))l.push([r,i[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=d}),define(ie[73],re([0,1,18,3,35,2,40,32,15,7,16,43,39]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class m{constructor(r={},n=[],o=[],s){this._contents=r,this._keys=n,this._overrides=o,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof m)return n;const o=new f("");return o.parseRaw(n),o.configurationModel});this._rawConfiguration=r.reduce((n,o)=>o===n?o:n.merge(o),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const o=this.rawConfiguration.getValue(r),s=n?this.rawConfiguration.getOverrideValue(r,n):void 0,h=n?this.rawConfiguration.override(n).getValue(r):o;return{value:o,override:s,merged:h}}getOverrideValue(r,n){const o=this.getContentsForOverrideIdentifer(n);return o?r?(0,C.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return D.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=P.deepClone(this.contents),o=P.deepClone(this.overrides),s=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const a of r)if(h.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(n,a.contents);for(const S of a.overrides){const[w]=o.filter(A=>D.equals(A.identifiers,S.identifiers));w?(this.mergeContents(w.contents,S.contents),w.keys.push(...S.keys),w.keys=D.distinct(w.keys)):o.push(P.deepClone(S))}for(const S of a.keys)s.indexOf(S)===-1&&s.push(S)}return new m(n,s,o,h.every(a=>a instanceof m)?void 0:h)}freeze(){return this.frozen=!0,this}clone(){return new m(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let h=this.contents[s];const a=n[s];a&&(typeof h=="object"&&typeof a=="object"?(h=P.deepClone(h),this.mergeContents(h,a)):h=a),o[s]=h}return new m(o,this.keys,this.overrides)}mergeContents(r,n){for(const o of Object.keys(n)){if(o in r&&I.isObject(r[o])&&I.isObject(n[o])){this.mergeContents(r[o],n[o]);continue}r[o]=P.deepClone(n[o])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,o=null;const s=h=>{h&&(o?this.mergeContents(o,h):o=P.deepClone(h))};for(const h of this.overrides)D.equals(h.identifiers,[r])?n=h.contents:h.identifiers.includes(r)&&s(h.contents);return s(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,C.addToValueTree)(this.contents,r,n,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,C.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let o=0;o<n;o++)r.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,r)}removeKey(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class f{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!I.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:o,keys:s,overrides:h,restricted:a,hasExcludedProperties:S}=this.doParseRaw(r,n);this._configurationModel=new m(o,s,h,S?[r]:void 0),this._restrictedConfigurations=a||[]}doParseContent(r){let n={},o=null,s=[];const h=[],a=[];function S(A){Array.isArray(s)?s.push(A):o!==null&&(s[o]=A)}const w={onObjectBegin:()=>{const A={};S(A),h.push(s),s=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const A=[];S(A),h.push(s),s=A,o=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:S,onError:(A,q,U)=>{a.push({error:A,offset:q,length:U})}};if(r)try{R.visit(r,w),n=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(r,n){const o=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,n);r=s.raw;const h=(0,C.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),a=Object.keys(r),S=this.toOverrides(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:h,keys:a,overrides:S,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(r,n,o,s){let h=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:h};const a={},S=[];for(const w in r)if(b.OVERRIDE_PROPERTY_REGEX.test(w)&&o){const A=this.filter(r[w],n,!1,s);a[w]=A.raw,h=h||A.hasExcludedProperties,S.push(...A.restricted)}else{const A=n[w],q=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&S.push(w),(q===void 0||s.scopes===void 0||s.scopes.includes(q))&&!(s.skipRestricted&&A?.restricted)?a[w]=r[w]:h=!0}return{raw:a,restricted:S,hasExcludedProperties:h}}toOverrides(r,n){const o=[];for(const s of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(s)){const h={};for(const a in r[s])h[a]=r[s][a];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(h),contents:(0,C.toValuesTree)(h,n)})}return o}}e.ConfigurationModelParser=f;class p extends T.Disposable{constructor(r,n,o,s){super(),this.userSettingsResource=r,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&o.isEqual(h.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class y{constructor(r,n,o,s,h,a,S,w,A,q,U,O,$){this.key=r,this.overrides=n,this.value=o,this.overrideIdentifiers=s,this.defaultConfiguration=h,this.policyConfiguration=a,this.applicationConfiguration=S,this.userConfiguration=w,this.localUserConfiguration=A,this.remoteUserConfiguration=q,this.workspaceConfiguration=U,this.folderConfigurationModel=O,this.memoryInspectValue=$}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(r,n,o,s,h=new m,a=new m,S=new L.ResourceMap,w=new m,A=new L.ResourceMap,q=!0){this._defaultConfiguration=r,this._policyConfiguration=n,this._applicationConfiguration=o,this._localUserConfiguration=s,this._remoteUserConfiguration=h,this._workspaceConfiguration=a,this._folderConfigurations=S,this._memoryConfiguration=w,this._memoryConfigurationByResource=A,this._freeze=q,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(r,n,o){return this.getConsolidatedConfigurationModel(r,n,o).getValue(r)}updateValue(r,n,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new m,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(r):s.setValue(r,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,o){const s=this.getConsolidatedConfigurationModel(r,n,o),h=D.distinct(s.overrides.map(w=>w.identifiers).flat()).filter(w=>s.getOverrideValue(r,w)!==void 0),a=this.getFolderConfigurationModelForResource(n.resource,o),S=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new y(r,n,s.getValue(r),h.length?h:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,S.inspect(r,n.overrideIdentifier))}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:s,updated:h,removed:a}=d(this._defaultConfiguration,r);n=[...s,...h,...a]}for(const s of n)for(const h of(0,b.overrideIdentifiersFromKey)(s)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(h),S=r.getKeysForOverrideIdentifier(h),w=[...S.filter(A=>a.indexOf(A)===-1),...a.filter(A=>S.indexOf(A)===-1),...a.filter(A=>!P.equals(this._defaultConfiguration.override(h).getValue(A),r.override(h).getValue(A)))];o.push([h,w])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:o,removed:s}=d(this._policyConfiguration,r),h=[...n,...o,...s];return h.length&&this.updatePolicyConfiguration(r),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:o,removed:s,overrides:h}=d(this.applicationConfiguration,r),a=[...n,...o,...s];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:h}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:s,overrides:h}=d(this.localUserConfiguration,r),a=[...n,...o,...s];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:h}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:s,overrides:h}=d(this.remoteUserConfiguration,r),a=[...n,...o,...s];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:h}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:s,overrides:h}=d(this.workspaceConfiguration,r),a=[...n,...o,...s];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:h}}compareAndUpdateFolderConfiguration(r,n){const o=this.folderConfigurations.get(r),{added:s,updated:h,removed:a,overrides:S}=d(o,n),w=[...s,...h,...a];return(w.length||!o)&&this.updateFolderConfiguration(r,n),{keys:w,overrides:S}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:h,overrides:a}=d(n,void 0);return{keys:[...o,...s,...h],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,o){let s=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier&&(s=s.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:r},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const s=n.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const h=this._memoryConfigurationByResource.get(r);h&&(o=o.merge(h))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(n=o.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=o}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:o,overrides:s,keys:h}=this._folderConfigurations.get(n);return r.push([n,{contents:o,overrides:s,keys:h}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.policy),s=this.parseConfigurationModel(r.application),h=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),S=r.folders.reduce((w,A)=>(w.set(E.URI.revive(A[0]),this.parseConfigurationModel(A[1])),w),new L.ResourceMap);return new u(n,o,s,h,new m,a,S,new m,new L.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function g(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const s of i)s.keys.forEach(h=>r.add(h)),s.overrides.forEach(([h,a])=>{const S=(0,L.getOrSet)(n,h,new Set);a.forEach(w=>S.add(w))});const o=[];return n.forEach((s,h)=>o.push([h,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=g;class c{constructor(r,n,o,s){this.change=r,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const h=new Set;r.keys.forEach(S=>h.add(S)),r.overrides.forEach(([,S])=>S.forEach(w=>h.add(w))),this.affectedKeys=[...h.values()];const a=new m;this.affectedKeys.forEach(S=>a.setValue(S,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!P.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let o=(0,C.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=c;function d(i,r){const{added:n,removed:o,updated:s}=l(r?.rawConfiguration,i?.rawConfiguration),h=[],a=i?.getAllOverrideIdentifiers()||[],S=r?.getAllOverrideIdentifiers()||[];if(r){const w=S.filter(A=>!a.includes(A));for(const A of w)h.push([A,r.getKeysForOverrideIdentifier(A)])}if(i){const w=a.filter(A=>!S.includes(A));for(const A of w)h.push([A,i.getKeysForOverrideIdentifier(A)])}if(r&&i){for(const w of a)if(S.includes(w)){const A=l({contents:i.getOverrideValue(void 0,w)||{},keys:i.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});h.push([w,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:o,updated:s,overrides:h}}function l(i,r){const n=i?r?i.keys.filter(h=>r.keys.indexOf(h)===-1):[...i.keys]:[],o=r?i?r.keys.filter(h=>i.keys.indexOf(h)===-1):[...r.keys]:[],s=[];if(i&&r){for(const h of r.keys)if(i.keys.indexOf(h)!==-1){const a=(0,C.getConfigurationValue)(r.contents,h),S=(0,C.getConfigurationValue)(i.contents,h);P.equals(a,S)||s.push(h)}}return{added:n,removed:o,updated:s}}}),define(ie[205],re([0,1,18,3,2,32,15,16,73,43,8,60,39]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class m extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(v.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.onDidUpdateConfiguration(g,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=m;class f extends I.ConfigurationModel{constructor(g={}){const c=v.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(c),l=Object.create(null),i=[];for(const r in c){const n=g[r],o=n!==void 0?n:c[r].default;(0,P.addToValueTree)(l,r,o,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(l))E.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,E.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,P.toValuesTree)(l[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(l,d,i)}}e.DefaultConfigurationModel=f;class p{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let y=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(g,c,d){super(),this.defaultConfiguration=g,this.policyService=c,this.logService=d,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const c={},d=[],l=v.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const i of g){const r=l[i];if(!r){d.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}d.push(i),c[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),d}onDidChangePolicies(g){const c=v.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),d=(0,D.coalesce)(g.map(l=>c.get(l)));this.update(d,!0)}update(g,c){const d=v.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),l=[],i=this._configurationModel.isEmpty();for(const r of g){const n=d[r]?.policy?.name;if(n){const o=this.policyService.getPolicyValue(n);(i?o!==void 0:!(0,T.equals)(this._configurationModel.getValue(r),o))&&l.push([r,o])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const n of r.keys)this._configurationModel.setValue(n,r.getValue(n));for(const[n,o]of l)o===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,o);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=pe([Y(1,b.IPolicyService),Y(2,C.ILogService)],y),e.PolicyConfiguration=y}),define(ie[206],re([0,1,6,3,2,19,16,73,205,60]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends R.Disposable{constructor(v,m,f,p){super(),this.settingsResource=v,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=f instanceof E.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,f,p)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,m)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:u})=>this.onDidDefaultConfigurationChange(y,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,m,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(v,m,new P.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(v,m){const f=typeof v=="string"?v:void 0,p=(0,L.isConfigurationOverrides)(v)?v:(0,L.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(f,p,void 0)}updateValue(v,m,f,p){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const m=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(f,m,2)}onDidDefaultConfigurationChange(v,m){const f=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(v,m);this.trigger(p,f,7)}onDidPolicyConfigurationChange(v){const m=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(f,m,7)}trigger(v,m,f){const p=new P.ConfigurationChangeEvent(v,{data:m},this.configuration);p.source=f,p.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(ie[207],re([0,1,9,4]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var R;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends D.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof T&&P._code===R.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof T&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof T&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof T&&P.isHandled}constructor(P,I=R.Unknown,E){super(P),this._message=P,this._code=I,this._detail=E,this.isHandled=I===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}}e.RemoteAuthorityResolverError=T}),define(ie[105],re([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=t;function R(E){if(!E)return;const C=E.indexOf("+");return C<0?E:E.substr(0,C)}e.getRemoteName=R;function T(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=T;function L(E){const{host:C,port:b}=I(E);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:b}}e.parseAuthorityWithPort=L;function P(E,C){let{host:b,port:v}=I(E);return typeof v>"u"&&(v=C),{host:b,port:v}}e.parseAuthorityWithOptionalPort=P;function I(E){const C=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const b=E.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const v=E.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:E,port:void 0}}}),define(ie[44],re([0,1,27,4,105]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,y){if(typeof p>"u"||p===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof p=="string"||typeof y=="string"){const u=typeof p=="string"?p:p.value,g=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(u,g)}return p._lower===y._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=E;function C(f){return b(f)}e.isApplicationScopedExtension=C;function b(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function m(f,p){if(p){const y=`onResolveRemoteAuthority:${(0,R.getRemoteName)(p)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[33],re([0,1,27,29,44,5,7,9,36]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,D.compareIgnoreCase)(r.id,n.id)===0}e.areSameExtensions=E;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(n){const o=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new b(n.identifier,o,s)}static parse(n){const o=C.exec(n);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,s="undefined"){this.version=o,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof b?E(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=b;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const n=v.exec(r);return n&&n[1]?[p(n[1]),n[2]]:[p(r),void 0]}e.getIdAndVersion=m;function f(r,n){return`${r}.${n}`}e.getExtensionId=f;function p(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function y(r,n){return p(f(r,n))}e.getGalleryExtensionId=y;function u(r,n){const o=[],s=h=>{for(const a of o)if(a.some(S=>E(n(S),n(h))))return a;return null};for(const h of r){const a=s(h);a?a.push(h):o.push([h])}return o}e.groupByExtension=u;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function c(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(r,n){const o=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const h=s.shift();if(h&&o.every(a=>!E(a.identifier,{id:h}))){const a=r.filter(S=>E(S.identifier,{id:h}));a.length===1&&(o.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=d;async function l(r,n){if(!T.isLinux)return!1;let o;try{o=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(h))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(r,n){const o=await l(r,n),s=(0,t.getTargetPlatform)(o?"alpine":T.platform,I.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(ie[51],re([0,1,6,17,2,40,7,33,14,4,8]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let b=class extends R.Disposable{constructor(m,f){super(),this.fileService=m,this.logService=f,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(m){return this.withProfileExtensions(m)}addExtensionsToProfile(m,f){return this.withProfileExtensions(f,p=>(p=p.filter(y=>m.some(([u])=>!(0,P.areSameExtensions)(y.identifier,u.identifier))),p.push(...m.map(([y,u])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:u}))),p))}removeExtensionFromProfile(m,f){return this.withProfileExtensions(f,p=>p.filter(y=>!(0,P.areSameExtensions)(y.identifier,m)))}async withProfileExtensions(m,f){return this.getResourceAccessQueue(m).queue(async()=>{let p=[];try{const y=await this.fileService.readFile(m),u=JSON.parse(y.value.toString());for(const g of u){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}p.push({identifier:g.identifier,location:L.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){p=f(p);const y=p.map(u=>({identifier:u.identifier,version:u.version,location:u.location.toJSON(),metadata:u.metadata}));await this.fileService.writeFile(m,t.VSBuffer.fromString(JSON.stringify(y)))}return p})}getResourceAccessQueue(m){let f=this.resourcesAccessQueueMap.get(m);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(m,f)),f}};b=pe([Y(0,I.IFileService),Y(1,C.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ie[208],re([0,1,24,33]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(T,L,P,I,E){try{const C=await T.getExtensionsControlManifest();if(!C.deprecated)return;const b=await T.getInstalled(1);for(const[v,m]of Object.entries(C.deprecated)){if(!m?.extension)continue;const{id:f,autoMigrate:p,preRelease:y}=m.extension;if(!p)continue;const u=b.find(c=>(0,t.areSameExtensions)(c.identifier,{id:v}));if(!u)continue;const g=(await L.getExtensions([{id:f,preRelease:y}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!g){E.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{E.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const c=!I.getDisabledExtensions().some(l=>(0,t.areSameExtensions)(l,u.identifier));await T.uninstall(u),E.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let d=b.find(l=>(0,t.areSameExtensions)(l.identifier,{id:f}));(!d||!d.isPreReleaseVersion&&c)&&(d=await T.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${d.identifier.id}'`),c||(await I.disableExtension(d.identifier),E.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(P.addToMigrationList((0,t.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,t.getExtensionId)(d.manifest.publisher,d.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(c){E.error(c)}}}catch(C){E.error(C)}}e.migrateUnsupportedExtensions=R}),define(ie[209],re([0,1,6,9,2,22,5,19,55,30,28,16,13,29,33,97,14,8]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class pt extends R.Disposable{constructor(d,l,i,r,n,o){super(),this.fileService=l,this.extensionGalleryService=i,this.configurationService=r,this.extensionSignatureVerificationService=n,this.logService=o,this.extensionsDownloadDir=d.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(d,l){await this.cleanUpPromise;const i=(0,P.joinPath)(this.extensionsDownloadDir,this.getName(d));try{await this.downloadFile(d,i,n=>this.extensionGalleryService.download(d,n,l))}catch(n){throw new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Download)}let r=!1;if(d.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const n=await this.downloadSignatureArchive(d);try{r=await this.extensionSignatureVerificationService.verify(i.fsPath,n.fsPath)}catch(o){throw await this.delete(n),await this.delete(i),new m.ExtensionManagementError(o.code,m.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:r}}async downloadSignatureArchive(d){await this.cleanUpPromise;const l=(0,P.joinPath)(this.extensionsDownloadDir,`${this.getName(d)}${pt.SignatureArchiveExtension}`);return await this.downloadFile(d,l,i=>this.extensionGalleryService.downloadSignatureArchive(d,i)),l}async downloadFile(d,l,i){if(await this.fileService.exists(l))return;if(l.scheme!==T.Schemas.file){await i(l);return}const r=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(r)||await i(r);try{await this.rename(r,l,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",d.identifier.id,l.path);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(n)}. Deleted the file from downloaded location`,r.path),n}}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,l,i){try{await C.Promises.rename(d.fsPath,l.fsPath)}catch(r){if(L.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${d} to ${l} with 'EPERM' error. Trying again...`),this.rename(d,l,i);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const l=[],i=[],r=[];for(const s of d.children)if(s.name.endsWith(pt.SignatureArchiveExtension))r.push(s.resource);else{const h=f.ExtensionKey.parse(s.name);h&&i.push([h,s])}const n=(0,f.groupByExtension)(i,([s])=>s),o=[];for(const s of n)s.sort((h,a)=>I.rcompare(h[0].version,a[0].version)),l.push(...s.slice(1).map(h=>h[1].resource)),o.push(s[0][1]);o.sort((s,h)=>s.mtime-h.mtime),l.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(s=>s.resource)),l.push(...r),await D.Promises.settled(l.map(s=>(this.logService.trace("Deleting from cache",s.path),this.fileService.del(s))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?f.ExtensionKey.create(d).toString().toLowerCase():(0,E.generateUuid)()}};g.SignatureArchiveExtension=".sigzip",g=pe([Y(0,v.INativeEnvironmentService),Y(1,y.IFileService),Y(2,m.IExtensionGalleryService),Y(3,b.IConfigurationService),Y(4,p.IExtensionSignatureVerificationService),Y(5,u.ILogService)],g),e.ExtensionsDownloader=g}),define(ie[210],re([0,1,2,12,28,44]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(I,E){super(),this.environmentService=I,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(E.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(I){I.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(ie[211],re([0,1,99,18,6,2,22,12,28,13,29,33,8,72,5,7]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends m.LanguagePackBaseService{constructor(d,l,i,r){super(i),this.extensionManagementService=d,this.logService=r,this.cache=this._register(new u(l,r)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(d){const i=(await this.cache.getLanguagePacks())[f.Language.value()];if(!i){this.logService.warn(`No language pack found for ${f.Language.value()}`);return}const r=i.translations[d];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const d=await this.cache.getLanguagePacks(),l=Object.keys(d).map(i=>{const r=d[i];return{...this.createQuickPickItem(i,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return l.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),l.sort((i,r)=>i.label.localeCompare(r.label)),l}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const l=await this.cache.getLanguagePacks();Object.keys(l).some(i=>l[i]&&l[i].extensions.some(r=>(0,b.areSameExtensions)(r.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(l);return!(0,t.equals)(Object.keys(d),Object.keys(i))}};y=pe([Y(0,C.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,C.IExtensionGalleryService),Y(3,v.ILogService)],y),e.NativeLanguagePackService=y;let u=class extends T.Disposable{constructor(d,l){super(),this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(l=>{Object.keys(l).forEach(i=>delete l[i]),this.createLanguagePacksFromExtensions(l,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...l){for(const i of l)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,i);Object.keys(d).forEach(i=>this.updateHash(d[i]))}createLanguagePacksFromExtension(d,l){const i=l.identifier,r=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const n of r)if(l.location.scheme===L.Schemas.file&&g(n)){let o=d[n.languageId];o||(o={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},d[n.languageId]=o);const s=o.extensions.filter(h=>(0,b.areSameExtensions)(h.extensionIdentifier,i))[0];s?s.version=l.manifest.version:o.extensions.push({extensionIdentifier:i,version:l.manifest.version});for(const h of n.translations)o.translations[h.id]=(0,P.join)(l.location.fsPath,h.path)}}updateHash(d){if(d){const l=(0,D.createHash)("md5");for(const i of d.extensions)l.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);d.hash=l.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(l=d(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),I.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>l,i=>this.logService.error(i))})}};u=pe([Y(0,E.INativeEnvironmentService),Y(1,v.ILogService)],u);function g(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const d of c.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(ie[212],re([0,1,6,17,24,9,3,2,30,91,207,105]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var m;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function f(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p(j){const H=new R.CancellationTokenSource;return setTimeout(()=>H.cancel(),j),H.token}function y(j,H){if(j.isCancellationRequested||H.isCancellationRequested)return R.CancellationToken.Cancelled;const _=new R.CancellationTokenSource;return j.onCancellationRequested(()=>_.cancel()),H.onCancellationRequested(()=>_.cancel()),_.token}class u{get didTimeout(){return this._state==="timedout"}constructor(H){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((_,N)=>{this._resolvePromise=_,this._rejectPromise=N}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function g(j,H){const _=new u(H);return _.registerDisposable(j.onControlMessage(N=>{const V=JSON.parse(N.toString()),K=z(V);K?_.reject(K):_.resolve(V)})),_.promise}function c(j,H,_,N,V,K,ee,ae){const Z=new u(ae);return H.connect(_,N,V,K,ee,(ne,oe)=>{Z.didTimeout?(ne&&j.error(ne),oe?.dispose()):ne||!oe?Z.reject(ne):Z.resolve(oe)}),Z.promise}function d(j,H){const _=new u(H);return j.then(N=>{_.didTimeout||_.resolve(N)},N=>{_.didTimeout||_.reject(N)}),_.promise}async function l(j,H,_,N){const V=X(j,H);j.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let K;try{K=await c(j.logService,j.socketFactory,j.host,j.port,(0,b.getRemoteServerRootPath)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,`renderer-${f(H)}-${j.reconnectionToken}`,N)}catch(oe){throw j.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),j.logService.error(oe),oe}j.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let ee,ae;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(K,null),ee=j.reconnectionProtocol,ae=!1):(ee=new E.PersistentProtocol(K,null),ae=!0),j.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const Z=await d(j.signService.createNewMessage((0,I.generateUuid)()),N),ne={type:"auth",auth:j.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(t.VSBuffer.fromString(JSON.stringify(ne)));try{const oe=await g(ee,y(N,p(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(j.logService.trace(`${V} 4/6. received SignRequest control message.`),!await d(j.signService.validate(Z,oe.signedData),N)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const de=await d(j.signService.sign(oe.data),N),ve={type:"connectionType",commit:j.commit,signedData:de,desiredConnectionType:H};return _&&(ve.args=_),j.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(t.VSBuffer.fromString(JSON.stringify(ve))),{protocol:ee,ownsProtocol:ae}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(j.logService.error(`${V} the handshake timed out. Error:`),j.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${V} received error control message when negotiating connection. Error:`),j.logService.error(oe)),ae&&B(ee),oe}}async function i(j,H,_,N){const V=Date.now(),K=X(j,H),{protocol:ee,ownsProtocol:ae}=await l(j,H,_,N),Z=new u(N);return Z.registerDisposable(ee.onControlMessage(ne=>{const oe=JSON.parse(ne.toString()),ue=z(oe);ue?(j.logService.error(`${K} received error control message when negotiating connection. Error:`),j.logService.error(ue),ae&&B(ee),Z.reject(ue)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${se(V)}!`),Z.resolve({protocol:ee,firstMessage:oe}))})),Z.promise}async function r(j,H){const{protocol:_}=await i(j,1,void 0,H);return{protocol:_}}async function n(j,H,_){const{protocol:N,firstMessage:V}=await i(j,2,H,_),K=V&&V.debugPort;return{protocol:N,debugPort:K}}async function o(j,H,_){const N=Date.now(),V=X(j,3),{protocol:K}=await l(j,3,H,_);return j.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${se(N)}!`),K}async function s(j,H,_){const{host:N,port:V,connectionToken:K}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,host:N,port:V,connectionToken:K,reconnectionToken:H,reconnectionProtocol:_,socketFactory:j.socketFactory,signService:j.signService,logService:j.logService}}async function h(j,H,_){return S(j,async N=>{const{protocol:V}=await r(N,R.CancellationToken.None);return new G(j,H,_,N.reconnectionToken,V)})}e.connectRemoteAgentManagement=h;async function a(j,H){return S(j,async _=>{const{protocol:N,debugPort:V}=await n(_,H,R.CancellationToken.None);return new W(j,H,_.reconnectionToken,N,V)})}e.connectRemoteAgentExtensionHost=a;async function S(j,H){for(let N=1;;N++)try{const V=(0,I.generateUuid)(),K=await s(j,V,null);return await H(K)}catch(V){if(N<5)j.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(V);else throw j.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(V),F.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(V)),V}}async function w(j,H,_){const N=await s(j,(0,I.generateUuid)(),null);return await o(N,{host:H,port:_},R.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function A(j){return(0,D.createCancelablePromise)(H=>new Promise((_,N)=>{const V=setTimeout(_,j*1e3);H.onCancellationRequested(()=>{clearTimeout(V),_()})}))}var q;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(q=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(H,_){this.reconnectionToken=H,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=U;class O{constructor(H,_,N,V){this.reconnectionToken=H,this.millisSinceLastIncomingData=_,this.durationSeconds=N,this.cancellableTimer=V,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class ${constructor(H,_,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=_,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=$;class k{constructor(H,_,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=_,this.attempt=N,this.type=4}}e.ConnectionGainEvent=k;class M{constructor(H,_,N,V){this.reconnectionToken=H,this.millisSinceLastIncomingData=_,this.attempt=N,this.handled=V,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class F extends P.Disposable{static triggerPermanentFailure(H,_,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=_,this._permanentFailureHandled=N,this._instances.forEach(V=>V._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||F._permanentFailure}constructor(H,_,N,V,K){super(),this._connectionType=H,this._options=_,this.reconnectionToken=N,this.protocol=V,this._reconnectionFailureIsFatal=K,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new k(this.reconnectionToken,0,0)),this._register(V.onSocketClose(ee=>{const ae=J(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${ae} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${ae} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${ae} received socket close event.`),this._beginReconnecting()})),this._register(V.onSocketTimeout(ee=>{const ae=J(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),F._instances.push(this),this._register((0,P.toDisposable)(()=>{const ee=F._instances.indexOf(this);ee>=0&&F._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=J(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const V=N<_.length?_[N]:_[_.length-1];try{if(V>0){const ee=A(V);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,ee)),this._options.logService.info(`${H} waiting for ${V} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${H} resolving connection...`);const K=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${K.host}:${K.port}...`),await this._reconnect(K,p(v)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,T.isCancellationError)(K)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,C.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,_,N){this._reconnectionFailureIsFatal?F.triggerPermanentFailure(H,_,N):this._gotoPermanentFailure(H,_,N)}_gotoPermanentFailure(H,_,N){this._onDidStateChange.fire(new M(this.reconnectionToken,H,_,N)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=F,F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class G extends F{constructor(H,_,N,V,K){super(1,H,V,K,!0),this.client=this._register(new E.Client(K,{remoteAuthority:_,clientId:N},H.ipcLogger))}async _reconnect(H,_){await r(H,_)}}e.ManagementPersistentConnection=G;class W extends F{constructor(H,_,N,V,K){super(2,H,N,V,!1),this._startArguments=_,this.debugPort=K}async _reconnect(H,_){await n(H,this._startArguments,_)}}e.ExtensionHostPersistentConnection=W;function B(j){try{j.acceptDisconnect();const H=j.getSocket();j.dispose(),H.dispose()}catch(H){(0,T.onUnexpectedError)(H)}}function z(j){if(j&&j.type==="error"){const H=new Error(`Connection error: ${j.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function x(j,H){for(;j.length<H;)j+=" ";return j}function J(j,H,_){return`[remote-connection][${x(f(j),13)}][${H.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function X(j,H){return`${J(H,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.host}:${j.port}]`}function se(j){return`${Date.now()-j} ms`}}),define(ie[213],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ie[214],re([0,1,84,143]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,T,L,P,I,E){const C=v=>E(v,void 0),b=D.createConnection({host:R,port:T},()=>{b.removeListener("error",C);const v=Buffer.alloc(16);for(let y=0;y<16;y++)v[y]=Math.round(Math.random()*256);const m=v.toString("base64"),f=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${T}${L}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];b.write(f.join(`\r
`)+`\r
\r
`);const p=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",p),E(void 0,new t.NodeSocket(b,I)))};b.on("data",p)});b.setNoDelay(!0),b.once("error",C)}}}),define(ie[106],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var t;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=T=>({type:"connected",info:T}),R.connecting=T=>({type:"connecting",progress:T})})(t=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride"}),define(ie[215],re([0,1,126,16,8]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,I){this.configurationService=P,this.logService=I}async request(P,I){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const E=await(0,D.request)(P,I);return this.logService.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.logService.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};T=pe([Y(0,t.IConfigurationService),Y(1,R.ILogService)],T),e.RequestService=T}),define(ie[45],re([0,1,17,162,43,4,39]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function I(p){return p.res.statusCode===204}async function E(p){return I(p)?null:(await(0,D.streamToBuffer)(p.stream)).toString()}e.asText=E;async function C(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.asTextOrError=C;async function b(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(I(p))return null;const u=(await(0,D.streamToBuffer)(p.stream)).toString();try{return JSON.parse(u)}catch(g){throw g.message+=`:
`+u,g}}e.asJson=b;function v(p){f(p)}e.updateProxyConfigurationsScope=v;let m;function f(p){const y=L.Registry.as(R.Extensions.Configuration),u=m;m={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[m],remove:u?[u]:[]})}f(2)}),define(ie[216],re([0,1,24,22,14,45]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,E){this.requestService=I,this.fileService=E}async download(I,E,C=D.CancellationToken.None){if(I.scheme===t.Schemas.file||I.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(I,E);return}const b={type:"GET",url:I.toString(!0)},v=await this.requestService.request(b,C);if(v.res.statusCode===200)await this.fileService.writeFile(E,v.stream);else{const m=await(0,T.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${m}`)}}};L=pe([Y(0,T.IRequestService),Y(1,R.IFileService)],L),e.DownloadService=L}),define(ie[217],re([0,1,18,24,2,19,179,14,8,25,45]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends R.Disposable{constructor(m,f,p,y){super(),this.fileService=m,this.productService=f,this.requestService=p,this.logService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,u])=>this.allConfigBasedTips.set(u.configPath,u))}getConfigBasedTips(m){return this.getValidConfigBasedTips(m)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(m){const f=[];for(const[p,y]of this.allConfigBasedTips)if(!(y.configScheme&&y.configScheme!==m.scheme))try{const u=await this.fileService.readFile((0,T.joinPath)(m,p)),g=new Map;Object.entries(y.recommendations).forEach(([d,l])=>{if((0,D.isNonEmptyArray)(l.remotes))for(const i of l.remotes)g.set(i,{extensionId:d,extensionName:l.name,configName:y.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else f.push({extensionId:d,extensionName:l.name,configName:y.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const c=(0,L.getDomainsOfRemotes)(u.value.toString(),[...g.keys()]);for(const d of c){const l=g.get(d);l&&f.push(l)}}catch{}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const m=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(m.res.statusCode!==200)return[];const f=await(0,C.asJson)(m);return f?f.workspaceRecommendations||[]:[]}catch(m){return this.logService.error(m),[]}}};b=pe([Y(0,P.IFileService),Y(1,E.IProductService),Y(2,C.IRequestService),Y(3,I.ILogService)],b),e.ExtensionTipsService=b}),define(ie[218],re([0,1,17,24]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.service=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,E,C=t.CancellationToken.None){switch(I){case"request":return this.service.request(E[0],C).then(async({res:b,stream:v})=>{const m=await(0,D.streamToBuffer)(v);return[{statusCode:b.statusCode,headers:b.headers},m]});case"resolveProxy":return this.service.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class T{constructor(P){this.channel=P}async request(P,I){const[E,C]=await this.channel.call("request",[P],I);return{res:E,stream:(0,D.bufferToStream)(C)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=T}),define(ie[219],re([0,1,215,218]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(L,P,I){this.configurationService=P,this.logService=I,this.browserRequestService=new D.RequestService(P,I),this.mainRequestService=new t.RequestChannelClient(L.getChannel("request"))}request(L,P){return this.getRequestService().request(L,P)}async resolveProxy(L){return this.getRequestService().resolveProxy(L)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(ie[107],re([0,1,66,4]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ie[220],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ie[221],re([0,1,92,6,24,3,2,22,30,8,107,220]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(p){this.logService=p,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(p){const y=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${y})`);const u=(0,C.hash)(p);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.doDisposeWorker(p));const g=new R.CancellationTokenSource;let c,d,l;this.processeDisposables.set(u,o=>{g.dispose(!0),c?.terminate(p,R.CancellationToken.None),d?.close(),l?.close(),this.processeDisposables.delete(u);const s=this.processResolvers.get(u);s&&(this.processResolvers.delete(u),s({reason:o}))}),c=await this.getOrCreateWebWorker(p);const i=new Promise(o=>{this.processResolvers.set(u,o)});if(g.token.isCancellationRequested)return i;const{port1:r,port2:n}=new MessageChannel;return d=r,l=n,await c.spawn(p,l,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${y})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[d])),i}getOrCreateWebWorker(p){let y=this.workers.get(p.process.moduleId);if(!y){this.logService.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const u=new m(p.process.type,this.logService);y=u.init(),u.onDidProcessSelfTerminate(({configuration:g,reason:c})=>{this.doDisposeWorker(g,c)}),this.workers.set(p.process.moduleId,y)}return y}async disposeWorker(p){return this.doDisposeWorker(p)}doDisposeWorker(p,y){const u=this.processeDisposables.get((0,C.hash)(p));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),u(y))}};v=pe([Y(0,E.ILogService)],v),e.SharedProcessWorkerService=v;class m extends L.Disposable{constructor(p,y){super(),this.type=p,this.logService=y,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const p=new t.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return y.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},y.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},y.onmessage=u=>{const{id:g,message:c,configuration:d,nonce:l}=u.data;switch(g){case b.SharedProcessWorkerMessages.Ready:p.complete(y);break;case b.SharedProcessWorkerMessages.Ack:if(l){const i=this.mapMessageNonceToPendingMessageResolve.get(l);i&&(this.mapMessageNonceToPendingMessageResolve.delete(l),i())}break;case b.SharedProcessWorkerMessages.SelfTerminated:d&&c&&this._onDidProcessSelfTerminate.fire({configuration:d,reason:JSON.parse(c)});break;case b.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case b.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case b.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case b.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async send(p,y,u){const g=await this.workerReady;if(!y.isCancellationRequested)return new Promise(c=>{const d=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,c);const l={...p,nonce:d};u?g.postMessage(l,[u]):g.postMessage(l),y.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&c()})})}spawn(p,y,u){const g={id:b.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,u,y)}terminate(p,y){const u={id:b.SharedProcessWorkerMessages.Terminate,configuration:p};return this.send(u,y)}}}),define(ie[222],re([0,1,63,22,178]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.vscodeUserData})}}pe([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ie[223],re([0,1,49,12,163,24,37,9,5,30,140,176,6]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let f;async function p(u,g,c){return g["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(c)&&!g["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(c)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(d,l)=>{const i=new T.CancellationTokenSource,r=setTimeout(()=>{i.dispose(!0),l(new Error((0,R.localize)(0,null)))},m);try{d(await y(u,i.token))}catch(n){!(0,P.isCancellationError)(n)&&!i.token.isCancellationRequested?l(new Error((0,R.localize)(1,null,(0,L.toErrorMessage)(n)))):d({})}finally{clearTimeout(r),i.dispose()}})),f)}e.getResolvedShellEnv=p;async function y(u,g){const c=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",c);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",d);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const n=await(0,C.getSystemShell)(I.OS,r);return u.trace("getUnixShellEnvironment#shell",n),new Promise((o,s)=>{if(g.isCancellationRequested)return s((0,P.canceled)());const h=(0,t.basename)(n);let a,S;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(a=`& '${process.execPath}' ${w} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,S=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,h==="tcsh"?S=["-ic"]:S=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),a);const A=(0,D.spawn)(n,[...S,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(A.kill(),s((0,P.canceled)()))),A.on("error",O=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(O)),s(O)});const q=[];A.stdout.on("data",O=>q.push(O));const U=[];A.stderr.on("data",O=>U.push(O)),A.on("close",(O,$)=>{const k=Buffer.concat(q).toString("utf8");u.trace("getUnixShellEnvironment#raw",k);const M=Buffer.concat(U).toString("utf8");if(M.trim()&&u.trace("getUnixShellEnvironment#stderr",M),O||$)return s(new Error((0,R.localize)(2,null,O,$)));const F=i.exec(k),G=F?F[1]:"{}";try{const W=JSON.parse(G);c?W.ELECTRON_RUN_AS_NODE=c:delete W.ELECTRON_RUN_AS_NODE,d?W.ELECTRON_NO_ATTACH_CONSOLE=d:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",W),o(W)}catch(W){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(W)),s(W)}})})}}),define(ie[108],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[224],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,T)=>Q(["vsda"],R,T))}async createNewMessage(R){try{const T=await this.vsda(),L=new T.validator;if(L){const P=String(D._nextId++);return this.validators.set(P,L),{id:P,data:L.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,T){if(!R.id)return!0;const L=this.validators.get(R.id);if(!L)return!1;this.validators.delete(R.id);try{return L.validate(T)==="ok"}catch{return!1}}async sign(R){try{const T=await this.vsda(),L=new T.signer;if(L)return L.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(ie[74],re([0,1,3,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends t.Disposable{constructor(b,v,m){super(),this.channel=b,this.profile=v,this.workspace=m}async getItems(){const b={profile:this.profile,workspace:this.workspace},v=await this.channel.call("getItems",b);return new Map(v)}updateItems(b){const v={profile:this.profile,workspace:this.workspace};return b.insert&&(v.insert=Array.from(b.insert.entries())),b.delete&&(v.delete=Array.from(b.delete.values())),this.channel.call("updateItems",v)}}class T extends R{constructor(b,v){super(b,v,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class L extends T{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class P extends T{constructor(b,v){super(b,v)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(b,v){super(b,void 0,v),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class E{constructor(b){this.channel=b}isUsed(b){const v={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",v)}}e.StorageClient=E}),define(ie[109],re([0,1,5,36,7,30]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,C,b,v,m,f,p,y,u,g){const c=Object.create(null);c["common.machineId"]=p,c.sessionID=(0,T.generateUuid)()+Date.now(),c.commitHash=m,c.version=f,c["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=t.platform,c["common.nodeArch"]=v,c["common.product"]=g||"desktop",y&&(c["common.msftInternal"]=y);let d=0;const l=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const i=L(b);i&&(c["common.platformDetail"]=i);try{const r=await E.readFile(R.URI.file(u));c["common.source"]=r.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function I(E){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const b=C.toLowerCase();return E.some(v=>b===v)}e.verifyMicrosoftInternalDomain=I}),define(ie[23],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[225],re([0,1,34,6,35,22,12,5,7,137,28,139,95,14,25,23]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function u(i,r){const n=`${i}::${r.join(":")}`,o=y.get(n);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,a=new Map,S=2e4;function w(q,U,O,$){const k=U.substring(q.length+1);return t.Promises.withAsyncBody(async M=>{let F;try{F=await C.Promises.readdir(U,{withFileTypes:!0})}catch{M();return}if($.count>=S){$.count+=F.length,$.maxReached=!0,M();return}let G=F.length;if(G===0){M();return}let W=F;$.count+F.length>S&&($.maxReached=!0,G=S-$.count,W=F.slice(0,G)),$.count+=F.length;for(const B of W)if(B.isDirectory()){if(O.includes(B.name)||await w(q,(0,L.join)(U,B.name),O,$),--G===0){M();return}}else{const z=B.name.lastIndexOf(".");if(z>=0){const x=B.name.substring(z+1);x&&h.set(x,(h.get(x)??0)+1)}for(const x of s)x.relativePathPattern?.test(k)!==!1&&x.filePattern.test(B.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--G===0){M();return}}})}const A=t.Promises.withAsyncBody(async q=>{const U={count:0,maxReached:!1};await w(i,i,r,U);const O=await d(i);q({configFiles:g(a),fileTypes:g(h),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:O})});return y.set(n,A),A}e.collectWorkspaceStats=u;function g(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function c(){const i={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=c;async function d(i){try{const r=new Map,n=(0,L.join)(i,".vscode","launch.json"),o=await C.Promises.readFile(n),s=[],h=(0,R.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(h)==="object"&&h.configurations)for(const a of h.configurations){const S=a.type;S&&(r.has(S)?r.set(S,r.get(S)+1):r.set(S,1))}return g(r)}catch{return[]}}e.collectLaunchConfigs=d;let l=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const o=D.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||n.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,b.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[s,h]=o,a=this.formatProcessList(r,s);return n.forEach(S=>{if((0,v.isRemoteDiagnosticError)(S))a+=`
${S.errorMessage}`,h+=`
${S.errorMessage}`;else if(a+=`

Remote: ${S.hostName}`,S.processes&&(a+=`
${this.formatProcessList(r,S.processes)}`),S.workspaceMetadata){h+=`
|  Remote: ${S.hostName}`;for(const w of Object.keys(S.workspaceMetadata)){const A=S.workspaceMetadata[w];let q=`${A.fileCount} files`;A.maxFilesReached&&(q=`more than ${q}`),h+=`|    Folder (${w}): ${q}`,h+=this.formatWorkspaceStats(A)}}}),{processInfo:a,workspaceInfo:h}})}async getSystemInfo(r,n){const{memory:o,vmHint:s,os:h,cpus:a}=c(),S={os:h,memory:o,cpus:a,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return P.isWindows||(S.load=`${D.loadavg().map(w=>Math.round(w)).join(", ")}`),P.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(r,n){const o=[];return(0,b.listProcesses)(r.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,s)),r.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),n.forEach(h=>{if((0,v.isRemoteDiagnosticError)(h))o.push(`
${h.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${h.hostName}`),o.push(this.formatMachineInfo(h.machineInfo)),h.processes&&o.push(this.formatProcessList(r,h.processes)),h.workspaceMetadata)for(const a of Object.keys(h.workspaceMetadata)){const S=h.workspaceMetadata[a];let w=`${S.fileCount} files`;S.maxFilesReached&&(w=`more than ${w}`),o.push(`Folder (${a}): ${w}`),o.push(this.formatWorkspaceStats(S))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const n=[];let s=0;const h=(A,q)=>{const U=` ${A}(${q})`;s+U.length>60?(n.push(a),a="|                 ",s=a.length):s+=U.length,a+=U};let a="|      File types:";const S=10,w=r.fileTypes.length>S?S:r.fileTypes.length;for(let A=0;A<w;A++){const q=r.fileTypes[A];h(q.name,q.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",s=0,r.configFiles.forEach(A=>{h(A.name,A.count)}),n.push(a)),r.launchConfigFiles.length>0){let A="|      Launch Configs:";r.launchConfigFiles.forEach(q=>{A+=q.count>1?` ${q.name}(${q.count})`:` ${q.name}`}),n.push(A)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],o=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(h=>{const a=I.URI.revive(h);if(a.scheme===T.Schemas.file){const S=a.fsPath;o.push(u(S,["node_modules",".git"]).then(w=>{let A=`${w.fileCount} files`;w.maxFilesReached&&(A=`more than ${A}`),n.push(`|    Folder (${(0,L.basename)(S)}): ${A}`),n.push(this.formatWorkspaceStats(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${S} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,n){const o=new Map;r.windows.forEach(h=>o.set(h.pid,h.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,o,s,n,0),s.join(`
`)}formatProcessItem(r,n,o,s,h){const a=h===0;let S;a?S=s.pid===r?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(h)} ${s.name}`,s.name==="window"&&(S=`${S} (${n.get(s.pid)})`));const w=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(w/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(A=>this.formatProcessItem(r,n,o,A,h+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:o}of r.folders){const s=I.URI.revive(o);if(s.scheme!==T.Schemas.file)continue;const h=s.fsPath;try{(await u(h,["node_modules",".git"])).fileTypes.forEach(S=>n.add(S.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const o=I.URI.revive(n);if(o.scheme!==T.Schemas.file)continue;const s=o.fsPath;try{const h=await u(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),h.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),h.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),h.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};l=pe([Y(0,p.ITelemetryService),Y(1,f.IProductService)],l),e.DiagnosticsService=l}),define(ie[226],re([0,1,106,3,23,13,2,8,7,12,49,25,5,6,101,16,161,34]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let g=class extends L.Disposable{constructor(d,l,i,r,n,o){super(),this.telemetryService=d,this.productService=l,this.environmentService=i,this.configurationService=o,this._onDidTokenFailedEmitter=new t.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new t.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new t.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=D.TunnelStates.disconnected,this._logger=this._register(r.createLogger(i.remoteTunnelLogResource,{name:"remoteTunnel"})),this._startTunnelProcessDelayer=new m.Delayer(100),this._register(n.onWillShutdown(s=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()})),this._register(o.onDidChangeConfiguration(s=>{s.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(d){if(d&&this._account?d.token!==this._account.token||d.authenticationProviderId!==this._account.authenticationProviderId:d!==this._account){this._account=d,this._onDidChangeAccountEmitter.fire(d),this._logger.info(`Account updated: ${d?d.authenticationProviderId:"undefined"}`),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!d});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(l){this._logger.error(l)}}}getTunnelCommandLocation(){if(!this._tunnelCommand){let d;v.isMacintosh?d=this.environmentService.appRoot:d=(0,E.dirname)((0,E.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,E.join)(d,"bin",`${this.productService.tunnelApplicationName}${v.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(D.TunnelStates.disconnected);return}this.setTunnelStatus(D.TunnelStates.connecting((0,y.localize)(0,null)));const d=this.runCodeTunneCommand("login",["user","login","--provider",this._account.authenticationProviderId,"--access-token",this._account.token]);this._tunnelProcess=d;try{if(await d,this._tunnelProcess!==d)return}catch(n){this._logger.error(n),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected);return}const l=["--parent-process-id",String(process.pid),"--accept-server-license-terms"],i=this.getHostName();i?l.push("--name",i):l.push("--random-name");const r=this.runCodeTunneCommand("tunnel",l,n=>{const o=n.match(/^\s*Open this link in your browser (https:[^\s]*)+/);if(o&&o[1]){const s=I.URI.parse(o[1]),h=s.path.match(/\/+([^\/])+\/([^\/]+)\//),a=h?{link:o[1],domain:s.authority,extensionId:h[1],hostName:h[2]}:{link:o[1],domain:s.authority,extensionId:"",hostName:""};this.setTunnelStatus(D.TunnelStates.connected(a))}});this._tunnelProcess=r,r.finally(()=>{r===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(d){d!==this._tunnelStatus&&(this._tunnelStatus=d,this._onDidChangeTunnelStatusEmitter.fire(d))}runCodeTunneCommand(d,l,i=()=>{}){return(0,m.createCancelablePromise)(r=>new Promise((n,o)=>{r.isCancellationRequested&&n();let s;if(r.onCancellationRequested(()=>{s&&(this._logger.info(`${d} terminating (${s.pid})`),s.kill())}),this._logger.info(`${d} appRoot ${this.environmentService.appRoot}`),this._logger.info(`${d} process.execPath ${process.execPath}`),process.env.VSCODE_DEV)i("Compiling tunnel CLI from sources and run",!1),this._logger.info(`${d} Spawning: cargo run -- tunnel ${l.join(" ")}`),s=(0,C.spawn)("cargo",["run","--","tunnel",...l],{cwd:(0,E.join)(this.environmentService.appRoot,"cli")});else{i("Running tunnel CLI",!1);const h=this.getTunnelCommandLocation();this._logger.info(`${d} Spawning: ${h} tunnel ${l.join(" ")}`),s=(0,C.spawn)(h,["tunnel",...l],{cwd:(0,u.homedir)()})}s.stdout.on("data",h=>{if(s){const a=h.toString();i(a,!1),this._logger.info(`${d} stdout (${s.pid}):  + ${a}`)}}),s.stderr.on("data",h=>{if(s){const a=h.toString();i(a,!0),this._logger.info(`${d} stderr (${s.pid}):  + ${a}`)}}),s.on("exit",h=>{s&&(this._logger.info(`${d} exit (${s.pid}):  + ${h}`),s=void 0,h===0?n():o())}),s.on("error",h=>{s&&(this._logger.info(`${d} error (${s.pid}):  + ${h}`),s=void 0,o())})}))}getHostName(){const d=this.configurationService.getValue(D.CONFIGURATION_KEY_HOST_NAME);if(d&&d.match(/^([\w-]+)$/)&&d.length<=20)return d;const l=(0,u.hostname)();if(l&&l.match(/^([\w-]+)$/))return l}};g=pe([Y(0,R.ITelemetryService),Y(1,b.IProductService),Y(2,T.INativeEnvironmentService),Y(3,P.ILoggerService),Y(4,f.ISharedProcessLifecycleService),Y(5,p.IConfigurationService)],g),e.RemoteTunnelService=g}),define(ie[110],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,{eventName:P,data:I}){return this.appenders.forEach(E=>E.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class t{constructor(T){this.channel=T}log(T,L){return this.channel.call("log",{eventName:T,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ie[52],re([0,1,32,86,15,16,109,23]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(o,s){return Promise.resolve(void 0)}publicLog2(o,s){return this.publicLog(o,s)}publicLogError(o,s){return Promise.resolve(void 0)}publicLogError2(o,s){return this.publicLogError(o,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(o,s,h){}async publicLogError(o,s,h){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(n,o){return o.onDidChangeConfiguration(s=>{s.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(s.source),configurationKeys:u(s.sourceConfig)})})}e.configurationTelemetry=C;function b(n,o){return!(o.disableTelemetry||!n.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=b;function v(n){const o=n.getValue(P.TELEMETRY_SETTING_ID),s=n.getValue("telemetry.enableCrashReporter");if(n.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function m(n){const o={},s={},h={};y(n,h);for(let a in h){a=a.length>150?a.substr(a.length-149):a;const S=h[a];typeof S=="number"?s[a]=S:typeof S=="boolean"?s[a]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${S.length}`),o[a]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(o[a]=S)}return{properties:o,measurements:s}}e.validateTelemetryData=m;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function p(n){if(!n)return"none";for(const o of f)if(n.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=p;function y(n,o,s=0,h){if(!!n)for(const a of Object.getOwnPropertyNames(n)){const S=n[a],w=h?h+a:a;Array.isArray(S)?o[w]=(0,D.safeStringify)(S):S instanceof Date?o[w]=S.toISOString():(0,R.isObject)(S)?s<2?y(S,o,s+1,w+"."):o[w]=(0,D.safeStringify)(S):o[w]=S}}function u(n){if(!n)return[];const o=[];return g(o,"",n),o}function g(n,o,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(h=>g(n,o?`${o}.${h}`:h,s[h])):n.push(o)}function c(n,o){const s=n.msftInternalDomains||[],h=o.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(s)||h}e.isInternalTelemetry=c;function d(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=d;function l(n,o){let s=n;const h=[];for(const A of o)for(;;){const q=A.exec(n);if(!q)break;h.push([q.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(s="";;){const A=S.exec(n);if(!A)break;const q=h.some(([U,O])=>A.index<O&&U<S.lastIndex);!a.test(A[0])&&!q&&(s+=n.substring(w,A.index)+"<REDACTED: user-file-path>",w=S.lastIndex)}return w<n.length&&(s+=n.substr(w)),s}function i(n){if(!n)return n;const o=n.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of s)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return n}function r(n,o){return(0,D.cloneAndChange)(n,s=>{if(typeof s=="string"){let h=s;h=l(h,o);for(const a of o)h=h.replace(a,"");return h=i(h),h}})}e.cleanData=r}),define(ie[227],re([0,1,50,52]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(T,L,P,I,E,C,b){const v={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${L.nameShort})`};if((0,t.supportsTelemetry)(L,P)&&(0,t.getTelemetryLevel)(I)===3){const m=await(0,D.getServiceMachineId)(P,E,C),{sessionId:f}=await b.getTelemetryInfo();v["X-Market-User-Id"]=m,v["VSCode-SessionId"]=f}return v}e.resolveMarketplaceHeaders=R}),define(ie[228],re([0,1,9,32,52]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(I,E,C){const b=await new Promise((y,u)=>{Q(["@microsoft/1ds-core-js"],y,u)}),v=await new Promise((y,u)=>{Q(["@microsoft/1ds-post-js"],y,u)}),m=new b.AppInsightsCore,f=new v.PostChannel,p={instrumentationKey:I,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(C){p.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:C};p.extensionConfig[f.identifier]=y}return m.initialize(p,[]),m.addTelemetryInitializer(y=>{E&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),m}class P{constructor(E,C,b,v,m){this._isInternalTelemetry=E,this._eventPrefix=C,this._defaultData=b,this._xhrOverride=m,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof v=="function"?this._aiCoreOrKey=v():this._aiCoreOrKey=v,this._asyncAiCore=null}_withAIClient(E){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{E(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(E,C){if(!this._aiCoreOrKey)return;C=(0,t.mixin)(C,this._defaultData),C=(0,R.validateTelemetryData)(C);const b=this._eventPrefix+"/"+E;try{this._withAIClient(v=>{v.pluginVersionString=C?.properties.version??"Unknown",v.track({name:b,baseData:{name:b,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ie[111],re([0,1,2,13,8,52]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends D.Disposable{constructor(I,E,C=""){super(),this.prefix=C;const b=I.getLogger(E.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(I.createLogger(E.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,E){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,T.validateTelemetryData)(E))}};L=pe([Y(0,R.ILoggerService),Y(1,t.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(ie[112],re([0,1,2,32,86,5,27,164,16,43,103,25,39,23,52]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(g,c,d){this._configurationService=c,this._productService=d,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,c){this._experimentProperties[g]=c}_updateTelemetryLevel(){let g=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const d=c.usage?3:c.error?2:0;g=Math.min(g,d)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,c=g.sessionID,d=g["common.machineId"],l=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:c,machineId:d,firstSessionDate:l,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,c,d,l){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(i=>{d=(0,t.mixin)(d,this._experimentProperties),d=(0,f.cleanData)(d,this._cleanupPatterns),d=(0,t.mixin)(d,i),this._appenders.forEach(r=>r.log(g,d))},i=>{console.error(i)})}publicLog(g,c,d){return this._log(g,3,c,d)}publicLog2(g,c,d){return this.publicLog(g,c,d)}publicLogError(g,c){return this._sendErrorTelemetry?this._log(g,2,c,!0):Promise.resolve(void 0)}publicLogError2(g,c){return this.publicLogError(g,c)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=pe([Y(1,I.IConfigurationService),Y(2,b.IProductService)],p),e.TelemetryService=p;function y(){const u=(0,P.localize)(0,null,C.default.nameLong),g=C.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=T.isWeb?"":(0,P.localize)(3,null),d=(0,P.localize)(4,null),l=(0,P.localize)(5,null),i=(0,P.localize)(6,null),r=(0,P.localize)(7,null),n=`
|       | ${d} | ${l} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${u} ${g} ${c}

&nbsp;

${r}
${n}

&nbsp;

${o}
`}v.Registry.as(E.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(E.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,P.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,P.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[229],re([0,1,285,228]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends t.AbstractOneDataSystemAppender{constructor(L,P,I,E){const C={sendPOST:(b,v)=>{const m={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const f=D.request(b.urlString,m,p=>{p.on("data",function(y){v(p.statusCode??200,p.headers,y.toString())}),p.on("error",function(y){v(0,{})})});f.write(b.data),f.end()}catch{v(0,{})}}};super(L,P,I,E,C)}}e.OneDataSystemAppender=R}),define(ie[230],re([0,1,22,68,16,13,8,25,23,110,111,112]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(f,p,y,u,g){this.configurationService=f,this.telemetryService=p,this.loggerService=y,this.environmentService=u,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:p,sessionId:y}=await this.telemetryService.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=p,u["common.vscodesessionid"]=y;const g=[f.id,JSON.stringify(u),f.aiKey],d=new t.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new E.TelemetryAppenderClient(d),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new b.TelemetryService({appenders:l,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,p,y){await(await this.getCustomTelemetryService(f)).publicLog(p,y)}async publicLogError(f,p,y){await(await this.getCustomTelemetryService(f)).publicLogError(p,y)}};v=pe([Y(0,R.IConfigurationService),Y(1,I.ITelemetryService),Y(2,L.ILoggerService),Y(3,T.IEnvironmentService),Y(4,P.IProductService)],v),e.CustomEndpointTelemetryService=v}),define(ie[231],re([0,1,6,24,3,2,8]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(E,C){super(),this._logService=C,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((C,b)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,C),this._onCreateRequest.fire({requestId:v,...E});const m=new t.CancellationTokenSource;(0,D.timeout)(this._timeout,m.token).then(()=>b(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,T.toDisposable)(()=>m.cancel())])})}acceptReply(E,C){const b=this._pendingRequests.get(E);b?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),b(C)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=pe([Y(1,L.ILogService)],P),e.RequestStore=P}),define(ie[113],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(c){c.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var P;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var C;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(c){c.TerminalView="view",c.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var u;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ie[232],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ie[233],re([0,1,34,22,32,12,5,36,27,15,28]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let l=0;return d&&d.length===4&&(l=parseInt(d[3])),l}e.getWindowsBuildNumber=b;async function v(d,l,i,r=P.env,n=C.Promises.exists){if(T.isAbsolute(d))return await n(d)?d:void 0;if(l===void 0&&(l=P.cwd()),T.dirname(d)!=="."){const a=T.join(l,d);return await n(a)?a:void 0}const s=(0,R.getCaseInsensitive)(r,"PATH");if(i===void 0&&(0,E.isString)(s)&&(i=s.split(T.delimiter)),i===void 0||i.length===0){const a=T.join(l,d);return await n(a)?a:void 0}for(const a of i){let S;if(T.isAbsolute(a)?S=T.join(a,d):S=T.join(l,a,d),await n(S))return S;if(L.isWindows){let w=S+".com";if(await n(w)||(w=S+".exe",await n(w)))return w}}const h=T.join(l,d);return await n(h)?h:void 0}e.findExecutable=v;function m(d,l,i,r,n){if(!l.shellIntegration.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration||L.isWindows&&!l.windowsEnableConpty)return;const o=d.args,s=P.platform==="win32"?T.basename(d.executable).toLowerCase():T.basename(d.executable),h=T.dirname(t.FileAccess.asFileUri("",Q).fsPath);let a;const S={VSCODE_INJECTION:"1"};if(L.isWindows){if(s==="pwsh.exe")return!o||g(o)?a=e.shellIntegrationArgs.get(f.WindowsPwsh):u(o)&&(a=e.shellIntegrationArgs.get(f.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h,""),{newArgs:a,envMixin:S}):void 0;r.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(s){case"bash":return!o||o.length===0?a=e.shellIntegrationArgs.get(f.Bash):c(o)&&(S.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(f.Bash)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h),{newArgs:a,envMixin:S}):void 0;case"pwsh":return!o||g(o)?a=e.shellIntegrationArgs.get(f.Pwsh):u(o)&&(a=e.shellIntegrationArgs.get(f.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h,""),{newArgs:a,envMixin:S}):void 0;case"zsh":{if(!o||o.length===0?a=e.shellIntegrationArgs.get(f.Zsh):c(o)?a=e.shellIntegrationArgs.get(f.ZshLogin):(o===e.shellIntegrationArgs.get(f.Zsh)||o===e.shellIntegrationArgs.get(f.ZshLogin))&&(a=o),!a)return;a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h);const w=T.join(D.tmpdir(),`${D.userInfo().username}-${n.applicationName}-zsh`);S.ZDOTDIR=w;const A=i?.ZDOTDIR??D.homedir()??"~";S.USER_ZDOTDIR=A;const q=[];return q.push({source:T.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(w,".zshrc")}),q.push({source:T.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(w,".zprofile")}),q.push({source:T.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(w,".zshenv")}),q.push({source:T.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(w,".zlogin")}),{newArgs:a,envMixin:S,filesToCopy:q}}}r.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=m;var f;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(f=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(f.Zsh,["-i"]),e.shellIntegrationArgs.set(f.ZshLogin,["-il"]),e.shellIntegrationArgs.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],y=["-nol","-nologo"];function u(d){return typeof d=="string"?p.includes(d.toLowerCase()):d.length===1&&p.includes(d[0].toLowerCase())||d.length===2&&(p.includes(d[0].toLowerCase())||p.includes(d[1].toLowerCase()))&&(y.includes(d[0].toLowerCase())||y.includes(d[1].toLowerCase()))}function g(d){return typeof d=="string"?y.includes(d.toLowerCase()):d.length===0||d?.length===1&&y.includes(d[0].toLowerCase())}function c(d){return d==="string"&&p.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&p.includes(d[0].toLowerCase())}}),define(ie[234],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function t(T){return T===D.HIGH_CONTRAST_DARK||T===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function R(T){return T===D.DARK||T===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(ie[114],re([0,1,53,3,2,4,39,234]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var I;(function(y){function u(g){return g&&typeof g=="object"&&typeof g.id=="string"}y.isThemeColor=u})(I=e.ThemeColor||(e.ThemeColor={}));function E(y){return{id:y}}e.themeColorFromId=E;var C;(function(y){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||I.isThemeColor(o.color))}y.isThemeIcon=u;const g=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(o){const s=g.exec(o);if(!s)return;const[,h]=s;return{id:h}}y.fromString=c;function d(o){return{id:o}}y.fromId=d;function l(o,s){let h=o.id;const a=h.lastIndexOf("~");return a!==-1&&(h=h.substring(0,a)),s&&(h=`${h}~${s}`),{id:h}}y.modify=l;function i(o){const s=o.id.lastIndexOf("~");if(s!==-1)return o.id.substring(s+1)}y.getModifier=i;function r(o,s){return o.id===s.id&&o.color?.id===s.color?.id}y.isEqual=r;function n(o,s){return{id:o.id,color:s?E(s):void 0}}y.asThemeIcon=n,y.asClassNameArray=D.CSSIcon.asClassNameArray,y.asClassName=D.CSSIcon.asClassName,y.asCSSSelector=D.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,R.toDisposable)(()=>{const g=this.themingParticipants.indexOf(u);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const m=new v;L.Registry.add(e.Extensions.ThemingContribution,m);function f(y){return m.onColorThemeChange(y)}e.registerThemingParticipant=f;class p extends R.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,g){let c=this.theme.getColor(u);return c&&g&&(c=g(c,this.theme)),c?c.toString():null}}e.Themable=p}),define(ie[235],re([0,1,53,7,166,114]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(v,m){const f=[{name:null,description:(0,R.localize)(0,null)}];return f.push(...v.map(p=>({name:p.profileName,description:P(p)}))),m&&f.push(...m.map(p=>({name:p.title,description:I(p)}))),{values:f.map(p=>p.name),markdownDescriptions:f.map(p=>p.description)}}e.createProfileSchemaEnums=L;function P(v){let m=`$(${T.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?m+=`
- args: "${v.args}"`:m+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(m+=`
- overrideName: ${v.overrideName}`),v.color&&(m+=`
- color: ${v.color}`),v.env&&(m+=`
- env: ${JSON.stringify(v.env)}`),m}function I(v){return`$(${T.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function E(v,m){if(!v&&!m)return!0;if(typeof v=="string"&&typeof m=="string")return v===m;if(Array.isArray(v)&&Array.isArray(m)){if(v.length!==m.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==m[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function C(v,m){if(!v&&!m)return!0;if(!v||!m)return!1;if(T.ThemeIcon.isThemeIcon(v)&&T.ThemeIcon.isThemeIcon(m))return v.id===m.id&&v.color===m.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof m=="object"&&"light"in m&&"dark"in m){const f=v,p=m;if((t.URI.isUri(f.light)||b(f.light))&&(t.URI.isUri(f.dark)||b(f.dark))&&(t.URI.isUri(p.light)||b(p.light))&&(t.URI.isUri(p.dark)||b(p.dark)))return f.light.path===p.light.path&&f.dark.path===p.dark.path}if(t.URI.isUri(v)&&t.URI.isUri(m)||b(v)||b(m)){const f=v,p=m;return f.path===p.path&&f.scheme===p.scheme}return!1}e.terminalIconsEqual=C;function b(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=b}),define(ie[236],re([0,1,53,165,43,39,235]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),d=>`$(${d.id})`)};const P={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(y),c()}e.registerTerminalPlatformConfiguration=u;let g;function c(d,l){const i=T.Registry.as(R.Extensions.Configuration);let r;d&&(r=(0,L.createProfileSchemaEnums)(d?.profiles,l));const n=g;g={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?r?.values:void 0,markdownEnumDescriptions:d?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?r?.values:void 0,markdownEnumDescriptions:d?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?r?.values:void 0,markdownEnumDescriptions:d?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(ie[237],re([0,1,49,53,12,5,28,89,233,114]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,b=!0;function v(r,n,o,s,h=process.env,a,S,w,A){return a=a||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},T.isWindows?m(o,a,h,S,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),A,w):d(a,S,o,r&&typeof r=="object"?{...r}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,w,h)}e.detectAvailableProfiles=v;async function m(r,n,o,s,h,a,S,w,A){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let O=!1;(0,I.getWindowsBuildNumber)()>=16299&&(O=!0),await y(w);const $=new Map;r&&($.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),l(a,$);const k=await f($.entries(),S,n,o,s,A);if(r||h)try{const M=await g(`${U}\\${O?"wsl":"bash"}.exe`,S);for(const F of M)(!a||!(F.profileName in a))&&k.push(F)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return k}async function f(r,n,o,s=process.env,h,a){const S=[];for(const[w,A]of r){if(A===null)continue;let q,U,O;if("source"in A){const M=C?.get(A.source);if(!M)continue;q=M.paths,U=A.args||M.args,A.icon?O=p(A.icon):M.icon&&(O=M.icon)}else q=Array.isArray(A.path)?A.path:[A.path],U=T.isWindows||Array.isArray(A.args)?A.args:void 0,O=p(A.icon);const $=await a?.(q)||q.slice(),k=await i(w,n,$,o,s,U,A.env,A.overrideName,A.isAutoDetected,h);k?(k.isAutoDetected=A.isAutoDetected,k.icon=O,k.color=A.color,S.push(k)):h?.debug("Terminal profile not validated",w,q)}return h?.debug("Validated terminal profiles",S),S}function p(r){return typeof r=="string"?{id:r}:r}async function y(r){C&&!r||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),C.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function u(){const r=[];for await(const n of(0,P.enumeratePowerShellInstallations)())r.push(n.exePath);return r}async function g(r,n){const o=[],s=await new Promise((S,w)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,q)=>{if(A)return w("Problem occurred when getting wsl distros");S(q)})});if(!s)return[];const h=new RegExp(/[\r?\n]/),a=s.split(h).filter(S=>S.trim().length>0&&S!=="");for(const S of a){if(S===""||S.startsWith("docker-desktop"))continue;const w=`${S} (WSL)`,A={profileName:w,path:r,args:["-d",`${S}`],isDefault:w===n,icon:c(S),isAutoDetected:!1};o.push(A)}return o}function c(r){return r.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):r.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function d(r,n,o,s,h,a,S,w){const A=new Map;if(o){const q=(await r.readFile("/etc/shells")).toString(),U=a||q.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),O=new Map;for(const $ of U){let k=(0,R.basename)($),M=O.get(k)||0;M++,M>1&&(k=`${k} (${M})`),O.set(k,M),A.set(k,{path:$,isAutoDetected:!0})}}return l(s,A),await f(A.entries(),h,r,w,n,S)}function l(r,n){if(!!r)for(const[o,s]of Object.entries(r))s===null||!("path"in s)&&!("source"in s)?n.delete(o):(s.icon=s.icon||n.get(o)?.icon,n.set(o,s))}async function i(r,n,o,s,h,a,S,w,A,q){if(o.length===0)return Promise.resolve(void 0);const U=o.shift();if(U==="")return i(r,n,o,s,h,a,S,w,A);const O={profileName:r,path:U,args:a,env:S,overrideName:w,isAutoDetected:A,isDefault:r===n};if((0,R.basename)(U)===U){const k=h.PATH?h.PATH.split(R.delimiter):void 0,M=await(0,I.findExecutable)(U,void 0,k,void 0,s.existsFile);return M?(O.path=M,O.isFromPath=!0,O):i(r,n,o,s,h,a)}return await s.existsFile((0,R.normalize)(U))?O:i(r,n,o,s,h,a,S,w,A)}}),define(ie[238],re([0,1,3,2,22,5,38,68,16,13,93,223,8,102,231,113,236,237]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=0,d=class extends t.Disposable{constructor(i,r,n,o){super(),this._reconnectConstants=i,this._configurationService=r,this._environmentService=n,this._logService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,C.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const n=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),L.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=n.getChannel(p.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const h=L.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(h.onProcessData(a=>this._onProcessData.fire(a))),this._register(h.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(h.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(h.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(h.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(h.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(h.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[n,h]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,r,n,o,s,h,a,S,w,A,q){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(i,r,n,o,s,h,a,S,w,A,q);return clearTimeout(U),c=Math.max(c,O),O}updateTitle(i,r,n){return this._proxy.updateTitle(i,r,n)}updateIcon(i,r,n,o){return this._proxy.updateIcon(i,r,n,o)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,r){return this._proxy.detachFromProcess(i,r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,r){return this._proxy.shutdown(i,r)}input(i,r){return this._proxy.input(i,r)}processBinary(i,r){return this._proxy.processBinary(i,r)}resize(i,r,n){return this._proxy.resize(i,r,n)}acknowledgeDataEvent(i,r){return this._proxy.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this._proxy.setUnicodeVersion(i,r)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,r){return this._proxy.installAutoReply(i,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,r,n,o=!1){const s=await this._shellEnv;return(0,u.detectAvailableProfiles)(r,n,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this._proxy.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this._proxy.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(i)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this._proxy.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this._proxy.refreshProperty(i,r)}async updateProperty(i,r,n){return this._proxy.updateProperty(i,r,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this._resolveVariablesRequestStore.acceptReply(i,r)}};d=pe([Y(1,I.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,v.ILogService)],d),e.PtyHostService=d}),define(ie[75],re([0,1,3,16,4,8]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var L;(function(p){p.Http="http",p.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=b;function v(p,y,u,g){if(u===1)return!1;if(u===2&&b(y)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(c?.length===4&&parseInt(c[1])>=18)return!1}return p<1024}e.isPortPrivileged=v;class m{constructor(y,u,g){this.remoteAddress=y,this.localAddress=u,this._dispose=g,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let f=class{constructor(y,u){this.logService=y,this.configurationService=u,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],u=Array.from(this._tunnels.values());for(const g of u){const c=Array.from(g.values());for(const d of c){const l=await d.value;l&&y.push(l)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:u}of y.values())await u.then(g=>g?.dispose());y.clear()}this._tunnels.clear()}setEnvironmentTunnel(y,u,g,c,d){this.addTunnelToMap(y,u,Promise.resolve({tunnelRemoteHost:y,tunnelRemotePort:u,localAddress:g,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(y,u){(b(y)||C(y))&&(y=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(y,u);if(g)return++g.refcount,g.value}openTunnel(y,u,g,c,d=!1,l,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${c}.`),!y)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(y,u,g,c,d,l,i);return r?r.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const u=this._tunnels.get(y.tunnelRemoteHost);if(u){const g=u.get(y.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,g))}}}}async tryDisposeTunnel(y,u,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${u}.`);const c=g.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(u),c}}async closeTunnel(y,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${u} `);const g=this._tunnels.get(y);if(g&&g.has(u)){const c=g.get(u);c.refcount=0,await this.tryDisposeTunnel(y,u,c)}}addTunnelToMap(y,u,g){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(u,{refcount:1,value:g})}async removeEmptyTunnelFromMap(y,u){const g=this._tunnels.get(y);g&&(await g.get(u)||g.delete(u),g.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,u){const g=[y];C(y)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(y)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const c=g.map(d=>this._tunnels.get(d));for(const d of c){const l=d?.get(u);if(l)return l}}canTunnel(y){return!!E(y)}createWithProvider(y,u,g,c,d,l,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${c}.`);const r=g;this._factoryInProgress.add(r);const n=c===void 0?g:c,o={elevationRequired:d?this.isPortPrivileged(n):!1},s={remoteAddress:{host:u,port:g},localAddressPort:c,privacy:l,public:l?l!==P.Private:void 0,protocol:i},h=y.forwardPort(s,o);return h?(this.addTunnelToMap(u,g,h),h.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),h}};f=pe([Y(0,T.ILogService),Y(1,t.IConfigurationService)],f),e.AbstractTunnelService=f}),define(ie[239],re([0,1,8,75,2,9,6]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(C){this._address=C,this._addressPromise&&(this._addressPromise.complete(C),this._addressPromise=null)}setTunnel(C){this._register(C)}}let I=class Lt extends R.Disposable{constructor(C,b){super(),this._tunnelService=C,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++Lt._lastId)}}async startTunnel(C,b,v,m,f,p){const y=new P,u=await Promise.resolve(this._tunnelService.openTunnel(C,y,v,m,f,p));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${m} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),y.dispose(),await u.dispose(),(0,T.canceled)();return y.setTunnel(u),this._tunnels.set(b,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${v}:${m} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(C,b){const v=this._tunnels.get(C);!v||v.setAddress(b)}async destroyTunnel(C){const b=this._tunnels.get(C);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this._tunnels.delete(C),await b.dispose();return}this._disposedTunnels.add(C)}};I._lastId=0,I=pe([Y(0,t.ISharedTunnelsService),Y(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(ie[240],re([0,1,84,34,124,214,6,2,16,8,25,212,75,108,5]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(d,l,i,r,n){let o;for(let s=3;s&&(o?.dispose(),o=await new y(d,l,i,r,n).waitForReady(),!(n&&R.BROWSER_RESTRICTED_PORTS[n]||!R.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));s--);return o}class y extends P.Disposable{constructor(l,i,r,n,o){super(),this.defaultTunnelHost=i,this.suggestedLocalPort=o,this.privacy=v.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=D.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(i=>{i()})}async waitForReady(){const l=this.suggestedLocalPort??this.tunnelRemotePort,i=(0,v.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,R.findFreePortFaster)(l,2,1e3,i),n=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(l){l.pause();const i=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,b.connectRemoteAgentTunnel)(this._options,i,this.tunnelRemotePort),n=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.destroy()}),n.on("end",()=>l.end()),n.on("close",()=>l.end()),n.on("error",()=>{l.destroy()}),l.pipe(n),n.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),n.end()})}}let u=class extends v.AbstractTunnelService{constructor(l,i,r,n,o){super(i,o),this.socketFactory=l,this.signService=r,this.productService=n}isPortPrivileged(l){return(0,v.isPortPrivileged)(l,this.defaultTunnelHost,f.OS,t.release())}retainOrCreateTunnel(l,i,r,n,o,s,h){const a=this.getTunnelFromMap(i,r);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,i,r,n,o,s,h);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const S={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},w=p(S,this.defaultTunnelHost,i,r,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(i,r,w),w}}};u=pe([Y(1,E.ILogService),Y(2,m.ISignService),Y(3,C.IProductService),Y(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(l,i,r,n){super(T.nodeSocketFactory,l,i,r,n)}};g=pe([Y(0,E.ILogService),Y(1,m.ISignService),Y(2,C.IProductService),Y(3,I.IConfigurationService)],g),e.TunnelService=g;let c=class extends P.Disposable{constructor(l,i,r,n){super(),this.logService=l,this.productService=i,this.signService=r,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(l,i,r,n,o,s,h,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${n} on local port ${o}.`),!this._tunnelServices.has(l)){const S=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(S),this._tunnelServices.set(l,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(i,r,n,o,s,h,a)}};c=pe([Y(0,E.ILogService),Y(1,C.IProductService),Y(2,m.ISignService),Y(3,I.IConfigurationService)],c),e.SharedTunnelsService=c}),define(ie[31],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ie[241],re([0,1,3,2,7,13,33,14,8,31]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let C=class extends t.Disposable{constructor(v,m,f,p,y){super(),this.extensionsManagementService=v,this.logService=p,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(g=>this.onInstallExtension(g))),this._register(v.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(v.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const u=R.URI.file(f.extensionsPath);this._register(m.watch(u)),this._register(D.Event.filter(m.onDidFilesChange,g=>g.rawChanges.some(c=>this.doesChangeAffects(c,u)))(()=>this.onDidChange()))}doesChangeAffects(v,m){return v.type!==1&&v.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),m)?!1:this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(m,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(v.resource).startsWith(".")}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const m of v)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(m=>!(0,L.areSameExtensions)(m,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,L.areSameExtensions)(m,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),m=v.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,L.areSameExtensions)(y,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),f=this.installedExtensions.filter(p=>this.installingExtensions.some(y=>(0,L.areSameExtensions)(y,p))?!1:v.every(y=>!(0,L.areSameExtensions)(y.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=v.map(p=>p.identifier),(m.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:f})}}};C=pe([Y(1,P.IFileService),Y(2,T.INativeEnvironmentService),Y(3,I.ILogService),Y(4,E.IUriIdentityService)],C),e.ExtensionsWatcher=C}),define(ie[242],re([0,1,31,94,14,19,122,3,2]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(v){this.uri=v,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let C=class{constructor(v){this._fileService=v,this._dispooables=new I.DisposableStore,this._limit=2**16;const m=new Map,f=p=>{let y=m.get(p.scheme);return y===void 0&&(y=v.hasProvider(p)&&!this._fileService.hasCapability(p,1024),m.set(p.scheme,y)),y};this._dispooables.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{m.delete(p.scheme)})),this.extUri=new T.ExtUri(f),this._canonicalUris=new L.SkipList((p,y)=>this.extUri.compare(p,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,T.normalizePath)(v));const m=this._canonicalUris.get(v);return m?m.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new E(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((f,p)=>f[1].touch<p[1].touch?1:f[1].touch>p[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let f=0;f<m;f++)this._canonicalUris.set(v[f][0],v[f][1].touch())}};C=pe([Y(0,R.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(D.IUriIdentityService,C,1)}),define(ie[243],re([0,1,3,2,14,42,48,17]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends t.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(C,b,v,m){super(),this.fileSystemScheme=C,this.fileSystemProvider=b,this.userDataScheme=v,this.logService=m,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(C,b){this.watchResources.set(C,C);const v=this.fileSystemProvider.watch(this.toFileSystemResource(C),b);return(0,t.toDisposable)(()=>{this.watchResources.delete(C),v.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,b,v){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(b),v)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,b,v){const m=(0,T.newWriteableStream)(f=>P.VSBuffer.concat(f.map(p=>P.VSBuffer.wrap(p))).buffer);return(async()=>{try{const f=await this.readFile(C);m.end(f)}catch(f){m.error(f),m.end()}})(),m}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,b,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),b,v)}delete(C,b){return this.fileSystemProvider.delete(this.toFileSystemResource(C),b)}copy(C,b,v){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(C),this.toFileSystemResource(b),v);throw new Error("copy not supported")}handleFileChanges(C){const b=[];for(const v of C){if(v.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(v.resource);this.watchResources.findSubstr(m)&&b.push({resource:m,type:v.type})}b.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(b))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(ie[61],re([0,1,81]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(L,P,I,E){const C=(0,D.setProperty)(L,P,I,E)[0];return C&&(L=L.substring(0,C.offset)+C.content+L.substring(C.offset+C.length)),L}e.edit=t;function R(L,P,I){let E=I;for(;E>=0;){if(L.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&L.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function T(L,P,I){let E=I;for(;E>=0;)if(L.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&L.charAt(E)===P.charAt(1)))return E;return L.length-1}e.getLineEndOffset=T}),define(ie[244],re([0,1,32,55,15]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(m,f,p,y,u,g){const c=[],d=[],l=[];if(!f){const M=m.filter(({identifier:F})=>u.every(G=>G.toLowerCase()!==F.id.toLowerCase()));return{local:{added:c,removed:d,updated:l},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}m=m.map(b),f=f.map(b),p=p?p.map(b):null;const i=new Map,r=M=>{M.uuid&&i.set(M.id.toLowerCase(),M.uuid)};m.forEach(({identifier:M})=>r(M)),f.forEach(({identifier:M})=>r(M)),p?.forEach(({identifier:M})=>r(M));const n=M=>{const F=M.identifier.uuid||i.get(M.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${M.identifier.id.toLowerCase()}`},o=(M,F)=>(M.set(n(F),F),M),s=m.reduce(o,new Map),h=f.reduce(o,new Map),a=f.reduce((M,F)=>o(M,(0,D.deepClone)(F)),new Map),S=p?p.reduce(o,new Map):null,w=y.reduce(o,new Map),A=u.reduce((M,F)=>{const G=i.get(F.toLowerCase());return M.add(G?`uuid:${G}`:`id:${F.toLowerCase()}`)},new Set),q=g.reduce((M,{id:F,uuid:G})=>(G=G??i.get(F.toLowerCase()),M.add(G?`uuid:${G}`:`id:${F.toLowerCase()}`)),new Set),U=L(s,h,A,!1);if(U.added.size>0||U.removed.size>0||U.updated.size>0){const M=L(S,s,A,!1),F=L(S,h,A,!0),G=(W,B,z,x)=>({...x,installed:B.installed||z.installed,version:z.version&&(!B.installed||t.gt(z.version,B.version))?z.version:B.version,state:I(B,z,S?.get(W)),preRelease:(B.installed?x.preRelease:z.preRelease)??B.preRelease});for(const W of F.removed.values()){const B=s.get(W);if(!B)continue;const z=(0,R.assertIsDefined)(S?.get(W)),x=!q.has(W)&&z.installed;B.installed&&x?d.push(B.identifier):a.set(W,B)}for(const W of F.added.values()){const B=(0,R.assertIsDefined)(h.get(W)),z=s.get(W);if(z){if(U.updated.has(W)){const x=G(W,z,B,B);P(z,B,!1,!1)||l.push(v(x,W)),a.set(W,x)}}else B.installed&&c.push(v(B,W))}for(const W of F.updated.values()){const B=(0,R.assertIsDefined)(h.get(W)),z=(0,R.assertIsDefined)(S?.get(W)),x=s.get(W);if(x)if(!q.has(W)&&z.installed&&x.installed&&!B.installed)d.push(x.identifier);else{const X=G(W,x,B,B);l.push(v(X,W)),a.set(W,X)}else B.installed&&c.push(v(B,W))}for(const W of M.added.values())F.added.has(W)||a.set(W,(0,R.assertIsDefined)(s.get(W)));for(const W of M.updated.values()){if(F.removed.has(W)||F.updated.has(W))continue;const B=(0,R.assertIsDefined)(s.get(W)),z=(0,R.assertIsDefined)(h.get(W));a.set(W,G(W,B,z,B))}for(const W of M.removed.values())F.updated.has(W)||F.removed.has(W)||w.has(W)||!(0,R.assertIsDefined)(h.get(W)).installed||q.has(W)||!(0,R.assertIsDefined)(S?.get(W)).installed||a.delete(W)}const O=[],$=L(h,a,new Set,!0),k=$.added.size>0||$.updated.size>0||$.removed.size>0;return k&&a.forEach((M,F)=>O.push(v(M,F))),{local:{added:c,removed:d,updated:l},remote:k?{added:[...$.added].map(M=>a.get(M)),updated:[...$.updated].map(M=>a.get(M)),removed:[...$.removed].map(M=>h.get(M)),all:O}:null}}e.merge=T;function L(m,f,p,y){const u=m?[...m.keys()].filter(i=>!p.has(i)):[],g=[...f.keys()].filter(i=>!p.has(i)),c=g.filter(i=>u.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),d=u.filter(i=>g.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),l=new Set;for(const i of u){if(d.has(i))continue;const r=m.get(i),n=f.get(i);(!n||!P(r,n,y,!0))&&l.add(i)}return{added:c,removed:d,updated:l}}function P(m,f,p,y){return!(m.disabled!==f.disabled||y&&m.installed!==f.installed||m.installed&&f.installed&&m.preRelease!==f.preRelease||!C(m.state,f.state)||p&&m.version!==f.version)}function I(m,f,p){const y=m.state,u=f.state,g=p?.state;if(!f.version||y&&t.gt(m.version,f.version))return y;if(u&&t.gt(f.version,m.version)||!y)return u;if(!u)return y;const c=(0,D.deepClone)(y),d=g?E(g,u):{added:Object.keys(u).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set},l=g?E(g,y):{added:Object.keys(y).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set};for(const i of[...d.added.values(),...d.updated.values()])c[i]=u[i];for(const i of d.removed.values())l.updated.has(i)||delete c[i];return c}function E(m,f){const p=Object.keys(m),y=Object.keys(f),u=y.filter(d=>p.indexOf(d)===-1).reduce((d,l)=>(d.add(l),d),new Set),g=p.filter(d=>y.indexOf(d)===-1).reduce((d,l)=>(d.add(l),d),new Set),c=new Set;for(const d of p){if(g.has(d))continue;const l=m[d],i=f[d];(0,D.equals)(l,i)||c.add(d)}return{added:u,removed:g,updated:c}}function C(m={},f={}){const{added:p,removed:y,updated:u}=E(m,f);return p.size===0&&y.size===0&&u.size===0}function b(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function v(m,f){const p={identifier:{id:m.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(p.version=m.version),m.disabled&&(p.disabled=!0),m.installed&&(p.installed=!0),m.state&&(p.state=m.state),p}}),define(ie[115],re([0,1,18,16,4]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}updateSynchronizedExtensions(P,I){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}getIgnoredExtensions(P){const I=P.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),C=[],b=[];if(Array.isArray(E))for(const v of E)v.startsWith("-")?b.push(v.substring(1)):C.push(v);return(0,D.distinct)([...I,...C].filter(v=>b.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};T=pe([Y(0,t.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ie[245],re([0,1,18,35,32,184,61]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(d){return(0,t.parse)(d)||[]}e.parseKeybindings=P;async function I(d,l,i,r,n){const o=P(d),s=P(l),h=i?P(i):null,a=[...o,...s,...h||[]].map(G=>G.key),S=await n.resolveUserBindings(a),w=C(o,s,h,S);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const A=v(o),q=v(s),U=h?v(h):null,O=f(A,q,S),$=U?f(U,A,S):{added:[...A.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},k=U?f(U,q,S):{added:[...q.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},M=E(O,$,k);let F=d;for(const G of M.removed.values())M.conflicts.has(G)||(F=g(F,G,r));for(const G of M.added.values()){if(M.conflicts.has(G))continue;const W=q.get(G);if(W.some(B=>B.command!==`-${G}`&&w.conflicts.has(S[B.key]))){M.conflicts.add(G);continue}F=u(F,W,r)}for(const G of M.updated.values()){if(M.conflicts.has(G))continue;const W=q.get(G);if(W.some(B=>B.command!==`-${G}`&&w.conflicts.has(S[B.key]))){M.conflicts.add(G);continue}F=c(F,G,W,r)}return{mergeContent:F,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=I;function E(d,l,i){const r=new Set,n=new Set,o=new Set,s=new Set;for(const h of l.removed.values())i.updated.has(h)&&s.add(h);for(const h of i.removed.values())s.has(h)||(l.updated.has(h)?s.add(h):n.add(h));for(const h of l.added.values())s.has(h)||i.added.has(h)&&d.updated.has(h)&&s.add(h);for(const h of i.added.values())s.has(h)||(l.added.has(h)?d.updated.has(h)&&s.add(h):r.add(h));for(const h of l.updated.values())s.has(h)||i.updated.has(h)&&d.updated.has(h)&&s.add(h);for(const h of i.updated.values())s.has(h)||(l.updated.has(h)?d.updated.has(h)&&s.add(h):o.add(h));return{added:r,removed:n,updated:o,conflicts:s}}function C(d,l,i,r){const n=new Set,o=b(d,r),s=b(l,r),h=i?b(i,r):null,a=m(o,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const S=h?m(h,o):{added:[...o.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=h?m(h,s):{added:[...s.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:q,updated:U,conflicts:O}=E(a,S,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:q,updated:U,conflicts:O}}function b(d,l){const i=new Map;for(const r of d){const n=l[r.key];let o=i.get(n);o||(o=[],i.set(n,o)),o.push(r)}return i}function v(d){const l=new Map;for(const i of d){const r=i.command[0]==="-"?i.command.substring(1):i.command;let n=l.get(r);n||(n=[],l.set(r,n)),n.push(i)}return l}function m(d,l){const i=[...d.keys()],r=[...l.keys()],n=r.filter(h=>i.indexOf(h)===-1).reduce((h,a)=>(h.add(a),h),new Set),o=i.filter(h=>r.indexOf(h)===-1).reduce((h,a)=>(h.add(a),h),new Set),s=new Set;for(const h of i){if(o.has(h))continue;const a=d.get(h).map(w=>({...w,key:h})),S=l.get(h).map(w=>({...w,key:h}));(0,D.equals)(a,S,(w,A)=>y(w,A))||s.add(h)}return{added:n,removed:o,updated:s}}function f(d,l,i){const r=[...d.keys()],n=[...l.keys()],o=n.filter(a=>r.indexOf(a)===-1).reduce((a,S)=>(a.add(S),a),new Set),s=r.filter(a=>n.indexOf(a)===-1).reduce((a,S)=>(a.add(S),a),new Set),h=new Set;for(const a of r){if(s.has(a))continue;const S=d.get(a).map(A=>({...A,key:i[A.key]})),w=l.get(a).map(A=>({...A,key:i[A.key]}));p(S,w)||h.add(a)}return{added:o,removed:s,updated:h}}function p(d,l){return!(!(0,D.equals)(d.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,r)=>y(i,r))||!(0,D.equals)(d.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,r)=>y(i,r)))}function y(d,l){if(d.command!==l.command||d.key!==l.key)return!1;const i=T.ContextKeyExpr.deserialize(d.when),r=T.ContextKeyExpr.deserialize(l.when);return!(i&&!r||!i&&r||i&&r&&!i.equals(r)||!R.equals(d.args,l.args))}function u(d,l,i){for(const r of l)d=L.edit(d,[-1],r,i);return d}function g(d,l,i){const r=P(d);for(let n=r.length-1;n>=0;n--)(r[n].command===l||r[n].command===`-${l}`)&&(d=L.edit(d,[n],void 0,i));return d}function c(d,l,i,r){const n=P(d),o=n.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=n.length-1;s>=0;s--)(n[s].command===l||n[s].command===`-${l}`)&&(d=L.edit(d,[s],void 0,r));for(let s=i.length-1;s>=0;s--)d=L.edit(d,[o],i[s],r);return d}}),define(ie[246],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,L,P){const I={},E={},C=new Set;if(!L)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const b=t(T,L);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=t(P,T),m=t(P,L),f={},p={},y=new Set,u=new Set;for(const g of v.removed.values())m.updated.has(g)?I[g]=L[g]:y.add(g);for(const g of m.removed.values())u.has(g)||(v.updated.has(g)?u.add(g):C.add(g));for(const g of v.updated.values())u.has(g)||(m.updated.has(g)?b.updated.has(g)&&u.add(g):p[g]=T[g]);for(const g of m.updated.values())u.has(g)||(v.updated.has(g)?b.updated.has(g)&&u.add(g):T[g]!==void 0&&(E[g]=L[g]));for(const g of v.added.values())u.has(g)||(m.added.has(g)?b.updated.has(g)&&u.add(g):f[g]=T[g]);for(const g of m.added.values())u.has(g)||(v.added.has(g)?b.updated.has(g)&&u.add(g):I[g]=L[g]);return{local:{added:I,removed:[...C.values()],updated:E},remote:{added:f,removed:[...y.values()],updated:p},conflicts:[...u.values()]}}e.merge=D;function t(T,L){const P=T?Object.keys(T):[],I=L?Object.keys(L):[],E=I.filter(v=>P.indexOf(v)===-1).reduce((v,m)=>(v.add(m),v),new Set),C=P.filter(v=>I.indexOf(v)===-1).reduce((v,m)=>(v.add(m),v),new Set),b=new Set;for(const v of P){if(C.has(v))continue;const m=T[v],f=L[v];m!==f&&b.add(v)}return{added:E,removed:C,updated:b}}function R(T,L){const{added:P,removed:I,updated:E}=t(T,L);return P.size===0&&I.size===0&&E.size===0}e.areSame=R}),define(ie[247],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,T,L,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!T){const C=R.filter(({id:b})=>!P.includes(b));return C.length?I.remote.added=C:I.remote=null,I}const E=t(R,T,P);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const C=t(L,R,P),b=t(L,T,P);for(const v of b.removed){const m=R.find(f=>f.id===v);m&&I.local.removed.push(m)}for(const v of b.added){const m=T.find(f=>f.id===v);C.added.includes(v)?E.updated.includes(v)&&I.local.updated.push(m):I.local.added.push(m)}for(const v of b.updated)I.local.updated.push(T.find(m=>m.id===v));for(const v of C.added)b.added.includes(v)||I.remote.added.push(R.find(m=>m.id===v));for(const v of C.updated)b.removed.includes(v)||b.updated.includes(v)||I.remote.updated.push(R.find(m=>m.id===v));for(const v of C.removed)I.remote.removed.push(T.find(m=>m.id===v))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=D;function t(R,T,L){R=R?R.filter(({id:v})=>!L.includes(v)):[],T=T.filter(({id:v})=>!L.includes(v));const P=R.map(({id:v})=>v),I=T.map(({id:v})=>v),E=I.filter(v=>P.indexOf(v)===-1),C=P.filter(v=>I.indexOf(v)===-1),b=[];for(const{id:v,name:m,shortName:f}of R){if(C.includes(v))continue;const p=T.find(y=>y.id===v);(!p||p.name!==m||p.shortName!==f)&&b.push(v)}return{added:E,removed:C,updated:b}}}),define(ie[26],re([0,1,18,15,172,43,29,4,104,39]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(h=>!!s[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function b(){const s=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(s).filter(w=>!!s[w].ignoreSync),a=Object.keys(s).filter(w=>s[w].scope===2||s[w].scope===6),S=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...a,...S])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function v(){const s="vscode://schemas/ignoredSettings",h=E.Registry.as(T.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=E.Registry.as(I.Extensions.JSONContribution),S=()=>{const w=C(),A=b().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),q=Object.keys(T.allSettings.properties).filter($=>A.indexOf($)===-1),U=A.filter($=>w.indexOf($)===-1),O={items:{type:"string",enum:[...q,...U.map($=>`-${$}`)]}};a.registerSchema(s,O)};return h.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=v;function m(s){return s&&(0,t.isObject)(s)&&(0,t.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=m;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(s,...h){return s?[s,...h]:h}e.getPathSegments=p;function y(s,h,a,S){return S.joinPath(a.userDataSyncHome,...p(s,h,`lastSync${h}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const h={};return h[e.HEADER_EXECUTION_ID]=s,h}e.createSyncHeaders=u;var g;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(h,a,S,w){super(h),this.code=a,this.resource=S,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class d extends c{constructor(h,a,S,w,A){super(h,S,void 0,A),this.url=a,this.serverCode=w}}e.UserDataSyncStoreError=d;class l extends c{constructor(h,a){super(h,a)}}e.UserDataAutoSyncError=l,function(s){function h(a){if(a instanceof s)return a;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(S&&S[1]){const w=S[2]==="unknown"?void 0:S[2],A=S[3]==="unknown"?void 0:S[3];return new s(a.message,S[1],w,A)}return new s(a.message,"Unknown")}s.toUserDataSyncError=h}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var n;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(s){return`sync.enable.${s}`}e.getEnablementKey=o,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ie[248],re([0,1,32,26]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(L,P,I,E,C){if(!P)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const b=T(L,P);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const v=I?T(I,P):{added:Object.keys(P).reduce((g,c)=>(g.add(c),g),new Set),removed:new Set,updated:new Set},m=I?T(I,L):{added:Object.keys(L).reduce((g,c)=>(g.add(c),g),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},p=D.deepClone(P),y=!I;for(const g of m.added.values())g!==t.SYNC_SERVICE_URL_TYPE&&y&&v.added.has(g)||(p[g]=L[g]);for(const g of m.updated.values())p[g]=L[g];for(const g of m.removed.values())E.unregistered.includes(g)||delete p[g];for(const g of v.added.values()){const c=P[g];if(E.machine.includes(g)){C.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(I&&m.added.has(g))continue;const d=L[g];d&&d.value===c.value||g===t.SYNC_SERVICE_URL_TYPE&&y&&m.added.has(g)||(d?f.updated[g]=c:f.added[g]=c)}for(const g of v.updated.values()){const c=P[g];if(E.machine.includes(g)){C.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(g)||m.removed.has(g))continue;const d=L[g];d&&d.value===c.value||(f.updated[g]=c)}for(const g of v.removed.values()){if(E.machine.includes(g)){C.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}m.updated.has(g)||m.removed.has(g)||f.removed.push(g)}const u=T(P,p);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}e.merge=R;function T(L,P){const I=Object.keys(L),E=Object.keys(P),C=E.filter(m=>I.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),b=I.filter(m=>E.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),v=new Set;for(const m of I){if(b.has(m))continue;const f=L[m],p=P[m];D.equals(f,p)||v.add(m)}return{added:C,removed:b,updated:v}}}),define(ie[249],re([0,1,18,35,81,46,32,61,26]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(a,S,w){let A=[];w?A=b(w):A=C(S);const q=[],U=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const O of A)O.startsWith("-")?U.push(O.substring(1)):q.push(O);return(0,D.distinct)([...a,...q].filter(O=>U.indexOf(O)===-1))}e.getIgnoredSettings=E;function C(a){let S=a.inspect("settingsSync.ignoredSettings").userValue;return S!==void 0||(S=a.inspect("sync.ignoredSettings").userValue,S!==void 0)?S:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const S=(0,t.parse)(a);return S?S["settingsSync.ignoredSettings"]||S["sync.ignoredSettings"]||[]:[]}function v(a,S){const w=(0,t.parse)(a)||{};let A="{}";for(const q of Object.keys(w)){const U=(0,R.setProperty)(A,[q],w[q],S);A=(0,R.applyEdits)(A,U)}return A}e.removeComments=v;function m(a,S,w,A){if(w.length){const q=h(S),U=(0,t.parse)(S)||{},O=(0,t.parse)(a);if(!O)return a;const $=[];for(const k of w){const M=U[k],F=O[k];M===void 0?a=P.edit(a,[k],void 0,A):F!==void 0?a=P.edit(a,[k],M,A):$.push(i(k,q))}$.sort((k,M)=>k.startOffset-M.startOffset),$.forEach(k=>a=g(k.setting.key,S,a,A))}return a}e.updateIgnoredSettings=m;function f(a,S,w,A,q,U){const O=m(a,S,A,U),$=w!==O,k=w!==S;if(!$&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!k)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(k&&!$)return{conflictsSettings:[],localContent:m(S,a,A,U),remoteContent:null,hasConflicts:!1};if(w===null&&y(a)){const K=p(a,S,A)?null:m(S,a,A,U);return{conflictsSettings:[],localContent:K,remoteContent:null,hasConflicts:!1}}let M=a,F=S;const G=(0,t.parse)(a),W=(0,t.parse)(S),B=w?(0,t.parse)(w):null,z=A.reduce((K,ee)=>(K.add(ee),K),new Set),x=u(G,W,z),J=u(B,G,z),X=u(B,W,z),se=new Map,j=new Set,H=K=>{j.add(K);const ee=q.filter(({key:ae})=>ae===K)[0];ee?(M=P.edit(M,[K],ee.value,U),F=P.edit(F,[K],ee.value,U)):se.set(K,{key:K,localValue:G[K],remoteValue:W[K]})};for(const K of J.removed.values())X.updated.has(K)?H(K):F=P.edit(F,[K],void 0,U);for(const K of X.removed.values())j.has(K)||(J.updated.has(K)?H(K):M=P.edit(M,[K],void 0,U));for(const K of J.updated.values())j.has(K)||(X.updated.has(K)?x.updated.has(K)&&H(K):F=P.edit(F,[K],G[K],U));for(const K of X.updated.values())j.has(K)||(J.updated.has(K)?x.updated.has(K)&&H(K):M=P.edit(M,[K],W[K],U));for(const K of J.added.values())j.has(K)||(X.added.has(K)?x.updated.has(K)&&H(K):F=g(K,M,F,U));for(const K of X.added.values())j.has(K)||(J.added.has(K)?x.updated.has(K)&&H(K):M=g(K,F,M,U));const _=se.size>0||!p(M,F,A),N=_||!p(M,a,[]),V=_||!p(F,S,[]);return{localContent:N?M:null,remoteContent:V?F:null,conflictsSettings:[...se.values()],hasConflicts:_}}e.merge=f;function p(a,S,w){if(a===S)return!0;const A=(0,t.parse)(a),q=(0,t.parse)(S),U=w.reduce((k,M)=>(k.add(M),k),new Set),O=h(a).filter(k=>!(k.setting&&U.has(k.setting.key))),$=h(S).filter(k=>!(k.setting&&U.has(k.setting.key)));if(O.length!==$.length)return!1;for(let k=0;k<O.length;k++){const M=O[k],F=$[k];if(M.setting&&F.setting){if(M.setting.key!==F.setting.key||!L.equals(A[M.setting.key],q[M.setting.key]))return!1}else if(!M.setting&&!F.setting){if(M.value!==F.value)return!1}else return!1}return!0}e.areSame=p;function y(a){return a?h(a).length===0:!0}e.isEmpty=y;function u(a,S,w){const A=a?Object.keys(a).filter(k=>!w.has(k)):[],q=Object.keys(S).filter(k=>!w.has(k)),U=q.filter(k=>A.indexOf(k)===-1).reduce((k,M)=>(k.add(M),k),new Set),O=A.filter(k=>q.indexOf(k)===-1).reduce((k,M)=>(k.add(M),k),new Set),$=new Set;if(a)for(const k of A){if(O.has(k))continue;const M=a[k],F=S[k];L.equals(M,F)||$.add(k)}return{added:U,removed:O,updated:$}}function g(a,S,w,A){const q=(0,t.parse)(S),U=h(S),O=h(w),$=c(a,U,O);return d(w,a,q[a],$,O,A)}e.addSetting=g;function c(a,S,w){const A=S.findIndex(U=>U.setting?.key===a),q=S[A-1];if(q){if(q.setting){const O=i(q.setting.key,w);if(O)return{index:w.indexOf(O),insertAfter:!0}}else{const O=r(A,S);if(O){const $=i(O.setting.key,w);if($){const k=n(w.indexOf($),w),M=o(S,O,S[A]);if(k){const F=o(w,$,k),G=s(M,F);return G?{index:w.indexOf(G),insertAfter:!0}:{index:w.indexOf(k),insertAfter:!1}}else{const F=o(w,$,w[w.length-1]),G=s(M,F);return G?{index:w.indexOf(G),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const U=S[A+1];if(U)if(U.setting){const O=i(U.setting.key,w);if(O)return{index:w.indexOf(O),insertAfter:!1}}else{const O=n(A,S);if(O){const $=i(O.setting.key,w);if($){const k=r(w.indexOf($),w),M=o(S,S[A],O);if(k){const F=o(w,k,$),G=s(M.reverse(),F.reverse());return G?{index:w.indexOf(G),insertAfter:!1}:{index:w.indexOf(k),insertAfter:!0}}else{const F=o(w,w[0],$),G=s(M.reverse(),F.reverse());return G?{index:w.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(a,S,w,A,q,U){let O;return A.index===-1?O=(0,R.setProperty)(a,[S],w,U):O=l(a,S,w,A,q,U).map($=>(0,R.withFormatting)(a,$,U)[0]),(0,R.applyEdits)(a,O)}function l(a,S,w,A,q,U){const O=`${JSON.stringify(S)}: ${JSON.stringify(w)}`,$=(0,T.getEOL)(U,a),k=q[A.index];if(A.insertAfter){const M=[];if(k.setting)M.push({offset:k.endOffset,length:0,content:","+O});else{const F=n(A.index,q),G=r(A.index,q),W=G?.setting?.commaOffset;G&&W===void 0&&M.push({offset:G.endOffset,length:0,content:","});const B=W!==void 0&&W>k.endOffset;M.push({offset:B?W+1:k.endOffset,length:0,content:F?$+O+",":$+O})}return M}else{if(k.setting)return[{offset:k.startOffset,length:0,content:O+","}];const M=(q[A.index-1]&&!q[A.index-1].setting?$:"")+O+(n(A.index,q)?",":"")+$;return[{offset:k.startOffset,length:0,content:M}]}}function i(a,S){return S.filter(w=>w.setting?.key===a)[0]}function r(a,S){for(let w=a-1;w>=0;w--)if(S[w].setting)return S[w]}function n(a,S){for(let w=a+1;w<S.length;w++)if(S[w].setting)return S[w]}function o(a,S,w){const A=a.indexOf(S),q=a.indexOf(w);return a.filter((U,O)=>A<O&&O<q)}function s(a,S){if(a.length&&S.length){let w=0;for(;w<S.length&&w<a.length;w++)if(a[w].value!==S[w].value)return S[w-1];return S[w-1]}}function h(a){const S=[];let w=-1,A,q;const U={onObjectBegin:O=>{w++},onObjectProperty:(O,$,k)=>{w===0&&(A=$,q=O)},onObjectEnd:(O,$)=>{w--,w===0&&S.push({startOffset:A,endOffset:O+$,value:a.substring(A,O+$),setting:{key:q,commaOffset:void 0}})},onArrayBegin:(O,$)=>{w++},onArrayEnd:(O,$)=>{w--,w===0&&S.push({startOffset:A,endOffset:O+$,value:a.substring(A,O+$),setting:{key:q,commaOffset:void 0}})},onLiteralValue:(O,$,k)=>{w===0&&S.push({startOffset:A,endOffset:$+k,value:a.substring(A,$+k),setting:{key:q,commaOffset:void 0}})},onSeparator:(O,$,k)=>{if(w===0&&O===","){let M=S.length-1;for(;M>=0&&!S[M].setting;M--);const F=S[M];F&&S.splice(M,1,{startOffset:F.startOffset,endOffset:F.endOffset,value:F.value,setting:{key:F.setting.key,commaOffset:$}})}},onComment:(O,$)=>{w===0&&S.push({startOffset:O,endOffset:O+$,value:a.substring(O,O+$)})}};return(0,t.visit)(a,U),S}}),define(ie[76],re([0,1,3,2,4,26]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let L=class extends t.Disposable{get account(){return this._account}constructor(I,E){super(),this.userDataSyncStoreService=I,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};L=pe([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(ie[250],re([0,1,2,7]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(v){this.service=v}listen(v,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(v,m,f){switch(m){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(v){this.service=v}listen(v,m){throw new Error(`Event not found: ${m}`)}call(v,m,f){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class L{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(v,m,f){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(v,m,f){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class E{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(v,m,f){switch(m){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class C extends D.Disposable{constructor(v){super(),this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:t.URI.revive(v.url),type:v.type,defaultUrl:t.URI.revive(v.defaultUrl),insidersUrl:t.URI.revive(v.insidersUrl),stableUrl:t.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(ie[251],re([0,1,13,8]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends t.AbstractLogger{constructor(L,P){super(),this.logger=this._register(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.logger.trace(L,...P)}debug(L,...P){this.logger.debug(L,...P)}info(L,...P){this.logger.info(L,...P)}warn(L,...P){this.logger.warn(L,...P)}error(L,...P){this.logger.error(L,...P)}critical(L,...P){this.logger.critical(L,...P)}flush(){this.logger.flush()}};R=pe([Y(0,t.ILoggerService),Y(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(ie[252],re([0,1,6,3,2]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:E}){super(),this.disposables=this._register(new R.DisposableStore),t.Event.latch(t.Event.any(P,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ie[116],re([0,1,174,12,48,19,7,4,22]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function E(r){const n=r;return typeof n?.id=="string"&&L.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(r,n){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=r;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=C;function b(r){const n=r;return typeof n?.id=="string"&&L.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=b;function v(r){const n=r;if(n?.uri)return{id:n.id,uri:L.URI.revive(n.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=v;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function p(r){const n=r;return!!(n&&typeof n=="object"&&L.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=p;class y{constructor(n,o,s,h,a){this._id=n,this._transient=s,this._configuration=h,this._ignorePathCasing=a,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class u{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,T.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function g(r){return new u({uri:r,index:0,name:(0,T.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(r,n){return T.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function d(r){let n;return L.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=d;function l(r,n){return!c(r,n)&&!d(r)}e.isSavedWorkspace=l;function i(r){return(typeof r=="string"?(0,t.extname)(r):(0,T.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ie[20],re([0,1,66,3,2,19,15,7,167,13,14,4,8,116,40,31,6,30,27]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&P.URI.isUri(o.location)&&P.URI.isUri(o.globalStorageHome)&&P.URI.isUri(o.settingsResource)&&P.URI.isUri(o.keybindingsResource)&&P.URI.isUri(o.tasksResource)&&P.URI.isUri(o.snippetsHome)&&((0,L.isUndefined)(o.extensionsResource)||P.URI.isUri(o.extensionsResource)))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function d(n,o){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:P.URI.revive(n.location).with({scheme:o}),globalStorageHome:P.URI.revive(n.globalStorageHome).with({scheme:o}),settingsResource:P.URI.revive(n.settingsResource).with({scheme:o}),keybindingsResource:P.URI.revive(n.keybindingsResource).with({scheme:o}),tasksResource:P.URI.revive(n.tasksResource).with({scheme:o}),snippetsHome:P.URI.revive(n.snippetsHome).with({scheme:o}),extensionsResource:P.URI.revive(n.extensionsResource)?.with({scheme:o}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(n,o,s,h){return{id:n,name:o,location:s,isDefault:!1,shortName:h?.shortName,globalStorageHome:(0,T.joinPath)(s,"globalStorage"),settingsResource:(0,T.joinPath)(s,"settings.json"),keybindingsResource:(0,T.joinPath)(s,"keybindings.json"),tasksResource:(0,T.joinPath)(s,"tasks.json"),snippetsHome:(0,T.joinPath)(s,"snippets"),extensionsResource:(0,T.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}e.toUserDataProfile=l;let i=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(o,s,h,a){super(),this.environmentService=o,this.fileService=s,this.uriIdentityService=h,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(o){this.enabled!==o&&(this._profilesObject=void 0,this.enabled=o)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const o=this.enabled?this.getStoredProfiles().map(S=>l((0,T.basename)(S.location),S.name,S.location,{shortName:S.shortName,useDefaultFlags:S.useDefaultFlags})):[];let s;const h=new f.ResourceMap,a=l((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(o.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||o.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),o.length){const S=this.getStoredProfileAssociations();if(S.workspaces)for(const[w,A]of Object.entries(S.workspaces)){const q=P.URI.parse(w),U=P.URI.parse(A),O=o.find($=>this.uriIdentityService.extUri.isEqual($.location,U));O&&h.set(q,O)}if(S.emptyWindow){const w=P.URI.parse(S.emptyWindow);s=o.find(A=>this.uriIdentityService.extUri.isEqual(A.location,w))}}this._profilesObject={profiles:o,workspaces:h,emptyWindow:s}}return this._profilesObject}async createTransientProfile(o){const s="Temp",h=new RegExp(`${(0,g.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const w of this.profiles){const A=h.exec(w.name),q=A?parseInt(A[1]):0;a=q>a?q:a}const S=`${s} ${a+1}`;return this.createProfile((0,D.hash)((0,u.generateUuid)()).toString(16),S,{transient:!0},o)}async createNamedProfile(o,s,h){return this.createProfile((0,D.hash)((0,u.generateUuid)()).toString(16),o,s,h)}async createProfile(o,s,h,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const S=await this.doCreateProfile(o,s,h);return a&&await this.setProfileForWorkspace(a,S),S}async doCreateProfile(o,s,h){let a=this.profileCreationPromises.get(s);return a||(a=(async()=>{try{const S=this.profiles.find(q=>q.name===s||q.id===o);if(S)return S;const w=l(o,s,(0,T.joinPath)(this.profilesHome,o),h);await this.fileService.createFolder(w.location);const A=[];return this._onWillCreateProfile.fire({profile:w,join(q){A.push(q)}}),await y.Promises.settled(A),this.updateProfiles([w],[],[]),w}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,a)),a}async updateProfile(o,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let h=this.profiles.find(a=>a.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);return h=l(h.id,s.name??h.name,h.location,{shortName:s.shortName??h.shortName,transient:s.transient??h.isTransient,useDefaultFlags:s.useDefaultFlags??h.useDefaultFlags}),this.updateProfiles([],[],[h]),h}async removeProfile(o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===o.id);if(!s)throw new Error(`Profile '${o.name}' does not exist`);const h=[];this._onWillRemoveProfile.fire({profile:s,join(a){h.push(a)}});try{await Promise.allSettled(h)}catch(a){this.logService.error(a)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(o,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let h=this.getProfileForWorkspace(o);return h||(h=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(o,h)),h}async setProfileForWorkspace(o,s){this.setProfileForWorkspaceSync(o,s)}setProfileForWorkspaceSync(o,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=this.profiles.find(a=>a.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(o,h)}unsetWorkspace(o,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(o,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const o=await this.fileService.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(s=>s.isDirectory&&this.profiles.every(h=>!this.uriIdentityService.extUri.isEqual(h.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const o=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(o.map(s=>this.removeProfile(s)))}getProfileForWorkspace(o){const s=this.getWorkspace(o);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(o){return(0,m.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,m.isWorkspaceIdentifier)(o)?o.configPath:"empty-window"}isProfileAssociatedToWorkspace(o){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,o.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,o.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,o.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,o.location)))}updateProfiles(o,s,h){const a=[...this.profiles,...o],S=[];this.transientProfilesObject.profiles=[];for(let w of a)w.isDefault||s.some(A=>w.id===A.id)||(w=h.find(A=>w.id===A.id)??w,w.isTransient?this.transientProfilesObject.profiles.push(w):S.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.saveStoredProfiles(S),this._profilesObject=void 0,this.triggerProfilesChanges(o,s,h)}triggerProfilesChanges(o,s,h){this._onDidChangeProfiles.fire({added:o,removed:s,updated:h,all:this.profiles})}updateWorkspaceAssociation(o,s,h){h=s?.isTransient?!0:h,h||this.updateWorkspaceAssociation(o,void 0,!0);const a=this.getWorkspace(o),S=h?this.transientProfilesObject:this.profilesObject;P.URI.isUri(a)?(S.workspaces.delete(a),s&&S.workspaces.set(a,s)):S.emptyWindow=s,h||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const o={};for(const[h,a]of this.profilesObject.workspaces.entries())o[h.toString()]=a.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:o,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(o){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(o){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([Y(0,E.IEnvironmentService),Y(1,C.IFileService),Y(2,p.IUriIdentityService),Y(3,v.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(o){this.storedProfiles=o}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(o){this.storedProfileAssociations=o}}e.InMemoryUserDataProfilesService=r}),define(ie[253],re([0,1,6,2,20]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends t.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};T=pe([Y(0,R.IUserDataProfilesService)],T),e.UserDataProfilesCleaner=T}),define(ie[254],re([0,1,18,6,24,9,3,2,5,7,148,29,33,44,8,25,23,20]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,o,s,h,a){super(),this.galleryService=n,this.telemetryService=o,this.logService=s,this.productService=h,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:S})=>S.cancel()),this.uninstallingExtensions.forEach(S=>S.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(s=>(0,b.isTargetPlatformCompatible)(s,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(C.localize(0,null),b.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(n,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,o)}catch(s){throw l(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(n),error:s}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(s),d(s)}}async uninstall(n,o={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,o)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const o=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:o,compatible:!0},R.CancellationToken.None);if(!s)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,o,s){const h=U=>`${v.ExtensionKey.create(U).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!E.URI.isUri(o)){const U=this.installingExtensions.get(h(o));if(U){this.logService.info("Extensions is already requested to install",o.identifier.id);const{local:O}=await U.task.waitUntilTaskIsFinished();return O}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],S=[],w=[],A=this.createInstallExtensionTask(n,o,s);E.URI.isUri(o)||this.installingExtensions.set(h(o),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:o,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),a.push({task:A,manifest:n});let q=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const O=await this.getAllDepsAndPackExtensions(A.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),$=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:k,manifest:M}of O){q=q||!!M.extensionDependencies?.some(W=>(0,v.areSameExtensions)({id:W},A.identifier));const F=h(k),G=this.installingExtensions.get(F);if(G){if(this.canWaitForTask(A,G.task)){this.logService.info("Waiting for already requested installing extension",k.identifier.id,A.identifier.id),G.waitingTasks.push(A);const W=G.task.identifier;S.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,B=>B.some(z=>(0,v.areSameExtensions)(z.identifier,W)))).then(B=>{if(!B.find(x=>(0,v.areSameExtensions)(x.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!$.some(({identifier:W})=>(0,v.areSameExtensions)(W,k.identifier))){const W=this.createInstallExtensionTask(M,k,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(F,{task:W,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:W.identifier,source:k,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",W.identifier.id,A.identifier.id),a.push({task:W,manifest:M})}}}catch(O){if(E.URI.isUri(A.source))(0,D.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,O.message),(0,D.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),O}const U=a.reduce((O,{task:$,manifest:k})=>(O.set($.identifier.id.toLowerCase(),{task:$,manifest:k}),O),new Map);for(;U.size;){let O;const $=[...U.values()].filter(({manifest:k})=>!k.extensionDependencies?.some(M=>U.has(M.toLowerCase())));$.length?O=U.size===1?$:$.filter(({task:k})=>!(k===A&&!q)):(this.logService.info("Found extensions with circular dependencies",$.map(({task:k})=>k.identifier.id)),O=[...U.values()]),await this.joinAllSettled(O.map(async({task:k})=>{const M=new Date().getTime();try{const{local:F}=await k.run();if(await this.joinAllSettled(this.participants.map(G=>G.postInstall(F,k.source,s,R.CancellationToken.None))),!E.URI.isUri(k.source)){const G=k.operation===3,W=G?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(l(this.telemetryService,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(k.source),wasVerified:k.wasVerified,duration:new Date().getTime()-M,durationSinceUpdate:W}),I.isWeb&&k.operation!==3)try{await this.galleryService.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,"install")}catch{}}w.push({local:F,identifier:k.identifier,operation:k.operation,source:k.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:F.isApplicationScoped})}catch(F){throw E.URI.isUri(k.source)||l(this.telemetryService,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(k.source),wasVerified:k.wasVerified,duration:new Date().getTime()-M,error:F}),this.logService.error("Error while installing the extension:",k.identifier.id),F}finally{U.delete(k.identifier.id.toLowerCase())}}))}return S.length&&await this.joinAllSettled(S),w.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(w),w.filter(({identifier:O})=>(0,v.areSameExtensions)(O,A.identifier))[0].local}catch(U){if(a.forEach(({task:O})=>O.cancel()),w.length)try{const O=await Promise.allSettled(w.map(({local:$})=>this.createUninstallExtensionTask($,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let $=0;$<O.length;$++){const k=O[$],{identifier:M}=w[$];k.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,T.getErrorMessage)(k.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(O),w.map(({identifier:$})=>$.id))}throw this._onDidInstallExtensions.fire(a.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source,context:s.context,profileLocation:s.profileLocation}))),U}finally{for(const[U,{task:O,waitingTasks:$}]of this.installingExtensions.entries()){const k=$.indexOf(A);k!==-1&&$.splice(k,1),$.length===0&&(O===A||k!==-1)&&this.installingExtensions.delete(U)}}}canWaitForTask(n,o){for(const[,{task:s,waitingTasks:h}]of this.installingExtensions.entries())if(s===n&&(h.includes(o)||h.some(a=>this.canWaitForTask(a,o)))||s===o&&h[0]&&!this.canWaitForTask(n,h[0]))return!1;return!0}async joinAllSettled(n){const o=[],s=[],h=await Promise.allSettled(n);for(const a of h)a.status==="fulfilled"?o.push(a.value):s.push(a.reason);if(s.length)throw c(s);return o}async getAllDepsAndPackExtensions(n,o,s,h,a){if(!this.galleryService.isEnabled())return[];const S=await this.getInstalled(void 0,a),w=[n],A=[],q=async(U,O)=>{const $=O.extensionDependencies||[],k=[...$];if(O.extensionPack){const M=s?S.find(F=>(0,v.areSameExtensions)(F.identifier,U)):void 0;for(const F of O.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(G=>(0,v.areSameExtensions)({id:G},{id:F}))||k.every(G=>!(0,v.areSameExtensions)({id:G},{id:F}))&&k.push(F)}if(k.length){const M=[...w,...A.map(G=>G.gallery.identifier)],F=k.filter(G=>M.every(W=>!(0,v.areSameExtensions)(W,{id:G})));if(F.length){const G=await this.galleryService.getExtensions(F.map(W=>({id:W,preRelease:h})),R.CancellationToken.None);for(const W of G){if(M.find(x=>(0,v.areSameExtensions)(x,W.identifier)))continue;const B=$.some(x=>(0,v.areSameExtensions)({id:x},W.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(W,!1,h)}catch(x){if(x instanceof b.ExtensionManagementError&&x.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw x}A.push({gallery:z.extension,manifest:z.manifest}),await q(z.extension.identifier,z.manifest)}}}};return await q(n,o),A}async checkAndGetCompatibleVersion(n,o,s){if((await this.getExtensionsControlManifest()).malicious.some(w=>(0,v.areSameExtensions)(n.identifier,w)))throw new b.ExtensionManagementError(C.localize(3,null,n.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const w=await this.getTargetPlatform();throw new b.ExtensionManagementError(C.localize(4,null,n.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(w)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(n,o,s);if(a){if(s&&!o&&n.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(C.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],R.CancellationToken.None))[0]?new b.ExtensionManagementError(C.localize(6,null,n.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(C.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const S=await this.galleryService.getManifest(a,R.CancellationToken.None);if(S===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(S.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:S}}async getCompatibleVersion(n,o,s){const h=await this.getTargetPlatform();let a=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==s&&(a=(await this.galleryService.getExtensions([{...n.identifier,preRelease:s}],{targetPlatform:h,compatible:!0},R.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(n,s,h)&&(a=n),a||(o?a=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:h,compatible:!0},R.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(n,s,h)),a}async uninstallExtension(n,o){const s=q=>`${q.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,h=this.uninstallingExtensions.get(s(n.identifier));if(h)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),h.waitUntilTaskIsFinished();const a=(q,U)=>{const O=this.createUninstallExtensionTask(q,U);return this.uninstallingExtensions.set(s(O.extension.identifier),O),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${q.identifier.id}@${q.manifest.version}`),this._onUninstallExtension.fire({identifier:q.identifier,profileLocation:o.profileLocation,applicationScoped:q.isApplicationScoped}),O},S=(q,U)=>{U?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,o.profileLocation.toString(),U.message):this.logService.error("Failed to uninstall extension:",`${q.identifier.id}@${q.manifest.version}`,U.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${q.identifier.id}@${q.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${q.identifier.id}@${q.manifest.version}`),l(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(q),error:U}),this._onDidUninstallExtension.fire({identifier:q.identifier,version:q.manifest.version,error:U?.code,profileLocation:o.profileLocation,applicationScoped:q.isApplicationScoped})},w=[],A=[];try{w.push(a(n,o));const q=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const U=this.getAllPackExtensionsToUninstall(n,q);for(const O of U)this.uninstallingExtensions.has(s(O.identifier))?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):w.push(a(O,o))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(w.map(U=>U.extension),q,n),await this.joinAllSettled(w.map(async U=>{try{if(await U.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(U.extension,o,R.CancellationToken.None))),U.extension.identifier.uuid)try{await this.galleryService.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}S(U.extension)}catch(O){const $=O instanceof b.ExtensionManagementError?O:new b.ExtensionManagementError((0,T.getErrorMessage)(O),b.ExtensionManagementErrorCode.Internal);throw S(U.extension,$),$}finally{A.push(U)}}))}catch(q){const U=q instanceof b.ExtensionManagementError?q:new b.ExtensionManagementError((0,T.getErrorMessage)(q),b.ExtensionManagementErrorCode.Internal);for(const O of w){try{O.cancel()}catch{}A.includes(O)||S(O.extension,U)}throw U}finally{for(const q of w)this.uninstallingExtensions.delete(s(q.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",q.extension.identifier.id)}}checkForDependents(n,o,s){for(const h of n){const a=this.getDependents(h,o);if(a.length){const S=a.filter(w=>!n.some(A=>(0,v.areSameExtensions)(A.identifier,w.identifier)));if(S.length)throw new Error(this.getDependentsErrorMessage(h,S,s))}}}getDependentsErrorMessage(n,o,s){return s===n?o.length===1?C.localize(8,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(9,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(10,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(11,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(12,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(13,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(n,o,s=[]){if(s.indexOf(n)!==-1)return[];s.push(n);const h=n.manifest.extensionPack?n.manifest.extensionPack:[];if(h.length){const a=o.filter(w=>!w.isBuiltin&&h.some(A=>(0,v.areSameExtensions)({id:A},w.identifier))),S=[];for(const w of a)S.push(...this.getAllPackExtensionsToUninstall(w,o,s));return[...a,...S]}return[]}getDependents(n,o){return o.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(h=>(0,v.areSameExtensions)({id:h},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,o,s){return s.profileLocation&&(0,m.isApplicationScopedExtension)(n)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,o,s)}createUninstallExtensionTask(n,o){return o.profileLocation&&n.isApplicationScoped&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,o)}};g=pe([Y(0,b.IExtensionGalleryService),Y(1,y.ITelemetryService),Y(2,f.ILogService),Y(3,p.IProductService),Y(4,u.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function c(r){const n=Array.isArray(r)?r:[r];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,s)=>new Error(`${o.message}${o.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function d(r){if(r instanceof b.ExtensionManagementError)return r;const n=new b.ExtensionManagementError(r.message,b.ExtensionManagementErrorCode.Internal);return n.stack=r.stack,n}function l(r,n,{extensionData:o,wasVerified:s,duration:h,error:a,durationSinceUpdate:S}){let w,A;a&&(a instanceof b.ExtensionManagementError?(w=a.code,a.code===b.ExtensionManagementErrorCode.Signature&&(A=a.message)):w=b.ExtensionManagementErrorCode.Internal),r.publicLog(n,{...o,wasVerified:s,success:!a,duration:h,errorcode:w,errorcodeDetail:A,durationSinceUpdate:S})}e.reportTelemetry=l;class i{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((o,s)=>{const h=n.onCancellationRequested(()=>{h.dispose(),s(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ie[77],re([0,1,18,6,32,17,9,35,130,2,22,12,5,19,55,87,15,7,151,13,33,44,70,14,4,8,25,3,67,51,20,31,180]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i,r,n,o,s,h,a,S,w,A,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(W){function B(z,x){if(z===x)return!0;const J=Object.keys(z),X=new Set;for(const se of Object.keys(x))X.add(se);if(J.length!==X.size)return!1;for(const se of J){if(z[se]!==x[se])return!1;X.delete(se)}return X.size===0}W.equals=B})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let O=class extends E.Disposable{constructor(B,z,x,J,X,se,j,H,_,N,V){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=z,this.extensionsControlLocation=x,this.cacheLocation=J,this.userDataProfilesService=X,this.extensionsProfileScannerService=se,this.fileService=j,this.logService=H,this.environmentService=_,this.productService=N,this.instantiationService=V,this._onDidChangeCache=this._register(new h.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,(0,m.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,(0,m.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(k,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,z,x){const[J,X]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(z)]),se=x?await this.scanExtensionsUnderDevelopment(B,[...J,...X]):[];return this.dedupExtensions(J,X,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const z=[];z.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),z.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[x,J]=await Promise.all(z);return this.applyScanOptions([...x,...J],0,B,!1)}async scanUserExtensions(B){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(B.profileLocation??this.userExtensionsLocation,!!B.profileLocation,1,!B.includeUninstalled,B.language);let J=await(B.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return J=await this.applyScanOptions(J,1,B,!0),this.logService.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(B,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(J=>J.scheme===C.Schemas.file).map(async J=>{const X=await this.createExtensionScannerInput(J,!1,1,!0,B.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(X)).map(j=>(j.type=z.find(H=>(0,d.areSameExtensions)(H.identifier,j.identifier))?.type??j.type,this.extensionsScanner.validate(j,X)))}))).flat();return this.applyScanOptions(x,"development",B,!0)}return[]}async scanExistingExtension(B,z,x){const J=await this.createExtensionScannerInput(B,!1,z,!0,x.language),X=await this.extensionsScanner.scanExtension(J);return!X||!x.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(B,z,x){const J=await this.createExtensionScannerInput(B,!1,z,!0,x.language),X=await this.extensionsScanner.scanOneOrMultipleExtensions(J);return this.applyScanOptions(X,z,x,!0)}async scanMetadata(B){const z=(0,m.joinPath)(B,"package.json"),x=(await this.fileService.readFile(z)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(B,z){const x=(0,m.joinPath)(B,"package.json"),J=(await this.fileService.readFile(x)).value.toString(),X=JSON.parse(J);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,X.__metadata={...X.__metadata,...z},await this.fileService.writeFile((0,m.joinPath)(B,"package.json"),T.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async applyScanOptions(B,z,x,J){return x.includeAllVersions||(B=this.dedupExtensions(z===0?B:void 0,z===1?B:void 0,z==="development"?B:void 0,await this.getTargetPlatform(),J)),x.includeInvalid||(B=B.filter(X=>X.isValid)),B.sort((X,se)=>{const j=b.basename(X.location.fsPath),H=b.basename(se.location.fsPath);return j<H?-1:j>H?1:0})}dedupExtensions(B,z,x,J,X){const se=(H,_,N)=>{if(H.isValid&&!_.isValid)return!1;if(H.isValid===_.isValid){if(X&&f.gt(H.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(f.eq(H.manifest.version,_.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===J)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${H.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${_.location.path}.`),!0},j=new Map;return B?.forEach(H=>{const _=l.ExtensionIdentifier.toKey(H.identifier.id),N=j.get(_);(!N||se(N,H,!1))&&j.set(_,H)}),z?.forEach(H=>{const _=l.ExtensionIdentifier.toKey(H.identifier.id),N=j.get(_);if(!N&&B&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!N||se(N,H,!1))&&j.set(_,H)}),x?.forEach(H=>{const _=l.ExtensionIdentifier.toKey(H.identifier.id),N=j.get(_);(!N||se(N,H,!0))&&j.set(_,H),j.set(_,H)}),[...j.values()]}async scanDefaultSystemExtensions(B,z){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),X=await(B&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",X.length),X}async scanDevSystemExtensions(B,z){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const J=z?await this.getBuiltInExtensionControl():{},X=[],se=u.URI.file(b.normalize(b.join(C.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const H of x){const _=J[H.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":X.push((0,m.joinPath)(se,H.name));break;default:X.push(u.URI.file(_));break}}const j=await Promise.all(X.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,B))));return this.logService.trace("Scanned dev system extensions:",j.length),(0,D.coalesce)(j)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,z,x,J,X,se=!0){const j=await this.getTranslations(X??v.language),H=await this.getMtime(B),_=z?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=_?await this.getMtime(_):void 0;return new $(B,H,_,N,z,x,J,se,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,X,j)}async getMtime(B){try{const z=await this.fileService.stat(B);if(typeof z.mtime=="number")return z.mtime}catch{}}};O=pe([Y(4,w.IUserDataProfilesService),Y(5,S.IExtensionsProfileScannerService),Y(6,r.IFileService),Y(7,o.ILogService),Y(8,c.IEnvironmentService),Y(9,s.IProductService),Y(10,n.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class ${constructor(B,z,x,J,X,se,j,H,_,N,V,K,ee,ae){this.location=B,this.mtime=z,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=J,this.profile=X,this.type=se,this.excludeObsolete=j,this.validate=H,this.productVersion=_,this.productDate=N,this.productCommit=V,this.devMode=K,this.language=ee,this.translations=ae}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,z){return(0,m.isEqual)(B.location,z.location)&&B.mtime===z.mtime&&(0,m.isEqual)(B.applicationExtensionslocation,z.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&B.profile===z.profile&&B.type===z.type&&B.excludeObsolete===z.excludeObsolete&&B.validate===z.validate&&B.productVersion===z.productVersion&&B.productDate===z.productDate&&B.productCommit===z.productCommit&&B.devMode===z.devMode&&B.language===z.language&&U.equals(B.translations,z.translations)}}let k=class extends E.Disposable{constructor(B,z,x,J,X){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=z,this.uriIdentityService=x,this.fileService=J,this.logService=X}async scanExtensions(B){const z=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let x={};if(B.excludeObsolete&&B.type===1)try{const J=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(J)}catch{}return(0,y.isEmptyObject)(x)?z:z.filter(J=>!x[d.ExtensionKey.create(J).toString()])}async scanExtensionsFromLocation(B){const z=await this.fileService.resolve(B.location);if(!z.children?.length)return[];const x=await Promise.all(z.children.map(async J=>{if(!J.isDirectory||B.type===1&&(0,m.basename)(J.resource).indexOf(".")===0)return null;const X=new $(J.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(X)}));return(0,D.coalesce)(x).sort((J,X)=>J.location.path<X.location.path?-1:1)}async scanExtensionsFromProfile(B){let z=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){z=z.filter(J=>!J.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,J=>!!J.metadata?.isApplicationScoped,B);z.push(...x)}return z}async scanExtensionsFromProfileResource(B,z,x){const J=await this.extensionsProfileScannerService.scanProfileExtensions(B);if(!J.length)return[];const X=await Promise.all(J.map(async se=>{if(z(se)){const j=new $(se.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(j,se.metadata)}return null}));return(0,D.coalesce)(X)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,m.joinPath)(B.location,"package.json"))){const z=await this.scanExtension(B);return z?[z]:[]}else return await this.scanExtensions(B)}catch(z){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,L.getErrorMessage)(z)),[]}}async scanExtension(B,z){try{let x=await this.scanExtensionManifest(B.location);if(x){x.publisher||(x.publisher=l.UNDEFINED_PUBLISHER),z=z??x.__metadata,delete x.__metadata;const J=(0,d.getGalleryExtensionId)(x.publisher,x.name),X=z?.id?{id:J,uuid:z.id}:{id:J},se=z?.isSystem?0:B.type,j=se===0||!!z?.isBuiltin;x=await this.translateManifest(B.location,x,$.createNlsConfiguration(B));const H={type:se,identifier:X,manifest:x,location:B.location,isBuiltin:j,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return B.validate?this.validate(H,B):H}}catch(x){B.type!==0&&this.logService.error(x)}return null}validate(B,z){let x=!0;const J=(0,i.validateExtensionManifest)(z.productVersion,z.productDate,z.location,B.manifest,B.isBuiltin);for(const[X,se]of J)X===p.default.Error&&(x=!1,this.logService.error(this.formatMessage(z.location,se)));return B.isValid=x,B.validations=J,B}async scanExtensionManifest(B){const z=(0,m.joinPath)(B,"package.json");let x;try{x=(await this.fileService.readFile(z)).value.toString()}catch(X){return(0,r.toFileOperationResult)(X)!==1&&this.logService.error(this.formatMessage(B,(0,g.localize)(0,null,z.path,X.message))),null}let J;try{J=JSON.parse(x)}catch{const se=[];(0,P.parse)(x,se);for(const j of se)this.logService.error(this.formatMessage(B,(0,g.localize)(1,null,z.path,j.offset,j.length,(0,I.getParseErrorMessage)(j.error))));return null}return(0,P.getNodeType)(J)!=="object"?(this.logService.error(this.formatMessage(B,(0,g.localize)(2,null,z.path))),null):J}async translateManifest(B,z,x){const J=await this.getLocalizedMessages(B,z,x);if(J)try{const X=[],se=await this.resolveOriginalMessageBundle(J.default,X);if(X.length>0)return X.forEach(H=>{this.logService.error(this.formatMessage(B,(0,g.localize)(3,null,J.default?.path,(0,I.getParseErrorMessage)(H.error))))}),z;if((0,P.getNodeType)(J)!=="object")return this.logService.error(this.formatMessage(B,(0,g.localize)(4,null,J.default?.path))),z;const j=J.values||Object.create(null);return(0,q.localizeManifest)(z,j,se)}catch{}return z}async getLocalizedMessages(B,z,x){const J=(0,m.joinPath)(B,"package.nls.json"),X=(_,N)=>{N.forEach(V=>{this.logService.error(this.formatMessage(B,(0,g.localize)(5,null,_?.path,(0,I.getParseErrorMessage)(V.error))))})},se=_=>{this.logService.error(this.formatMessage(B,(0,g.localize)(6,null,_?.path)))},j=`${z.publisher}.${z.name}`,H=x.translations[j];if(H)try{const _=u.URI.file(H),N=(await this.fileService.readFile(_)).value.toString(),V=[],K=(0,P.parse)(N,V);return V.length>0?(X(_,V),{values:void 0,default:J}):(0,P.getNodeType)(K)!=="object"?(se(_),{values:void 0,default:J}):{values:K.contents?K.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.fileService.exists(J))return;let N;try{N=await this.findMessageBundles(B,x)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const V=(await this.fileService.readFile(N.localized)).value.toString(),K=[],ee=(0,P.parse)(V,K);return K.length>0?(X(N.localized,K),{values:void 0,default:N.original}):(0,P.getNodeType)(ee)!=="object"?(se(N.localized),{values:void 0,default:N.original}):{values:ee,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(B,z){if(B)try{const x=(await this.fileService.readFile(B)).value.toString();return(0,P.parse)(x,z)}catch{}}findMessageBundles(B,z){return new Promise((x,J)=>{const X=se=>{const j=(0,m.joinPath)(B,`package.nls.${se}.json`);this.fileService.exists(j).then(H=>{H&&x({localized:j,original:(0,m.joinPath)(B,"package.nls.json")});const _=se.lastIndexOf("-");_===-1?x({localized:(0,m.joinPath)(B,"package.nls.json"),original:null}):(se=se.substring(0,_),X(se))})};if(z.devMode||z.pseudo||!z.language)return x({localized:(0,m.joinPath)(B,"package.nls.json"),original:null});X(z.language)})}formatMessage(B,z){return`[${B.path}]: ${z}`}};k=pe([Y(1,S.IExtensionsProfileScannerService),Y(2,A.IUriIdentityService),Y(3,r.IFileService),Y(4,o.ILogService)],k);let M=class extends k{constructor(B,z,x,J,X,se){super(z,x,J,X,se),this.cacheFile=B,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new h.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const z=await this.readExtensionCache();if(this.input=B,z&&z.input&&$.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(J=>(J.location=u.URI.revive(J.location),J));const x=await super.scanExtensions(B);return await this.writeExtensionCache({input:B,result:x}),x}async readExtensionCache(){try{const B=await this.fileService.readFile(this.cacheFile),z=JSON.parse(B.value.toString());return{result:z.result,input:(0,a.revive)(z.input)}}catch(B){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(B))}return null}async writeExtensionCache(B){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(B)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const B=await this.readExtensionCache();if(!B)return;const z=B.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(x,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(J){this.logService.error(J)}}};M=pe([Y(2,S.IExtensionsProfileScannerService),Y(3,A.IUriIdentityService),Y(4,r.IFileService),Y(5,o.ILogService)],M);function F(W,B){const z=(0,d.getExtensionId)(W.manifest.publisher,W.manifest.name);return{id:z,identifier:new l.ExtensionIdentifier(z),isBuiltin:W.type===0,isUserBuiltin:W.type===1&&W.isBuiltin,isUnderDevelopment:B,extensionLocation:W.location,uuid:W.identifier.uuid,targetPlatform:W.targetPlatform,...W.manifest}}e.toExtensionDescription=F;class G extends O{constructor(B,z,x,J,X,se,j,H,_,N,V){super(B,z,(0,m.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)(J,l.MANIFEST_CACHE_FOLDER),X,se,j,H,_,N,V),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const K=await this.fileService.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse(K.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}e.NativeExtensionsScannerService=G}),define(ie[255],re([0,1,49,6,37,3,2,22,12,28,8,20]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends L.Disposable{constructor(f,p){super(),this.userDataProfilesService=f,this.logService=p,this.processesLimiter=new t.Limiter(5)}async postUninstall(f){const p=this.parseScript(f,"uninstall");return p&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),E.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,p){const y=`vscode:${p}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const u=f.manifest.scripts[y].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(f,p,y,u,g){return new Promise((c,d)=>{const l=this.start(f,p,y,g);let i;const r=n=>{i&&(clearTimeout(i),i=null),n?d(n):c(void 0)};l.on("error",n=>{r((0,R.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,o)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),u&&(i=setTimeout(()=>{i=null,l.kill(),d("timed out")},5e3))})}start(f,p,y,u){const g={silent:!0,execArgv:void 0},c=(0,D.fork)(f,[`--type=extension-post-${p}`,...y],g);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const d=T.Event.fromNodeEventEmitter(c.stdout,"data"),l=T.Event.fromNodeEventEmitter(c.stderr,"data");d(n=>this.logService.info(u.identifier.id,u.manifest.version,`post-${p}`,n)),l(n=>this.logService.error(u.identifier.id,u.manifest.version,`post-${p}`,n));const i=T.Event.any(T.Event.map(d,n=>({data:`%c${n}`,format:[""]})),T.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(i,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),c}getExtensionStoragePath(f){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};v=pe([Y(0,b.IUserDataProfilesService),Y(1,C.ILogService)],v),e.ExtensionsLifecycle=v}),define(ie[256],re([0,1,7,13,51,77,14,4,8,25,20]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends T.NativeExtensionsScannerService{constructor(m,f,p,y,u,g,c){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,D.URI.file(u.userDataPath),m,f,p,y,u,g,c)}};b=pe([Y(0,C.IUserDataProfilesService),Y(1,R.IExtensionsProfileScannerService),Y(2,L.IFileService),Y(3,I.ILogService),Y(4,t.INativeEnvironmentService),Y(5,E.IProductService),Y(6,P.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ie[21],re([0,1,6,3,2,198,15,69,4,20]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));function m(g){const c=g.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=m;class f extends R.Disposable{constructor(c={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,d){if(d===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:d,target:this.getKeyTargets(c)[d]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,d,l){return this.getStorage(d)?.get(c,l)}getBoolean(c,d,l){return this.getStorage(d)?.getBoolean(c,l)}getNumber(c,d,l){return this.getStorage(d)?.getNumber(c,l)}store(c,d,l,i){if((0,L.isUndefinedOrNull)(d)){this.remove(c,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,l,i),this.getStorage(l)?.set(c,d)})}remove(c,d){this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,void 0),this.getStorage(d)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,d){const l=[],i=this.getKeyTargets(c);for(const r of Object.keys(i))i[r]===d&&l.push(r);return l}updateKeyTarget(c,d,l){const i=this.getKeyTargets(d);typeof l=="number"?i[c]!==l&&(i[c]=l,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[c]=="number"&&(delete i[c],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const d=this.getStorage(c);return d?m(d):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=C.NONE){this._onWillSaveState.fire({reason:c});const d=this.getStorage(-1),l=this.getStorage(0),i=this.getStorage(1);switch(c){case C.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return u(c,d,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,d){return this.emitWillSaveState(C.NONE),(0,E.isUserDataProfile)(c)?this.switchToProfile(c,d):this.switchToWorkspace(c,d)}canSwitchProfile(c,d){return!(c.id===d.id||p(d)&&p(c))}switchData(c,d,l,i){this.withPausedEmitters(()=>{if(i)for(const[r,n]of c)d.set(r,n);else{const r=new Set;for(const[n,o]of c)r.add(n),d.get(n)!==o&&this.emitDidChangeValue(l,n);for(const[n]of d.items)r.has(n)||this.emitDidChangeValue(l,n)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function p(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class y extends f{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(c){return!1}}e.InMemoryStorageService=y;async function u(g,c,d,l,i,r){const n=U=>{try{return JSON.parse(U)}catch{return U}},o=new Map,s=new Map;g.forEach((U,O)=>{o.set(O,U),s.set(O,n(U))});const h=new Map,a=new Map;c.forEach((U,O)=>{h.set(O,U),a.set(O,n(U))});const S=new Map,w=new Map;d.forEach((U,O)=>{S.set(O,U),w.set(O,n(U))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const A=[];if(o.forEach((U,O)=>{A.push({key:O,value:U})}),console.table(A),console.groupEnd(),console.log(s),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];h.forEach((O,$)=>{U.push({key:$,value:O})}),console.table(U),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const q=[];S.forEach((U,O)=>{q.push({key:O,value:U})}),console.table(q),console.groupEnd(),console.log(w)}e.logStorage=u}),define(ie[117],re([0,1,3,2,15,29,33,21]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends t.Disposable{constructor(b,v){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(b)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"}))),this._register(v.onDidInstallExtensions(m=>m.forEach(({local:f,operation:p})=>{f&&p===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(b,v){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:v}),!0):!1}async disableExtension(b,v){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const v=this.getDisabledExtensions();return v.every(m=>!(0,L.areSameExtensions)(m,b))?(v.push(b),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(b){const v=this.getDisabledExtensions();for(let m=0;m<v.length;m++){const f=v[m];if((0,L.areSameExtensions)(f,b))return v.splice(m,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(b){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,v){this.storageManger.set(b,v,0)}};I=pe([Y(0,P.IStorageService),Y(1,T.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class E extends t.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(b,v){let m;return v===0?((0,R.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,v)),m=this.storage[b]):m=this._get(b,v),JSON.parse(m)}set(b,v,m){const f=JSON.stringify(v.map(({id:y,uuid:u})=>({id:y,uuid:u})));this._get(b,m)!==f&&(m===0&&(v.length?this.storage[b]=f:delete this.storage[b]),this._set(b,v.length?f:void 0,m))}onDidStorageChange(b){if(b.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const m=this.get(b.key,b.scope);delete this.storage[b.key];const f=this.get(b.key,b.scope),p=m.filter(u=>!f.some(g=>(0,L.areSameExtensions)(u,g))),y=f.filter(u=>!m.some(g=>(0,L.areSameExtensions)(g,u)));(p.length||y.length)&&this._onDidChange.fire([...p,...y])}}_get(b,v){return this.storageService.get(b,v,"[]")}_set(b,v,m){v?this.storageService.store(b,v,m,1):this.storageService.remove(b,m)}}e.StorageManager=E}),define(ie[257],re([0,1,18,24,9,5,36,15,7,16,13,29,33,70,14,8,25,45,227,21,23]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=T.isWeb?"web":(0,b.getTargetPlatform)(T.platform,L.arch);var i;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(..._){return String(_.reduce((N,V)=>N|V,0))}var n;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class S{constructor(N=a){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(N,V=this.state.pageSize){return new S({...this.state,pageNumber:N,pageSize:V})}withFilter(N,...V){const K=[...this.state.criteria,...V.length?V.map(ee=>({filterType:N,value:ee})):[{filterType:N}]];return new S({...this.state,criteria:K})}withSortBy(N){return new S({...this.state,sortBy:N})}withSortOrder(N){return new S({...this.state,sortOrder:N})}withFlags(...N){return new S({...this.state,flags:N.reduce((V,K)=>V|K,0)})}withAssetTypes(...N){return new S({...this.state,assetTypes:N})}withSource(N){return new S({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:V,pageSize:K,sortBy:ee,sortOrder:ae,flags:Z,assetTypes:ne}=this.state;return{filters:[{criteria:N,pageNumber:V,pageSize:K,sortBy:ee,sortOrder:ae}],assetTypes:ne,flags:Z}}get searchText(){const N=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function w(_,N){const V=(_||[]).filter(K=>K.statisticName===N)[0];return V?V.value:0}function A(_){const N="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(K=>K.assetType.indexOf(N)===0).reduce((K,ee)=>{const ae=O(_,ee.assetType);return ae&&K.push([ee.assetType.substring(N.length),ae]),K},[])}function q(_){if(_.properties){const N=_.properties.filter(ee=>ee.key===o.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=N.filter(ee=>V.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return O(_,o.Repository)}function U(_){return{uri:`${_.fallbackAssetUri}/${o.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${o.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function O(_,N){return _.files.filter(K=>K.assetType===N)[0]?{uri:`${_.assetUri}/${N}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${N}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function $(_,N){const V=_.properties?_.properties.filter(ee=>ee.key===N):[],K=V.length>0&&V[0].value;return K?K.split(",").map(ee=>(0,v.adoptToGalleryExtensionId)(ee)):[]}function k(_){const N=_.properties?_.properties.filter(V=>V.key===s.Engine):[];return N.length>0&&N[0].value||""}function M(_){const N=_.properties?_.properties.filter(V=>V.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function F(_){const N=_.properties?_.properties.filter(K=>K.key===s.LocalizedLanguages):[],V=N.length>0&&N[0].value||"";return V?V.split(","):[]}function G(_){return _.properties?.find(N=>N.key===s.SponsorLink)?.value}function W(_){return _.indexOf("preview")!==-1}function B(_){return _.targetPlatform?(0,b.toTargetPlatform)(_.targetPlatform):"undefined"}function z(_){const N=(0,D.distinct)(_.versions.map(B)),V=!!_.tags?.includes(b.WEB_EXTENSION_TAG),K=N.indexOf("web");return V?K===-1&&N.push("web"):K!==-1&&N.splice(K,1),N}function x(_,N){const V=(0,b.getFallbackTargetPlarforms)(N);for(let K=0;K<_.length;K++){const ee=_[K];if(ee.version===_[K-1]?.version){let ae=K;const Z=B(ee);if(Z===N)for(;ae>0&&_[ae-1].version===ee.version;)ae--;else if(V.includes(Z))for(;ae>0&&_[ae-1].version===ee.version&&B(_[ae-1])!==N;)ae--;ae!==K&&(_.splice(K,1),_.splice(ae,0,ee))}}return _}e.sortExtensionVersions=x;function J(_,N,V){_.telemetryData={index:N,querySource:V}}function X(_,N,V){const K=_.versions[0],ee={manifest:O(N,o.Manifest),readme:O(N,o.Details),changelog:O(N,o.Changelog),license:O(N,o.License),repository:q(N),download:U(N),icon:O(N,o.Icon),signature:O(N,o.Signature),coreTranslations:A(N)};return{identifier:{id:(0,v.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:N.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(K),description:_.shortDescription||"",installCount:w(_.statistics,"install"),rating:w(_.statistics,"averagerating"),ratingCount:w(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:V,assets:ee,properties:{dependencies:$(N,s.Dependency),extensionPack:$(N,s.ExtensionPack),engine:k(N),localizedLanguages:F(N),targetPlatform:B(N),isPreReleaseVersion:M(N)},hasPreReleaseVersion:M(K),hasReleaseVersion:!0,preview:W(_.flags),isSigned:!!ee.signature}}let se=class{constructor(N,V,K,ee,ae,Z,ne,oe){this.requestService=V,this.logService=K,this.environmentService=ee,this.telemetryService=ae,this.fileService=Z,this.productService=ne,this.configurationService=oe;const ue=ne.extensionsGallery;this.extensionsGalleryUrl=ue?.serviceUrl,this.extensionsGallerySearchUrl=ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ne.version,ne,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,V,K){const ee=t.CancellationToken.isCancellationToken(V)?{}:V,ae=t.CancellationToken.isCancellationToken(V)?V:K,Z=[],ne=[],oe=[],ue=[];let de=!0;for(const Ee of N){Ee.uuid?ne.push(Ee.uuid):Z.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);oe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Pe}if(!ne.length&&!Z.length)return[];let ve=new S().withPage(1,N.length);ne.length&&(ve=ve.withFilter(n.ExtensionId,...ne)),Z.length&&(ve=ve.withFilter(n.ExtensionName,...Z)),(ee.queryAllVersions||de)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),ee.source&&(ve=ve.withSource(ee.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:ee.targetPlatform??l,includePreRelease:oe,versions:ue,compatible:!!ee.compatible},ae);return ee.source&&we.forEach((Ee,Pe)=>J(Ee,Pe,ee.source)),we}async getCompatibleExtension(N,V,K){if((0,b.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(N,V,K))return N;const ee=new S().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,N.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(ee,{targetPlatform:K,compatible:!0,includePreRelease:V},t.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(N,V,K){if(!(0,b.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,K)||!V&&N.properties.isPreReleaseVersion)return!1;let ee=N.properties.engine;if(!ee){const ae=await this.getManifest(N,t.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ee=ae.engines.vscode}return(0,m.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(N,V,K,ee,ae){if(!(0,b.isTargetPlatformCompatible)(B(N),ee,ae)||V!=="any"&&M(N)!==(V==="prerelease"))return!1;if(K)try{const Z=await this.getEngine(N);if(!(0,m.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,R.getErrorMessage)(Z)),!1}return!0}async query(N,V){let K=N.text||"";const ee=N.pageSize??50;let ae=new S().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(ae=ae.withFilter(n.Category,we||ve),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(ae=ae.withFilter(n.Tag,we||ve),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),ae=ae.withFilter(n.SearchText,K)),ae=ae.withSortBy(0)):N.ids?ae=ae.withFilter(n.ExtensionId,...N.ids):N.names?ae=ae.withFilter(n.ExtensionName,...N.names):ae=ae.withSortBy(4),typeof N.sortBy=="number"&&(ae=ae.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(ae=ae.withSortOrder(N.sortOrder)),N.source&&(ae=ae.withSource(N.source));const Z=async(de,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(de,{targetPlatform:l,compatible:!1,includePreRelease:!!N.includePreRelease},ve);return we.forEach((Pe,Oe)=>J(Pe,(de.pageNumber-1)*de.pageSize+Oe,N.source)),{extensions:we,total:Ee}},{extensions:ne,total:oe}=await Z(ae,V),ue=async(de,ve)=>{if(ve.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await Z(ae.withPage(de+1),ve);return we};return{firstPage:ne,total:oe,pageSize:ae.pageSize,getPage:ue}}async queryGalleryExtensions(N,V,K){const ee=N.flags;!!(N.flags&i.IncludeLatestVersionOnly)&&!!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(N.flags&i.IncludeLatestVersionOnly)&&!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags,i.IncludeLatestVersionOnly)),V.versions?.length&&(N=N.withFlags(N.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),N=N.withFlags(N.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ae,total:Z}=await this.queryRawGalleryExtensions(N,K);if(!(N.flags&i.IncludeLatestVersionOnly)){const de=[];for(const ve of ae){const we=await this.toGalleryExtensionWithCriteria(ve,V);we&&de.push(we)}return{extensions:de,total:Z}}const oe=[],ue=new Map;for(let de=0;de<ae.length;de++){const ve=ae[de],we={id:(0,v.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Oe=>(0,v.areSameExtensions)(Oe,we))?.includePreRelease;if(V.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(z(ve),V.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,V);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==V.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,de):oe.push([de,Pe])}if(ue.size){const de=new Date().getTime(),ve=new S().withFlags(ee&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(n.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,V,K);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);oe.push([Pe,Ee])}}return{extensions:oe.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:Z}}async toGalleryExtensionWithCriteria(N,V){const K={id:(0,v.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},ee=V.versions?.find(oe=>(0,v.areSameExtensions)(oe,K))?.version,ae=(0,P.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(oe=>(0,v.areSameExtensions)(oe,K))?.includePreRelease,Z=z(N),ne=x(N.versions,V.targetPlatform);if(V.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(Z,V.targetPlatform))return null;for(let oe=0;oe<ne.length;oe++){const ue=ne[oe];if(!(ee&&ue.version!==ee)){if(await this.isValidVersion(ue,ae?"any":"release",V.compatible,Z,V.targetPlatform))return X(N,ue,Z);if(ee&&ue.version===ee)return null}}return ee||V.compatible?null:X(N,N.versions[0],Z)}async queryRawGalleryExtensions(N,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(i.Unpublished));const K=await this.commonHeadersPromise,ee=JSON.stringify(N.raw),ae={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let ne,oe,ue=0;try{if(ne=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&N.criteria.some(ve=>ve.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:ae},V),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,u.asJson)(ne);if(de){const ve=de.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(de){throw oe=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!ne&&(0,u.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:oe?(0,R.isCancellationError)(oe)?"canceled":(0,R.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(N,V,K,ee){if(!this.isEnabled())return;const ae=T.isWeb?this.api(`/itemName/${N}.${V}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${V}/${K}/stats?statType=${ee}`),Z=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",oe={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:ae,headers:oe},t.CancellationToken.None)}catch{}}async download(N,V,K){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const ee=(0,v.getGalleryExtensionTelemetryData)(N),ae=new Date().getTime(),Z=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ne=K===2?"install":K===3?"update":"",oe=ne?{uri:`${N.assets.download.uri}${I.URI.parse(N.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${N.assets.download.fallbackUri}${I.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:N.assets.download,ue=await this.getAsset(oe);await this.fileService.writeFile(V,ue.stream),Z(new Date().getTime()-ae)}async downloadSignatureArchive(N,V){if(!N.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const K=await this.getAsset(N.assets.signature);await this.fileService.writeFile(V,K.stream)}async getReadme(N,V){if(N.assets.readme){const K=await this.getAsset(N.assets.readme,{},V);return await(0,u.asTextOrError)(K)||""}return""}async getManifest(N,V){if(N.assets.manifest){const K=await this.getAsset(N.assets.manifest,{},V),ee=await(0,u.asTextOrError)(K);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(N,V){const K=O(N,o.Manifest);if(!K)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},ae=await this.getAsset(K,{headers:ee});return await(0,u.asJson)(ae)}async getCoreTranslation(N,V){const K=N.assets.coreTranslations.filter(ee=>ee[0]===V.toUpperCase())[0];if(K){const ee=await this.getAsset(K[1]),ae=await(0,u.asTextOrError)(ee);return ae?JSON.parse(ae):null}return null}async getChangelog(N,V){if(N.assets.changelog){const K=await this.getAsset(N.assets.changelog,{},V);return await(0,u.asTextOrError)(K)||""}return""}async getAllCompatibleVersions(N,V,K){let ee=new S().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?ee=ee.withFilter(n.ExtensionId,N.identifier.uuid):ee=ee.withFilter(n.ExtensionName,N.identifier.id);const{galleryExtensions:ae}=await this.queryRawGalleryExtensions(ee,t.CancellationToken.None);if(!ae.length)return[];const Z=z(ae[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(Z,K))return[];const ne=[];await Promise.all(ae[0].versions.map(async de=>{try{await this.isValidVersion(de,V?"any":"release",!0,Z,K)&&ne.push(de)}catch{}}));const oe=[],ue=new Set;for(const de of x(ne,K))ue.has(de.version)||(ue.add(de.version),oe.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:M(de)}));return oe}async getAsset(N,V={},K=t.CancellationToken.None){const ee=await this.commonHeadersPromise,ae={type:"GET"},Z={...ee,...V.headers||{}};V={...V,...ae,headers:Z};const ne=N.uri,oe=N.fallbackUri,ue={...V,url:ne};try{const de=await this.requestService.request(ue,K);if(de.res.statusCode===200)return de;const ve=await(0,u.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ve}`)}catch(de){if((0,R.isCancellationError)(de))throw de;const ve=(0,R.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ne,message:ve});const we={...V,url:oe};return this.requestService.request(we,K)}}async getEngine(N){let V=k(N);if(!V){const K=await this.getManifestFromRawExtensionVersion(N,t.CancellationToken.None);if(!K)throw new Error("Manifest was not found");V=K.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,u.asJson)(N),K=[],ee={};if(V){for(const ae of V.malicious)K.push({id:ae});if(V.migrateToPreRelease)for(const[ae,Z]of Object.entries(V.migrateToPreRelease))(!Z.engine||(0,m.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(ee[ae.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(V.deprecated)for(const[ae,Z]of Object.entries(V.deprecated))Z&&(ee[ae.toLowerCase()]=(0,P.isBoolean)(Z)?{}:Z)}return{malicious:K,deprecated:ee}}};se=pe([Y(1,u.IRequestService),Y(2,p.ILogService),Y(3,C.IEnvironmentService),Y(4,d.ITelemetryService),Y(5,f.IFileService),Y(6,y.IProductService),Y(7,E.IConfigurationService)],se);let j=class extends se{constructor(N,V,K,ee,ae,Z,ne,oe){super(N,V,K,ee,ae,Z,ne,oe)}};j=pe([Y(0,c.IStorageService),Y(1,u.IRequestService),Y(2,p.ILogService),Y(3,C.IEnvironmentService),Y(4,d.ITelemetryService),Y(5,f.IFileService),Y(6,y.IProductService),Y(7,E.IConfigurationService)],j),e.ExtensionGalleryService=j;let H=class extends se{constructor(N,V,K,ee,ae,Z,ne){super(void 0,N,V,K,ee,ae,Z,ne)}};H=pe([Y(0,u.IRequestService),Y(1,p.ILogService),Y(2,C.IEnvironmentService),Y(3,d.ITelemetryService),Y(4,f.IFileService),Y(5,y.IProductService),Y(6,E.IConfigurationService)],H),e.ExtensionGalleryServiceWithNoStorageService=H}),define(ie[78],re([0,1,4,3,2,21,33,25,18,8,15]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=class Xe extends R.Disposable{static toKey(f){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const p=b.exec(f);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(f,p){const y=await f.getInstalled(),u=[];for(const[g,c]of Xe.readAllExtensionsWithKeysForSync(p)){const d=y.find(l=>(0,L.areSameExtensions)(l.identifier,{id:g}))?.manifest.version;for(const l of c)d!==l&&u.push(Xe.toKey({id:g,version:l}))}for(const g of u)p.remove(g,0)}static readAllExtensionsWithKeysForSync(f){const p=new Map,y=f.keys(0,1);for(const u of y){const g=Xe.fromKey(u);if(g){let c=p.get(g.id.toLowerCase());c||p.set(g.id.toLowerCase(),c=[]),c.push(g.version)}}return p}constructor(f,p,y){super(),this.storageService=f,this.productService=p,this.logService=y,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Xe.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const p=Xe.fromKey(f.key);if(p){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(p.id.toLowerCase());else{let y=this.extensionsWithKeysForSync.get(p.id.toLowerCase());y||this.extensionsWithKeysForSync.set(p.id.toLowerCase(),y=[]),y.push(p.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,C.isString)(f))return f;const p=f.manifest?f.manifest.publisher:f.publisher,y=f.manifest?f.manifest.name:f.name;return(0,L.getExtensionId)(p,y)}getExtensionState(f,p){const y=this.getExtensionId(f),u=this.storageService.get(y,p?0:1);if(u)try{return JSON.parse(u)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${p}): ${g}`)}}setExtensionState(f,p,y){const u=this.getExtensionId(f);p===void 0?this.storageService.remove(u,y?0:1):this.storageService.store(u,JSON.stringify(p),y?0:1,1)}setKeysForSync(f,p){this.storageService.store(Xe.toKey(f),JSON.stringify(p),0,1)}getKeysForSync(f){const p=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],y=this.storageService.get(Xe.toKey(f),0),u=y?JSON.parse(y):void 0;return u&&p?(0,I.distinct)([...u,...p]):u||p}addToMigrationList(f,p){if(f!==p){const y=this.migrationList.filter(u=>!u.includes(f)&&!u.includes(p));y.push([f,p]),this.migrationList=y}}getSourceExtensionToMigrate(f){const p=this.migrationList.find(([,y])=>f===y);return p?p[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(f);if(Array.isArray(p))return p}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};v=pe([Y(0,T.IStorageService),Y(1,P.IProductService),Y(2,E.ILogService)],v),e.ExtensionStorageService=v}),define(ie[258],re([0,1,18,6,3,12,5,36,7,152,13,29,33,217,98,14,8,59,25,45,21,23]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends m.ExtensionTipsService{constructor(s,h,a,S,w,A,q,U,O,$){super(q,U,O,$),this.environmentService=s,this.telemetryService=h,this.extensionManagementService=a,this.storageService=S,this.nativeHostService=w,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&Object.entries(U.exeBasedExtensionTips).forEach(([k,M])=>{const F=[],G=[],W=[];Object.entries(M.recommendations).forEach(([B,z])=>{z.important?M.important?F.push({extensionId:B,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):G.push({extensionId:B,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):W.push({extensionId:B,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),F.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:F}),G.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:G}),W.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:W})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),h=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...h]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),h=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(h,a)}groupImportantTipsByExe(s,h){const a=new Map;s.forEach(U=>a.set(U.extensionId.toLowerCase(),U));const{installed:S,uninstalled:w}=this.groupByInstalled([...a.keys()],h);for(const U of S){const O=a.get(U);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:O.exeName})}for(const U of w){const O=a.get(U);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:O.exeName})}const A=this.getPromptedExecutableTips(),q=new Map;for(const U of w){const O=a.get(U);if(O&&(!A[O.exeName]||!A[O.exeName].includes(O.extensionId))){let $=q.get(O.exeName);$||($=[],q.set(O.exeName,$)),$.push(O)}}return q}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,h]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(h).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(h[0].exeName,h);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const S=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(S(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const S=this._register((0,t.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),h=Date.now()-s,a=7*24*60*60*1e3;if(h<a){const A=this._register((0,t.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},a-h));return}const[S,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(S),this.addToRecommendedExecutables(w[0].exeName,w);const q=this._register((0,t.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(S),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const q=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(q(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const q=this._register((0,t.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const h=await this.extensionManagementService.getInstalled(1),a=s.filter(w=>!w.whenNotInstalled||w.whenNotInstalled.every(A=>h.every(q=>!(0,v.areSameExtensions)(q.identifier,{id:A})))).map(({extensionId:w})=>w.toLowerCase()),S=(0,E.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,S,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(r,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(r,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(s,h){const a=this.getPromptedExecutableTips();a[s]=h.map(({extensionId:S})=>S.toLowerCase()),this.storageService.store(i,JSON.stringify(a),-1,0)}groupByInstalled(s,h){const a=[],S=[],w=h.reduce((A,q)=>(A.add(q.identifier.id.toLowerCase()),A),new Set);return s.forEach(A=>{w.has(A.toLowerCase())?a.push(A):S.push(A)}),{installed:a,uninstalled:S}}async getValidExecutableBasedExtensionTips(s){const h=[],a=new Map;for(const S of s.keys()){const w=s.get(S);if(!w||!(0,D.isNonEmptyArray)(w.recommendations))continue;const A=[];L.isWindows?w.windowsPath&&A.push(w.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(A.push((0,T.join)("/usr/local/bin",S)),A.push((0,T.join)("/usr/bin",S)),A.push((0,T.join)(this.environmentService.userHome.fsPath,S)));for(const q of A){let U=a.get(q);if(U===void 0&&(U=await this.fileService.exists(I.URI.file(q)),a.set(q,U)),U)for(const{extensionId:O,extensionName:$,isExtensionPack:k,whenNotInstalled:M}of w.recommendations)h.push({extensionId:O,extensionName:$,isExtensionPack:k,exeName:S,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath,whenNotInstalled:M})}}return h}};n=pe([Y(0,C.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,b.IExtensionManagementService),Y(3,d.IStorageService),Y(4,u.INativeHostService),Y(5,f.IExtensionRecommendationNotificationService),Y(6,p.IFileService),Y(7,g.IProductService),Y(8,c.IRequestService),Y(9,y.ILogService)],n),e.ExtensionTipsService=n}),define(ie[259],re([0,1,6,2,19,69,21,74,20]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends L.AbstractStorageService{constructor(b,v,m,f){super(),this.initialWorkspace=b,this.initialProfiles=v,this.mainProcessService=m,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new t.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new t.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const b=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),v=this._register(new T.Storage(b));return this._register(v.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m))),v}createProfileStorage(b){this.profileStorageDisposables.clear(),this.profileStorageProfile=b;let v;if((0,L.isProfileUsingDefaultStorage)(b))v=this.applicationStorage;else{const m=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));v=this.profileStorageDisposables.add(new T.Storage(m))}return this.profileStorageDisposables.add(v.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),v}createWorkspaceStorage(b){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=b?.id;let v;if(b){const m=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));v=this.workspaceStorageDisposables.add(new T.Storage(m)),this.workspaceStorageDisposables.add(v.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return v}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(b,v){if(!this.canSwitchProfile(this.profileStorageProfile,b))return;const m=this.profileStorage,f=m.items;m!==this.applicationStorage&&await m.close(),this.profileStorage=this.createProfileStorage(b),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,v)}async switchToWorkspace(b,v){const m=this.workspaceStorage,f=m?.items??new Map;await m?.close(),this.workspaceStorage=this.createWorkspaceStorage(b),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,v)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.profileStorageProfile.id===b.id:this.workspaceStorageId===b.id}}e.NativeStorageService=E}),define(ie[260],re([0,1,3,2,19,13,58,20]),function(Q,e,D,t,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends t.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(C,b,v){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=b.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(v.userRoamingDataHome,"profiles"),this._profiles=C.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const f=m.added.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),p=m.removed.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),y=m.updated.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme));this._profiles=m.all.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:p,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(C){this.enabled=C}isEnabled(){return this.enabled}async createNamedProfile(C,b,v){const m=await this.channel.call("createNamedProfile",[C,b,v]);return(0,P.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(C,b,v,m){const f=await this.channel.call("createProfile",[C,b,v,m]);return(0,P.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(C){const b=await this.channel.call("createTransientProfile",[C]);return(0,P.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(C,b){await this.channel.call("setProfileForWorkspace",[C,b])}removeProfile(C){return this.channel.call("removeProfile",[C])}async updateProfile(C,b){const v=await this.channel.call("updateProfile",[C,b]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};I=pe([Y(1,L.IMainProcessService),Y(2,T.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(ie[41],re([0,1,18,6,17,24,3,35,2,27,15,7,168,16,13,14,8,50,21,23,31,26,20]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=void 0;function r(S){return!!(S&&S.version!==void 0&&typeof S.version=="number"&&S.content!==void 0&&typeof S.content=="string"&&(Object.keys(S).length===2||Object.keys(S).length===3&&S.machineId!==void 0&&typeof S.machineId=="string"))}e.isSyncData=r;function n(S,w){return`${(0,E.uppercaseFirstLetter)(S)}${w.isDefault?"":` (${w.name})`}`}e.getSyncResourceLogLabel=n;let o=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(w,A,q,U,O,$,k,M,F,G,W,B){super(),this.syncResource=w,this.collection=A,this.fileService=q,this.environmentService=U,this.userDataSyncStoreService=$,this.userDataSyncBackupStoreService=k,this.userDataSyncEnablementService=M,this.telemetryService=F,this.logService=G,this.configurationService=W,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(w.syncResource,w.profile),this.extUri=B.extUri,this.syncFolder=this.extUri.joinPath(U.userDataSyncHome,...(0,l.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,U,this.extUri),this.currentMachineIdPromise=(0,u.getServiceMachineId)(U,q,O)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const w=await this.syncPreviewPromise;this.syncPreviewPromise=null;const A=await this.performSync(w.remoteUserData,w.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(A)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.hasRemoteChanged(w):!0)&&this._onDidChangeLocal.fire()}}setStatus(w){this._status!==w&&(this._status=w,this._onDidChangStatus.fire(w))}async sync(w,A={}){await this._sync(w,!0,this.getUserDataSyncConfiguration(),A)}async preview(w,A,q={}){return this._sync(w,!1,A,q)}async apply(w,A={}){try{this.syncHeaders={...A};const q=await this.doApply(w);return this.setStatus(q),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(w,A,q,U){try{if(this.syncHeaders={...U},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const $=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(w,$);return O=await this.performSync(k,$,A,q),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(w){const A=await this.resolveContent(w);if(!A)return!1;const q=this.parseSyncData(A);if(!q)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const U=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,U),$=await this.isRemoteDataFromCurrentMachine(O),k=await this.generateSyncPreview({ref:O.ref,syncData:q},U,$,this.getUserDataSyncConfiguration(),T.CancellationToken.None),M=[];for(const F of k){const G=await this.getAcceptResult(F,F.remoteResource,void 0,T.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,T.CancellationToken.None);M.push([F,{...G,remoteChange:W!==0?W:2}])}await this.applyResult(O,U,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(w){const A=await this.currentMachineIdPromise;return!!w.syncData?.machineId&&w.syncData.machineId===A}async getLatestRemoteUserData(w,A){if(A){const q=w?w[this.resource]:void 0;if(A.ref===q||q===void 0&&A.syncData===null)return A}return this.getRemoteUserData(A)}async performSync(w,A,q,U){if(w.syncData&&w.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(w,A,q,U)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(w,A,q,U);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),A=await this.getLastSyncUserData(),this.performSync(w,A,q,U)}throw O}}async doSync(w,A,q,U){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)($=>this.doGenerateSyncResourcePreview(w,A,q,U,$)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":q?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(w){return await this.updateSyncResourcePreview(w,async A=>{const q=await this.getMergeResult(A,T.CancellationToken.None);await this.fileService.writeFile(A.previewResource,R.VSBuffer.fromString(q?.content||""));const U=q&&!q.hasConflicts?await this.getAcceptResult(A,A.previewResource,void 0,T.CancellationToken.None):void 0;return A.acceptResult=U,A.mergeState=q.hasConflicts?"conflict":U?"accepted":"preview",A.localChange=U?U.localChange:q.localChange,A.remoteChange=U?U.remoteChange:q.remoteChange,A}),this.syncPreviewPromise}async accept(w,A){return await this.updateSyncResourcePreview(w,async q=>{const U=await this.getAcceptResult(q,w,A,T.CancellationToken.None);return q.acceptResult=U,q.mergeState="accepted",q.localChange=U.localChange,q.remoteChange=U.remoteChange,q}),this.syncPreviewPromise}async discard(w){return await this.updateSyncResourcePreview(w,async A=>{const q=await this.getMergeResult(A,T.CancellationToken.None);return await this.fileService.writeFile(A.previewResource,R.VSBuffer.fromString(q.content||"")),A.acceptResult=void 0,A.mergeState="preview",A.localChange=q.localChange,A.remoteChange=q.remoteChange,A}),this.syncPreviewPromise}async updateSyncResourcePreview(w,A){if(!this.syncPreviewPromise)return;let q=await this.syncPreviewPromise;const U=q.resourcePreviews.findIndex(({localResource:O,remoteResource:$,previewResource:k})=>this.extUri.isEqual(O,w)||this.extUri.isEqual($,w)||this.extUri.isEqual(k,w));U!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async O=>{const $=[...q.resourcePreviews];return $[U]=await A($[U]),{...q,resourcePreviews:$}}),q=await this.syncPreviewPromise,this.updateConflicts(q.resourcePreviews),q.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(w){if(!this.syncPreviewPromise)return"idle";const A=await this.syncPreviewPromise;return A.resourcePreviews.some(({mergeState:q})=>q==="conflict")?"hasConflicts":A.resourcePreviews.some(({mergeState:q})=>q!=="accepted")?"syncing":(await this.applyResult(A.remoteUserData,A.lastSyncUserData,A.resourcePreviews.map(q=>[q,q.acceptResult]),w),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(w){const A=w.filter(({mergeState:q})=>q==="conflict");(0,D.equals)(this._conflicts,A,(q,U)=>this.extUri.isEqual(q.previewResource,U.previewResource))||(this._conflicts=A,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:A,ref:q})=>({created:A,uri:this.toRemoteBackupResource(q)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:A,ref:q})=>({created:A,uri:this.toLocalBackupResource(q)}))}toRemoteBackupResource(w){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${w}`})}toLocalBackupResource(w){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${w}`})}async getMachineId({uri:w}){const A=this.extUri.basename(w);if(this.extUri.isEqual(w,this.toRemoteBackupResource(A))){const{content:q}=await this.getUserData(A);if(q)return this.parseSyncData(q)?.machineId}}async resolveContent(w){const A=this.extUri.basename(w);if(this.extUri.isEqual(w,this.toRemoteBackupResource(A))){const{content:q}=await this.getUserData(A);return q}return this.extUri.isEqual(w,this.toLocalBackupResource(A))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,A):null}async resolvePreviewContent(w){const A=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(A)for(const q of A.resourcePreviews){if(this.extUri.isEqual(q.acceptedResource,w))return q.acceptResult?q.acceptResult.content:null;if(this.extUri.isEqual(q.remoteResource,w))return q.remoteContent;if(this.extUri.isEqual(q.localResource,w))return q.localContent;if(this.extUri.isEqual(q.baseResource,w))return q.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(w,A,q,U,O){const $=await this.isRemoteDataFromCurrentMachine(w),k=await this.generateSyncPreview(w,A,$,U,O),M=[];for(const F of k){const G=F.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)M.push({...F,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=q?await this.getMergeResult(F,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,R.VSBuffer.fromString(W?.content||""));const B=W&&!W.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,O):void 0;M.push({...F,acceptResult:B,mergeState:W?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:W?W.localChange:F.localChange,remoteChange:B?B.remoteChange:W?W.remoteChange:F.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:A,resourcePreviews:M,isLastSyncFromCurrentMachine:$}}async getLastSyncUserData(){try{const w=await this.fileService.readFile(this.lastSyncResource),A=JSON.parse(w.value.toString()),q=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=A.version&&q&&A.version!==q,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${A.version} is not compatible with current sync state version ${q}.`),await this.resetLocal(),null;const U=A;if(U.content===null)return{ref:A.ref,syncData:null};const O=JSON.parse(U.content);if(r(O))return{...A,syncData:O,content:void 0}}catch(w){w instanceof p.FileOperationError&&w.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(w)}return null}async updateLastSyncUserData(w,A={}){if(A.ref||A.content||A.version)throw new Error("Cannot have core properties as additional");const q=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),U={ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null,version:q,...A};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(U)))}async getRemoteUserData(w){const{ref:A,content:q}=await this.getUserData(w);let U=null;return q!==null&&(U=this.parseSyncData(q)),{ref:A,syncData:U}}parseSyncData(w){try{const A=JSON.parse(w);if(r(A))return A}catch(A){this.logService.error(A)}throw new l.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(w){if((0,C.isString)(w)){const A=await this.userDataSyncStoreService.resolveResourceContent(this.resource,w,this.collection);return{ref:w,content:A}}else{const A=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,A,this.collection,this.syncHeaders)}}async updateRemoteUserData(w,A){const q=await this.currentMachineIdPromise,U={version:this.version,machineId:q,content:w};try{return A=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(U),A,this.collection,this.syncHeaders),{ref:A,syncData:U}}catch(O){throw O instanceof l.UserDataSyncError&&O.code==="TooLarge"&&(O=new l.UserDataSyncError(O.message,O.code,this.resource)),O}}async backupLocal(w){const A={version:this.version,content:w};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(A))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};o=pe([Y(2,p.IFileService),Y(3,f.IEnvironmentService),Y(4,g.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,c.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,d.IUriIdentityService)],o),e.AbstractSynchroniser=o;let s=class extends o{constructor(w,A,q,U,O,$,k,M,F,G,W,B,z){super(A,q,U,O,$,k,M,F,G,W,B,z),this.file=w,this._register(this.fileService.watch(this.extUri.dirname(w))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(w,A,q){try{A?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(w),q?void 0:A):await this.fileService.createFile(this.file,R.VSBuffer.fromString(w),{overwrite:q})}catch(U){throw U instanceof p.FileOperationError&&U.fileOperationResult===1||U instanceof p.FileOperationError&&U.fileOperationResult===3?new l.UserDataSyncError(U.message,"LocalPreconditionFailed"):U}}onFileChanges(w){!w.contains(this.file)||this.triggerLocalChange()}};s=pe([Y(3,p.IFileService),Y(4,f.IEnvironmentService),Y(5,g.IStorageService),Y(6,l.IUserDataSyncStoreService),Y(7,l.IUserDataSyncBackupStoreService),Y(8,l.IUserDataSyncEnablementService),Y(9,c.ITelemetryService),Y(10,l.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,d.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let h=class extends s{constructor(w,A,q,U,O,$,k,M,F,G,W,B,z,x){super(w,A,q,U,O,$,k,M,F,G,W,z,x),this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(w,A){const q=[],U=(0,P.parse)(w,q,{allowEmptyContent:!0,allowTrailingComma:!0});return q.length>0||!(0,C.isUndefined)(U)&&A!==Array.isArray(U)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};h=pe([Y(3,p.IFileService),Y(4,f.IEnvironmentService),Y(5,g.IStorageService),Y(6,l.IUserDataSyncStoreService),Y(7,l.IUserDataSyncBackupStoreService),Y(8,l.IUserDataSyncEnablementService),Y(9,c.ITelemetryService),Y(10,l.IUserDataSyncLogService),Y(11,l.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,d.IUriIdentityService)],h),e.AbstractJsonFileSynchroniser=h;let a=class{constructor(w,A,q,U,O,$){this.resource=w,this.userDataProfilesService=A,this.environmentService=q,this.logService=U,this.fileService=O,this.extUri=$.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(void 0,this.resource,q,this.extUri)}async initialize({ref:w,content:A}){if(!A){this.logService.info("Remote content does not exist.",this.resource);return}const q=this.parseSyncData(A);if(!!q)try{await this.doInitialize({ref:w,syncData:q})}catch(U){this.logService.error(U)}}parseSyncData(w){try{const A=JSON.parse(w);if(r(A))return A}catch(A){this.logService.error(A)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(w,A={}){const q={ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null,...A};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(q)))}};a=pe([Y(1,i.IUserDataProfilesService),Y(2,f.IEnvironmentService),Y(3,y.ILogService),Y(4,p.IFileService),Y(5,d.IUriIdentityService)],a),e.AbstractInitializer=a}),define(ie[261],re([0,1,18,17,3,35,5,15,169,16,13,14,21,23,31,20,41,245,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(i,r,n){try{const o=JSON.parse(i);if(!r)return(0,P.isUndefined)(o.all)?null:o.all;switch(L.OS){case 2:return(0,P.isUndefined)(o.mac)?null:o.mac;case 3:return(0,P.isUndefined)(o.linux)?null:o.linux;case 1:return(0,P.isUndefined)(o.windows)?null:o.windows}}catch(o){return n.error(o),null}}e.getKeybindingsContentFromSyncContent=c;let d=class extends y.AbstractJsonFileSynchroniser{constructor(r,n,o,s,h,a,S,w,A,q,U,O,$){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,w,A,q,o,s,S,O,h,U,a,$),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(a.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,n,o,s){const h=r.syncData?c(r.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&o?r:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,S=await this.getLocalFileContent(),w=await this.getFormattingOptions();let A=null,q=!1,U=!1,O=!1;if(h){let M=S?S.value.toString():"[]";if(M=M||"[]",this.hasErrors(M,!0))throw new g.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==M||a!==h){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,u.merge)(M,h,a,w,this.userDataSyncUtilService);F.hasChanges&&(A=F.mergeContent,O=F.hasConflicts,q=O||F.mergeContent!==M,U=O||F.mergeContent!==h)}}else S&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=S.value.toString(),U=!0);const $={content:O?a:A,localChange:q?S?2:1:0,remoteChange:U?2:0,hasConflicts:O},k=S?S.value.toString():null;return[{fileContent:S,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:k,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:h,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const n=this.getKeybindingsContentFromLastSyncUserData(r);if(n===null)return!0;const o=await this.getLocalFileContent(),s=o?o.value.toString():"",h=await this.getFormattingOptions(),a=await(0,u.merge)(s||"[]",n,n,h,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(r,n){return r.previewResult}async getAcceptResult(r,n,o,s){if(this.extUri.isEqual(n,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(r,n,o,s){const{fileContent:h}=o[0][0];let{content:a,localChange:S,remoteChange:w}=o[0][1];if(S===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new g.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(S!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),h&&await this.backupLocal(this.toSyncContent(h.value.toString())),await this.updateLocalFileContent(a||"[]",h,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),w!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(A,s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const n=(0,T.parse)(r.value.toString());if((0,D.isNonEmptyArray)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:n}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let n=await super.resolveContent(r);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(r)),n){const o=this.parseSyncData(n);if(o)switch(this.extUri.basename(r)){case"keybindings.json":return c(o.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,n){let o={};try{o=JSON.parse(n||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete o.all:o.all=r,L.OS){case 2:o.mac=r;break;case 3:o.linux=r;break;case 1:o.windows=r;break}return JSON.stringify(o)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=pe([Y(2,g.IUserDataSyncStoreService),Y(3,g.IUserDataSyncBackupStoreService),Y(4,g.IUserDataSyncLogService),Y(5,E.IConfigurationService),Y(6,g.IUserDataSyncEnablementService),Y(7,b.IFileService),Y(8,C.IEnvironmentService),Y(9,v.IStorageService),Y(10,g.IUserDataSyncUtilService),Y(11,m.ITelemetryService),Y(12,f.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let l=class extends y.AbstractInitializer{constructor(r,n,o,s,h){super("keybindings",n,o,s,r,h)}async doInitialize(r){const n=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,t.VSBuffer.fromString(n)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,T.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(n)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return c(r,!0,this.logService)}catch(n){return this.logService.error(n),null}}};l=pe([Y(0,b.IFileService),Y(1,p.IUserDataProfilesService),Y(2,C.IEnvironmentService),Y(3,g.IUserDataSyncLogService),Y(4,f.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ie[262],re([0,1,17,3,170,16,73,13,29,14,21,23,31,20,41,61,249,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function c(i){const r=JSON.parse(i);return g(r)?r:{settings:i}}e.parseSettingsSyncContent=c;let d=class extends f.AbstractJsonFileSynchroniser{constructor(r,n,o,s,h,a,S,w,A,q,U,O,$,k){super(r.settingsResource,{syncResource:"settings",profile:r},n,o,s,h,a,S,U,O,w,A,q,k),this.extensionManagementService=$,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const n=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(r,n),s=this.getSettingsSyncContent(o),h=new L.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&h.parse(s.settings),h.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,n,o){const s=await this.getLocalFileContent(),h=await this.getFormattingOptions(),a=this.getSettingsSyncContent(r);n=n===null&&o?r:n;const S=n?this.getSettingsSyncContent(n):null,w=await this.getIgnoredSettings();let A=null,q=!1,U=!1,O=!1;if(a){let F=s?s.value.toString().trim():"{}";F=F||"{}",this.validateContent(F),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const G=(0,y.merge)(F,a.settings,S?S.settings:null,w,[],h);A=G.localContent||G.remoteContent,q=G.localContent!==null,U=G.remoteContent!==null,O=G.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=s.value.toString().trim()||"{}",this.validateContent(A),U=!0);const $=s?s.value.toString():null,k=S?.settings??null,M={content:O?k:A,localChange:q?2:0,remoteChange:U?2:0,hasConflicts:O};return[{fileContent:s,baseResource:this.baseResource,baseContent:k,localResource:this.localResource,localContent:$,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const n=this.getSettingsSyncContent(r);if(n===null)return!0;const o=await this.getLocalFileContent(),s=o?o.value.toString().trim():"",h=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,y.merge)(s||"{}",n.settings,n.settings,h,[],a).remoteContent!==null}async getMergeResult(r,n){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,y.updateIgnoredSettings)(r.previewResult.content,"{}",s,o):null}}async getAcceptResult(r,n,o,s){const h=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:r.fileContent?(0,y.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,h):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:r.remoteContent!==null?(0,y.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,h):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o!==null?(0,y.updateIgnoredSettings)(o,r.fileContent?r.fileContent.value.toString():"{}",a,h):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(r,n,o,s){const{fileContent:h}=o[0][0];let{content:a,localChange:S,remoteChange:w}=o[0][1];if(S===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),S!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),h&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(h.value.toString()))),await this.updateLocalFileContent(a,h,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const A=await this.getFormattingOptions(),q=this.getSettingsSyncContent(r),U=await this.getIgnoredSettings(a);a=(0,y.updateIgnoredSettings)(a,q?q.settings:"{}",U,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const n=await this.getFormattingOptions(),o=(0,p.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,y.isEmpty)(o)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:n}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r))return this.resolvePreviewContent(r);let n=await super.resolveContent(r);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(r)),n){const o=this.parseSyncData(n);if(o){const s=this.parseSettingsSyncContent(o.content);if(s)switch(this.extUri.basename(r)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(r){let n=await super.resolvePreviewContent(r);if(n){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();n=(0,y.updateIgnoredSettings)(n,"{}",s,o)}return n}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return c(r)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:h})=>!!h)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(n,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new u.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};d=pe([Y(2,E.IFileService),Y(3,P.IEnvironmentService),Y(4,C.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncLogService),Y(8,u.IUserDataSyncUtilService),Y(9,T.IConfigurationService),Y(10,u.IUserDataSyncEnablementService),Y(11,b.ITelemetryService),Y(12,I.IExtensionManagementService),Y(13,v.IUriIdentityService)],d),e.SettingsSynchroniser=d;let l=class extends f.AbstractInitializer{constructor(r,n,o,s,h){super("settings",n,o,s,r,h)}async doInitialize(r){const n=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return c(r)}catch(n){this.logService.error(n)}return null}};l=pe([Y(0,E.IFileService),Y(1,m.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,v.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ie[263],re([0,1,17,3,32,16,13,14,21,23,31,20,41,246,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let p=class extends v.AbstractSynchroniser{constructor(g,c,d,l,i,r,n,o,s,h,a,S){super({syncResource:"snippets",profile:g},c,l,d,i,r,n,h,a,o,s,S),this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,w=>w.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,c,d){const l=await this.getSnippetsFileContents(),i=this.toSnippetsContents(l),r=g.syncData?this.parseSnippets(g.syncData):null;c=c===null&&d?g:c;const n=c&&c.syncData?this.parseSnippets(c.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const o=(0,m.merge)(i,r,n);return this.getResourcePreviews(o,l,r||{},n||{})}async hasRemoteChanged(g){const c=g.syncData?this.parseSnippets(g.syncData):null;if(c===null)return!0;const d=await this.getSnippetsFileContents(),l=this.toSnippetsContents(d),i=(0,m.merge)(l,c,c);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(g,c){return g.previewResult}async getAcceptResult(g,c,d,l){if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder))return d===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:d,localChange:d===null?g.fileContent!==null?3:0:2,remoteChange:d===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(g,c,d,l){const i=d.map(([r,n])=>({...r,acceptResult:n}));i.every(({localChange:r,remoteChange:n})=>r===0&&n===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,l)),i.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(i,g,l)),c?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of i)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,c,d,l){const i=new Map;for(const r of Object.keys(g.local.added)){const n={content:g.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.local.updated)){const n={content:g.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0},o=c[r]?c[r].value.toString():null;i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},o=c[r]?c[r].value.toString():null;i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.added)){const n={content:g.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1},o=c[r]?c[r].value.toString():null;i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.updated)){const n={content:g.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2},o=c[r]?c[r].value.toString():null;i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.conflicts){const n={content:l[r]??null,hasConflicts:!0,localChange:c[r]?2:1,remoteChange:d[r]?2:1},o=c[r]?c[r].value.toString():null;i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r]||null,localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(c))if(!i.has(r)){const n={content:c[r]?c[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},o=c[r]?c[r].value.toString():null;i.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r]||null,localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:g}){const c=await super.resolveContent(g);if(c){const d=this.parseSyncData(c);if(d){const l=this.parseSnippets(d),i=[];for(const r of Object.keys(l)){const n=this.extUri.joinPath(g,r),o=this.extUri.joinPath(this.snippetsFolder,r),s=await this.fileService.exists(o);i.push({resource:n,comparableResource:s?o:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let c=await super.resolveContent(g);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(g)),c){const d=this.parseSyncData(c);if(d)return this.parseSnippets(d)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const c={};for(const d of g)d.fileContent&&(c[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(c)))}async updateLocalSnippets(g,c){for(const{fileContent:d,acceptResult:l,localResource:i,remoteResource:r,localChange:n}of g)if(n!==0){const o=r?this.extUri.basename(r):this.extUri.basename(i),s=this.extUri.joinPath(this.snippetsFolder,o);n===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):n===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,D.VSBuffer.fromString(l.content),{overwrite:c}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,D.VSBuffer.fromString(l.content),c?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(g,c,d){const l=c.syncData?this.parseSnippets(c.syncData):{},i=(0,R.deepClone)(l);for(const{acceptResult:r,localResource:n,remoteResource:o,remoteChange:s}of g)if(s!==0){const h=n?this.extUri.basename(n):this.extUri.basename(o);s===3?delete i[h]:i[h]=r.content}return(0,m.areSame)(l,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),c=await this.updateRemoteUserData(JSON.stringify(i),d?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),c}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const c={};for(const d of Object.keys(g))c[d]=g[d].value.toString();return c}async getSnippetsFileContents(){const g={};let c;try{c=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof P.FileOperationError&&d.fileOperationResult===1)return g;throw d}for(const d of c.children||[]){const l=d.resource,i=this.extUri.extname(l);if(i===".json"||i===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,l),n=await this.fileService.readFile(l);g[r]=n}}return g}};p=pe([Y(2,L.IEnvironmentService),Y(3,P.IFileService),Y(4,I.IStorageService),Y(5,f.IUserDataSyncStoreService),Y(6,f.IUserDataSyncBackupStoreService),Y(7,f.IUserDataSyncLogService),Y(8,T.IConfigurationService),Y(9,f.IUserDataSyncEnablementService),Y(10,E.ITelemetryService),Y(11,C.IUriIdentityService)],p),e.SnippetsSynchroniser=p;let y=class extends v.AbstractInitializer{constructor(g,c,d,l,i){super("snippets",c,d,l,g,i)}async doInitialize(g){const c=g.syncData?JSON.parse(g.syncData.content):null;if(!c){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(c)){const i=c[l];if(i){const r=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,l);await this.fileService.createFile(r,D.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};y=pe([Y(0,P.IFileService),Y(1,b.IUserDataProfilesService),Y(2,L.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,C.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(ie[264],re([0,1,17,16,13,14,21,23,31,20,41,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(y,u){try{return JSON.parse(y).tasks}catch(g){return u.error(g),null}}e.getTasksContentFromSyncContent=v;let m=class extends C.AbstractFileSynchroniser{constructor(u,g,c,d,l,i,r,n,o,s,h,a){super(u.tasksResource,{syncResource:"tasks",profile:u},g,n,o,s,c,d,r,h,l,i,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,g,c,d){const l=u.syncData?v(u.syncData.content,this.logService):null;g=g===null&&c?u:g;const i=g?.syncData?v(g.syncData.content,this.logService):null,r=await this.getLocalFileContent();let n=null,o=!1,s=!1,h=!1;if(l){const w=r?r.value.toString():null;if(!i||i!==w||i!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=p(w,l,i);n=A.content,h=A.hasConflicts,o=A.hasLocalChanged,s=A.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),s=!0);const a={content:h?i:n,localChange:o?r?2:1:0,remoteChange:s?2:0,hasConflicts:h},S=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:S,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const g=u?.syncData?v(u.syncData.content,this.logService):null;if(g===null)return!0;const c=await this.getLocalFileContent(),d=c?c.value.toString():null,l=p(d,g,g);return l.hasLocalChanged||l.hasRemoteChanged}async getMergeResult(u,g){return u.previewResult}async getAcceptResult(u,g,c,d){if(this.extUri.isEqual(g,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return c===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(u,g,c,d){const{fileContent:l}=c[0][0],{content:i,localChange:r,remoteChange:n}=c[0][1];if(r===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),l&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(l.value.toString()))),await this.updateLocalFileContent(i||"{}",l,d),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const o=JSON.stringify(this.toTasksSyncContent(i||"{}"));u=await this.updateRemoteUserData(o,d?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:u}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(u,"tasks.json"),comparableResource:g}]}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let g=await super.resolveContent(u);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(u)),g){const c=this.parseSyncData(g);if(c)switch(this.extUri.basename(u)){case"tasks.json":return v(c.content,this.logService)}}return null}toTasksSyncContent(u){return{tasks:u}}};m=pe([Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncBackupStoreService),Y(4,b.IUserDataSyncLogService),Y(5,t.IConfigurationService),Y(6,b.IUserDataSyncEnablementService),Y(7,T.IFileService),Y(8,R.IEnvironmentService),Y(9,L.IStorageService),Y(10,P.ITelemetryService),Y(11,I.IUriIdentityService)],m),e.TasksSynchroniser=m;let f=class extends C.AbstractInitializer{constructor(u,g,c,d,l){super("tasks",g,c,d,u,l),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const g=u.syncData?v(u.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(g)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=pe([Y(0,T.IFileService),Y(1,E.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,b.IUserDataSyncLogService),Y(4,I.IUriIdentityService)],f),e.TasksInitializer=f;function p(y,u,g){if(y===null&&u===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=g!==y,d=g!==u;return!c&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!d?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!c?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ie[265],re([0,1,46,7,16,13,14,21,23,31,20,41,247,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let f=class vt extends b.AbstractSynchroniser{constructor(u,g,c,d,l,i,r,n,o,s,h,a,S){super({syncResource:"profiles",profile:u},g,d,l,i,r,n,h,a,o,s,S),this.userDataProfilesService=c,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const g=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(u,g);return c?.syncData?p(c.syncData):null}async generateSyncPreview(u,g,c){const d=u.syncData?p(u.syncData):null,l=g?.syncData?p(g.syncData):null,i=this.getLocalUserDataProfiles(),{local:r,remote:n}=(0,v.merge)(i,d,l,[]),o={local:r,remote:n,content:l?this.stringifyRemoteProfiles(l):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},s=this.stringifyLocalProfiles(i,!1);return[{baseResource:this.baseResource,baseContent:l?this.stringifyRemoteProfiles(l):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:d?this.stringifyRemoteProfiles(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const g=u?.syncData?p(u.syncData):null,c=this.getLocalUserDataProfiles(),{remote:d}=(0,v.merge)(c,g,g,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async getMergeResult(u,g){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,g,c,d){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(g,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(u){const g=this.getLocalUserDataProfiles(),c=(0,v.merge)(g,null,null,[]),{local:d,remote:l}=c;return{content:u.localContent,local:d,remote:l,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:l!==null?2:0}}async acceptRemote(u){const g=u.remoteContent?JSON.parse(u.remoteContent):null,c=[],d=[];for(const l of this.getLocalUserDataProfiles()){const i=g?.find(r=>r.id===l.id);i&&(c.push({id:l.id,name:l.name,collection:i.collection}),d.push(l))}if(g!==null){const l=(0,v.merge)(d,g,c,[]),{local:i,remote:r}=l;return{content:u.remoteContent,local:i,remote:r,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,g,c,d){const{local:l,remote:i,localChange:r,remoteChange:n}=c[0][1];if(r===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),r!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const o=[];for(const s of l.added)o.push(this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}));for(const s of l.removed)o.push(this.userDataProfilesService.removeProfile(s));for(const s of l.updated){const h=this.userDataProfilesService.profiles.find(a=>a.id===s.id);h?o.push(this.userDataProfilesService.updateProfile(h,{name:s.name,shortName:s.shortName})):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(o)}if(n!==0){const o=c[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of i?.added||[]){const h=await this.userDataSyncStoreService.createCollection(this.syncHeaders);o.push({id:s.id,name:s.name,collection:h,shortName:s.shortName})}for(const s of i?.removed||[])o.splice(o.findIndex(({id:h})=>s.id===h),1);for(const s of i?.updated||[]){const h=o.find(({id:a})=>s.id===a);h&&o.splice(o.indexOf(h),1,{id:s.id,name:s.name,collection:h.collection,shortName:s.shortName})}u=await this.updateRemoteUserData(this.stringifyRemoteProfiles(o),d?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${i?.added.length?` Added: ${JSON.stringify(i.added.map(s=>s.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(s=>s.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(s=>s.name))}.`:""}`);for(const s of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}g?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"profiles.json"),comparableResource:vt.PROFILES_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,vt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const c=await this.resolvePreviewContent(u);return c&&(0,D.toFormattedString)(JSON.parse(c),{})}let g=await super.resolveContent(u);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(u)),g){const c=this.parseSyncData(g);if(c)switch(this.extUri.basename(u)){case"profiles.json":return(0,D.toFormattedString)(p(c),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((g,c)=>g.name.localeCompare(c.name)))}stringifyLocalProfiles(u,g){const c=[...u].sort((d,l)=>d.name.localeCompare(l.name)).map(d=>({id:d.id,name:d.name}));return g?(0,D.toFormattedString)(c,{}):JSON.stringify(c)}};f.PROFILES_DATA_URI=t.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),f=pe([Y(2,C.IUserDataProfilesService),Y(3,L.IFileService),Y(4,T.IEnvironmentService),Y(5,P.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncBackupStoreService),Y(8,m.IUserDataSyncLogService),Y(9,R.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,I.ITelemetryService),Y(12,E.IUriIdentityService)],f),e.UserDataProfilesManifestSynchroniser=f;function p(y){return JSON.parse(y.content)}}),define(ie[266],re([0,1,6,17,65,2,19,16,13,14,20,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let v=class extends T.Disposable{constructor(f,p,y,u,g){super(),this.environmentService=f,this.fileService=p,this.configurationService=y,this.logService=u,this.userDataProfilesService=g;for(const c of this.userDataProfilesService.profiles)for(const d of b.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(c,d))}async getAllRefs(f,p){const y=this.getResourceBackupHome(f,p),u=await this.fileService.resolve(y);return u.children?u.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)})):[]}async resolveContent(f,p,y){if(!y){const u=await this.getAllRefs(f,p);u.length&&(y=u[u.length-1].ref)}if(y){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,p,y);return(await this.fileService.readFile(u)).value.toString()}return null}async backup(f,p,y){const u=this.getResourceBackupHome(f,p),g=(0,L.joinPath)(u,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,t.VSBuffer.fromString(y))}catch(c){this.logService.error(c)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(f,p){return(0,L.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[p]:[f.id,p])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const p=await this.fileService.resolve(f);if(p.children){const y=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=y.filter(d=>Date.now()-this.getCreationTime(d)>u);const c=y.length-g.length;c<10&&(g=g.slice(10-c)),await D.Promises.settled(g.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};v=pe([Y(0,I.IEnvironmentService),Y(1,E.IFileService),Y(2,P.IConfigurationService),Y(3,b.IUserDataSyncLogService),Y(4,C.IUserDataProfilesService)],v),e.UserDataSyncBackupStoreService=v}),define(ie[267],re([0,1,3,2,5,13,21,23,26]),function(Q,e,D,t,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let C=class extends t.Disposable{constructor(v,m,f,p){super(),this.storageService=v,this.telemetryService=m,this.environmentService=f,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:v}),this.storageService.store(E,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,I.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,m){if(this.isResourceEnabled(v)!==m){const f=(0,I.getEnablementKey)(v);this.storeResourceEnablement(f,m)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,m){this.storageService.store(v,m,-1,R.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==-1)return;if(E===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const m=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===v.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}};C=pe([Y(0,L.IStorageService),Y(1,P.ITelemetryService),Y(2,T.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(ie[79],re([0,1,3,2,5,27,173,13,14,4,25,50,21,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",p="Safari",y="Chrome",u="Edge",g="Firefox",c="Android";function d(r){switch(r){case p:case y:case u:case g:case c:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function l(){return R.isSafari?p:R.isChrome?y:R.isEdge?u:R.isFirefox?g:R.isAndroid?c:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let i=class st extends t.Disposable{constructor(n,o,s,h,a,S){super(),this.storageService=s,this.userDataSyncStoreService=h,this.logService=a,this.productService=S,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(n,o,s)}async getMachines(n){const o=await this.currentMachineIdPromise;return(await this.readMachinesData(n)).machines.map(h=>({...h,isCurrent:h.id===o}))}async addCurrentMachine(n){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(n);s.machines.some(({id:h})=>h===o)||(s.machines.push({id:o,name:this.computeCurrentMachineName(s.machines),platform:l()}),await this.writeMachinesData(s))}async removeCurrentMachine(n){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(n),h=s.machines.filter(({id:a})=>a!==o);h.length!==s.machines.length&&(s.machines=h,await this.writeMachinesData(s))}async renameMachine(n,o,s){const h=await this.readMachinesData(s),a=h.machines.find(({id:S})=>S===n);if(a){a.name=o,await this.writeMachinesData(h);const S=await this.currentMachineIdPromise;n===S&&this.storageService.store(f,o,-1,1)}}async setEnablements(n){const o=await this.readMachinesData();for(const[s,h]of n){const a=o.machines.find(S=>S.id===s);a&&(a.disabled=h?void 0:!0)}await this.writeMachinesData(o)}computeCurrentMachineName(n){const o=this.storageService.get(f,-1);if(o)return o;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,h=new RegExp(`${(0,T.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const S of n){const w=h.exec(S.name),A=w?parseInt(w[1]):0;a=A>a?A:a}return`${s} #${a+1}`}async readMachinesData(n){this.userData=await this.readUserData(n);const o=this.parse(this.userData);if(o.version!==st.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return o}async writeMachinesData(n){const o=JSON.stringify(n),s=await this.userDataSyncStoreService.writeResource(st.RESOURCE,o,this.userData?.ref||null);this.userData={ref:s,content:o},this._onDidChange.fire()}async readUserData(n){if(this.userData){const o=n&&n.latest?n.latest[st.RESOURCE]:void 0;if(this.userData.ref===o)return this.userData;if(o===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(st.RESOURCE,this.userData)}parse(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(o){this.logService.error(o)}return{version:st.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([Y(0,P.IEnvironmentService),Y(1,I.IFileService),Y(2,v.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncLogService),Y(5,C.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ie[268],re([0,1,6,65,37,9,3,2,5,19,7,171,25,21,23,26,76,79]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",c="sync.sessionId",d="sync.storeUrl",l="sync.productQuality";let i=class extends P.Disposable{get syncUrl(){const o=this.storageService.get(d,-1);return o?C.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(d,o.toString(),-1,1):this.storageService.remove(d,-1)}get productQuality(){return this.storageService.get(l,-1)}set productQuality(o){o?this.storageService.store(l,o,-1,1):this.storageService.remove(l,-1)}constructor(o,s,h,a,S,w,A,q,U,O){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=h,this.userDataSyncEnablementService=a,this.userDataSyncService=S,this.logService=w,this.userDataSyncAccountService=A,this.telemetryService=q,this.userDataSyncMachinesService=U,this.storageService=O,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(h.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(S.onDidChangeLocal($=>this.triggerSync([$],!1,!1))),this._register(L.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:o,message:s}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(h=>this.onDidFinishSync(h))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,s,h){try{this.userDataSyncAccountService.account&&!h&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),s)this.updateEnablement(!1);else throw a}}updateEnablement(o){this.userDataSyncEnablementService.isEnabled()!==o&&(this.userDataSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const s=p.UserDataSyncError.toUserDataSyncError(o);s instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(o,s,h){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",h)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([Y(0,v.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncEnablementService),Y(4,p.IUserDataSyncService),Y(5,p.IUserDataSyncLogService),Y(6,y.IUserDataSyncAccountService),Y(7,f.ITelemetryService),Y(8,u.IUserDataSyncMachinesService),Y(9,m.IStorageService)],i),e.UserDataAutoSyncService=i;class r extends P.Disposable{constructor(o,s,h,a,S,w,A,q){super(),this.lastSyncUrl=o,this.interval=s,this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=a,this.userDataSyncService=S,this.userDataSyncMachinesService=w,this.logService=A,this.storageService=q,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(o,s){const h=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(S){if((0,T.isCancellationError)(S))return}return this.doSync(o,s,a)});return this.syncPromise=h,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!o&&(!(0,E.isEqual)(s.defaultUrl,o.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,o.insidersUrl)||!(0,E.isEqual)(s.stableUrl,o.stableUrl))}async doSync(o,s,h){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),h.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const S=this.storageService.get(c,-1);if(S&&this.manifest&&S!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(h.isCancellationRequested)return;const A=w.find(q=>q.isCurrent);if(A?.disabled)throw new p.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(q){throw new p.UserDataAutoSyncError((0,R.toErrorMessage)(q),q instanceof p.UserDataSyncError?q.code:"Unknown")}if(this.manifest&&this.manifest.session!==S&&this.storageService.store(c,this.manifest.session,-1,1),h.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(S){this.logService.error(S),a=S}this._onDidFinishSync.fire(a)}register(o){return super._register(o)}}r.INTERVAL_SYNCING="Interval"}),define(ie[62],re([0,1,2,69,4,21]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let L=class extends D.Disposable{constructor(E){super(),this.storageService=E}async readStorageData(E){return this.withProfileScopedStorageService(E,async C=>this.getItems(C))}async updateStorageData(E,C,b){return this.withProfileScopedStorageService(E,async v=>this.writeItems(v,C,b))}async withProfileScopedStorageService(E,C){if(this.storageService.hasScope(E))return C(this.storageService);const b=await this.createStorageDatabase(E),v=new P(b);try{await v.initialize();const m=await C(v);return await v.flush(),m}finally{v.dispose(),await this.closeAndDispose(b)}}getItems(E){const C=new Map,b=v=>{for(const m of E.keys(0,v))C.set(m,{value:E.get(m,0),target:v})};return b(0),b(1),C}writeItems(E,C,b){for(const[v,m]of C)E.store(v,m,0,b)}async closeAndDispose(E){try{await E.close()}finally{(0,D.isDisposable)(E)&&E.dispose()}}};L=pe([Y(0,T.IStorageService)],L),e.AbstractUserDataSyncProfilesStorageService=L;class P extends T.AbstractStorageService{constructor(E){super({flushInterval:100}),this.profileStorage=this._register(new t.Storage(E))}doInitialize(){return this.profileStorage.init()}getStorage(E){return E===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ie[269],re([0,1,6,24,9,3,46,2,27,7,16,13,117,29,33,78,14,4,71,8,21,23,31,20,41,244,115,26,62]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i,r,n,o,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0;async function S(U,O){const $=JSON.parse(U.content);if(U.version===1||U.version===2){const k=(await O.getInstalled(0)).filter(M=>M.isBuiltin);for(const M of $)U.version===1&&(M.enabled===!1&&(M.disabled=!0),delete M.enabled),U.version===2&&k.every(F=>!(0,f.areSameExtensions)(F.identifier,M.identifier))&&(M.installed=!0)}return $}let w=class St extends n.AbstractSynchroniser{constructor(O,$,k,M,F,G,W,B,z,x,J,X,se,j,H,_,N){super({syncResource:"extensions",profile:O},$,M,k,F,G,W,X,se,x,J,H),this.profile=O,this.extensionManagementService=B,this.ignoredExtensionsManagementService=z,this.instantiationService=N,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(A),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,V=>V.some(({local:K})=>!!K)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,V=>!V.error),T.Event.filter(_.onDidChange,V=>V.valueChanges.some(({profile:K,changes:ee})=>this.syncResource.profile.id===K.id&&ee.some(ae=>ae.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),j.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(O,$){const k=O.syncData?await S(O.syncData,this.extensionManagementService):null,M=$?.skippedExtensions||[],F=$?.builtinExtensions||[],G=$?.syncData?await S($.syncData,this.extensionManagementService):null,{localExtensions:W,ignoredExtensions:B}=await this.localExtensionsProvider.getLocalExtensions(this.profile);k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:x}=(0,o.merge)(W,k,G,M,B,F),J={local:z,remote:x,content:this.getPreviewContent(W,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:x!==null?2:0},X=this.stringify(W,!1);return[{skippedExtensions:M,builtinExtensions:F,baseResource:this.baseResource,baseContent:G?this.stringify(G,!1):X,localResource:this.localResource,localContent:X,localExtensions:W,remoteResource:this.remoteResource,remoteExtensions:k,remoteContent:k?this.stringify(k,!1):null,previewResource:this.previewResource,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(O){const $=O.syncData?await S(O.syncData,this.extensionManagementService):null,{localExtensions:k,ignoredExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.profile),{remote:F}=(0,o.merge)(k,$,$,O.skippedExtensions||[],M,O.builtinExtensions||[]);return F!==null}getPreviewContent(O,$,k,M){const F=[...$,...k],G=new Set,W=B=>{G.add(B.id.toLowerCase()),B.uuid&&G.add(B.uuid)};F.forEach(({identifier:B})=>W(B)),M.forEach(W);for(const B of O)G.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&G.has(B.identifier.uuid)||F.push(B);return this.stringify(F,!1)}async getMergeResult(O,$){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,$,k,M){if(this.extUri.isEqual($,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual($,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual($,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${$.toString()}`)}async acceptLocal(O){const $=await this.extensionManagementService.getInstalled(void 0,this.profile.location),k=this.ignoredExtensionsManagementService.getIgnoredExtensions($),M=(0,o.merge)(O.localExtensions,null,null,O.skippedExtensions,k,O.builtinExtensions),{local:F,remote:G}=M;return{content:O.localContent,local:F,remote:G,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:G!==null?2:0}}async acceptRemote(O){const $=await this.extensionManagementService.getInstalled(void 0,this.profile.location),k=this.ignoredExtensionsManagementService.getIgnoredExtensions($),M=O.remoteContent?JSON.parse(O.remoteContent):null;if(M!==null){const F=(0,o.merge)(O.localExtensions,M,O.localExtensions,[],k,O.builtinExtensions),{local:G,remote:W}=F;return{content:O.remoteContent,local:G,remote:W,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:O.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(O,$,k,M){let{skippedExtensions:F,localExtensions:G}=k[0][0];const{local:W,remote:B,localChange:z,remoteChange:x}=k[0][1];if(z===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(G)),F=await this.localExtensionsProvider.updateLocalExtensions(W.added,W.removed,W.updated,F,this.profile)),B){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const J=JSON.stringify(B.all);O=await this.updateRemoteUserData(J,M?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(X=>X.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(X=>X.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(X=>X.identifier.id))}.`:""}`)}if($?.ref!==O.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const J=G.filter(X=>!X.installed).map(X=>X.identifier);await this.updateLastSyncUserData(O,{skippedExtensions:F,builtinExtensions:J}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${F.length?` Skipped: ${JSON.stringify(F.map(X=>X.identifier.id))}.`:""}`)}}async getAssociatedResources({uri:O}){return[{resource:this.extUri.joinPath(O,"extensions.json"),comparableResource:St.EXTENSIONS_DATA_URI}]}async resolveContent(O){if(this.extUri.isEqual(O,St.EXTENSIONS_DATA_URI)){const{localExtensions:k,ignoredExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.profile);return this.stringify(k.filter(F=>!M.some(G=>(0,f.areSameExtensions)({id:G},F.identifier))),!0)}if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const k=await this.resolvePreviewContent(O);return k&&this.stringify(JSON.parse(k),!0)}let $=await super.resolveContent(O);if($)return $;if($=await super.resolveContent(this.extUri.dirname(O)),$){const k=this.parseSyncData($);if(k)switch(this.extUri.basename(O)){case"extensions.json":return this.stringify(this.parseExtensions(k),!0)}}return null}stringify(O,$){return O.sort((k,M)=>!k.identifier.uuid&&M.identifier.uuid?-1:k.identifier.uuid&&!M.identifier.uuid?1:(0,I.compare)(k.identifier.id,M.identifier.id)),$?(0,L.toFormattedString)(O,{}):JSON.stringify(O)}async hasLocalData(){try{const{localExtensions:O}=await this.localExtensionsProvider.getLocalExtensions(this.profile);if(O.some($=>$.installed||$.disabled))return!0}catch{}return!1}parseExtensions(O){return JSON.parse(O.content)}};w.EXTENSIONS_DATA_URI=E.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),w=pe([Y(2,b.IEnvironmentService),Y(3,y.IFileService),Y(4,d.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,m.IExtensionManagementService),Y(8,s.IIgnoredExtensionsManagementService),Y(9,h.IUserDataSyncLogService),Y(10,C.IConfigurationService),Y(11,h.IUserDataSyncEnablementService),Y(12,l.ITelemetryService),Y(13,p.IExtensionStorageService),Y(14,i.IUriIdentityService),Y(15,a.IUserDataSyncProfilesStorageService),Y(16,u.IInstantiationService)],w),e.ExtensionsSynchroniser=w;let A=class{constructor(O,$,k,M,F,G){this.extensionManagementService=O,this.userDataSyncProfilesStorageService=$,this.extensionGalleryService=k,this.ignoredExtensionsManagementService=M,this.instantiationService=F,this.logService=G}async getLocalExtensions(O){const $=await this.extensionManagementService.getInstalled(void 0,O.extensionsResource),k=this.ignoredExtensionsManagementService.getIgnoredExtensions($);return{localExtensions:await this.withProfileScopedServices(O,async(F,G)=>{const W=F.getDisabledExtensions();return $.map(B=>{const{identifier:z,isBuiltin:x,manifest:J,preRelease:X}=B,se={identifier:z,preRelease:X,version:J.version};W.some(j=>(0,f.areSameExtensions)(j,z))&&(se.disabled=!0),x||(se.installed=!0);try{const j=G.getKeysForSync({id:z.id,version:J.version});if(j){const H=G.getExtensionState(B,!0)||{};se.state=Object.keys(H).reduce((_,N)=>(j.includes(N)&&(_[N]=H[N]),_),{})}}catch(j){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",O)}: Error while parsing extension state`,(0,R.getErrorMessage)(j))}return se})}),ignoredExtensions:k}}async updateLocalExtensions(O,$,k,M,F){const G=(0,n.getSyncResourceLogLabel)("extensions",F);return this.withProfileScopedServices(F,async(W,B)=>{const z=[],x=[],J=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource);if($.length){const se=J.filter(({identifier:j,isBuiltin:H})=>!H&&$.some(_=>(0,f.areSameExtensions)(j,_)));await D.Promises.settled(se.map(async j=>{this.logService.trace(`${G}: Uninstalling local extension...`,j.identifier.id),await this.extensionManagementService.uninstall(j,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:F.extensionsResource}),this.logService.info(`${G}: Uninstalled local extension.`,j.identifier.id),z.push(j.identifier)}))}(O.length||k.length)&&await D.Promises.settled([...O,...k].map(async se=>{const j=J.find(_=>(0,f.areSameExtensions)(_.identifier,se.identifier));if(j&&j.isBuiltin){se.state&&j.manifest.version===se.version&&this.updateExtensionState(se.state,j,j.manifest.version,B),W.getDisabledExtensions().some(N=>(0,f.areSameExtensions)(N,se.identifier))!==!!se.disabled&&(se.disabled?(this.logService.trace(`${G}: Disabling extension...`,se.identifier.id),await W.disableExtension(se.identifier),this.logService.info(`${G}: Disabled extension`,se.identifier.id)):(this.logService.trace(`${G}: Enabling extension...`,se.identifier.id),await W.enableExtension(se.identifier),this.logService.info(`${G}: Enabled extension`,se.identifier.id))),z.push(se.identifier);return}const H=(await this.extensionGalleryService.getExtensions([{...se.identifier,preRelease:se.preRelease}],t.CancellationToken.None))[0];if(se.state&&(j?j.manifest.version===se.version:!!H)&&this.updateExtensionState(se.state,j||H,j?.manifest.version,B),H)try{W.getDisabledExtensions().some(N=>(0,f.areSameExtensions)(N,se.identifier))!==!!se.disabled&&(se.disabled?(this.logService.trace(`${G}: Disabling extension...`,se.identifier.id,H.version),await W.disableExtension(H.identifier),this.logService.info(`${G}: Disabled extension`,se.identifier.id,H.version)):(this.logService.trace(`${G}: Enabling extension...`,se.identifier.id,H.version),await W.enableExtension(H.identifier),this.logService.info(`${G}: Enabled extension`,se.identifier.id,H.version))),(!j||j.preRelease!==se.preRelease)&&(await this.extensionManagementService.canInstall(H)?(this.logService.trace(`${G}: Installing extension...`,se.identifier.id,H.version),await this.extensionManagementService.installFromGallery(H,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:se.preRelease,profileLocation:F.extensionsResource}),this.logService.info(`${G}: Installed extension.`,se.identifier.id,H.version),z.push(H.identifier)):(this.logService.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,H.displayName||H.identifier.id),x.push(se)))}catch(_){x.push(se),_ instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(_.code)?this.logService.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,H.displayName||H.identifier.id):(this.logService.error(_),this.logService.info(`${G}: Skipped synchronizing extension`,H.displayName||H.identifier.id))}else x.push(se),this.logService.info(`${G}: Skipped synchronizing extension because the extension is not found.`,se.identifier.id)}));const X=[];for(const se of M)z.some(j=>(0,f.areSameExtensions)(j,se.identifier))||X.push(se);for(const se of x)X.some(j=>(0,f.areSameExtensions)(j.identifier,se.identifier))||X.push(se);return X})}updateExtensionState(O,$,k,M){const F=M.getExtensionState($,!0)||{},G=k?M.getKeysForSync({id:$.identifier.id,version:k}):void 0;G?G.forEach(W=>{F[W]=O[W]}):Object.keys(O).forEach(W=>F[W]=O[W]),M.setExtensionState($,F,!0)}async withProfileScopedServices(O,$){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(O,async k=>{const M=new P.DisposableStore,F=this.instantiationService.createChild(new g.ServiceCollection([d.IStorageService,k])),G=M.add(F.createInstance(v.GlobalExtensionEnablementService)),W=M.add(F.createInstance(p.ExtensionStorageService));try{return await $(G,W)}finally{M.dispose()}})}};A=pe([Y(0,m.IExtensionManagementService),Y(1,a.IUserDataSyncProfilesStorageService),Y(2,m.IExtensionGalleryService),Y(3,s.IIgnoredExtensionsManagementService),Y(4,u.IInstantiationService),Y(5,h.IUserDataSyncLogService)],A),e.LocalExtensionsProvider=A;let q=class extends n.AbstractInitializer{constructor(O,$,k,M,F,G,W){super("extensions",M,F,G,k,W),this.extensionManagementService=O,this.ignoredExtensionsManagementService=$}async parseExtensions(O){return O.syncData?await S(O.syncData,this.extensionManagementService):null}generatePreview(O,$){const k=[],M=[],F=[];for(const G of O){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(G.identifier.id))continue;const W=$.find(B=>(0,f.areSameExtensions)(B.identifier,G.identifier));W?(k.push(W),G.disabled&&F.push(G.identifier)):G.installed&&(M.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&F.push(G.identifier))}return{installedExtensions:k,newExtensions:M,disabledExtensions:F,remoteExtensions:O}}};q=pe([Y(0,m.IExtensionManagementService),Y(1,s.IIgnoredExtensionsManagementService),Y(2,y.IFileService),Y(3,r.IUserDataProfilesService),Y(4,b.IEnvironmentService),Y(5,c.ILogService),Y(6,i.IUriIdentityService)],q),e.AbstractExtensionsInitializer=q}),define(ie[270],re([0,1,17,9,3,35,46,5,7,30,16,13,14,8,50,21,23,31,41,61,248,26,20,62,4]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",s=["locale"];function h(U,O){const $=U.storage?Object.keys(U.storage).sort():[],k={};return $.forEach(M=>k[M]=U.storage[M]),U.storage=k,O?(0,L.toFormattedString)(U,{}):JSON.stringify(U)}const a=1;let S=class yt extends g.AbstractSynchroniser{constructor(O,$,k,M,F,G,W,B,z,x,J,X,se,j){super({syncResource:"globalState",profile:O},$,M,B,X,F,G,z,x,W,J,se),this.userDataSyncProfilesStorageService=k,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=j.createInstance(w),this._register(M.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(M.onDidFilesChange,H=>H.contains(this.environmentService.argvResource)),R.Event.filter(k.onDidChange,H=>!!(H.targetChanges.some(_=>this.syncResource.profile.id===_.id)||H.valueChanges.some(({profile:_,changes:N})=>this.syncResource.profile.id===_.id&&N.some(V=>V.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,$,k){const M=O.syncData?JSON.parse(O.syncData.content):null;$=$===null&&k?O:$;const F=$&&$.syncData?JSON.parse($.syncData.content):null,G=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.getStorageKeys(F),{local:B,remote:z}=(0,d.merge)(G.storage,M?M.storage:null,F?F.storage:null,W,this.logService),x={content:null,local:B,remote:z,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:z.all!==null?2:0},J=h(G,!1);return[{baseResource:this.baseResource,baseContent:F?h(F,!1):J,localResource:this.localResource,localContent:J,localUserData:G,remoteResource:this.remoteResource,remoteContent:M?h(M,!1):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:W}]}async hasRemoteChanged(O){const $=O.syncData?JSON.parse(O.syncData.content):null;if($===null)return!0;const k=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),M=await this.getStorageKeys($),{remote:F}=(0,d.merge)(k.storage,$.storage,$.storage,M,this.logService);return F.all!==null}async getMergeResult(O,$){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,$,k,M){if(this.extUri.isEqual($,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual($,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual($,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${$.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const $=JSON.parse(O.remoteContent),{local:k,remote:M}=(0,d.merge)(O.localUserData.storage,$.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:k,remote:M,localChange:Object.keys(k.added).length>0||Object.keys(k.updated).length>0||k.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(O,$,k,M){const{localUserData:F}=k[0][0],{local:G,remote:W,localChange:B,remoteChange:z}=k[0][1];if(B===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),B!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.localGlobalStateProvider.writeLocalGlobalState(G,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),z!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const x=JSON.stringify({storage:W.all});O=await this.updateRemoteUserData(x,M?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}$?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:O}){return[{resource:this.extUri.joinPath(O,"globalState.json"),comparableResource:yt.GLOBAL_STATE_DATA_URI}]}async resolveContent(O){if(this.extUri.isEqual(O,yt.GLOBAL_STATE_DATA_URI)){const k=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);return h(k,!0)}if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const k=await this.resolvePreviewContent(O);return k&&h(JSON.parse(k),!0)}let $=await super.resolveContent(O);if($)return $;if($=await super.resolveContent(this.extUri.dirname(O)),$){const k=this.parseSyncData($);if(k)switch(this.extUri.basename(O)){case"globalState.json":return h(JSON.parse(k.content),!0)}}return null}async hasLocalData(){try{const{storage:O}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${o}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(O){const $=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),k=[],M=[];for(const[W,B]of $)B.target===0?k.push(W):B.target===1&&M.push(W);const F=[...k,...M],G=O?.storage?Object.keys(O.storage).filter(W=>!W.startsWith(o)&&!F.includes(W)&&$.get(W)!==void 0):[];if(!P.isWeb){const W=[...l.ALL_SYNC_RESOURCES.map(B=>(0,l.getEnablementKey)(B)),l.SYNC_SERVICE_URL_TYPE];G.push(...W),M.push(...W)}return{user:k,machine:M,unregistered:G}}};S.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),S=pe([Y(2,r.IUserDataSyncProfilesStorageService),Y(3,v.IFileService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncLogService),Y(7,b.IEnvironmentService),Y(8,l.IUserDataSyncEnablementService),Y(9,y.ITelemetryService),Y(10,C.IConfigurationService),Y(11,p.IStorageService),Y(12,u.IUriIdentityService),Y(13,n.IInstantiationService)],S),e.GlobalStateSynchroniser=S;let w=class{constructor(O,$,k,M){this.fileService=O,this.environmentService=$,this.userDataSyncProfilesStorageService=k,this.logService=M}async getLocalGlobalState(O){const $={};if(O.isDefault){const M=await this.getLocalArgvContent(),F=(0,T.parse)(M);for(const G of s)F[G]!==void 0&&($[`${o}${G}`]={version:1,value:F[G]})}const k=await this.userDataSyncProfilesStorageService.readStorageData(O);for(const[M,F]of k)F.value&&F.target===0&&($[M]={version:1,value:F.value});return{storage:$}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,t.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:$,updated:k},M){const F=(0,g.getSyncResourceLogLabel)("globalState",M),G={},W=new Map,B=await this.userDataSyncProfilesStorageService.readStorageData(M),z=(x,J)=>{for(const X of x){if(X.startsWith(o)){G[X.substring(o.length)]=J?J[X].value:void 0;continue}if(J){const se=J[X];se.value!==B.get(X)?.value&&W.set(X,se.value)}else B.get(X)!==void 0&&W.set(X,void 0)}};if(z(Object.keys(O),O),z(Object.keys(k),k),z($),Object.keys(G).length){this.logService.trace(`${F}: Updating locale...`);const x=await this.getLocalArgvContent();let J=x;for(const X of Object.keys(G))J=(0,c.edit)(J,[X],G[X],{});x!==J&&(this.logService.trace(`${F}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(J)),this.logService.info(`${F}: Updated locale.`)),this.logService.info(`${F}: Updated locale`)}W.size&&(this.logService.trace(`${F}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(M,W,0),this.logService.info(`${F}: Updated global state`,[...W.keys()]))}};w=pe([Y(0,v.IFileService),Y(1,b.IEnvironmentService),Y(2,r.IUserDataSyncProfilesStorageService),Y(3,l.IUserDataSyncLogService)],w),e.LocalGlobalStateProvider=w;let A=class extends g.AbstractInitializer{constructor(O,$,k,M,F,G){super("globalState",k,M,F,$,G),this.storageService=O}async doInitialize(O){const $=O.syncData?JSON.parse(O.syncData.content):null;if(!$){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const k={},M={};for(const F of Object.keys($.storage))F.startsWith(o)?k[F.substring(o.length)]=$.storage[F].value:this.storageService.get(F,0)===void 0&&(M[F]=$.storage[F].value);if(Object.keys(k).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const G of Object.keys(k))F=(0,c.edit)(F,[G],k[G],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F))}if(Object.keys(M).length)for(const F of Object.keys(M))this.storageService.store(F,M[F],0,0)}};A=pe([Y(0,p.IStorageService),Y(1,v.IFileService),Y(2,i.IUserDataProfilesService),Y(3,b.IEnvironmentService),Y(4,l.IUserDataSyncLogService),Y(5,u.IUriIdentityService)],A),e.GlobalStateInitializer=A;let q=class{constructor(O,$,k,M,F){this.userDataSyncStoreClient=O,this.storageService=$,this.environmentService=k,this.fileService=M,this.logService=F}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const $=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(O,$)}catch(k){if(k instanceof l.UserDataSyncError)switch(k.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,$)}throw k}}async doSync(O,$){const k=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,$),M=this.parseGlobalState(k)||{storage:{}};M.storage[l.SYNC_SERVICE_URL_TYPE]={value:O,version:a};const F=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),G={version:a,machineId:F,content:h(M,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(G),k.ref,void 0,$)}parseGlobalState({content:O}){if(!O)return null;const $=JSON.parse(O);if((0,g.isSyncData)($))return $?JSON.parse($.content):null;throw new Error("Invalid remote data")}};q=pe([Y(1,p.IStorageService),Y(2,b.IEnvironmentService),Y(3,v.IFileService),Y(4,m.ILogService)],q),e.UserDataSyncStoreTypeSynchronizer=q}),define(ie[271],re([0,1,18,6,24,37,3,2,19,15,30,16,13,29,4,25,21,23,20,269,270,261,262,263,264,265,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i,r,n,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const h="sync.lastSyncTime";let a=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(U,O,$,k,M,F,G,W,B,z){super(),this.userDataSyncStoreService=U,this.userDataSyncStoreManagementService=O,this.instantiationService=$,this.logService=k,this.telemetryService=M,this.storageService=F,this.userDataSyncEnablementService=G,this.userDataProfilesService=W,this.productService=B,this.environmentService=z,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=O.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(h,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(U,O){this.checkEnablement(),this.logService.info("Sync started.");const $=new Date().getTime(),k=(0,C.generateUuid)();try{const W=(0,s.createSyncHeaders)(k);O&&(W["Cache-Control"]="no-cache"),U=await this.userDataSyncStoreService.manifest(U,W)}catch(W){const B=s.UserDataSyncError.toUserDataSyncError(W);throw A(B,k,this.userDataSyncStoreManagementService,this.telemetryService),B}const M=!1,F=this;let G;return{manifest:U,async run(){if(M)throw new Error("Can run a task only once");G=(0,t.createCancelablePromise)(W=>F.sync(U,!1,k,W)),await G.finally(()=>G=void 0),F.logService.info(`Sync done. Took ${new Date().getTime()-$}ms`),F.updateLastSyncTime()},stop(){return G?.cancel(),F.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const U=new Date().getTime(),O=(0,C.generateUuid)(),$=(0,s.createSyncHeaders)(O);let k;try{k=await this.userDataSyncStoreService.manifest(null,$)}catch(G){const W=s.UserDataSyncError.toUserDataSyncError(G);throw A(W,O,this.userDataSyncStoreManagementService,this.telemetryService),W}await this.resetLocal();const M=this,F=new R.CancellationTokenSource;return{id:O,async merge(){return M.sync(k,!0,O,F.token)},async apply(){await M.applyManualSync(k,O,F.token),M.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),M.updateLastSyncTime()},stop(){return F.cancel(),M.stop()},dispose(){F.cancel(),M.stop()}}}async sync(U,O,$,k){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,U,O,$,k));const F=M.enabled.find(G=>G.resource==="profiles");if(F){const G=await F.getLastSyncedProfiles()||[];if(k.isCancellationRequested)return;await this.syncRemoteProfiles(G,U,O,$,k)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(U,O,$,k,M){for(const F of U){if(M.isCancellationRequested)return;const G=this.userDataProfilesService.profiles.find(B=>B.id===F.id);if(!G){this.logService.error(`Settings Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",F.name);const W=this.getOrCreateActiveProfileSynchronizer(G,F);this._syncErrors.push(...await this.syncProfile(W,O,$,k,M))}}async applyManualSync(U,O,$){const k=this.getActiveProfileSynchronizers();for(const B of k){if($.isCancellationRequested)return;await B.apply(O,$)}const M=k.find(B=>B.profile.isDefault);if(!M)return;const F=M.enabled.find(B=>B.resource==="profiles");if(!F)return;const W=(await F.getRemoteSyncedProfiles(U?.latest??null)||[]).filter(B=>k.every(z=>z.profile.id!==B.id));W.length&&await this.syncRemoteProfiles(W,U,!1,O,$)}async syncProfile(U,O,$,k,M){return(await U.sync(O,$,k,M)).map(([G,W])=>({profile:U.profile,syncResource:G,error:W}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(U=>U.stop()))}async resolveContent(U){for(const O of this.userDataProfilesService.profiles){const $=await this.performAction(O,async k=>{const M=await k.resolveContent(U);if(M)return M});if(!(0,E.isUndefinedOrNull)($))return $}return null}async replace(U,O){this.checkEnablement(),await this.performAction(U.profile,async $=>{if(U.syncResource===$.resource)return await $.replace(O),!0})}async accept(U,O,$,k){this.checkEnablement(),await this.performAction(U.profile,async M=>{if(U.syncResource===M.resource)return await M.accept(O,$),k&&await M.apply((0,E.isBoolean)(k)?!1:k.force,(0,s.createSyncHeaders)((0,C.generateUuid)())),!0})}async getRemoteSyncResourceHandles(U){return await this.performAction(U.profile,async $=>{if($.resource===U.syncResource)return $.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(U){return await this.performAction(U.profile,async $=>{if($.resource===U.syncResource)return $.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(U,O){return await this.performAction(U.profile,async k=>{if(k.resource===U.syncResource)return k.getAssociatedResources(O)})||[]}async getMachineId(U,O){return await this.performAction(U.profile,async k=>{if(k.resource===U.syncResource)return await k.getMachineId(O)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async O=>{if(O.resource!=="globalState"&&await O.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async O=>{if(await O.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(U){this.logService.error(U)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(h,-1);for(const[U]of this.activeProfileSynchronizers.values())try{await U.resetLocal()}catch(O){this.logService.error(O)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(U,O){const $=new P.DisposableStore;try{const k=this.activeProfileSynchronizers.get(U.id);if(k){const B=await this.performActionWithProfileSynchronizer(k[0],O,$);return(0,E.isUndefined)(B)?null:B}if(U.isDefault){const B=$.add(this.instantiationService.createInstance(S,U,void 0)),z=await this.performActionWithProfileSynchronizer(B,O,$);return(0,E.isUndefined)(z)?null:z}if(this.userDataProfilesService.isEnabled()||this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const M=$.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,U,void 0)),F=await this.userDataSyncStoreService.manifest(null),W=(await M.getRemoteSyncedProfiles(F?.latest??null)||[]).find(B=>B.id===U.id);if(W){const B=$.add(this.instantiationService.createInstance(S,U,W.collection)),z=await this.performActionWithProfileSynchronizer(B,O,$);return(0,E.isUndefined)(z)?null:z}return null}finally{$.dispose()}}async performActionWithProfileSynchronizer(U,O,$){const k=[...U.enabled,...U.disabled.map(M=>$.add(U.createSynchronizer(M)))];for(const M of k){const F=await O(M);if(!(0,E.isUndefined)(F))return F}}setStatus(U){const O=this._status;this._status!==U&&(this._status=U,this._onDidChangeStatus.fire(U),O==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const U=this.getActiveProfileSynchronizers().map(O=>O.conflicts).flat();(0,D.equals)(this._conflicts,U,(O,$)=>O.profile.id===$.profile.id&&O.syncResource===$.syncResource&&(0,D.equals)(O.conflicts,$.conflicts,(k,M)=>(0,I.isEqual)(k.previewResource,M.previewResource)))||(this._conflicts=U,this._onDidChangeConflicts.fire(U))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(h,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(U,O){let $=this.activeProfileSynchronizers.get(U.id);if(!$){const k=new P.DisposableStore,M=k.add(this.instantiationService.createInstance(S,U,O?.collection));k.add(M.onDidChangeStatus(F=>this.setStatus(F))),k.add(M.onDidChangeConflicts(F=>this.updateConflicts())),k.add(M.onDidChangeLocal(F=>this._onDidChangeLocal.fire(F))),this.activeProfileSynchronizers.set(U.id,$=[M,k])}return $[0]}getActiveProfileSynchronizers(){const U=[];for(const[O]of this.activeProfileSynchronizers.values())U.push(O);return U}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,U])=>U.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=pe([Y(0,s.IUserDataSyncStoreService),Y(1,s.IUserDataSyncStoreManagementService),Y(2,f.IInstantiationService),Y(3,s.IUserDataSyncLogService),Y(4,u.ITelemetryService),Y(5,y.IStorageService),Y(6,s.IUserDataSyncEnablementService),Y(7,g.IUserDataProfilesService),Y(8,p.IProductService),Y(9,v.IEnvironmentService)],a),e.UserDataSyncService=a;let S=class extends P.Disposable{get enabled(){return this._enabled.sort((U,O)=>U[1]-O[1]).map(([U])=>U)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(U=>!this.userDataSyncEnablementService.isResourceEnabled(U))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(U,O,$,k,M,F,G,W,B,z,x,J){super(),this._profile=U,this.collection=O,this.userDataSyncEnablementService=$,this.instantiationService=k,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=F,this.telemetryService=G,this.logService=W,this.productService=B,this.userDataProfilesService=z,this.configurationService=x,this.environmentService=J,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(z.onDidChangeProfiles(()=>{if(z.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!z.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=z.defaultProfile;for(const[X]of this._enabled)X instanceof c.ExtensionsSynchroniser&&(X.profile=this._profile)}})),this._register($.onDidChangeResourceEnablement(([X,se])=>this.onDidChangeResourceEnablement(X,se))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,X])=>X.dispose())));for(const X of s.ALL_SYNC_RESOURCES)$.isResourceEnabled(X)&&this.registerSynchronizer(X)}onDidChangeResourceEnablement(U,O){O?this.registerSynchronizer(U):this.deRegisterSynchronizer(U)}registerSynchronizer(U){if(this._enabled.some(([M])=>M.resource===U))return;if(U==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(U==="profiles"){if(!this._profile.isDefault||!this.userDataProfilesService.isEnabled())return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const O=new P.DisposableStore,$=O.add(this.createSynchronizer(U));O.add($.onDidChangeStatus(()=>this.updateStatus())),O.add($.onDidChangeConflicts(()=>this.updateConflicts())),O.add($.onDidChangeLocal(()=>this._onDidChangeLocal.fire(U)));const k=this.getOrder(U);this._enabled.push([$,k,O])}deRegisterSynchronizer(U){const O=this._enabled.findIndex(([$])=>$.resource===U);if(O!==-1){const $=this._enabled.splice(O,1);for(const[k,,M]of $){if(k.status!=="idle"){const F=k.conflicts.conflicts.length>0;k.stop(),F&&this.updateConflicts(),this.updateStatus()}M.dispose()}}}createSynchronizer(U){switch(U){case"settings":return this.instantiationService.createInstance(i.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(l.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(r.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(n.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(c.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(U,O,$,k){if(k.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const F=[],G=(0,s.createSyncHeaders)($),W=(this.collection?U?.collections?.[this.collection]?.latest:U?.latest)??null,B=O?await this.getUserDataSyncConfiguration(W):{};for(const z of M){if(k.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(z.resource))return[];try{if(O){const x=await z.preview(W,B,G);if(x)for(const J of x.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await z.merge(J.previewResource)}else await z.sync(W,G)}catch(x){const J=s.UserDataSyncError.toUserDataSyncError(x);if(A(J,$,this.userDataSyncStoreManagementService,this.telemetryService),w(x))throw J;this.logService.error(x),this.logService.error(`${z.resource}: ${(0,T.toErrorMessage)(x)}`),F.push([z.resource,J])}}return F}finally{this.updateStatus()}}async apply(U,O){const $=(0,s.createSyncHeaders)(U);for(const k of this.enabled){if(O.isCancellationRequested)return;try{await k.apply(!1,$)}catch(M){const F=s.UserDataSyncError.toUserDataSyncError(M);if(A(F,U,this.userDataSyncStoreManagementService,this.telemetryService),w(M))throw F;this.logService.error(M),this.logService.error(`${k.resource}: ${(0,T.toErrorMessage)(M)}`)}}}async stop(){for(const U of this.enabled)try{U.status!=="idle"&&await U.stop()}catch(O){this.logService.error(O)}}async resetLocal(){for(const U of this.enabled)try{await U.resetLocal()}catch(O){this.logService.error(`${U.resource}: ${(0,T.toErrorMessage)(O)}`),this.logService.error(O)}}async getUserDataSyncConfiguration(U){if(!this.profile.isDefault)return{};const O=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),$=this.enabled.find(k=>k instanceof i.SettingsSynchroniser);if($){const k=await $.getRemoteUserDataSyncConfiguration(U);return{...O,...k}}return O}setStatus(U){this._status!==U&&(this._status=U,this._onDidChangeStatus.fire(U))}updateStatus(){return this.updateConflicts(),this.enabled.some(U=>U.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(U=>U.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const U=this.enabled.filter(O=>O.status==="hasConflicts").filter(O=>O.conflicts.conflicts.length>0).map(O=>O.conflicts);(0,D.equals)(this._conflicts,U,(O,$)=>O.syncResource===$.syncResource&&(0,D.equals)(O.conflicts,$.conflicts,(k,M)=>(0,I.isEqual)(k.previewResource,M.previewResource)))||(this._conflicts=U,this._onDidChangeConflicts.fire(U))}getOrder(U){switch(U){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};S=pe([Y(2,s.IUserDataSyncEnablementService),Y(3,f.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,s.IUserDataSyncStoreManagementService),Y(6,u.ITelemetryService),Y(7,s.IUserDataSyncLogService),Y(8,p.IProductService),Y(9,g.IUserDataProfilesService),Y(10,b.IConfigurationService),Y(11,v.IEnvironmentService)],S);function w(q){if(q instanceof s.UserDataSyncError)switch(q.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function A(q,U,O,$){$.publicLog2("sync/error",{code:q.code,serverCode:q instanceof s.UserDataSyncStoreError?String(q.serverCode):void 0,url:q instanceof s.UserDataSyncStoreError?q.url:void 0,resource:q.resource,executionId:U,service:O.userDataSyncStore.url.toString()})}}),define(ie[272],re([0,1,3,2,7,20,26]),function(Q,e,D,t,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(b,v){return{...b,profile:(0,T.reviveProfile)(b.profile,v.profilesHome.scheme)}}class I{constructor(v,m,f){this.service=v,this.userDataProfilesService=m,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(v,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(v,m,f){try{return await this._call(v,m,f)}catch(p){throw this.logService.error(p),p}}async _call(v,m,f){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(f[0]));case"accept":return this.service.accept(P(f[0],this.userDataProfilesService),R.URI.revive(f[1]),f[2],f[3]);case"replace":return this.service.replace(P(f[0],this.userDataProfilesService),R.URI.revive(f[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(f[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(f[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(f[0],this.userDataProfilesService),{created:f[1].created,uri:R.URI.revive(f[1].uri)});case"getMachineId":return this.service.getMachineId(P(f[0],this.userDataProfilesService),{created:f[1].created,uri:R.URI.revive(f[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const p=m.substring(11),y=f[0],u=this.getManualSyncTask(y);switch(f=f.slice(1),p){case"merge":return u.merge();case"apply":return u.apply();case"stop":return u.stop();case"dispose":return this.disposeManualSyncTask(u)}}throw new Error("Invalid call")}getManualSyncTask(v){const m=this.manualSyncTasks.get(this.createKey(v));if(!m)throw new Error(`Manual sync taks not found: ${v}`);return m.manualSyncTask}async createManualSyncTask(){const v=new t.DisposableStore,m=v.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:v}),m.id}disposeManualSyncTask(v){v.dispose();const m=this.createKey(v.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(v){return`manualSyncTask-${v}`}}e.UserDataSyncChannel=I;let E=class extends t.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(v,m){super(),this.userDataProfilesService=m,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,y){return v.call(f,p,y).then(null,u=>{throw L.UserDataSyncError.toUserDataSyncError(u)})},listen(f,p){return v.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,y])=>{this.updateStatus(f),this.updateConflicts(p),y&&this.updateLastSyncTime(y),this._register(this.channel.listen("onDidChangeStatus")(u=>this.updateStatus(u))),this._register(this.channel.listen("onDidChangeLastSyncTime")(u=>this.updateLastSyncTime(u)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(p=>({...p,error:L.UserDataSyncError.toUserDataSyncError(p.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const v=await this.channel.call("createManualSyncTask"),m=this;return new C(v,{async call(p,y,u){return m.channel.call(`manualSync/${p}`,[v,...Array.isArray(y)?y:[y]],u)},listen(){throw new Error("not supported")}})}replace(v,m){return this.channel.call("replace",[v,m])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(v,m,f,p){return this.channel.call("accept",[v,m,f,p])}resolveContent(v){return this.channel.call("resolveContent",[v])}async getLocalSyncResourceHandles(v){return(await this.channel.call("getLocalSyncResourceHandles",[v])).map(({created:f,uri:p})=>({created:f,uri:R.URI.revive(p)}))}async getRemoteSyncResourceHandles(v){return(await this.channel.call("getRemoteSyncResourceHandles",[v])).map(({created:f,uri:p})=>({created:f,uri:R.URI.revive(p)}))}async getAssociatedResources(v,m){return(await this.channel.call("getAssociatedResources",[v,m])).map(({resource:p,comparableResource:y})=>({resource:R.URI.revive(p),comparableResource:R.URI.revive(y)}))}async getMachineId(v,m){return this.channel.call("getMachineId",[v,m])}async updateStatus(v){this._status=v,this._onDidChangeStatus.fire(v)}async updateConflicts(v){this._conflicts=v.map(m=>({syncResource:m.syncResource,profile:(0,T.reviveProfile)(m.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:m.conflicts.map(f=>({...f,baseResource:R.URI.revive(f.baseResource),localResource:R.URI.revive(f.localResource),remoteResource:R.URI.revive(f.remoteResource),previewResource:R.URI.revive(f.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(v){this._lastSyncTime!==v&&(this._lastSyncTime=v,this._onDidChangeLastSyncTime.fire(v))}};E=pe([Y(1,T.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class C extends t.Disposable{constructor(v,m){super(),this.id=v,this.channel=m}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ie[273],re([0,1,6,24,9,3,2,132,5,19,15,7,30,16,13,14,25,45,50,21,26]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",r="sync.user-session-id",n="sync.machine-session-id",o=100,s=1e3*60*5;let h=class extends L.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(U){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,U,-1,I.isWeb?0:1)}constructor(U,O,$){super(),this.productService=U,this.configurationService=O,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter($.onDidChangeValue,k=>k.key===d.SYNC_SERVICE_URL_TYPE&&k.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[d.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,O){U=I.isWeb&&U?.web?{...U,...U.web}:U;const $={...U||{},...O||{}};if($&&(0,C.isString)($.url)&&(0,C.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(k=>Array.isArray($.authenticationProviders[k].scopes))){const k=$,M=!!k.canSwitch&&!O?.url,F=k.url===k.insidersUrl?"insiders":"stable",G=(M?this.userDataSyncStoreType:void 0)||F,W=O?.url||(G==="insiders"?k.insidersUrl:G==="stable"?k.stableUrl:k.url);return{url:b.URI.parse(W),type:G,defaultType:F,defaultUrl:b.URI.parse(k.url),stableUrl:b.URI.parse(k.stableUrl),insidersUrl:b.URI.parse(k.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(k.authenticationProviders).reduce((B,z)=>(B.push({id:z,scopes:k.authenticationProviders[z].scopes}),B),[])}}}};h=pe([Y(0,y.IProductService),Y(1,m.IConfigurationService),Y(2,c.IStorageService)],h),e.AbstractUserDataSyncStoreManagementService=h;let a=class extends h{constructor(U,O,$){super(U,O,$);const k=this.storageService.get(l,-1);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const M=this.productService[d.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(l,JSON.stringify(M),-1,1):this.storageService.remove(l,-1)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=pe([Y(0,y.IProductService),Y(1,m.IConfigurationService),Y(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let S=class extends L.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(U,O,$,k,M,F,G){super(),this.requestService=$,this.logService=k,this.storageService=G,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,g.getServiceMachineId)(M,F,G).then(W=>{const B={"X-Client-Name":`${O.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":O.version};return O.commit&&(B["X-Client-Commit"]=O.commit),B}),this.session=new A(o,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(U,O){this.authToken={token:U,type:O}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,E.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(i,-1);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(O=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),O).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,O=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]="application/json";const $=await this.request(O,{type:"GET",headers:U},[],t.CancellationToken.None);return await(0,u.asJson)($)||[]}async createCollection(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]=P.Mimes.text;const $=await this.request(O,{type:"POST",headers:U},[],t.CancellationToken.None),k=await(0,u.asTextOrError)($);if(!k)throw new d.UserDataSyncStoreError("Server did not return the collection id",O,"NoCollection",$.res.statusCode,$.res.headers[d.HEADER_OPERATION_ID]);return k}async deleteCollection(U,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=U?(0,E.joinPath)(this.userDataSyncStoreUrl,"collection",U).toString():(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},await this.request($,{type:"DELETE",headers:O},[],t.CancellationToken.None)}async getAllResourceRefs(U,O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,O,U),k={},M=await this.request($.toString(),{type:"GET",headers:k},[],t.CancellationToken.None);return(await(0,u.asJson)(M)||[]).map(({url:G,created:W})=>({ref:(0,E.relativePath)($,$.with({path:G})),created:W*1e3}))}async resolveResourceContent(U,O,$,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,U),O).toString();k={...k},k["Cache-Control"]="no-cache";const F=await this.request(M,{type:"GET",headers:k},[],t.CancellationToken.None);return await(0,u.asTextOrError)(F)}async deleteResource(U,O,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=O!==null?(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,U),O).toString():this.getResourceUrl(this.userDataSyncStoreUrl,$,U).toString(),M={};await this.request(k,{type:"DELETE",headers:M},[],t.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),O={"Content-Type":P.Mimes.text};await this.request(U,{type:"DELETE",headers:O},[],t.CancellationToken.None)}async readResource(U,O,$,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,U),"latest").toString();k={...k},k["Cache-Control"]="no-cache",O&&(k["If-None-Match"]=O.ref);const F=await this.request(M,{type:"GET",headers:k},[304],t.CancellationToken.None);let G=null;if(F.res.statusCode===304&&(G=O),G===null){const W=F.res.headers.etag;if(!W)throw new d.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);const B=await(0,u.asTextOrError)(F);if(!B&&F.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",M,"EmptyResponse",F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);G={ref:W,content:B}}return G}async writeResource(U,O,$,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,k,U).toString();M={...M},M["Content-Type"]=P.Mimes.text,$&&(M["If-Match"]=$);const G=await this.request(F,{type:"POST",data:O,headers:M},[],t.CancellationToken.None),W=G.res.headers.etag;if(!W)throw new d.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",G.res.statusCode,G.res.headers[d.HEADER_OPERATION_ID]);return W}async manifest(U,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json",U&&(O["If-None-Match"]=U.ref);const k=await this.request($,{type:"GET",headers:O},[304],t.CancellationToken.None);let M=null;if(k.res.statusCode===304&&(M=U),!M){const G=k.res.headers.etag;if(!G)throw new d.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);const W=await(0,u.asTextOrError)(k);if(!W&&k.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",$,"EmptyResponse",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);W&&(M={...JSON.parse(W),ref:G})}const F=this.storageService.get(r,-1);return F&&M&&F!==M.session&&this.clearSession(),M===null&&F&&this.clearSession(),M&&this.storageService.store(r,M.session,-1,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(U,O,$){return O?(0,E.joinPath)(U,"collection",O,"resource",$):(0,E.joinPath)(U,"resource",$)}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(n,-1)}async request(U,O,$,k){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;O.headers={...O.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(O.headers),this.logService.trace("Sending request to server",{url:U,type:O.type,headers:{...O.headers,authorization:void 0}});let F;try{F=await this.session.request(U,O,k)}catch(z){if(!(z instanceof d.UserDataSyncStoreError)){let x="RequestFailed";const J=(0,R.getErrorMessage)(z).toLowerCase();J.includes("xhr timeout")?x="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?x="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":J.includes("headers must be an object")?x="RequestHeadersNotObject":(0,R.isCancellationError)(z)&&(x="RequestCanceled"),z=new d.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,x,void 0,void 0)}throw this.logService.info("Request failed",U),z}const G=F.res.headers[d.HEADER_OPERATION_ID],W={url:U,status:F.res.statusCode,"execution-id":O.headers[d.HEADER_EXECUTION_ID],"operation-id":G},B=(0,u.isSuccess)(F)||F.res.statusCode&&$.indexOf(F.res.statusCode)!==-1;if(B?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),F.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new d.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",F.res.statusCode,G);if(this._onTokenSucceed.fire(),F.res.statusCode===409)throw new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",F.res.statusCode,G);if(F.res.statusCode===410)throw new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",F.res.statusCode,G);if(F.res.statusCode===412)throw new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",F.res.statusCode,G);if(F.res.statusCode===413)throw new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",F.res.statusCode,G);if(F.res.statusCode===426)throw new d.UserDataSyncStoreError(`${O.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",F.res.statusCode,G);if(F.res.statusCode===429){const z=F.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",F.res.statusCode,G)):new d.UserDataSyncStoreError(`${O.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",F.res.statusCode,G)}if(!B)throw new d.UserDataSyncStoreError("Server returned "+F.res.statusCode,U,"Unknown",F.res.statusCode,G);return F}addSessionHeaders(U){let O=this.storageService.get(n,-1);O===void 0&&(O=(0,v.generateUuid)(),this.storageService.store(n,O,-1,1)),U["X-Machine-Session-Id"]=O;const $=this.storageService.get(r,-1);$!==void 0&&(U["X-User-Session-Id"]=$)}};S=pe([Y(1,y.IProductService),Y(2,u.IRequestService),Y(3,d.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,p.IFileService),Y(6,c.IStorageService)],S),e.UserDataSyncStoreClient=S;let w=class extends S{constructor(U,O,$,k,M,F,G){super(U.userDataSyncStore?.url,O,$,k,M,F,G),this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};w=pe([Y(0,d.IUserDataSyncStoreManagementService),Y(1,y.IProductService),Y(2,u.IRequestService),Y(3,d.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,p.IFileService),Y(6,c.IStorageService)],w),e.UserDataSyncStoreService=w;class A{constructor(U,O,$,k){this.limit=U,this.interval=O,this.requestService=$,this.logService=k,this.requests=[],this.startTime=void 0}request(U,O,$){if(this.isExpired()&&this.reset(),O.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(O,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(ie[274],re([0,1,3,59,25,21,23,268,26,76,79]),function(Q,e,D,t,R,T,L,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(m,f,p,y,u,g,c,d,l,i,r){super(m,f,p,y,u,c,d,l,i,r),this._register(D.Event.debounce(D.Event.any(D.Event.map(g.onDidFocusWindow,()=>"windowFocus"),D.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(n,o)=>n?[...n,o]:[o],1e3)(n=>this.triggerSync(n,!0,!1)))}};b=pe([Y(0,R.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,t.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,L.ITelemetryService),Y(9,C.IUserDataSyncMachinesService),Y(10,T.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ie[275],re([0,1,3,2,58,8,62,21,74,20]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let C=class extends L.AbstractUserDataSyncProfilesStorageService{constructor(v,m,f,p){super(f),this.mainProcessService=v;const y=v.getChannel("profileStorageListener"),u=this._register(new t.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{u.value=y.listen("onDidChange")(g=>{p.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(c=>(0,E.reviveProfile)(c,m.profilesHome.scheme)),valueChanges:g.valueChanges.map(c=>({...c,profile:(0,E.reviveProfile)(c.profile,m.profilesHome.scheme)}))})})},onLastListenerRemove:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(v){const m=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(v)?new I.ApplicationStorageDatabaseClient(m):new I.ProfileStorageDatabaseClient(m,v)}};C=pe([Y(0,R.IMainProcessService),Y(1,E.IUserDataProfilesService),Y(2,P.IStorageService),Y(3,T.ILogService)],C),e.UserDataSyncProfilesStorageService=C}),define(ie[276],re([0,1,99,22,5,19]),function(Q,e,D,t,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(E){function C(){let b=E.scheme===t.Schemas.file?(0,T.originalFSPath)(E):E.toString();return R.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:C(),configPath:E}}e.getWorkspaceIdentifier=L;function P(E,C){function b(){if(E.scheme!==t.Schemas.file)return(0,D.createHash)("md5").update(E.toString()).digest("hex");if(!C)return;let m;return R.isLinux?m=C.ino:R.isMacintosh?m=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?m=Math.floor(C.birthtimeMs):m=C.birthtime.getTime()),(0,D.createHash)("md5").update(E.fsPath).update(m?String(m):"").digest("hex")}const v=b();if(typeof v=="string")return{id:v,uri:E}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(ie[277],re([0,1,6,9,2,12,28,13,58,8,59,74,116,276]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends R.Disposable{constructor(y,u,g,c){super(),this.environmentService=y,this.logService=u,this.nativeHostService=g,this.mainProcessService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const y=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new b.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(y.map(async g=>{const c=(0,T.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===m.NON_EMPTY_WORKSPACE_ID_LENGTH||g===v.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===g)||await u.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await L.Promises.rm(c))}))}catch(y){(0,t.onUnexpectedError)(y)}}};f=pe([Y(0,P.INativeEnvironmentService),Y(1,E.ILogService),Y(2,C.INativeHostService),Y(3,I.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(ie[118],re([0,1,54,6,12,15,28,144,286,287]),function(Q,e,D,t,R,T,L,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(i,r){let n=r.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=r}}e.ExtractError=C;function b(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,n)=>r+n,i&61440)}function v(l){if(l instanceof C)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new C(i,l)}function m(l,i,r,n,o,s){const h=R.dirname(i),a=R.join(n,h);if(!a.startsWith(n))return Promise.reject(new Error(P.localize(0,null,i)));const S=R.join(n,i);let w;return s.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(L.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,q)=>{if(!s.isCancellationRequested)try{w=(0,D.createWriteStream)(S,{mode:r}),w.once("close",()=>A()),w.once("error",q),l.once("error",q),l.pipe(w)}catch(U){q(U)}}))}function f(l,i,r,n){let o=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{o.cancel(),l.close()}),new Promise((h,a)=>{const S=new t.Sequencer,w=A=>{A.isCancellationRequested||(s++,l.readEntry())};l.once("error",a),l.once("close",()=>o.then(()=>{n.isCancellationRequested||l.entryCount===s?h():a(new C("Incomplete",new Error(P.localize(1,null,s,l.entryCount))))},a)),l.readEntry(),l.on("entry",A=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){w(n);return}const q=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(q)){const $=R.join(i,q);o=(0,t.createCancelablePromise)(k=>L.Promises.mkdir($,{recursive:!0}).then(()=>w(k)).then(void 0,a));return}const U=y(l,A),O=b(A);o=(0,t.createCancelablePromise)($=>S.queue(()=>U.then(k=>m(k,q,O,i,r,$).then(()=>w($)))).then(null,a))})})}function p(l,i=!1){return new Promise((r,n)=>{(0,I.open)(l,i?{lazyEntries:!0}:void 0,(o,s)=>{o?n(v(o)):r((0,T.assertIsDefined)(s))})})}function y(l,i){return new Promise((r,n)=>{l.openReadStream(i,(o,s)=>{o?n(v(o)):r((0,T.assertIsDefined)(s))})})}function u(l,i){return new Promise((r,n)=>{const o=new E.ZipFile;i.forEach(h=>{h.contents?o.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&o.addFile(h.localPath,h.path)}),o.end();const s=(0,D.createWriteStream)(l);o.outputStream.pipe(s),o.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>r(l))})}e.zip=u;function g(l,i,r={},n){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=p(l,!0);return r.overwrite&&(s=s.then(h=>L.Promises.rm(i).then(()=>h))),s.then(h=>f(h,i,{sourcePathRegex:o},n))}e.extract=g;function c(l,i){return p(l).then(r=>new Promise((n,o)=>{r.on("entry",s=>{s.fileName===i&&y(r,s).then(h=>n(h),h=>o(h))}),r.once("close",()=>o(new Error(P.localize(2,null,i))))}))}function d(l,i){return c(l,i).then(r=>new Promise((n,o)=>{const s=[];r.once("error",o),r.on("data",h=>s.push(h)),r.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=d}),define(ie[278],re([0,1,118,154]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=R}),define(ie[119],re([0,1,6,37,9,2,22,12,5,19,55,15,7,30,28,118,153,96,13,254,29,33,51,77,209,255,278,210,241,44,70,14,4,8,25,23,31,20]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i,r,n,o,s,h,a,S,w,A,q,U,O,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,q.refineServiceDecorator)(d.IExtensionManagementService);let F=class extends c.AbstractExtensionManagementService{constructor(j,H,_,N,V,K,ee,ae,Z,ne,oe,ue){super(j,H,_,ne,ue),this.extensionsScannerService=V,this.extensionsProfileScannerService=K,this.downloadService=ee,this.fileService=Z,this.installGalleryExtensionsTasks=new Map;const de=this._register(ae.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(ae.createInstance(G,we=>de.postUninstall(we))),this.manifestCache=this._register(new h.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(ae.createInstance(n.ExtensionsDownloader));const ve=this._register(new a.ExtensionsWatcher(this,Z,N,_,oe));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const H=await this.collectFiles(j),_=await(0,p.zip)((0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,m.generateUuid)()).fsPath,H);return v.URI.file(_)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:H,cleanup:_}=await this.downloadVsix(j),N=P.resolve(H.fsPath);try{return await(0,s.getManifest)(N)}finally{await _()}}getInstalled(j,H){return this.extensionsScanner.scanExtensions(j??null,H)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(j,H={}){this.logService.trace("ExtensionManagementService#install",j.toString());const{location:_,cleanup:N}=await this.downloadVsix(j);try{const V=await(0,s.getManifest)(P.resolve(_.fsPath));if(V.engines&&V.engines.vscode&&!(0,w.isEngineValid)(V.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,l.getGalleryExtensionId)(V.publisher,V.name),this.productService.version));return await this.installExtension(V,_,H)}finally{await N()}}getMetadata(j){return this.extensionsScannerService.scanMetadata(j.location)}async updateMetadata(j,H){this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id);const _={...H};return H.isPreReleaseVersion&&(_.preRelease=!0),j=await this.extensionsScanner.updateMetadata(j,_),this.manifestCache.invalidate(),j}async updateExtensionScope(j,H){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.updateMetadata(j,{isMachineScoped:H}),this.manifestCache.invalidate(),j}removeUninstalledExtensions(j){return this.extensionsScanner.cleanUp(j)}async download(j,H){const{location:_}=await this.extensionsDownloader.download(j,H);return _}async downloadVsix(j){if(j.scheme===L.Schemas.file)return{location:j,async cleanup(){}};this.logService.trace("Downloading extension from",j.toString());const H=(0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,m.generateUuid)());return await this.downloadService.download(j,H),this.logService.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.fileService.del(H)}catch(N){this.logService.error(N)}}}}doCreateInstallExtensionTask(j,H,_){let N;if(v.URI.isUri(H))N=new z(j,H,_,this.galleryService,this.extensionsScanner,this.logService);else{const V=l.ExtensionKey.create(H).toString();N=this.installGalleryExtensionsTasks.get(V),N||(this.installGalleryExtensionsTasks.set(V,N=new B(j,H,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),N.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(V)))}return _.profileLocation?new x(N,_.profileLocation,this.extensionsProfileScannerService):N}doCreateUninstallExtensionTask(j,H){return H.profileLocation?new X(j,H.profileLocation,this.extensionsProfileScannerService):new J(j,H,this.extensionsScanner)}async collectFiles(j){const H=async N=>{let V=await f.Promises.readdir(N);V=V.map(ae=>P.join(N,ae));const K=await Promise.all(V.map(ae=>f.Promises.stat(ae)));let ee=Promise.resolve([]);return K.forEach((ae,Z)=>{const ne=V[Z];ae.isFile()&&(ee=ee.then(oe=>[...oe,ne])),ae.isDirectory()&&(ee=ee.then(oe=>H(ne).then(ue=>[...oe,...ue])))}),ee};return(await H(j.location.fsPath)).map(N=>({path:`extension/${P.relative(j.location.fsPath,N)}`,localPath:N}))}};F=pe([Y(0,d.IExtensionGalleryService),Y(1,$.ITelemetryService),Y(2,U.ILogService),Y(3,g.INativeEnvironmentService),Y(4,r.IExtensionsScannerService),Y(5,i.IExtensionsProfileScannerService),Y(6,u.IDownloadService),Y(7,q.IInstantiationService),Y(8,A.IFileService),Y(9,O.IProductService),Y(10,k.IUriIdentityService),Y(11,M.IUserDataProfilesService)],F),e.ExtensionManagementService=F;let G=class extends T.Disposable{constructor(j,H,_,N){super(),this.beforeRemovingExtension=j,this.fileService=H,this.extensionsScannerService=_,this.logService=N,this.uninstalledPath=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(j){await this.removeUninstalledExtensions(),j&&await this.removeOutdatedExtensions()}async scanExtensions(j,H){const _={includeInvalid:!0,profileLocation:H};let N=[];return j===null||j===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):j===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(_)),N=j!==null?N.filter(V=>V.type===j):N,Promise.all(N.map(V=>this.toLocalExtension(V)))}async scanUserExtensions(j){const H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return Promise.all(H.map(_=>this.toLocalExtension(_)))}async extractUserExtension(j,H,_,N){const V=j.toString(),K=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,m.generateUuid)()}`),ee=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,V);try{await f.Promises.rm(ee)}catch{throw new d.ExtensionManagementError(y.localize(1,null,ee,j.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(j,H,K,N),await this.extensionsScannerService.updateMetadata(v.URI.file(K),_);try{await this.rename(j,K,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await f.Promises.rm(K)}catch{}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(ae)}. Deleted from extracted location`,K),ae}return this.scanLocalExtension(v.URI.file(ee),1)}async updateMetadata(j,H){return await this.extensionsScannerService.updateMetadata(j.location,H),this.scanLocalExtension(j.location,j.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...j){const H=j.map(_=>l.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{H.forEach(N=>_[N.toString()]=!0)})}async setInstalled(j){await this.withUninstalledExtensions(N=>delete N[j.toString()]);const _=(await this.scanUserExtensions(!0)).find(N=>l.ExtensionKey.create(N).equals(j))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(j,H){this.logService.trace(`Deleting ${H} extension from disk`,j.identifier.id,j.location.fsPath),await f.Promises.rm(j.location.fsPath),this.logService.info("Deleted from disk",j.identifier.id,j.location.fsPath)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.withUninstalledExtensions(H=>delete H[l.ExtensionKey.create(j).toString()])}async withUninstalledExtensions(j){return this.uninstalledFileLimiter.queue(async()=>{let H;try{H=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let _={};if(H)try{_=JSON.parse(H)}catch{}return j&&(j(_),Object.keys(_).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await f.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(j,H,_,N){this.logService.trace(`Started extracting the extension from ${H} to ${_}`);try{await f.Promises.rm(_)}catch(V){throw new d.ExtensionManagementError(this.joinErrors(V).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(H,_,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${_}:`,j.id)}catch(V){try{await f.Promises.rm(_)}catch{}let K=d.ExtensionManagementErrorCode.Extract;throw V instanceof p.ExtractError&&(V.type==="CorruptZip"?K=d.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(K=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(V.message,K)}}async rename(j,H,_,N){try{await f.Promises.rename(H,_)}catch(V){if(I.isWindows&&V&&V.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${H} to ${_} with 'EPERM' error. Trying again...`,j.id),this.rename(j,H,_,N);throw new d.ExtensionManagementError(V.message||y.localize(2,null,H,_),V.code||d.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,H){const _=await this.extensionsScannerService.scanExistingExtension(j,H,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(y.localize(3,null,j.path))}async toLocalExtension(j){const H=await this.fileService.resolve(j.location);let _,N;return H.children&&(_=H.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,N=H.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:_,changelogUrl:N,publisherDisplayName:j.metadata?.publisherDisplayName||null,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated}}async removeUninstalledExtensions(){const j=await this.getUninstalledExtensions(),H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const K of H)j[l.ExtensionKey.create(K).toString()]||_.add(K.identifier.id.toLowerCase());const N=(0,l.groupByExtension)(H,K=>K.identifier);await D.Promises.settled(N.map(async K=>{const ee=K.sort((ae,Z)=>C.rcompare(ae.manifest.version,Z.manifest.version))[0];_.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}));const V=H.filter(K=>j[l.ExtensionKey.create(K).toString()]);await D.Promises.settled(V.map(K=>this.removeUninstalledExtension(K)))}async removeOutdatedExtensions(){const j=await this.extensionsScannerService.scanSystemExtensions({}),H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],N=await this.extensionsScannerService.getTargetPlatform(),V=(0,l.groupByExtension)(H,K=>K.identifier);for(const K of V)if(K.length>1&&_.push(...K.sort((ee,ae)=>{const Z=C.rcompare(ee.manifest.version,ae.manifest.version);return Z!==0?Z:ee.targetPlatform===N?-1:1}).slice(1)),K[0].type===0){const ee=j.find(ae=>(0,l.areSameExtensions)(ae.identifier,K[0].identifier));(!ee||C.gte(ee.manifest.version,K[0].manifest.version))&&_.push(K[0])}await D.Promises.settled(_.map(K=>this.removeExtension(K,"outdated")))}joinErrors(j){const H=Array.isArray(j)?j:[j];return H.length===1?H[0]instanceof Error?H[0]:new Error(H[0]):H.reduce((_,N)=>new Error(`${_.message}${_.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};G=pe([Y(1,A.IFileService),Y(2,r.IExtensionsScannerService),Y(3,U.ILogService)],G),e.ExtensionsScanner=G;class W extends c.AbstractExtensionTask{get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(j,H,_,N,V){super(),this.identifier=j,this.source=H,this.options=_,this.extensionsScanner=N,this.logService=V,this.wasVerified=!1,this._operation=2}async installExtension(j,H){try{const _=await this.unsetUninstalledAndGetLocal(j.key);if(_)return this.extensionsScanner.updateMetadata(_,j.metadata)}catch{throw I.isMacintosh?new d.ExtensionManagementError(y.localize(4,null),d.ExtensionManagementErrorCode.Internal):new d.ExtensionManagementError(y.localize(5,null),d.ExtensionManagementErrorCode.Internal)}return this.extract(j,H)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const _=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),_}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.toString()]}async extract({zipPath:j,key:H,metadata:_},N){const V=await this.extensionsScanner.extractUserExtension(H,j,_,N);return this.logService.info("Extracting completed.",H.id),V}}class B extends W{constructor(j,H,_,N,V,K){super(H.identifier,H,_,V,K),this.manifest=j,this.gallery=H,this.extensionsDownloader=N}async doRun(j){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(ee=>(0,l.areSameExtensions)(ee.identifier,this.gallery.identifier));_&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,S.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,N),metadata:N};const{location:V,verified:K}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!K,this.validateManifest(V.fsPath);const ee=await this.installExtension({zipPath:V.fsPath,key:l.ExtensionKey.create(this.gallery),metadata:N},j);return _&&!this.options.profileLocation&&(_.targetPlatform!==ee.targetPlatform||C.neq(_.manifest.version,ee.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:ee,metadata:N}}catch(ee){try{await this.extensionsDownloader.delete(V)}catch(ae){this.logService.warn("Error while deleting the downloaded file",V.toString(),(0,R.getErrorMessage)(ae))}throw ee}}async validateManifest(j){try{await(0,s.getManifest)(j)}catch(H){throw new d.ExtensionManagementError((0,c.joinErrors)(H).message,d.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=B;class z extends W{constructor(j,H,_,N,V,K){super({id:(0,l.getGalleryExtensionId)(j.publisher,j.name)},H,_,V,K),this.manifest=j,this.location=H,this.galleryService=N}async doRun(j){const H=new l.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ee=>(0,l.areSameExtensions)(this.identifier,ee.identifier)),V=await this.getMetadata(this.identifier.id,this.manifest.version,j);if(V.isApplicationScoped=(0,S.isApplicationScopedExtension)(this.manifest),V.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,V.isBuiltin=this.options.isBuiltin||N?.isBuiltin,V.installedTimestamp=Date.now(),N)if(this._operation=3,H.equals(new l.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const ee=await this.unsetUninstalledAndGetLocal(H);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:H,metadata:V},j),metadata:V}}async getMetadata(j,H,_){try{let[N]=await this.galleryService.getExtensions([{id:j,version:H}],_);if(N||([N]=await this.galleryService.getExtensions([{id:j}],_)),N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class x{constructor(j,H,_){this.task=j,this.profileLocation=H,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const j=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[j.local,j.metadata]],this.profileLocation),j}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class J extends c.AbstractExtensionTask{constructor(j,H,_){super(),this.extension=j,this.options=H,this.extensionsScanner=_}async doRun(j){const H=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=l.ExtensionKey.create(this.extension);H.push(..._.filter(V=>N.equals(l.ExtensionKey.create(V))))}else H.push(..._.filter(N=>(0,l.areSameExtensions)(N.identifier,this.extension.identifier)));if(!H.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...H),this.options.remove)for(const N of H)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(V){throw new Error(y.localize(9,null,(0,t.toErrorMessage)(V)))}}}class X extends c.AbstractExtensionTask{constructor(j,H,_){super(),this.extension=j,this.profileLocation=H,this.extensionsProfileScannerService=_}async doRun(j){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ie[279],re([0,1,2,29,33,51,78,208,119,44,4,8,21,31,20]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const p={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let y=class extends D.Disposable{constructor(c,d,l,i,r,n,o,s){super(),this.userDataProfilesService=d,c.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(c,l,i,r,s),L.ExtensionStorageService.removeOutdatedExtensionVersions(c,o),this._register(n.createInstance(u))}};y=pe([Y(0,I.INativeServerExtensionManagementService),Y(1,f.IUserDataProfilesService),Y(2,t.IExtensionGalleryService),Y(3,L.IExtensionStorageService),Y(4,t.IGlobalExtensionEnablementService),Y(5,C.IInstantiationService),Y(6,v.IStorageService),Y(7,b.ILogService)],y),e.ExtensionsCleaner=y;let u=class extends D.Disposable{constructor(c,d,l,i,r){super(),this.extensionManagementService=c,this.userDataProfilesService=d,this.extensionsProfileScannerService=l,this.uriIdentityService=i,this.logService=r,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:c,removed:d,all:l}){try{await Promise.all(d.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(l.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{c.length&&(await Promise.all(c.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(l=>l.installedTimestamp&&!this.profileExtensionsLocations.has(this.getKey(l.identifier,l.manifest.version)));d.length&&await Promise.all(d.map(l=>this.extensionManagementService.uninstall(l,p)))}async onDidInstallExtensions(c){for(const{local:d,profileLocation:l}of c)!d||!l||this.addExtensionWithKey(this.getKey(d.identifier,d.manifest.version),l)}async onDidUninstallExtension(c){!c.profileLocation||!c.version||this.removeExtensionWithKey(this.getKey(c.identifier,c.version),c.profileLocation)&&await this.uninstallExtensions([{identifier:c.identifier,version:c.version}])}async populateExtensionsFromProfile(c){const d=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const l of d)this.addExtensionWithKey(this.getKey(l.identifier,l.version),c)}async removeExtensionsFromProfile(c){const d=[];for(const l of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(l,c))continue;const i=this.fromKey(l);i&&d.push(i)}d.length&&await this.uninstallExtensions(d)}addExtensionWithKey(c,d){let l=this.profileExtensionsLocations.get(c);l||(l=[],this.profileExtensionsLocations.set(c,l)),l.push(d)}removeExtensionWithKey(c,d){const l=this.profileExtensionsLocations.get(c);if(l){const i=l.findIndex(r=>this.uriIdentityService.extUri.isEqual(r,d));i>-1&&l.splice(i,1)}return l?.length?!1:(this.profileExtensionsLocations.delete(c),!0)}async uninstallExtensions(c){const l=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>i.installedTimestamp&&c.some(r=>this.getKey(i.identifier,i.manifest.version)===this.getKey(r.identifier,r.version)));l.length&&await Promise.all(l.map(i=>this.extensionManagementService.uninstall(i,p)))}getKey(c,d){return`${E.ExtensionIdentifier.toKey(c.id)}@${d}`}fromKey(c){const[d,l]=(0,R.getIdAndVersion)(c);return l?{identifier:{id:d},version:l}:void 0}};u=pe([Y(0,I.INativeServerExtensionManagementService),Y(1,f.IUserDataProfilesService),Y(2,T.IExtensionsProfileScannerService),Y(3,m.IUriIdentityService),Y(4,b.ILogService)],u)}),define(ie[288],re([0,1,92,34,37,9,2,22,19,7,38,142,201,279,202,194,195,277,183,186,16,206,95,225,96,216,13,222,117,257,29,97,185,258,119,98,181,14,197,199,56,4,192,71,193,58,72,211,8,102,59,103,25,45,21,259,109,23,110,111,112,52,230,113,232,238,78,115,26,76,266,250,251,79,267,271,272,273,274,275,62,252,108,224,75,240,213,239,107,221,31,242,5,243,187,204,203,77,256,20,51,200,60,260,219,229,253,226,106,101]),function(Q,e,D,t,R,T,L,P,I,E,C,b,v,m,f,p,y,u,g,c,d,l,i,r,n,o,s,h,a,S,w,A,q,U,O,$,k,M,F,G,W,B,z,x,J,X,se,j,H,_,N,V,K,ee,ae,Z,ne,oe,ue,de,ve,we,Ee,Pe,Oe,$e,Ve,Je,ce,fe,ge,be,Ie,Te,Re,Ne,_e,Me,We,ke,Ae,te,le,he,me,Se,Ce,De,ze,Fe,Le,qe,Be,Ze,et,At,wt,_t,Ot,Et,bt,Ut,Ct,Mt,Nt,Ft,$t,Wt,Pt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends L.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const ye=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Ue="vscode:electron-main->shared-process=disposeWorker",je=(He,tt)=>{this.onDisposeWorker(tt)};D.ipcRenderer.on(Ue,je),this._register((0,L.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,ce.registerConfiguration)(),ye.invokeFunction(Ue=>{const je=Ue.get(H.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(je)}),this._register((0,L.combinedDisposable)(ye.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(f.LanguagePackCachedDataCleaner),ye.createInstance(u.UnusedWorkspaceStorageDataCleaner),ye.createInstance(y.LogsDataCleaner),ye.createInstance(p.LocalizationsUpdater),ye.createInstance(m.ExtensionsCleaner),ye.createInstance($t.UserDataProfilesCleaner)))}async initServices(){const ye=new x.ServiceCollection,Ue={_serviceBrand:void 0,...V.default};ye.set(K.IProductService,Ue);const je=new C.StaticRouter(Ye=>Ye==="main"),He=new J.MessagePortMainProcessService(this.server,je);ye.set(X.IMainProcessService,He);const tt=this.configuration.policiesData?new Ut.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new Ct.NullPolicyService;ye.set(Ct.IPolicyService,tt);const xe=new h.SharedProcessEnvironmentService(this.configuration.args,Ue);ye.set(s.INativeEnvironmentService,xe);const ct=new _.LogLevelChannelClient(this.server.getChannel("logLevel",je)),it=new _.LoggerChannelClient(this.configuration.logLevel,ct.onDidChangeLogLevel,He.getChannel("logger"));ye.set(H.ILoggerService,it);const ut=this._register(new H.MultiplexLogService([this._register(new H.ConsoleLogger(this.configuration.logLevel)),this._register(it.createLogger((0,I.joinPath)(E.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new _.FollowerLogService(ct,ut));ye.set(H.ILogService,Ge),this.lifecycleService=new It.SharedProcessLifecycleService(Ge),ye.set(It.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new Fe.SharedProcessWorkerService(Ge),ye.set(ze.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new F.FileService(Ge));ye.set(M.IFileService,Qe);const ht=this._register(new G.DiskFileSystemProvider(Ge));Qe.registerProvider(P.Schemas.file,ht);const dt=this._register(new Ze.FileUserDataProvider(P.Schemas.file,this._register(new et.DiskFileSystemProviderClient(He.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Be.isLinux})),P.Schemas.vscodeUserData,Ge));Qe.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this._register(new Mt.UserDataProfilesNativeService(this.configuration.profiles,He,xe));ye.set(Et.IUserDataProfilesService,nt);const Ke=this._register(new l.ConfigurationService(nt.defaultProfile.settingsResource,Qe,tt,Ge));ye.set(d.IConfigurationService,Ke);const ot=new Z.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},He,xe);ye.set(ae.IStorageService,ot),this._register((0,L.toDisposable)(()=>ot.flush())),await Promise.all([Ke.initialize(),ot.initialize()]),ye.set(Le.IUriIdentityService,new qe.UriIdentityService(Qe)),ye.set(ee.IRequestService,new Nt.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new W.SyncDescriptor(c.ChecksumService,void 0,!1)),ye.set(wt.IV8InspectProfilingService,new W.SyncDescriptor(At.InspectProfilingService,void 0,!1));const lt=C.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(N.INativeHostService,lt),ye.set(n.IDownloadService,new W.SyncDescriptor(o.DownloadService,void 0,!0));const ft=this._register(new te.ActiveWindowManager(lt)),gt=new C.StaticRouter(Ye=>ft.getActiveClientId().then(mt=>Ye===mt));ye.set($.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",gt)));let rt;const at=[],Rt=(0,we.isInternalTelemetry)(Ue,Ke);if((0,we.supportsTelemetry)(Ue,xe)){const Ye=new de.TelemetryLogAppender(it,xe);at.push(Ye);const{installSourcePath:mt}=xe;if(Ue.aiConfig?.ariaKey){const Tt=new Ft.OneDataSystemAppender(Rt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,L.toDisposable)(()=>Tt.flush())),at.push(Tt)}rt=new ve.TelemetryService({appenders:at,commonProperties:(0,ne.resolveCommonProperties)(Qe,(0,t.release)(),(0,t.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Rt,mt),sendErrorTelemetry:!0,piiPaths:(0,we.getPiiPathsFromEnvironment)(xe)},Ke,Ue)}else{rt=we.NullTelemetryService;const Ye=we.NullAppender;at.push(Ye)}this.server.registerChannel("telemetryAppender",new ue.TelemetryAppenderChannel(at)),ye.set(oe.ITelemetryService,rt);const jt=new Ee.CustomEndpointTelemetryService(Ke,rt,it,xe,Ue);ye.set(oe.ICustomEndpointTelemetryService,jt),ye.set(bt.IExtensionsProfileScannerService,new W.SyncDescriptor(bt.ExtensionsProfileScannerService,void 0,!0)),ye.set(_t.IExtensionsScannerService,new W.SyncDescriptor(Ot.ExtensionsScannerService,void 0,!0)),ye.set(A.IExtensionSignatureVerificationService,new W.SyncDescriptor(A.ExtensionSignatureVerificationService,void 0,!0)),ye.set(O.INativeServerExtensionManagementService,new W.SyncDescriptor(O.ExtensionManagementService,void 0,!0)),ye.set(w.IExtensionGalleryService,new W.SyncDescriptor(S.ExtensionGalleryService,void 0,!0)),ye.set(w.IExtensionTipsService,new W.SyncDescriptor(U.ExtensionTipsService,void 0,!1)),ye.set(se.ILanguagePackService,new W.SyncDescriptor(j.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new W.SyncDescriptor(r.DiagnosticsService,void 0,!1)),ye.set(fe.IUserDataSyncAccountService,new W.SyncDescriptor(fe.UserDataSyncAccountService,void 0,!0)),ye.set(ce.IUserDataSyncLogService,new W.SyncDescriptor(Ie.UserDataSyncLogService,void 0,!0)),ye.set(ce.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(w.IGlobalExtensionEnablementService,new W.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),ye.set(Je.IIgnoredExtensionsManagementService,new W.SyncDescriptor(Je.IgnoredExtensionsManagementService,void 0,!0)),ye.set(Ve.IExtensionStorageService,new W.SyncDescriptor(Ve.ExtensionStorageService)),ye.set(ce.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Me.UserDataSyncStoreManagementService,void 0,!0)),ye.set(ce.IUserDataSyncStoreService,new W.SyncDescriptor(Me.UserDataSyncStoreService,void 0,!0)),ye.set(Te.IUserDataSyncMachinesService,new W.SyncDescriptor(Te.UserDataSyncMachinesService,void 0,!0)),ye.set(ce.IUserDataSyncBackupStoreService,new W.SyncDescriptor(ge.UserDataSyncBackupStoreService,void 0,!1)),ye.set(ce.IUserDataSyncEnablementService,new W.SyncDescriptor(Re.UserDataSyncEnablementService,void 0,!0)),ye.set(ce.IUserDataSyncService,new W.SyncDescriptor(Ne.UserDataSyncService,void 0,!1)),ye.set(Ae.IUserDataSyncProfilesStorageService,new W.SyncDescriptor(ke.UserDataSyncProfilesStorageService,void 0,!0));const kt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,xe,Ge);return kt.initialize(),ye.set(Oe.ILocalPtyService,this._register(kt)),ye.set(le.ISignService,new W.SyncDescriptor(he.SignService,void 0,!1)),ye.set(me.ISharedTunnelsService,new W.SyncDescriptor(Se.SharedTunnelsService)),ye.set(Ce.ISharedProcessTunnelService,new W.SyncDescriptor(De.SharedProcessTunnelService)),ye.set(Pt.IRemoteTunnelService,new W.SyncDescriptor(Wt.RemoteTunnelService)),new z.InstantiationService(ye)}initChannels(ye){const Ue=new _.LogLevelChannel(ye.get(H.ILogService),ye.get(H.ILoggerService));this.server.registerChannel("logLevel",Ue);const je=new q.ExtensionManagementChannel(ye.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",je);const He=C.ProxyChannel.fromService(ye.get(se.ILanguagePackService));this.server.registerChannel("languagePacks",He);const tt=C.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",tt);const xe=new q.ExtensionTipsChannel(ye.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",xe);const ct=C.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",ct);const it=C.ProxyChannel.fromService(ye.get(wt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",it);const ut=new be.UserDataSyncMachinesServiceChannel(ye.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ut);const Ge=C.ProxyChannel.fromService(ye.get(oe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Qe=new be.UserDataSyncAccountServiceChannel(ye.get(fe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Qe);const ht=new be.UserDataSyncStoreManagementServiceChannel(ye.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ht);const dt=new _e.UserDataSyncChannel(ye.get(ce.IUserDataSyncService),ye.get(Et.IUserDataProfilesService),ye.get(H.ILogService));this.server.registerChannel("userDataSync",dt);const nt=this._register(ye.get(B.IInstantiationService).createInstance(We.UserDataAutoSyncService)),Ke=new be.UserDataAutoSyncChannel(nt);this.server.registerChannel("userDataAutoSync",Ke);const ot=ye.get(Oe.ILocalPtyService),lt=C.ProxyChannel.fromService(ot);this.server.registerChannel(Pe.TerminalIpcChannels.LocalPty,lt);const ft=C.ProxyChannel.fromService(ye.get(Ce.ISharedProcessTunnelService));this.server.registerChannel(Ce.ipcSharedProcessTunnelChannelName,ft);const gt=C.ProxyChannel.fromService(ye.get(ze.ISharedProcessWorkerService));this.server.registerChannel(ze.ipcSharedProcessWorkerChannelName,gt);const rt=C.ProxyChannel.fromService(ye.get(Pt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",rt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,T.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Ue=>{const je=(0,R.toErrorMessage)(Ue,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function qt(Dt){const ye=new zt(Dt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=qt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bece5db81842e38bf85e8a08fb1f12b7f78d4384/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
